  /*
 * Copyright (C) 1994-2000 Cicero ISS
 *
 * Releaseversion: 2.0 9.8.95 Stefan Brueck
 *
 * Versionsgeschichte:
 * sb 9.8.95: Prototypen fuer REFHF/REFF
 * sb 2.7.95: Prototyp fuer B_redim() auf variable Argumente erweitert
 * sb 25.6.95: Prototyp fuer B_setdllinstance() geaendert
 * ++CT 23.6.95, sb 7.7.05: Neue Definitionen fuer B_ccur B_cint B_csng B_cdbl B_clng
 * ww 21.06.95: Da B_Loadstring keine Information ber die Instance der DLL hat,
 *              implementiere ich zwei Funktionen ber die die DLL-Instance
 *              gesetzt und abgefragt werden kann. (neue_fn.c, read.c)
 * ov 16.6.95: B_loadstring() implementiert (read.c)
 * sb 11.6.95: Variable Parameterzahl bei B_lock/B_unlock
 * sb 30.4.95: Neue Prototypen fuer REFHX.C
 * --- BNC_RELEASE 21 ---
 * ct 04.06.96	Verwaltung fuer Statische Strings in Typen.
 *				Neue Verwaltung (Freigabe) bei REFHx()
 *				B_init() verwaltet eine BNC interne Versionsnummer anhand
 *				deren der BNC feststellen kann ob das aufrufende Prog.
 *				mit der BNC-Version zusammenarbeitet.
 * --- BNC_RELEASE 20 ---
 * sb 12.2.95: B_locate() mit varargs ausgestattet (QBASIC/GFA-BASIC ident.)
 *             B_color() mit varargs ausgestattet (QBASIC/GFA-BASIC ident.)
 * ..OV.9.2.95: B_rps_str_ref() ueberarbeitet
 * --- BNC_RELEASE 19 ---
 * gb 29.1.95: Bugfix fuer B_cint() Makro
 * --- BNC_RELEASE 18 ---
 * sb 19.12.94: Prototyp fuer B_cfree() hinzugefuegt
 * --- BNC_RELEASE 14 ---
 * ++OV 22.11.94
 * 				 Prototyp fuer extern void  BNC_WINAPI B_dbsfree(Bstr str);
 * 				 (Anm.: War schon in der Aend. geg. Releaseversion 1.0 drin)
 * 				 #ifdef QBASIC
 * 					extern Bstr BNC_WINAPI B_erdev(void);
 *      		B_color(int,...) -> B_color(int);
 * 				 #endif
 * 				 extern Bstr BNC_WINAPI B_tc(const char *member, int memberlen);
 * 				 #define B_typeconv(member)  B_tc(member, sizeof(member))
 * --- BNC_RELEASE 13 ---
 * ++OV 11.11.94
 * 				 extern BFstr BNC_WINAPI B_cpy(Bstr dest, Bstr src);
 * 				 (B_rps_str_ref wird sich auf Grund eines Fehlers, wenn pseudolokale
 *					realloziert werden noch aendern - vgl. Geralds Aenderungen)
 * 				 #define B_rps_str_ref(a,b,c)...
 * 				 #define B_datapointer(dat)...
 *         Achtung: Aenderung in der Source nicht dokumentiert - alte Version
 *				 kann nicht rekonstruiert werden. sb 21.11.94
 * ov/sb 5.11.94: Prototyp von B_start_druck() geaendert
 * --- BNC_RELEASE 12 ---
 * 1.11.94 Ausgabe der Releaseversion 1.0, lokale Aenderungen gegen die zentral
 *         gepflegte Release sind jeweils im Abschnitt 'Aenderungen gegen... '
 *         einzutragen und werden spaeter fuer alle in die Releaseversion ueber-
 *         nommen
 *
 * Aenderungen gegen Releaseversion:
 1.) ++CT160296	B_timer() Problem mit MSVC
 2.) ++CT200296	Einfuegen der fehlenden Protortypen fuer B_varptr u. B_strlwr
 3.) ++OV.22.2.96: void WINAPI B_init_refhx_stack(void)
 4.) ..CT070396 	Da nicht exportiert in Basicerweiterung	des jeweiligen
 *					Projektes einfuegen
 *					Fkt.: B_shell;B_clsqb;B_run;B_inkey
 5.) ..CT170496		Bei GET u. PUT ist in Q-Basic die Variable RECORDNUMER&
 *					auf den Wertebereich 2^32-1 definiert.
 *					--> aus "int satz" wird "long satz"
 *					Folgeaenderung in GETK.C
 6) ..CT040696		Neue Funktionen fuer die Statischen Strings in Typen
 7) ..CT040696		Neue Funktion zur Freigabe des REFHx()-Stacks
 8) ..CT040696		Neue Funktion B_dynamic() zur Verwaltung von qausi-statischen
 *					und dynamischen Arrays.
 9) ..CT040696		Interne Variable zur Versionserkennung
 */
/* -------------------------------------------------------------------------- */
/* ------------------------- - Systemabhaengiger Teil ----------------------- */
/* -------------------------------------------------------------------------- */

/********************************
 *            ATARI             *
 ********************************/
#if defined(ATARI)
	#define B_timer() (unsigned long) (clock()*10)
#endif /* ATARI */

/********************************
 *             MAC              *
 ********************************/
#if defined(MAC)
	#define B_timer() (unsigned long) (clock()*10)
#endif /* MAC */

/********************************
 *             MSDOS            *
 ********************************/
#if defined(MSDOS)
	#include <stdlib.h>
	#include <stdio.h>
	#include <ctype.h>
	#include <string.h>
	#include <math.h>
	#include <dos.h>
	#include <setjmp.h>
	#include <stdarg.h>
#ifdef __BORLANDC__
	#include <dir.h>
#else
	/* eingefuegt statt in den einzelnen Modulen 30.4.94 OV. */
	#include <direct.h>
#endif
	#define B_timer() (unsigned long) (clock()*10)
#endif /* MSDOS */

/********************************
 *             OS2              *
 ********************************/
#if defined(OS2)
	#include <stdlib.h>
	#include <stdio.h>
	#include <ctype.h>
	#include <string.h>
	#include <math.h>
	#include <setjmp.h>
	#include <stdarg.h>
	#define B_timer() (unsigned long) (clock()*10)

	#define LF_FACESIZE         32
	typedef DWORD COLORREF;
	typedef struct tagBITMAP {
		int     	bmType;
		int     	bmWidth;
		int     	bmHeight;
		int     	bmWidthBytes;
		BYTE    	bmPlanes;
		BYTE    	bmBitsPixel;
		void FAR* bmBits;
	} BITMAP;

	typedef struct tagLOGFONT {
		int     	lfHeight;
		int     	lfWidth;
		int     	lfEscapement;
		int     	lfOrientation;
		int     	lfWeight;
		BYTE    	lfItalic;
		BYTE    	lfUnderline;
		BYTE    	lfStrikeOut;
		BYTE    	lfCharSet;
		BYTE    	lfOutPrecision;
		BYTE    	lfClipPrecision;
		BYTE    	lfQuality;
		BYTE    	lfPitchAndFamily;
		char    	lfFaceName[LF_FACESIZE];
	} LOGFONT;

	typedef struct tagLOGPEN {
		UINT    	lopnStyle;
		POINT   	lopnWidth;
		COLORREF 	lopnColor;
	} LOGPEN;

	typedef struct tagLOGBRUSH {
		UINT     	lbStyle;
		COLORREF 	lbColor;
		int      	lbHatch;
	} LOGBRUSH;
	/* Parallele Schnittstelle */
	extern void BNC_WINAPI B_printerdlg(void *pd);
	extern void BNC_WINAPI B_setprinter_settings(
		void *pd,
		int *startseite,
		int *endseite,
		int *kopienanzahl,
		DWORD *flags
		);

	extern void BNC_WINAPI B_getprinter_settings(
		void *pd, HDC *hdc,
		int *max_millimeter_x,
		int *max_millimeter_y,
		int *max_pixel_x,
		int *max_pixel_y,
		int *dpi_x,
		int *dpi_y,
		int *startseite,
		int *endseite,
		int *kopienanzahl,
		DWORD *flags
	);

#endif /* OS2 */

/********************************
 *    WINDOWS und WINDOWS_NT    *
 ********************************/
#if defined(WINDOWS) || defined(WINDOWS_NT)
	#include <stdlib.h>
	#include <stdio.h>
	#include <ctype.h>
	#include <string.h>
#ifndef __cplusplus	//muss separat aufgerufen werden wegen doppeltem C-Linkage unter C++
	#include <math.h>	
#endif
	#include <dos.h>
	#include <setjmp.h>
	#include <stdarg.h>
# ifdef __BORLANDC__
#  include <dir.h>
# else
	/* eingefuegt statt in den einzelnen Modulen 30.4.94 OV. */
	#include <direct.h>
# endif

	/* Parallele Schnittstelle */
# include <commdlg.h>
	extern PRINTDLG *BNC_WINAPI B_printerdlg(PRINTDLG *pd);
	extern PRINTDLG *BNC_WINAPI B_setprinter_settings(
		PRINTDLG *pd,
		int *startseite,
		int *endseite,
		int *kopienanzahl,
		DWORD *flags
		);

	extern PRINTDLG *BNC_WINAPI B_getprinter_settings(
		PRINTDLG *pd, HDC *hdc,
		int *max_millimeter_x,
		int *max_millimeter_y,
		int *max_pixel_x,
		int *max_pixel_y,
		int *dpi_x,
		int *dpi_y,
		int *startseite,
		int *endseite,
		int *kopienanzahl,
		DWORD *flags
	);

	/* MIDI (Funktionen aus der DLL) */
# include <mmsystem.h>
	extern int  BNC_WINAPI AudioInit(HWND, WORD);
	extern void BNC_WINAPI timeCallback(UINT, UINT, DWORD, DWORD, DWORD);
	extern void BNC_WINAPI AudioStart(void);
	extern void BNC_WINAPI AudioStop(void);
	extern WORD BNC_WINAPI AudioSetTempo(BYTE);
	extern WORD BNC_WINAPI AudioGetTempo(void);
	extern void BNC_WINAPI AudioMidiThru(BOOL fCondition);
	extern void BNC_WINAPI AudioSendEvent(BYTE bStatus, BYTE bVal1, BYTE bVal2);
	extern WORD BNC_WINAPI AudioGetEvent(LPSTR t,int l);
	extern WORD BNC_WINAPI AudioIn(BOOL fCondition);
	extern DWORD BNC_WINAPI AudioGetTime(void);
	extern DWORD BNC_WINAPI AudioWrite(BYTE, BYTE, BYTE, DWORD, BYTE);
	extern DWORD BNC_WINAPI AudioQueryBuf(void);
# define TICKS           192
# define MAXRING         512
# define MAXMIDIBUFFER   1024

	// extern void BNC_WINAPI B_windowsmessage(LRESULT (CALLBACK *winmessage)(HWND, UINT, WPARAM, LPARAM));
	extern void BNC_WINAPI B_windowsmessage(void huge *winmessage);
	
	/* * 1.) ++CT160296	B_timer() Problem mit MSVC */
# undef B_timer
DLL_DECL extern long BNC_WINAPI B_timer(void);
#endif /* WINDOWS || WINDOWS_NT */

#if defined(WINDOWS)
#endif /* WINDOWS */

#if defined(WINDOWS_NT)
# include <io.h>
#endif /* WINDOWS_NT */

/* -------------------------------------------------------------------------- */
/* -------------------------- Systemunabhaengiger Teil ---------------------- */
/* --------------------------  Basicunhaengiger Teil ------------------------ */
/* -------------------------------------------------------------------------- */
#undef  FALSE
#undef  TRUE
#define FALSE           0
#define TRUE            -1
#define PI              3.141592654
#define PIXEL           0
#define UNIT            1
#define X_OR       			!=

DLL_DECL extern double BNC_WINAPI B_trunc(double x);

#define B_add(x,y) 			(long)(x)+(long)(y)
#define B_sub(x,y) 			(long)(x)-(long)(y)
#define B_mul(x,y) 			(long)(x)*(long)(y)
#define B_div(x,y) 			(long)(x)/(long)(y)
#define B_mod(x,y) 			(long)(x)%(long)(y)
#define B_rad(a)   			((a)*0.01745329251994)
#define B_deg(a)   			((a)*57.29577951308)
#define B_sinq(x)  			sin(B_rad(x))
#define B_cosq(x)  			cos(B_rad(x))
#if BNC_RELEASE >= 18
	/* gb 29.1.95: Ausgetestet */
#if 1	//ab.. 25.3.97 Korrektur nach Klaes
# define B_cint(zahl) ((zahl) >= 0 ) ? (int)((zahl) + (double) 0.5) : (int)((zahl) - (double) 0.5)  
#else
# define  B_cint(a)       ((long)((a) + 0.5))
#endif
/* ++CT 23.6.95: Neue Definitionen fuer B_ccur B_cint B_csng B_cdbl B_clng    */
/* Definitionen gelten nur fuer QBASIC,PDS-BASIC und VB-DOS NICHT VB-WINDOWS! */
/* Auszug aus BNC_ADVO.INI
	CCUR	##5:B_ccur(p1)
	CINT    ##3:B_cint(p1)
	CSNG    ##7:B_csng(p1)
	CDBL    ##5:B_cdbl(p1)
	CLNG    ##4:B_clng(p1)
*/
#if defined(QBASIC)
# define B_ccur(a)	((double)(a))
# define B_csng(a)	((float)(a))
# define B_cdbl(a)	((double)(a))
# if 1	//ab.. 25.3.97 Korrektur nach Klaes
#  define B_clng(zahl) ((zahl) >= 0 ) ? (long)((zahl) + (double) 0.5) : (long)((zahl) - (double) 0.5)  
# else
#  define B_clng(a)	((long)(a))
# endif
#endif /* QBASIC */

#else /* BNC_RELEASE < 18 */
# define B_cint(a)       ((int)(a))
#endif /* BNC_RELEASE >= 18 */

#define B_cfloat(a)     ((double)(a))
#define B_frac(x)       ((x) - B_trunc(x))
#define B_odd(a)        ((fmod(((int)(a)),2) == 0) ? 0 : -1)
#define B_even(a)       ((fmod(((int)(a)),2) == 0) ? -1 : 0)
#define B_swapc(a,b) 		{char A;A=(a);(a)=(b);(b)=A;}
#define B_swapu(a,b) 		{unsigned char A;A=(a);(a)=(b);(b)=A;}
#define B_swapi(a,b) 		{int A;A=(a);(a)=(b);(b)=A;}
#define B_swapl(a,b) 		{long A;A=(a);(a)=(b);(b)=A;}
#define B_swapd(a,b) 		{double A;A=(a);(a)=(b);(b)=A;}
#define B_swaps(a,b) 		{Bstr p=a;a=b;b=p;}
#define B_swapf(a,b) 		{Feld A;A=(a);(a)=(b);(b)=A;}
#define B_bmove(a,b,c)  (B_hidem(),_fmemcpy((void huge *)(long)(b),(void huge *)(long)(a),(long)c))

DLL_DECL extern void BNC_WINAPI B_dummy(void);

/* PEEK - POKE */
extern short BNC_WINAPI B_dpeek(long a);
extern long  BNC_WINAPI B_lpeek(long a);
#define B_poke(x,y)     *(char  huge *)(x) = ((char)(y))
#define B_dpoke(x,y)    *(int  huge *)(x) = ((int)(y))
#define B_lpoke(x,y)    *(long huge *)(x) = ((long)(y))
#define B_spoke(x,y)    B_poke(x,y)
#define B_sdpoke(x,y)   B_dpoke(x,y)
#define B_slpoke(x,y)   B_lpoke(x,y)
#define B_peek(a)       (unsigned char) *((char  huge *)(a))

/* GUI-Elemente */
/* ..sb 4.1.94 Siehe Kommentar bei B_fileselect in filesel.c */
extern BFstr BNC_WINAPI B_fileselect(Bstr a, Bstr b, Bstr c, Bstr d);
#define B_fileselect(a,b,c,d) (d) = B_fileselect((a),(b),(c),(d))
extern void BNC_WINAPI B_openwk(int nr,int x,int y,int w,int h,long attr);
extern void BNC_WINAPI B_openw(int nr,int x,int y);
extern void BNC_WINAPI B_closew(int a);
extern void BNC_WINAPI B_clearw(int nr);
extern void BNC_WINAPI B_titlew(int nr,Bstr a);
extern void BNC_WINAPI B_infow(int nr,Bstr a);
extern void BNC_WINAPI B_topw(int nr);
extern void BNC_WINAPI B_fullw(int nr);
extern void BNC_WINAPI B_menu(int a,int b);
extern void BNC_WINAPI B_menut(int pos,int flag, char *text);
extern void BNC_WINAPI B_menu_ein(Bstr m[]);
extern void BNC_WINAPI B_menu_aus(void);
extern void BNC_WINAPI B_menu_off(void);
extern void BNC_WINAPI B_on_menu(int klicks,int taste, int zust, int fl1,int ix,\
	int iy,int ib,int ih, int fl2,int i2x,int i2y,int i2b,int i2h,long timer);
DLL_DECL extern int BNC_WINAPI B_alert(int icon, Bstr bt, int db, Bstr text, int back);
#ifdef LIBRARY_INCLUDE
# ifdef C6
# undef B_alert
# else /* !C6 */
# undef B_alert(a, b, c, d, e)
# endif /* C6 */
#else /* !LIBRARY_INCLUDE */
# define B_alert(a, b, c, d, e) (e=B_alert(a, b, c, d, e))
#endif /* LIBRARY_INCLUDE */

DLL_DECL extern void BNC_WINAPI B_stop(void);

/* Graphik */
extern void BNC_WINAPI B_drawtext(int x1,int y1,int x2,int y2,Bstr text,int format);
extern void BNC_WINAPI B_text(int x,int y,int laenge,Bstr c);
DLL_DECL extern void BNC_WINAPI B_cls(void);
extern void BNC_WINAPIV B_curve(int verbindenB, int count, ...);
extern void BNC_WINAPI B_achar(int code,int x,int y,long f,int stil,int winkel);
extern void BNC_WINAPI B_atext(int x,int y,long font,Bstr s);
extern void BNC_WINAPI B_vdisys(int opc, int c_int, int c_pts, int subopc);
extern void BNC_WINAPI B_boundary(int mode);
extern int  BNC_WINAPI B_gemsys(int a);
extern void BNC_WINAPI B_deftext(int x, int y, int c, int d,int font);
extern void BNC_WINAPI B_defline(int x, int y, int c, int d);
extern void BNC_WINAPI B_defmark(int x, int y, int c);
extern void BNC_WINAPI B_deffill(int x, int y, int d);
extern void BNC_WINAPI B_fdeffill(int a, Bstr c);
extern void BNC_WINAPIV B_color(int a, ...);  /* ..sb 12.2.95 */
extern void BNC_WINAPI B_rc_copy(long sadr,int sx,int sy,int w,int h,long dadr,int dx,int dy,int mode);
extern void BNC_WINAPI B_colorwin(int color, int back_color);
extern void BNC_WINAPI B_setcolor(int r_egister, long mwert);
extern void BNC_WINAPI B_rgbcolor(long f);
extern void BNC_WINAPI B_msetcolor(int r_egister, int rot, int gruen, int blau);
extern void BNC_WINAPI B_mrgbcolor(int rot, int gruen, int blau);
extern void BNC_WINAPI B_graphmode(int mode);
extern void BNC_WINAPI B_draw(int xa, int ya, int xe, int ye);
extern void BNC_WINAPI B_box(int x, int y, int c, int d);
extern void BNC_WINAPI B_circle(int x, int y, int r,int w1,int w2);
extern void BNC_WINAPI B_pcircle(int x, int y, int r,int w1,int w2);
extern void BNC_WINAPI B_ellipse(int x, int y, int xr, int yr,int w1,int w2);
extern void BNC_WINAPI B_pellipse(int x, int y, int xr, int yr,int w1,int w2);
extern void BNC_WINAPI B_drawa(int mode, int xa, int ya);
extern void BNC_WINAPI B_rbox(int x, int y, int c, int d);
extern void BNC_WINAPI B_pbox(int x, int y, int c, int d);
extern void BNC_WINAPI B_prbox(int x, int y, int c, int d);
extern void BNC_WINAPI B_line(int xa, int ya,int xe,int ye);
extern void BNC_WINAPI B_aline(int x, int y, int x2, int y2, int d1, int stil, int modus);
extern void BNC_WINAPI B_fill(int x,int y,int farbe);
extern void BNC_WINAPI B_plot(int x, int y);

extern void BNC_WINAPI B_polyline(int p,int a,int b,int ox,int oy);
extern void BNC_WINAPI B_poly(int p,int art);
extern int HVA, HV[MAXPOLY];
#define B_fillpxy(p,a,b,ox,oy) \
	{for(HVA=0;HVA<(p);HVA++)    \
		{                                              \
		HV[2*HVA] = ((int) (a)[HVA] + (int)ox);        \
		HV[2*HVA+1] = ((int) (b)[HVA] + (int)oy);      \
		}}

#define B_polyline(p,a,b,ox,oy)\
	{B_fillpxy((p),(a),(b),(ox),(oy));B_poly(p,1);}

#define B_polyfill(p,a,b,ox,oy)\
	{B_fillpxy((p),(a),(b),(ox),(oy));B_poly(p,2);}

#define B_polymark(p,a,b,ox,oy)\
	{B_fillpxy((p),(a),(b),(ox),(oy));B_poly(p,3);}

/* Maus */
extern void BNC_WINAPI B_showm(void);
extern void BNC_WINAPI B_hidem(void);
extern void BNC_WINAPI B_fdefmouse(int huge *a);
extern int  BNC_WINAPI B_mousex(void);
extern int  BNC_WINAPI B_mousey(void);
extern int  BNC_WINAPI B_mousek(void);
extern int  BNC_WINAPI B_point(int x, int y);
extern void BNC_WINAPI B_mousexyk(int *x, int *y, int *k);
extern void BNC_WINAPI B_setmouse(int mx,int my,int mk);
#define B_mouse(x, y, k); 				{int X,Y,K;B_mousexyk(&X,&Y,&K);x=X;y=Y;k=K;}
extern void BNC_WINAPI B_defmouse(int a);
#define B_fdefmouse(a)            B_fdefmouse((int huge *)(a))

/* Speicherverwaltung */
extern void  BNC_WINAPI B_free(void huge *s);
extern void  BNC_WINAPI B_cfree(void huge *s);
extern void  BNC_WINAPI B_erase(void huge *s);
extern BFstr BNC_WINAPI B_lfree(Bstr s);
extern BFstr BNC_WINAPI B_lrealloc(Bstr arr,BSV max_l);
extern BFstr BNC_WINAPI B_ncpy(char dest[], Bstr src,BSV len);
extern BFstr BNC_WINAPI B_lxrealloc(Bstr s,BSV max_l,Bstr anh);
extern BFstr BNC_WINAPI B_lxdrealloc(BSV max_l,Bstr anh);
extern BFstr BNC_WINAPI B_ldrealloc(BSV max_l);
extern BFstr BNC_WINAPI B_realloc(Bstr sp, BSV old, BSV n_ew);
extern BFstr BNC_WINAPI B_ndcpy(Bstr src);
#if BNC_RELEASE >= 20
  extern Bstr BNC_WINAPIV B_redim(int typ, void huge *feld, int c_har, long anzahl_dimensionen, ...);
#else /* BNC_RELEASE < 20 */
  extern Bstr  BNC_WINAPI  B_redim(int typ, void huge *f, int c_har, long lenold, long lennew);
#endif /* BNC_RELEASE >= 20 */
extern Bstr  BNC_WINAPIV B_dim(int typ, void huge *f, BSV c_har, long dim, ...);
extern void  BNC_WINAPIV B_arrayfill(int typ, void huge *fp, double wert, ...);
extern void  BNC_WINAPI B_insert(int typ,void huge *f_, int index, Bstr s,double d);
#ifndef CBASIC	//ab.. 15.4.97
extern void  BNC_WINAPI B_delete(int typ,void huge *f,int index);
#endif
extern void  BNC_WINAPI B_srealloc(Bstr *str, Bstr arr, BSV max_l);
extern void  BNC_WINAPI B_drealloc(Bstr *str, BSV max_l);
extern void  BNC_WINAPI B_dsfree(Bstr str);
extern void  BNC_WINAPI B_dbsfree(Bstr str);

/* Strings */
extern unsigned char BNC_WINAPI B_asc(Bustr s);
extern BFstr BNC_WINAPI  B_left(Bstr  a, BSV b);
extern BFstr BNC_WINAPI  B_trim(Bstr a);
extern BFstr BNC_WINAPI  B_ltrim(Bstr a);
extern BFstr BNC_WINAPI  B_rtrim(Bstr a);
extern BFstr BNC_WINAPI  B_string(BSV zahl, Bstr s);
DLL_DECL extern BFstr BNC_WINAPIV B_sprintf(Bstr z,Bstr form, ...);
DLL_DECL extern BFstr BNC_WINAPI  B_nsprintf(Bstr z,Bstr form,BSV len);
extern BSV   BNC_WINAPI  B_instr(BSV a,Bstr b,Bstr c);
extern BSV   BNC_WINAPI  B_rinstr(BSV a,Bstr b,Bstr c);
extern BSV   BNC_WINAPI  B_instri(BSV a,Bstr b,Bstr c);
extern BSV   BNC_WINAPI  B_rinstri(BSV a,Bstr b,Bstr c);
extern BFstr BNC_WINAPI  B_right(Bstr a, BSV b);
extern BFstr BNC_WINAPI  B_mid(Bstr a, BSV b,BSV c);
extern BFstr BNC_WINAPI  B_strupr(Bstr);
extern BFstr BNC_WINAPI  B_lset(Bstr a, Bstr b);
extern BFstr BNC_WINAPI  B_rset(Bstr a, Bstr b);
DLL_DECL extern void BNC_WINAPI B_dslset(void huge* ziel, int z_laenge, void huge* quelle, int q_laenge);
DLL_DECL extern void BNC_WINAPI B_dsrset(void huge* ziel, int z_laenge, void huge* quelle, int q_laenge);
extern BFstr BNC_WINAPI  B_hex(long a,int n);
extern BFstr BNC_WINAPI  B_oct(long a,int n);
extern BFstr BNC_WINAPI  B_bin(long a,int n);
extern BFstr BNC_WINAPI  B_chr(unsigned char a);
extern BFstr BNC_WINAPI  B_space(BSV a);
extern BFstr BNC_WINAPI  B_date(void);
extern BFstr BNC_WINAPI  B_time(void);
extern BSV   BNC_WINAPI  B_strlen(Bstr a);
extern long  BNC_WINAPI  B_strcmp(int modus,Bstr a,Bstr b);
extern long	 BNC_WINAPI  B_xstrcmp(int modus, Bstr a, BSV lenab, Bstr b);
extern long	 BNC_WINAPI  B_typecmp(int modus, Bstr a, BSV lena, Bstr b, BSV lenb);

extern void BNC_WINAPI type_test(Bstr type_str, BSV type_str_len);
extern Bstr  BNC_WINAPI  B_tc(const char *member, int memberlen);
#define B_typeconv(member)  B_tc(member, sizeof(member))

extern void  BNC_WINAPI B_midncpy(Bstr a, BSV start, BSV n, Bstr t);
/* Kopiert len Bytes von src-> dest, funktioniert auch bei len>64KByte */
extern BFstr BNC_WINAPI B_copy(Bstr dest,Bstr src,BSV len);
/* wie B_copy, hngt jedoch kein 0-Byte an */
extern BFstr BNC_WINAPI B_typecopy(Bstr dest,Bstr src,BSV len);
/* C/BNC <- C/BNC */
extern BFstr BNC_WINAPI B_strcpy(Bstr dest,Bstr source);
/* C/BNC <- C/BNC + C/BNC */
extern BFstr BNC_WINAPI B_xstrcpy(Bstr dest,Bstr source,Bstr zus);
/* C/BNC <- type */
extern BFstr BNC_WINAPI B_strncpy(Bstr dest, Bstr type, BSV typelen);
/* type <- C/BNC */
extern BFstr BNC_WINAPI B_typecpy(Bstr type, BSV typelen, Bstr src);
/* type <- type */
extern BFstr BNC_WINAPI B_xtypecpy(Bstr dest, BSV destlen, Bstr src, BSV srclen);
/* type <- C/BNC */
/* ab..5.8.96 neue Funktion */
extern BFstr BNC_WINAPIV B_typprintf(Bstr typedest, BSV typedestlen, Bstr form, ...);
/* C/BNC + C/BNC */
extern BFstr BNC_WINAPI B_strcat(Bstr  dest, Bstr src);
/* C/BNC + type */
extern BFstr BNC_WINAPI B_strncat(Bstr str, Bstr type, BSV typelen);
/* type + C/BNC */
extern BFstr BNC_WINAPI B_typecat(Bstr type, BSV typelen, Bstr src);
/* type + type */
extern BFstr BNC_WINAPI B_xtypecat(Bstr dtype, BSV dtypelen, Bstr srctype, BSV srctypelen);

/* Bilder */
extern void  BNC_WINAPI B_bget(int fp, long b, long c);
extern void  BNC_WINAPI B_bput(int fp, long b, long c);
DLL_DECL extern BFstr BNC_WINAPI B_get(int x1, int y1, int x2, int y2, Bstr c);
extern BFstr BNC_WINAPI B_sget(Bstr c);
extern void  BNC_WINAPI B_sput(Bstr c);
DLL_DECL extern void  BNC_WINAPI B_put(int x1, int y1, Bstr c, long mode);
extern void  BNC_WINAPI B_putm(int x, int y, Bstr s, int mode);
#define B_get(p1, p2, p3, p4, a) 	B_get(p1, p2, p3, p4, (Bstr)a)
#define B_sget(a) 								B_sget((Bstr)a)

/* Text: Ein- und Ausgabe */
DLL_DECL extern void  BNC_WINAPIV B_printf(int x,int y,Bstr form, ...);
DLL_DECL extern void  BNC_WINAPIV B_print_using(int fp,Bstr uform, Bstr form, ...);
DLL_DECL extern void  BNC_WINAPI  B_init_forminput(Bstr text);										/* ++sb 5.2.94 */
extern BFstr BNC_WINAPI  B_form_input(int mode, int anzahl, Bstr b);		/* ..sb 5.2.94 */
extern void  BNC_WINAPIV B_input(int mode,int komma,Bstr text,Bstr form, ...);
extern BFstr BNC_WINAPI  B_char(long a, Bstr b, int fl);
DLL_DECL extern BFstr BNC_WINAPI  B_inputkr(BSV anz, int kan);
extern BFstr BNC_WINAPI  B_input_S(BSV anz);
DLL_DECL extern BFstr BNC_WINAPI  B_inkey(void);
extern int   BNC_WINAPI  B_textattr(int *attrib);          						/* ++ww 7.6.94 */
extern int   BNC_WINAPI  B_textextent(Bstr t, int *extent);						/* ++ww 7.6.94 */
extern int   BNC_WINAPI  B_txtlen(Bstr t);
extern void  BNC_WINAPI  B_print_at(int a,int b);
DLL_DECL extern void  BNC_WINAPIV B_locate(int, int, ...);                     /* ..sb 12.2.95 */
#define B_char(a,b,fl)	B_char((long)(a),(Bstr)(b),(fl))

/* parallele Schnittstelle */
extern HANDLE BNC_WINAPI  	B_getprinter_handle(void);
extern void 	BNC_WINAPI 	B_setprinter_handle(HANDLE hdl);
extern HDC 	  BNC_WINAPI    B_printer_open(void);
extern void   BNC_WINAPI    B_printer_close(void);
extern int    BNC_WINAPIV   B_lprintf(Bstr text, ...);
extern void   BNC_WINAPIV   B_lprint_using(int x,Bstr form, ...);
extern BSV    BNC_WINAPI    B_lread(Bstr port,Bstr puffer,BSV len);
extern BSV    BNC_WINAPI    B_lwrite(Bstr port,Bstr puffer,BSV len);
extern void 	BNC_WINAPI 	B_printer_einrichten(int flag);
extern int 		BNC_WINAPI 	B_printer_abort(void);
extern void		BNC_WINAPI	  B_initprinter(void);
extern void		BNC_WINAPI	  B_exitprinter();
extern void		BNC_WINAPI 	B_hardcopy(void);
extern void 	BNC_WINAPI 	B_hardcopy_xywh(int x1, int y1, int w1, int h1, int x2, int y2, int w2, int h2);
extern int  	BNC_WINAPI 	B_start_druck(void);
extern void 	BNC_WINAPI 	B_end_druck(void);
extern void 	BNC_WINAPI 	B_druck_position(int mode,int *x,int *y,int *zeile);
extern int    BNC_WINAPI    B_getprinter_abort(void);
extern void   BNC_WINAPI    B_setprinter_abort(int flag);

/* serielle Schnittstelle */
extern BSV  BNC_WINAPI  B_cread(int nr,Bstr puffer,BSV len);
extern BSV  BNC_WINAPI  B_cwrite(int nr,Bstr puffer,BSV len);
extern int  BNC_WINAPI  B_comm_open(int nr);
extern int  BNC_WINAPIV B_cprintf(int nr,LPSTR text, ...);
extern int  BNC_WINAPIV B_cinput(int nr,LPSTR text, ...);
extern char BNC_WINAPI  B_comm_config(int nr,unsigned int baud,char xonf,char rtsf,char b_yte,int parity,char stopb);
extern void BNC_WINAPI  B_comm_close(int nr);

/* Midi */
extern BFstr BNC_WINAPI  B_inpmid(void);
extern BSV   BNC_WINAPIV B_mprintf(LPSTR text, va_list argpoint);
extern BSV   BNC_WINAPI  B_mread(Bstr puffer,BSV len);
extern BSV   BNC_WINAPI  B_mwrite(Bstr puffer,BSV len);
extern int   BNC_WINAPI  B_midi_open(int kanal);
extern int   BNC_WINAPIV B_minput(LPSTR text, ...);
extern void  BNC_WINAPI  B_midi_close(void);

/* Clipboard/Zwischenablage */
extern BFstr BNC_WINAPI B_strfromclip(Bstr string);
extern int   BNC_WINAPI B_clipboard_open(int pixel_x, int pixel_y);
extern void  BNC_WINAPI B_clipboard_close(void);
extern void  BNC_WINAPI B_pictoclip(int x, int y, int w, int h);
extern void  BNC_WINAPI B_cliptopic(int x, int y);
extern void  BNC_WINAPI B_strtoclip(Bstr string);

/* Fenster */
extern HWND BNC_WINAPI wind_create(long attr,int x, int y, int w, int h);
extern int  BNC_WINAPI wind_open(HWND hwnd, int x, int y, int w, int h);
extern int  BNC_WINAPI wind_delete(HWND hwnd);
extern int  BNC_WINAPI wind_close(HWND hwnd);
extern void BNC_WINAPI wind_set(HWND hwnd, int mode, char huge *text, int x, int y);
extern void BNC_WINAPI wind_get(HWND hwnd, int mode, int *p1,int *p2, int *p3, int *p4);

/* GEM Funktionen (aus Kompatibilittsgrnden) */
#define WIND_CREATE(attr,wx,wy,ww,wh) 									wind_create((long)(attr),(int)(wx),(int)(wy),(int)(ww),(int)(wh))
#define WIND_OPEN(handle,init_x,init_y,init_w,init_h) 	wind_open(B_win(handle),(int)(init_x),(int)(init_y),(int)(init_w), (int)(init_h))
#define WIND_CLOSE(handle)         											wind_close(B_win(handle))
#define WIND_DELETE(handle)        											wind_delete(B_win(handle))
#define WIND_SET(handle,field,w1,w2,w3,w4)            	wind_set(handle,(int)field,(Bstr)(((long)(w1)<<16) | (int)(w2)),(int)(w3),(int)(w4))
#define WIND_FIND(fx,fy)           											wind_find((int)(fx),(int)(fy))
#define WIND_UPDATE(flag)          											wind_update((int)(flag))
#define WIND_GET(handle,field,w1,w2,w3,w4)            	{int A,B,C,D;wind_get(B_win(handle),(int)field,&A,&B,&C,&D);w1=A;w2=B;w3=C;w4=D;}
#define WIND_CALC(w_type,attr,ix,iy,iw,ih,ox,oy,ow,oh)  {int A,B,C,D;wind_calc((int)w_type,(int)attr,(int)ix,(int)iy,(int)iw,(int)ih,&A,&B,&C,&D); ox = A; oy = B; ow = C; oh = D;}
#define FORM_ALERT(button,string)     									form_alert((int)(button),(Bstr )(string))
/*
 * Vor Verwendung dieser GEM-Routinen (EVNT_*) sind die globalen Definitionen:
 * int HVA,B_GINTOUT[256],B_INTOUT[256]; erforderlich
 */
#define EVNT_BUTTON(clicks,mask,state,mx,my,bu,kb)      evnt_multi(MU_BUTTON,clicks,mask,state,0,0,0,0,0,0,0,0,0,0,0L,0,0,&mx,&my,&bu,&kb,&clicks,&clicks)
#define EVNT_MOUSE(fl,ox,oy,ow,oh,mx,my,button,state)   evnt_multi(MU_M1,1,1,1,fl,ox,oy,ow,oh,0,0,0,0,0,0L,0,0,&mx,&my,&button,&state,&ox,&ox),\
	/* hier liegt ein Fehler vor! irgendwann ist ein Teil des Files geloescht worden! */

#define EVNT_MESAG(pbuff)                               {int HVA;evnt_multi(MU_MESAG,1,1,1,fl,0,0,0,0,0,0,0,0,0,pbuff,0,0,&HVA,&HVA,&HVA,&HVA,&HVA,&HVA);}
#define EVNT_MULTI(f,c,m,s,ms,mx,my,mh,mt,fs,m2x,m2y,m2w,m2h,buff,co,mox,moy,mbu,oks,kr,br) \
 (B_seteventflag(f),B_on_menu(c,m,s,ms,mx,my,mh,mt,fs,m2x,m2y,m2w,m2h,co), \
	mox=B_mousex(), moy=B_mousey(), mbu=B_mousek(), oks=B_inkey())

#if !defined(BUSINESS_BASIC)
#endif /* BUSINESS_BASIC */

/* Umwandlungen */
extern BFstr BNC_WINAPI B_tab(long a);
extern BFstr BNC_WINAPI B_itoab(int a,int b,int c);
extern BFstr BNC_WINAPI B_utoab(unsigned int a,int b,int c);
extern BFstr BNC_WINAPI B_ltoab(long a,int b,int c);
extern BFstr BNC_WINAPI B_lutoab(unsigned long a,int b,int c);
extern BFstr BNC_WINAPI B_ftoab(double a,int b,int c);
DLL_DECL extern double BNC_WINAPI B_val(Bstr a);
DLL_DECL extern int BNC_WINAPI B_valint(Bstr a);
extern long  BNC_WINAPI B_btol(Bstr s);
extern long  BNC_WINAPI B_atol(Bstr a);
extern int   BNC_WINAPI B_valf(Bstr a);
extern int   BNC_WINAPI B_atoi(Bstr a);
#if 1	//ab.. 18.2.97 signed
extern BFstr BNC_WINAPI B_mki(short a);
extern BFstr BNC_WINAPI B_mkl(long a);
#else
extern BFstr BNC_WINAPI B_mki(unsigned short a);
extern BFstr BNC_WINAPI B_mkl(unsigned long a);
#endif
extern BFstr BNC_WINAPI B_mks(float a);
extern BFstr BNC_WINAPI B_mkd(double a);

/* Sound */
DLL_DECL extern void BNC_WINAPI B_beep(void);

/* Dateihandling */
#if 0	//ab.. 28.2.97 realisiert ueber Funktionen in dpath.c
#define B_kill(a) 	              remove((char *)(a))
#define B_name(a,b)               rename((char *)(a),(char *)(b))
#endif
#define B_rename(a,b)             rename((char *)(a),(char *)(b))
extern void BNC_WINAPI  B_dir(int mode, Bstr src, Bstr dest);
extern void BNC_WINAPI  B_openk(Bstr art, int fp, Bstr file, int satz);
extern void BNC_WINAPI  B_openr(Bstr a, int fp, Bstr file, long anz);
extern void BNC_WINAPI  B_mkdir(Bstr path);
extern void BNC_WINAPIV B_fputc(int anz, int kanal, ...);
extern void BNC_WINAPIV B_fputi(int anz, int kanal, ...);
extern void BNC_WINAPIV B_fputl(int anz, int kanal, ...);
DLL_DECL extern void BNC_WINAPIV B_fscanf(int fp, LPSTR form, ...);
DLL_DECL extern void BNC_WINAPIV B_fxscanf(int fp, LPSTR form, ...);
DLL_DECL extern void BNC_WINAPIV B_fprintf(int fp, LPSTR form, ...);
DLL_DECL extern void BNC_WINAPIV B_field(int nr, ...);
DLL_DECL extern int  BNC_WINAPI  B_fgetc(int index);
DLL_DECL extern int  BNC_WINAPI  B_feof(int fp);
DLL_DECL extern int  BNC_WINAPI  B_closeall(void);
extern void BNC_WINAPI  B_touch(int fp);

/* Verschiedene */
extern void BNC_WINAPI B_longjmp(jmp_buf jbuf, short ind);	/* ++gb 29.1.95 in ERROR.C */
DLL_DECL extern void BNC_WINAPI B_settime(Bstr zeit,Bstr datum);
extern BFstr BNC_WINAPI B_an(Bstr a);
extern long BNC_WINAPI B_himem(void);
DLL_DECL extern void BNC_WINAPI B_qsort(int typ,void huge *a,void huge *skr,long huge *ind,int anz,int auf);
DLL_DECL extern void BNC_WINAPI B_ssort(int typ,void huge *a,void huge *skr,long huge *ind,int anz,int auf);
DLL_DECL extern void BNC_WINAPI B_bsave(Bstr a,long b,long c);
DLL_DECL extern void BNC_WINAPI B_bload(Bstr a, long b);
DLL_DECL extern void BNC_WINAPI B_clr(Bstr a);

extern BFstr BNC_WINAPI B_errd(int x);
extern unsigned long BNC_WINAPI B_dfree(int a);
extern unsigned long BNC_WINAPI B_fre(int a);
extern unsigned char BNC_WINAPI B_inp(int a);
DLL_DECL extern void BNC_WINAPI B_swap(void huge* a, int a_laenge, void huge* b, int b_laenge);
DLL_DECL extern long BNC_WINAPI B_swapb(long a);
extern long BNC_WINAPI B_keylook(void);
extern long BNC_WINAPI B_keyget(void);
extern long BNC_WINAPI B_keytest(void);
DLL_DECL extern long BNC_WINAPI B_lof(int a);
DLL_DECL extern int BNC_WINAPI B_exist(Bstr a);
extern int BNC_WINAPI B_fatal(void);
DLL_DECL extern int BNC_WINAPI B_record(int nr,int satz);
DLL_DECL extern void BNC_WINAPI B_seek(int fp,long anz);  
DLL_DECL extern long BNC_WINAPI B_tellseek(int index);	//ab.. 9.6.97
DLL_DECL extern void BNC_WINAPI B_chdrive(int drive);
DLL_DECL void BNC_WINAPI B_chdir(const char* szDirName);	//ab.. 28.2.97 dazu
extern void BNC_WINAPI B_super(int a);
extern void BNC_WINAPI B_fehler(void *fp, int mode, int E_RR);
extern void BNC_WINAPI B_clip(int ofon,int x1,int y1,int x2,int y2,int ox,int oy,int mode);
extern void BNC_WINAPI B_clip_parray(HDC hdc);
extern void BNC_WINAPI B_stime(Bstr a);
extern void BNC_WINAPI B_sdate(Bstr a);
extern Bstr BNC_WINAPI B_sp_test(BSV laenge);

extern void BNC_WINAPI B_error(int fehler);
DLL_DECL extern long BNC_WINAPI B_err(void);
DLL_DECL extern long BNC_WINAPI B_erl(void);

#ifndef LIBRARY_INCLUDE
#undef	ERR
#undef	ERL
#undef	ERDEV
# define ERR			B_err()
# define ERL			B_erl()
# define ERDEV		B_erdev_nr()
#endif /* !LIBRARY_INCLUDE */

extern void BNC_WINAPI B_inline(long adr,BSV anzahl);
extern void BNC_WINAPI B_xinline(long adr, BSV anzahl,Bstr datei);
extern void BNC_WINAPI B_store(int f,void huge *_f,long anf,long ende);
extern void BNC_WINAPI B_recall(int f,void huge *_f,long anf,long ende,long huge *x);

#ifndef LIBRARY_INCLUDE
# define B_recall(f,feld,anf,ende,x)    {long p;B_recall(f,feld,anf,ende,&p), x = p;}
#endif /* LIBRARY_INCLUDE */

/* Mathe - Routinen */
extern BFstr BNC_WINAPIV B_maxc(int a, int b, ...);
extern BFstr BNC_WINAPIV B_minc(int a,int b, ...);
DLL_DECL extern double BNC_WINAPI B_atn(double a);
DLL_DECL extern double BNC_WINAPI B_sqr(double a);
DLL_DECL extern double BNC_WINAPIV B_max(int a, int b, ...);
DLL_DECL extern double BNC_WINAPIV B_min(int a,int b, ...);
DLL_DECL extern double BNC_WINAPI B_round(double x,int n);
DLL_DECL extern double BNC_WINAPI B_cvd(Bustr a);
DLL_DECL extern float BNC_WINAPI B_cvs(Bustr a);
#if 1	//ab.. 18.2.97 signed
DLL_DECL extern long BNC_WINAPI B_cvl(Bustr a);
DLL_DECL extern short BNC_WINAPI B_cvi(Bustr a);
#else
extern unsigned long BNC_WINAPI B_cvl(Bustr a);
extern unsigned short BNC_WINAPI B_cvi(Bustr a);
#endif
extern long BNC_WINAPI B_btol(Bstr s);
extern int BNC_WINAPI B_fix(double a);
DLL_DECL extern int BNC_WINAPI B_sgn(double a);
DLL_DECL extern char BNC_WINAPI B_ugl(double a,double b);
DLL_DECL extern void BNC_WINAPI B_defnum(int mode);
DLL_DECL extern void BNC_WINAPI B_exit(int mode);
DLL_DECL extern void BNC_WINAPI B_init(int mode);

/* BIT-OPERATIONEN */
#define B_Logik(a)  	(int)(!((int) (a)) ? 0 : -1)
#define B_mkLogik(a)  (-(1 && (a)))
#define B_and(x,y)  	(((long)(x) & (long)(y)))
#define B_or(x,y)   	(((long)(x) | (long)(y)))
#define B_xor(x,y)  	(((long)(x) ^ (long)(y)))
#define B_eqv(x,y)  	(~((long)(x) ^ (long)(y)))
#define B_imp(x,y)  	(~(long)(x) | (long)(y))

#define B_bclr(x,y)  ((long)(x)  & ~(1L << ((y) % 32)))
#define B_bchg(x,y)  ((long)(x)  ^  (1L << ((y) % 32)))
#define B_bset(x,y)  ((long)(x)  |  (1L << ((y) % 32)))
#define B_btst(x,y) (((long)(x)  &  (1L << ((y) % 32))) ? -1 : 0)

#define B_shl(x,y)  (long)((unsigned long)(x) << (y))
#define B_shr(x,y)  (long)((unsigned long)(x) >> (y))
#define B_shlc(x,y) (((unsigned char)(x)) << (y))
#define B_shrc(x,y) (((unsigned char)(x)) >> (y))
#define B_shli(x,y) (((unsigned short)(x)) << (y))
#define B_shri(x,y) (short)(((unsigned short)(x)) >> (y))
#define B_ror(x,y)  _lrotr(x,y)
#define B_rol(x,y)  _lrotl(x,y)
#define B_rori(x,y) _rotr(x,y)
#define B_roli(x,y) _rotl(x,y)

#define B_rorc(x,y) \
	((unsigned char)(((unsigned char)(x)>>((y)&7))|((unsigned char)(x)<<(-(y)&7))))
#define B_rolc(x,y) \
	((unsigned char)(((unsigned char)(x)<<((y)&7))|((unsigned char)(x)>>(-(y)&7))))
#define B_min2(a,b) ((a>b)?(b):(a))
#define B_max2(a,b) ((a<b)?(b):(a))
#if 0	//ab.. 28.2.97 realisiert als Funktion in chdrive.c
#define B_chdir(a)        (void) chdir(a)
#endif
#define B_log(a)          log(a)

extern BFstr BNC_WINAPI B_read_string(Bstr string,long *daz);
extern BFstr BNC_WINAPI B_findfirst(Bstr fname, int attr);
extern BFstr BNC_WINAPI B_findnext(void);
extern double BNC_WINAPI B_read_wert(long *daz);
extern long  BNC_WINAPI B_fgetdta(void);
extern long  BNC_WINAPI B_loc(int fp);
extern long  BNC_WINAPI B_relseek(int fp,long offs);
extern void  BNC_WINAPI B_fsetdta(long dta);
extern int   BNC_WINAPI B_fsfirst(Bstr pfad,int attr);
extern int   BNC_WINAPI B_fsnext(void);
extern int BNC_WINAPI file_select(Bstr path, Bstr name);
extern int BNC_WINAPI fsel_input(Bstr path, Bstr name, int huge *rueck);
extern int BNC_WINAPI fsel_exinput(Bstr path, Bstr name, int huge *rueck, Bstr ext);
extern int BNC_WINAPI form_alert(int mode, Bstr str);


#define FGETDTA      B_fgetdta
#define FSETDTA(adr) B_fsetdta(adr)
#define Fgetdta      B_fgetdta
#define Fsetdta(adr) B_fsetdta(adr)

/* Dialog-Verwaltung */
extern HWND BNC_WINAPI B_dlgitem(char dialog,int item);
extern LONG BNC_WINAPI B_dialog(Bstr dialog, BOOL (BNC_WINAPI *proc)(HWND,BNC_MSG,BNC_WPARAM,BNC_LPARAM)); 		/* Modaler Dialog */
extern LONG BNC_WINAPI B_nmdialog(Bstr dialog, BOOL (BNC_WINAPI *proc)(HWND,BNC_MSG,BNC_WPARAM,BNC_LPARAM));	/* Nichtmodaler Dialog */
extern void BNC_WINAPI B_getevent(void);
extern void BNC_WINAPI B_peekevent(void);
extern void BNC_WINAPI B_dialog_pc(char nr,int x,int y,int w,int h,char huge *text);
extern void BNC_WINAPI B_control(Bstr text,int nr,Bstr c_lass,DWORD stil,int x,int y,int w,int h);
extern void BNC_WINAPI B_checkbox(Bstr text,int nr,int x,int y,int w,int h,DWORD stil);
extern void BNC_WINAPI B_groupbox(Bstr text,int nr,int x,int y,int w,int h,DWORD stil);
extern void BNC_WINAPI B_pushbutton(Bstr text,int nr,int x,int y,int w,int h,DWORD stil);
extern void BNC_WINAPI B_defpushbutton(Bstr text,int nr,int x,int y,int w,int h,DWORD stil);
extern void BNC_WINAPI B_radiobutton(Bstr text,int nr,int x,int y,int w,int h,DWORD stil);
extern void BNC_WINAPI B_icon(Bstr text,int nr,int x,int y,int w,int h,DWORD stil);
extern void BNC_WINAPI B_listbox(Bstr text,int nr,int x,int y,int w,int h,DWORD stil);
extern void BNC_WINAPI B_edittext(Bstr text,int nr,int x,int y,int w,int h,DWORD stil);
extern void BNC_WINAPI B_combobox(Bstr text,int nr,int x,int y,int w,int h,DWORD stil);
extern void BNC_WINAPI B_scrollbar(Bstr text,int nr,int x,int y,int w,int h,DWORD stil);
extern void BNC_WINAPI B_ltext(Bstr text,int nr,int x,int y,int w,int h,DWORD stil);
extern void BNC_WINAPI B_rtext(Bstr text,int nr,int x,int y,int w,int h,DWORD stil);
extern void BNC_WINAPI B_ctext(Bstr text,int nr,int x,int y,int w,int h,DWORD stil);
extern void BNC_WINAPI B_closedialog(char nr);
extern void BNC_WINAPI B_showdialog(char nr);
extern void BNC_WINAPI B_enddialog(void);
extern void BNC_WINAPI B_dlgbase(int);

/* Diverses */
extern BFstr BNC_WINAPI B_copydeskriptor(Bstr ziel, Bstr quelle);
extern WORD BNC_WINAPI B_getnearest(int r, int g, int b);
DLL_DECL extern Bstr BNC_WINAPI B_command(void);
extern Bstr BNC_WINAPI B_ucase(Bstr);
extern Bstr BNC_WINAPI B_lcase(Bstr);
DLL_DECL extern double BNC_WINAPI B_rnd(void);
DLL_DECL extern long BNC_WINAPI B_random(long r);
DLL_DECL extern short BNC_WINAPI B_rand(int r);
extern int  BNC_WINAPI B_popup(Bstr b,int mxI,int myI,unsigned char iU);
extern int  BNC_WINAPI B_bncstr(Bstr a);
extern void BNC_WINAPI B_GetWindowText(HWND,Bstr ,BSV );
extern void BNC_WINAPI B_setfont(HWND);
extern void BNC_WINAPI rwabs(int flag,long buf,int count,int recno,int dev);
DLL_DECL extern void BNC_WINAPI B_randomize(unsigned r);
extern void BNC_WINAPI B_clipcursor(int x1, int y1, int x2, int y2);
extern void BNC_WINAPI B_initprinter(void);  /* Init Druckerzeichensatz */
extern void BNC_WINAPI B_exitprinter(void);  /* Fontstile zuruecksetzen */
extern void BNC_WINAPI B_initline(void);  /* Init LINIENstile */
extern void BNC_WINAPI B_exitline(void);  /* ...zuruecksetzen */
extern void BNC_WINAPI B_initfill(void);  /* Init FUELLstile  */
extern void BNC_WINAPI B_exitfill(void);  /* ...zuruecksetzen */
extern void BNC_WINAPI B_inittext(void);  /* Init TEXTstile   */
extern void BNC_WINAPI B_exittext(void);  /* ...zuruecksetzen */

/*****************************************************************
* Neuimplementierungen: Zugriffsfunktionen auf globale Variablen *
*****************************************************************/
/* 3.11.93 */
typedef struct linesettingstype LINESTYLE;
typedef struct fillsettingstype FILLSTYLE;
typedef struct textsettingstype TEXTSTYLE;

DLL_DECL extern FILE *BNC_WINAPI B_getfp(int k);
DLL_DECL extern FILE *BNC_WINAPI B_setfp(int k, FILE * neuer_fp);	/* sb 5.1.95: Rueckgabe alter_fp */
DLL_DECL extern HANDLE BNC_WINAPI B_win(int nr);
DLL_DECL extern HWND BNC_WINAPI B_getaktwindow(void);
DLL_DECL extern void BNC_WINAPI B_setaktwindow(HWND hwnd);
#ifdef OS2
extern VOID BNC_WINAPI B_setaktclient(HWND hwnd);
extern HWND BNC_WINAPI B_getaktclient(void);
#endif
DLL_DECL extern HINSTANCE BNC_WINAPI B_getaktinstance(void);
DLL_DECL void BNC_WINAPI B_setaktinstance(HINSTANCE hauptinstanz);
extern DWORD BNC_WINAPI B_events(int index);
extern UINT BNC_WINAPI B_exec(int mode,Bstr path,Bstr kom,Bstr env);
extern Bstr	BNC_WINAPI B_calloc(long anz, long size);
extern Bstr BNC_WINAPI B_gettemp(void);
extern BNC_DWORD BNC_WINAPI B_getgoffset(void);
extern BNC_SHORT BNC_WINAPI B_geteventflag(void);
extern BNC_SHORT BNC_WINAPI B_showmouse(void);
extern BNC_SHORT BNC_WINAPI B_hidemouse(void);
extern BNC_SHORT BNC_WINAPI B_getredraw(void);
extern BNC_BYTE	 BNC_WINAPI B_getdynstr(void);
extern BSV	BNC_WINAPI B_getdefstr(void);
extern BSV	BNC_WINAPI B_getdefmaxs(void);
extern void BNC_WINAPI B_menut(int pos, int flag, char *text); /* relevant fr GFA_PC */
extern void BNC_WINAPI B_stemp(void);
extern void BNC_WINAPI B_rtemp(void);
extern void BNC_WINAPI B_vtab(int vt);
extern void BNC_WINAPI B_htab(int ht);
extern void BNC_WINAPI B_set_onmenu(PF omfunc);
extern void BNC_WINAPI B_set_om_message(PF ommfunc);
extern void BNC_WINAPI B_set_om_key(PF omkfunc);
extern void BNC_WINAPI B_set_om_button(PF ombfunc);
extern void BNC_WINAPI B_set_om_timer(PF omtfunc);
extern void BNC_WINAPI B_set_om_m1(PF omm1func);
extern void BNC_WINAPI B_set_om_m2(PF omm2func);
extern long	BNC_WINAPI B_setzl(long neues_zl);			/* sb 5.1.95: Rueckgabe altes_zl */
extern void	BNC_WINAPI B_setcurspos(int x,int y);
extern void	BNC_WINAPI B_setli(int li_);
extern void	BNC_WINAPI B_setol(int ol);
extern void BNC_WINAPI B_ausgabe(int pos);
extern void BNC_WINAPI B_setlf(int font);						/* sb 13.2.94 */
extern void BNC_WINAPI B_setgoffset(int x,int y);
extern void BNC_WINAPI B_setEMF(int emf);           /* sb 7.5.95 */
extern void BNC_WINAPI B_seteventflag(int emf);
extern void BNC_WINAPI B_getlinestyle(LINESTYLE *lst);
extern void BNC_WINAPI B_getfillstyle(FILLSTYLE *fst);
extern void BNC_WINAPI B_gettextstyle(TEXTSTYLE *tst);
DLL_DECL extern void BNC_WINAPI B_initfeld(ULONG s_max);
DLL_DECL extern void BNC_WINAPI B_initstring(BNC_BYTE strfl,BSV bncstr,BSV maxs);
extern void BNC_WINAPI B_setfonttyp(char ffl);
extern char BNC_WINAPI B_getcpu(void);
extern void BNC_WINAPI B_setcpu(char cpu);
extern void BNC_WINAPI B_setoutput(char out);
extern void BNC_WINAPI B_setmaxprinterline(int l);
extern void BNC_WINAPI B_getlogfont(LOGFONT *l_f);
extern void BNC_WINAPI B_getlogbrush(LOGBRUSH *l_b);
extern void BNC_WINAPI B_getlogpen(LOGPEN *l_p);
extern void BNC_WINAPI B_setlogfont(LOGFONT *l_f);
extern void BNC_WINAPI B_setlogbrush(LOGBRUSH *l_b);
extern void BNC_WINAPI B_setlogpen(LOGPEN *l_p);
extern void BNC_WINAPI B_setjmpbuf(jmp_buf jmpb);		/* ++sb 8.5.94 */
extern void BNC_WINAPI B_seterrfn(void (*errorf)(void));
#ifdef OS2
// ++WW 07.12.95
extern void BNC_WINAPI B_wmessage(MRESULT (EXPENTRY *winmessage)(HWND,BNC_MSG,BNC_WPARAM,BNC_LPARAM));
#else
DLL_DECL extern void BNC_WINAPI B_wmessage(long (BNC_WINAPI *winmessage)(HWND,BNC_MSG,BNC_WPARAM,BNC_LPARAM));
#endif
extern long BNC_WINAPI B_getsp(void);
extern long BNC_WINAPI B_getakttemplen(void);
extern long BNC_WINAPI B_setsp(long sp_,Bstr p);
extern long BNC_WINAPI B_setdaz(long daz);
extern int BNC_WINAPI B_getmaxresx(void);		/* ..sb 8.5.94 */
extern int BNC_WINAPI B_getmaxresy(void);		/* ..sb 8.5.94 */
extern int BNC_WINAPI B_getmaxcolor(void); 	/* ..sb 8.5.94 */
extern int BNC_WINAPI B_windtab(int i,int j);
extern int BNC_WINAPI B_crscol(void);
extern int BNC_WINAPI B_crslin(void);
extern int BNC_WINAPI B_setob(int ob);

extern Bstr huge    * BNC_WINAPI REFHS(Bstr wert);
extern double huge  * BNC_WINAPI REFHD(double wert);
extern long huge    * BNC_WINAPI REFHL(long wert);
extern int huge     * BNC_WINAPI REFHI(int wert);
extern unsigned char huge * BNC_WINAPI REFHC(unsigned char wert);
extern Bstr   * BNC_WINAPI REFS(Bstr wert);
extern double * BNC_WINAPI REFD(double wert);
extern long   * BNC_WINAPI REFL(long wert);
extern int    * BNC_WINAPI REFI(int wert);
extern unsigned char * BNC_WINAPI REFC(unsigned char wert);

extern float huge  * BNC_WINAPI REFHF(float wert);
extern float       * BNC_WINAPI REFF(float wert);

#if BNC_RELEASE >= 20
  /* ++sb 30.4.95 */
	extern void BNC_WINAPI REFHx_stemp(void);
	extern void BNC_WINAPI REFHx_rtemp(void);
DLL_DECL 	extern Bstr BNC_WINAPI B_loadstring(long num);  // ++ov 16.6.95
DLL_DECL extern int 	BNC_WINAPI B_lock(int nr, int satz, long anfang, long ende);
DLL_DECL extern int 	BNC_WINAPI B_unlock(int nr, int satz, long anfang, long ende);
#else /* BNC_RELEASE < 20 */
	extern int 	BNC_WINAPI B_lock(int nr, int satz, long anfang, long ende);
	extern int 	BNC_WINAPI B_unlock(int nr, int satz, long anfang, long ende);
#endif /* BNC_RELEASE >= 20 */

/* Behandlung pseudolokaler Variablen */
extern BFstr BNC_WINAPI B_cpy(Bstr dest,Bstr src);

/* Stringrueckgabe bei Referenzstrings */
#if BNC_RELEASE >= 19
  /* ..OV.9.2.95 */
# define B_rps_str_ref(ueb,merk_global,global)	\
    if(merk_global != NULL) 									  \
      { 																			  \
        ueb = B_strcpy(ueb,global); 					  \
        global = B_strcpy(global,merk_global);  \
      }
#else /* BNC_RELEASE < 19 */
# define B_rps_str_ref(a,b,c)                  \
    ((a) = ((b) == &(a))                        \
      ? (a),B_cpy((a),(c))                      \
      : (*(b)=B_cpy(*(b),(a)),B_cpy((a),(c))))
#endif /* BNC_RELEASE >= 19 */
/* Stringrueckgabe bei Value-strings */
#define B_rps_str_val(a,b)  	(a) = B_cpy((a),(b))

/* Wertrueckgabe */
#define B_rps(a,b,c)  				((a) = ((b) == &(a)) ? (a) : (*(b) = (a),(c)))
#define B_datapointer(dat)		((dat == -1)? DAZ :(DAZ = dat))

/*******************************************
* Neue Funktionen  ++OV. 13.9.94 in CVDI.C *
*******************************************/
/* bearbeiten auch INTEL/Motorola-Format */
extern double BNC_WINAPI B_double(long a);
extern long   BNC_WINAPI B_long(long a);
extern int    BNC_WINAPI B_int(long a);
extern void   BNC_WINAPI B_setint(long a, int i);
extern void   BNC_WINAPI B_setlong(long a, long l);
extern void   BNC_WINAPI B_setdouble(long a, double d);

/* -------------------------------------------------------------------------- */
/* -------------------------  Basicabhaengiger Teil ------------------------- */
/* -------------------------------------------------------------------------- */
/***********************************
 *      BUSINESS-BASIC             *
 ***********************************/
#if defined(BUSINESS_BASIC)
	#undef B_kill
#else /* !BUSINESS_BASIC */
	extern void  BNC_WINAPI B_clear(void);
	extern BFstr BNC_WINAPI B_spc(BSV a);
	DLL_DECL extern int   BNC_WINAPI B_open(char *mode,int nr,Bstr pfad,int anz);
	DLL_DECL extern int   BNC_WINAPI B_close(int nr);
#endif /* BUSINESS_BASIC */

/***********************************
 *            GFA-BASIC            *
 ***********************************/
#if defined(GFA_PC) || defined(GFA_ST)
#endif /* GFA_PC || GFA_ST */

#if defined(GFA_PC)
#else /* !GFA_PC */
	extern long BNC_WINAPIV gemdos(long a,...);
	extern int  BNC_WINAPI 	bios(int a, int b);
	extern int  BNC_WINAPIV xbios(int a, ...);
	extern void BNC_WINAPI 	Bconout(int a,int b);
#endif /* GFA_PC */

/***********************************
 *            QBASIC               *
 ***********************************/
#if defined(QBASIC)
DLL_DECL	extern BFstr 	BNC_WINAPI B_command( void );

/*ab.. 4.2.97 dpath, curdir, name, kill fuer Thalesplus nicht hier exportieren, sondern ueber BSTR_TP.CPP*/
extern BFstr BNC_WINAPI  B_dpath(Bstr a);
extern Bstr	 BNC_WINAPIV B_curdir(Bstr lw, ...);	/* ab.. 29.2.96 curdir aufgenommen */
extern void  BNC_WINAPI  B_name(const char* szOldName, const char* szNewName);	//ab.. 28.2.97 dazu
extern void  BNC_WINAPI  B_kill(const char* szFileName);	//ab.. 28.2.97 dazu

			extern Bstr 	BNC_WINAPI B_tc(const char *member, int memberlen);
DLL_DECL	extern void *	BNC_WINAPI B_ssegadd(Bstr BNCString);
DLL_DECL	extern void  	BNC_WINAPI B_beep(void);
			extern void 	BNC_WINAPI B_menu_rc(Bstr NameRc);
#if BNC_RELEASE >= 20
  /*
   * ++sb 1.5.95
   */
# define BNC_SETPRGSTATUS  1
# define BNC_GETPRGSTATUS  2
# define BNC_CHAINPRG      1
# define BNC_CHAINDLL      2
# define BNC_SETJMPBUF     1
# define BNC_GETJMPBUF     2
DLL_DECL extern HINSTANCE  BNC_WINAPI B_setdllinstance(HINSTANCE hinst); // ++WW 21.06.95
DLL_DECL extern HINSTANCE  BNC_WINAPI B_getdllinstance(void);            // ++WW 21.06.95
DLL_DECL extern int        BNC_WINAPI B_prgstatus(int aktion, int neuer_status);
DLL_DECL extern jmp_buf *  BNC_WINAPI B_dlljmpbuf(int action, jmp_buf *neuer_jb);
DLL_DECL extern void 	    BNC_WINAPI B_chain(Bstr commandstring, void huge *common_vars_ptr);
#else /* BNC_RELEASE < 20 */
	extern void 	BNC_WINAPI B_chain(Bstr commandstring);
#endif /* BNC_RELEASE >= 20 */
DLL_DECL extern void 	BNC_WINAPI B_sleep(long d);
DLL_DECL extern void 	BNC_WINAPI B_clsqb(int);
DLL_DECL extern void 	BNC_WINAPI B_width(int,int);
DLL_DECL extern void 	BNC_WINAPI B_screen(int,int,int,int);
	extern void 	BNC_WINAPI B_run(Bstr);
DLL_DECL extern unsigned int BNC_WINAPI B_sadd(Bstr BNCString);
DLL_DECL extern unsigned int BNC_WINAPI B_sseg(Bstr BNCString);
DLL_DECL extern unsigned int BNC_WINAPI B_varseg(void *BNCString);
DLL_DECL extern int 		BNC_WINAPI B_shell(Bstr commandstring);
	extern int 		BNC_WINAPI B_ubound(void huge *f, int index);
	extern int 		BNC_WINAPI B_lbound(void huge *f, int index);
	extern long 	BNC_WINAPI B_erdev_nr(void);
	extern Bstr 	BNC_WINAPI B_erdev(void);

DLL_DECL extern int BNC_WINAPI B_freefile(void);

DLL_DECL extern int BNC_WINAPI B_getk(int, long, int, void huge *);
DLL_DECL extern int BNC_WINAPI B_putk(int, long, int, void huge *);

	/* ++CT200296	Einfuegen der fehlenden Protortypen fuer B_varptr u. B_strlwr */
DLL_DECL extern unsigned int BNC_WINAPI B_varptr(void *BNCString);
	extern BFstr 		BNC_WINAPI B_strlwr(Bstr str);
#else /* !QBASIC */
	extern BFstr  	BNC_WINAPI B_dpath(int a);
	extern int  	BNC_WINAPI B_getk(int nr, int satz);
	extern int  	BNC_WINAPI B_putk(int nr, int satz);
	extern void 	BNC_WINAPI B_pause(long a);
	#define B_delay(a) 	B_pause(50*(a))

#if BNC_RELEASE >= 20
# pragma message("sb 16.4.95: B_chain fuer !QBASIC und BNC_RELEASE >= 20 nicht implementiert")
#else /* BNC_RELEASE < 20 */
# define B_chain(a)  WinExec(a,SW_SHOW)
#endif /* BNC_RELEASE >= 20 */

#endif /* QBASIC */


/*********************************************
 *            CBASIC       ab..1.4.97        *
 *********************************************/
#ifdef CBASIC
# include <cbasic.h>



#endif


#ifdef BNC_GOSUB /* ++OV.24.1.96 */
extern jmp_buf Bgosubstack[];
extern int Bstackindex;
DLL_DECL extern void BNC_WINAPI B_stackfehler(void);
#endif

extern void BNC_WINAPI B_init_refhx_stack(void);

#if BNC_RELEASE >= 21
/* 6) ..CT040696		Neue Funktionen fuer die Statischen Strings in Typen */
	/* Statischen String auf Stack werfen */
extern Bstr huge * BNC_WINAPI B_push_statictypestring(char huge * pStaticStr, size_t StaticStrSize);
	/* Abfragen des Top of Stack */
extern Bstr BNC_WINAPI B_gettop_statictypestring(void);

/* Letzten statischen String von Stack holen */
extern void BNC_WINAPI B_pop_statictypestring(void);

/* Static-Type-String Stack freigeben */
extern void BNC_WINAPI B_free_statictypestring_stack(void);
#if 0
/* 7) ..CT040696		Neue Funktion zur Freigabe des REFHx()-Stacks */
extern int BNC_WINAPI B_ref_free(long FreeCnt);
#endif
/* 8) ..CT040696		Neue Funktion B_dynamic() zur Verwaltung von qausi-statischen
*						und dynamischen Arrays.
*/
extern void BNC_WINAPI B_dynamic(void);

/* 9) ..CT040696		Interne Variable zur Versionserkennung */
extern int B_programm_version;	/* s.h. B_init() INIT.C */

#endif /* BNC_RELEASE >= 21 */


/* END OF FILE */
