#ifndef THALESPLUS_INCL
# define THALESPLUS_INCL

// ************* Definitionen fuer ARAMISPL ***************************
#define	WINDOWS
#define	WINDOWS_NT
#define	QBASIC

	// Definitionen fuer Homer
    //dllimport fuer ARAMISPL -Lib
#define	B_UDLL							
#define	B_CPP_CONTRACT
#define	THALESPLUS
	// Definitionen fuer ARAMISkonvertat
#define	BNC_GOSUB 100
	//Definitionen fuer CVD
#ifndef WIN32
# define	WIN32
#endif

    // auch bei 32 Bit soll int 2 Byte sein wegen Kompatibilitaet zu Basic
#define INT2BYTE   
//******************************** Ende Definitionen *******************

// Funktionen, die im Homer deaktiviert werden; benutzt werden ARAMISfunktionen
#define B_sqr	Homer_sqr
#define B_fix	Homer_fix
#define B_int	Homer_int

#include <stdhomer.h>

#undef B_sqr	
#undef B_fix	
#undef B_int	

extern"C" {
#include <b_nach_c.h>
}
#include <math.h>	

#define BI_TSTR_HPP_EINBINDEN
#include <Bc_tstr.hpp>
#include <Bc_tarr.hpp>
#include <error_pl.hpp>
#include <bstr_tp.hpp>
#include <cp_th_fu.hpp>

#ifdef PROJEKT_97
# include <cbc_fio.hpp>
#endif

	// Umstellung auf int als 2 Byte-Wort
#undef B_Int
#define B_Int	B_Shrt

// Bibliotheksfunktionen, realisiert durch Wrapper-Funktionen
#define B_trim				B_trimS
#define B_rtrim				B_rTrimS
#define B_ltrim				B_lTrimS
#define B_strupr			B_uCaseS
#define B_strlwr			B_lCaseS

#define B_left(a,b)			B_leftS(a,(B_Lng)b)
#define B_right(a,b)		B_rightS(a,(B_Lng)b)
#define B_mid(a,b,c)		B_midS(a,(B_Lng)b,(B_Lng)c)
#define B_instr(a,b,c)		B_inStr(b,c,(B_Lng)a,(B_UChar)0)

// Bibliotheksfunktionen, realisiert durch Konstruktor-Aufrufe
#define B_space(a)			B_String(' ', a)
#define B_string(a,b)		B_String(*((b).value), (a))


// Bibliotheksfunktionen, realisiert durch Methoden
#define B_strlen(a)			(a).len()
#define B_strptr(a)			(a).value
#define B_ubound(a,b)		(a).uBound(b)
#define B_lbound(a,b)		(a).lBound(b)
#define B_erase(a)			(a).erase()

// Bibliotheksfunktionen, realisiert durch cpp-Funktionen
#define B_fxscanf			B_fxscanf_cpp
#define B_fprintf			B_fprintf_cpp

	// Sonstige



// Referenzerzeugungsklasse/-methode
#define		REFHI(a)	B_Ref<B_Int>(a).gR()
#define		REFHL(a)	B_Ref<B_Lng>(a).gR()
#define		REFHF(a)	B_Ref<B_Flt>(a).gR()
#define		REFHD(a)	B_Ref<B_Dbl>(a).gR()


//Erzeugung von B_Strings aus Literalstrings per Konstruktor
#define BS(literalstring) B_String(literalstring, B_explicit)
//Erzeugung von Fixstrings des Typs B_String im Unterschied zu B_TStrings
#define FS(fixstring, zeichenzahl)	fixstring(zeichenzahl, B_fixed)

    //8.4.97 Umstellung auf int als 2 Byte-Wort
#ifdef INT2BYTE	
# define B_varptr(Adresse)	(B_Int)(LOWORD((DWORD) &Adresse))
# define B_varseg(Adresse)	(B_Int)(HIWORD((DWORD) &Adresse))

# define B_sadd(String)		(B_Int)(LOWORD((DWORD)String.value))
# define B_sseg(String)		(B_Int)(HIWORD((DWORD)String.value))
#else
# define B_varptr(a)		REFHI((int)&(a))
# define B_varseg(a)		REFHI((int)&(a))

# define B_sseg(a)		(B_Int)(a.value)
# define B_sadd(a)		(B_Int)(a.value)
#endif


#define B_ssegadd(String)	(B_Lng)(String.value)

#define B_swap(a,b)		B_swap((void*)&(a), sizeof(a), (void*)&(b), sizeof(b))
#define B_dslset(a,b)	B_dslset((void*)&(a), sizeof(a), (void*)&(b), sizeof(b))
#define B_lset(a,b)		B_lSet(a,b)
#define B_rset(a,b)		B_rSet(a,b)


/*	Funktionen der ARAMIS Lib, die primaer keine Stringfunktionen 
	darstellen, aber Bstr zurueckliefern und daher gekapselt werden.
	Kapselfunktionen stehen in bstr_tp.cpp
*/
#define B_mki			B_mkiS
#define B_mkl			B_mklS
#define B_mks			B_mksS
#define B_mkd			B_mkdS

#define B_itoab			B_itoabS
#define B_utoab			B_utoabS
#define B_ltoab			B_ltoabS
#define B_lutoab		B_lutoabS
#define B_ftoab			B_ftoabS

#define B_hex			B_hexS
#define B_oct			B_octS
#define B_bin			B_binS
#define B_chr			B_chrS
#define B_date			B_dateS
#define B_time			B_timeS


/*	Problem: Uebergabe eines B_TStrings an B_String&	
	Loesung ueber  Anlegen einer temporaren Kopie mit Referenzrueckgabe
	Implementierung in cp_th_fu.cpp
*/
#undef	BNC_STAT_STR
#undef	BNC_STAT_RET

#define BNC_STAT_STR		B_Push_B_TString

/*	Freigabe des zu LETZT gepufferten Strings
*/
#define BNC_STAT_RET(a)	{a=B_Gettop_B_TString(); B_Pop_B_TString();}


	//Allgemeiner Konstruktor fuer User-Types
#define INIT_TYP(a)		memset((void*)((a)), 0, sizeof(*a))

#endif  //THALESPLUS_INCL