#ifndef BC_CURR_HPP
# define BC_CURR_HPP

# ifdef THALESPLUS	//ab.. 20.3.97 wird bei Thalesplus nicht benoetigt

  class B_Currency;	//es erfolgt lediglich eine Deklaration

#  ifndef BC_EXCPT_HPP
#   include "bc_excpt.hpp"
#  endif 

# else	//Original-Teil

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Project:                 VB nach C/C++ Konverter Klassenbibliothek
// Modul:                   VB Klasse fuer VB Currency Datentyp
// Filename:                bc_curr.hpp
// Version:                 1.0
// Status:                  beta
//
// Copyright:               Copyright (C) 1995
//                          Cicerosoft GmbH, 
//                          Ballweilerstr. 7,
//                          66399 Erfweiler-Ehlingen
//
// Operating System(s):     Win95
// Compiler:                VC++ 4.1
//
// Author:                  Jochen Diener JD
// Creation Date:           20.12.95
// Last Modification:       JD 04.07.96
//
// Description:             Beinhaltet alle Klassen / Hilfsfkt. die im Zusammenhang mit der VB 
//                          Konvertierung, fuer die Bereitstellung des Datentyps Currency benoetigt 
//                          werden. 
//                          
// Dependencies:            bc_curr.cpp    ->  Implementierung der Member/Hilfsfkt.
//                          bi_curr.hpp    ->  Inlinefkt. der Klasse
//
// Remarks:                 Die Beschreibung zu den Klassenmethoden werden so kurz als moeglich
//                          gehalten um die Uebersichtlichkeit zu erhoehen, Eine genauere Beschreibung
//                          laesst sich ggf. in den VB Handbuechern finden
//
// Revision(s):   
//                          
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

//================================= Defintionsabhaengigkeiten ===============================================
//
#include <iostream.h>
#include <oaidl.h> // wegen Currency

#ifndef BD_LIB_HPP
  #include "bd_lib.hpp"
#endif

#ifndef BD_INTYP_HPP       
  #include "bd_intyp.hpp"  
#endif

#ifndef BC_EXCPT_HPP
  #include "bc_excpt.hpp"
#endif 

#ifndef BC_BOOL_HPP
  #include "bc_bool.hpp"   
#endif

#ifndef BC_NULL_HPP
  #include "bc_null.hpp"   
#endif

#ifndef BC_EMPTY_HPP
  #include "bc_empty.hpp"  
#endif

#ifndef BC_BYTE_HPP
  #include "bc_byte.hpp"
#endif

#ifndef BC_INT_HPP
  #include "bc_int.hpp"
#endif

#ifndef BC_LONG_HPP
  #include "bc_long.hpp"
#endif

#ifndef BC_SNGLE_HPP
  #include "bc_sngle.hpp"
#endif

#ifndef BC_DBL_HPP
  #include "bc_dbl.hpp"
#endif

class B_String;
class B_fstream;						// CT131296 Fuer FileIO abgeleitete fstream-Klasse

//================================= Export =================================================================
//

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Description:                                                                           (C) CiceroSoft 1995
//     B_Currency    Emuliert VB-Datentyp Currency
// Hierachy:    
// Inheritance: 
// Errorhandling:
// Note: 
//     fuer alle Operatoren und Funktione die einen B_Sinlge, B_Double, B_Float, B_Dbl Datentyp
//     als Parameter erlauben gilt: Wenn der Wertebereich des Parameters den von Currency uebersteigt 
//     erfolgt ein Laufzeitfehler(6) Ueberlauf in VB.
//     Fliesskomawerte werden auf die 4 Nachkommastellen gerundet.
class DLL_DECL B_Currency
  {
  //==================== MANGAEMENT =========================================================================
  //
  public: 
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     ctor
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Currency(); // Standardkonstruktor initialisiert Integer in VB auf 0

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     ctor's fuer Bibliotheksdatentypen
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Currency(const B_String&); // throw (B_TypeMismatch, B_Overflow);
#ifdef B_VB_COMPATIBLE
    B_Currency(const B_Double&); // throw (B_Overflow);
    B_Currency(const B_Single&); // throw (B_Overflow);
    B_Currency(const B_Long&);
    B_Currency(const B_Integer&);
    B_Currency(const B_Byte&);
#endif
    B_Currency(const B_Boolean&);
    B_Currency(const B_Empty&); 
    B_Currency(const B_Null&);   // throw (B_InvalidNull);
    
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     ctor's fuer C-Standarddatentypen
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Currency(B_cCStr,      const B_Explicit&); // throw (B_TypeMismatch, B_Overflow);
    B_Currency(const B_Dbl,  const B_Explicit&); // throw (B_Overflow);
    B_Currency(const B_Flt,  const B_Explicit&); // throw (B_Overflow);
    B_Currency(const B_Lng,  const B_Explicit&); 
    B_Currency(const B_UInt, const B_Explicit&); 
    B_Currency(const B_Int,  const B_Explicit&);   

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     ctor's fuer OLE-Datentypen
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //     auf einen Konstruktor fuer den CURRENCY Datentpy wurde verzichtet da VARIANT ausreicht
    //     und keine Perfomranceverlsute entstehen
    B_Currency(const CURRENCY);

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     cctor
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Currency(const B_Currency&);

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     dtor
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    ~B_Currency();
    
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Zuweisungsop.
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Currency& operator=(const B_Currency&);

  //==================== INTERFACE ============================================================================
  //
  public:
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Zuweisungsop. fuer Bibliotheksdatentypen
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Currency& operator=(const B_String&)  throw(B_TypeMismatch, B_Overflow);   
#ifdef B_VB_COMPATIBLE    
    B_Currency& operator=(const B_Double&)  throw(B_Overflow);
    B_Currency& operator=(const B_Single&)  throw(B_Overflow);
    B_Currency& operator=(const B_Long&);
    B_Currency& operator=(const B_Integer&);    
    B_Currency& operator=(const B_Byte&);
#endif
    B_Currency& operator=(const B_Boolean&);  
    B_Currency& operator=(const B_Empty&);  
    B_Currency& operator=(const B_Null&)  throw(B_InvalidNull);   

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Zuweisungsop. fuer C-Standarddatentypen
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Currency& operator=(B_cCStr)      throw(B_TypeMismatch, B_Overflow);   
    B_Currency& operator=(const B_Int);   
    B_Currency& operator=(const B_UInt);   
    B_Currency& operator=(const B_Lng);
    B_Currency& operator=(const B_Flt)  throw(B_Overflow);
    B_Currency& operator=(const B_Dbl)  throw(B_Overflow); 

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Zuweisungsop. fuer OLE-Datentyp
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Currency& operator=(const CURRENCY);

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Addition des Wertes selbst mit einem anderen Wert. Entspricht x = x + y
    // Parameter:  
    //     Wert der hinzuaddiert werden soll (Entspricht y)
    // Return Value:
    //     Das Ergebnis der Addition
    // Errorhandling:
    // Note:      
    //
    B_Currency& operator+=(const B_Currency&) throw(B_Overflow);
#ifdef B_VB_COMPATIBLE
    B_Currency& operator+=(const B_Double&)   throw(B_Overflow);
    B_Currency& operator+=(const B_Single&)   throw(B_Overflow);
    B_Currency& operator+=(const B_Long&)     throw(B_Overflow);
    B_Currency& operator+=(const B_Integer&)  throw(B_Overflow);
    B_Currency& operator+=(const B_Byte&)     throw(B_Overflow);
#endif
    B_Currency& operator+=(const B_Boolean&)  throw(B_Overflow);
    B_Currency& operator+=(const B_Empty&);
    B_Currency& operator+=(const B_Null&)     throw(B_InvalidNull);
    B_Currency& operator+=(const B_Dbl)       throw(B_Overflow);

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Subtraktion des Wertes selbst mit einem anderen Wert. Entspricht x = x - y
    // Parameter:  
    //     Wert der subtrahiert werden soll (Entspricht y)
    // Return Value:
    //     Das Ergebnis der Subtraktion
    // Errorhandling:
    // Note:      
    //
    B_Currency& operator-=(const B_Currency&) throw(B_Overflow);
#ifdef B_VB_COMPATIBLE
    B_Currency& operator-=(const B_Double&)   throw(B_Overflow);
    B_Currency& operator-=(const B_Single&)   throw(B_Overflow);
    B_Currency& operator-=(const B_Long&)     throw(B_Overflow);
    B_Currency& operator-=(const B_Integer&)  throw(B_Overflow);
    B_Currency& operator-=(const B_Byte&)     throw(B_Overflow);
#endif    
    B_Currency& operator-=(const B_Boolean&)  throw(B_Overflow);
    B_Currency& operator-=(const B_Empty&);
    B_Currency& operator-=(const B_Null&)     throw(B_InvalidNull);
    B_Currency& operator-=(const B_Dbl)       throw(B_Overflow);

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Multiplikation des Wertes selbst mit einem anderen Wert. Entspricht x = x * y
    // Parameter:  
    //     Wert der multipliziert werden soll (Entspricht y)
    // Return Value:
    //     Das Ergebnis der Multiplikation
    // Errorhandling:
    // Note:      
    //
    B_Currency& operator*=(const B_Currency&) throw(B_Overflow);
#ifdef B_VB_COMPATIBLE
    B_Currency& operator*=(const B_Double&)   throw(B_Overflow);    
    B_Currency& operator*=(const B_Single&)   throw(B_Overflow);
    B_Currency& operator*=(const B_Long&)     throw(B_Overflow);
    B_Currency& operator*=(const B_Integer&)  throw(B_Overflow);
    B_Currency& operator*=(const B_Byte&)     throw(B_Overflow);
#endif
    B_Currency& operator*=(const B_Boolean&);
    B_Currency& operator*=(const B_Empty&);
    B_Currency& operator*=(const B_Null&)     throw(B_InvalidNull);
    B_Currency& operator*=(const B_Dbl)       throw(B_Overflow);

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Division des Wertes selbst mit einem anderen Wert. Entspricht x = x / y
    // Parameter:  
    //     Wert der dividiert werden soll (Entspricht y)
    // Return Value:
    //     Das Ergebnis der Division
    // Errorhandling:
    // Note:      
    //     Normalerweise ist der Rueckgabewert einer Division von zwei Currency-Werten Double.
    //     Damit dieser operator korrekt eingesetzt werden kann wird B_Currency zurueckgegeben
    //     und somit auch hier auf 4 Stellen gerundet !! Da das Ergebnis nicht in einem Ausdruck
    //     weiterverwendet wird sollte dies normalerweise zu keinen Problemen fuehren.
    B_Currency& operator/=(const B_Currency&) throw(B_ZeroDivide);
#ifdef B_VB_COMPATIBLE
    B_Currency& operator/=(const B_Double&)   throw(B_ZeroDivide);
    B_Currency& operator/=(const B_Single&)   throw(B_ZeroDivide);
    B_Currency& operator/=(const B_Long&)     throw(B_ZeroDivide);    
    B_Currency& operator/=(const B_Integer&)  throw(B_ZeroDivide);
    B_Currency& operator/=(const B_Byte&)     throw(B_ZeroDivide);
#endif
    B_Currency& operator/=(const B_Boolean&)  throw(B_ZeroDivide);
    B_Currency& operator/=(const B_Empty&)    throw(B_ZeroDivide);
    B_Currency& operator/=(const B_Null&)     throw(B_InvalidNull);
    B_Currency& operator/=(const B_Dbl)       throw(B_ZeroDivide);

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Division des Wertes selbst mit einem anderen Wert. Entspricht x = x / y
    // Parameter:  
    //     Wert der dividiert werden soll (Entspricht y)
    // Return Value:
    //     Das Ergebnis der Division
    // Errorhandling:
    // Note:      
    //     Normalerweise ist der Rueckgabewert einer Division von zwei Currency-Werten Double.
    //     Damit dieser operator korrekt eingesetzt werden kann wird B_Currency zurueckgegeben
    //     und somit auch hier auf 4 Stellen gerundet !! Da das Ergebnis nicht in einem Ausdruck
    //     weiterverwendet wird sollte dies normalerweise zu keinen Problemen fuehren.
    B_Currency& operator%=(const B_Currency&) throw(B_ZeroDivide);
#ifdef B_VB_COMPATIBLE
    B_Currency& operator%=(const B_Double&)   throw(B_ZeroDivide);
    B_Currency& operator%=(const B_Single&)   throw(B_ZeroDivide);
    B_Currency& operator%=(const B_Long&)     throw(B_ZeroDivide);    
    B_Currency& operator%=(const B_Integer&)  throw(B_ZeroDivide);
    B_Currency& operator%=(const B_Byte&)     throw(B_ZeroDivide);
#endif
    B_Currency& operator%=(const B_Boolean&)  throw(B_ZeroDivide);
    B_Currency& operator%=(const B_Empty&)    throw(B_ZeroDivide);
    B_Currency& operator%=(const B_Null&)     throw(B_InvalidNull);
    B_Currency& operator%=(const B_Dbl)       throw(B_ZeroDivide);

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     operator!   Nicht-Operator
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
#ifdef B_VB_COMPATIBLE
    B_Long operator!() const throw(B_Overflow, B_Underflow);
#else
    B_Lng operator!() const throw(B_Overflow, B_Underflow);
#endif

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Konvertierungsop. fuer C-Standarddatentyp
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    operator B_Dbl() const;

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Konvertierungsop. fuer OLE-Datentyp
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    operator const CURRENCY();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //      Konvertiert das Objekt in seinen ganzzahligen Anteil.  Bei negativen Zahlen 
    //      konvertiert Int das Objekt in diejenige negative ganze Zahl, die kleiner oder 
    //      gleich dem Objektwert ist. 
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //     Die Methoden geben B_Single zurueck die Funktionen (B_int()) aus Kompatibilitaet zu VB korrekterweise B_Double    
    //     ACHTUNG an alle C++ Programmierer int ist nicht vergleichbar mit den mathe Bibliotheksfkt. floor/ceil von C/C++.
    //     int( 2.8)  = floor(2.8)   -> 2
    //     int(-2.8)  = floor(-2.8)  -> -3
    //     Die Funktion ist aus Kompatibilitaetsgruenden zu VB enthalten
    B_Currency& intf();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Konvertiert das Objekt in seinen ganzzahligen Anteil.  Bei negativen Zahlen 
    //     konvertiert Fix das Objekt in diejenige negative ganze Zahl, die groesser oder 
    //     gleich dem Objektwert ist. 
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //     Die Methoden geben B_Single zurueck die Funktionen aus Kompatibilitaet zu VB korrekterweise B_Double
    //     ACHTUNG an alle C++ Programmierer int ist nicht vergleichbar mit den mathe  Bibliotheksfkt. floor/ceil von C/C++.
    //     fix( 2.8)  = floor(2.8)   ->  2
    //     fix(-2.8)  = ceil(-2.8)   -> -2
    //     Fix(Zahl) entspricht also in C/C++ dem folgenden Ausdruck: Sgn(Zahl) * Int(Abs(Zahl))
    B_Currency& fix();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Konvertiert das Objekt in seine Fractional=Nachkomma Darstellung. D.h dass der 
    //     Vorkommaanteil der Zahl abgeschnitten (zu 0 gestzt) wird.
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //     123.45678 -> 0.45678
    //     Die Funktion dient zur Ergaenzung der int und fix Funktionennt(Abs(Zahl))
    B_Currency& fract();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Konvertiert das Objekt in seine groesste Integerdarstellung die kleiner oder
    //     gleich ist als der akt. Wert des Objektes.
    //     floor(2.8)  ->  2
    //     floor(-2.8) -> -3   
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Currency& floor();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Konvertiert das Objekt in seine kleinste Integerdarstellung die groesser oder
    //     gleich ist als der akt. Wert des Objektes.
    //     ceil(2.8)  ->  3
    //     ceil(-2.8) -> -2   
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Currency& ceil();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Wandelt den Wert des Objektes in einen Absoluten Wert um, d.h 
    //     negativer Objektwert -> positiv
    //     positiver Objektwert -> bleibt positiv
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Currency& abs();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Gibt den Wert des Objektes als entsprechenden C/C++ Datentyp zurueck
    // Parameter:  
    // Return Value:
    //     Kopie des Objetkwertes als B_Lng
    // Errorhandling:
    // Note:      
    //     Den genauen Typ von B_Flt kann man in bd_intyp.hpp feststellen, in der alle C/C++ Datentypen definiert sind.
    //     Diese Funktion soll den Datenaustausch zwischen Klassen der Klassenbibliothek
    //     und den mit den C++ Standarddatentypen geschriebenen Funktionen ermoeglichen
    //     wenn diese keine Klassen als Parameter erlauben.
    B_Dbl getValue() const;

    //----------------------------------------------------------------------------------------------------       
    // Method:
    //     Gibt die Groesse des Wert des Objektes als entsprechenden C/C++ Datentyp zurueck
    // Return Value:
    //     Groesse in Byte
    // Note:
    //     Den genauen Typ und somit seine groesse koennen zwischen den C/C++ Datentypen der
    //     Compiler unterschiedlich sein, deshalb wurde diese Method eingefuegt die eine
    //     portable Programmierung aehnlich sizeof() ermoeglichen soll.
    B_ULng  getValueSize() const;  
    
    //----------------------------------------------------------------------------------------------------       
    // Method: 
    //     Gibt die Groesse des Objktes zurueck, diese entspricht der durch das Objekt belegten
    //     Speicherplatz
    // Return Value: 
    //     Groesse in Byte
    // Note: 
    //     Den genauen Typ und somit seine groesse koennen zwischen den C/C++ Compiler 
    //     unterschiedlich sein. Auch koennte sich die Klassenimplementierung aendern so
    //     dass aeltere Programme nur mit Aenderungsprogramm lauffaehig waeren, deshalb 
    //     wurde diese Method eingefuegt die eine portable Programmierung aehnlich 
    //     sizeof() ermoeglichen soll.
    B_ULng getSize() const;       

    //----------------------------------------------------------------------------------------------------       
    // Method:
    //     Unaeres Minus
    // Parameter:  
    // Return Value: 
    // Note:      
    // 
    B_Currency operator-() const;

    //----------------------------------------------------------------------------------------------------       
    // Method:
    //     Praefix  Inkrement/Dekrement
    // Parameter:  
    // Return Value: 
    // Note:      
    // 
    B_Currency& operator++() throw(B_Overflow);
    B_Currency& operator--() throw(B_Underflow);

    //----------------------------------------------------------------------------------------------------       
    // Method: 
    //     Setzt den internen Status des Objektes auf optional. Somit kann mit isMissing der Status
    //     abgefragt werden und die Emulation des gleichnamigen VB Befehls wird moeglich.
    // Return Value: 
    // Note: 
    //
    B_Currency& isOptional();

    //----------------------------------------------------------------------------------------------------       
    // Method: 
    //     Abfragen des internen Objektstatus ob das Argument einer Funktion optional ist oder nicht
    // Return Value: 
    // Note: 
    //
    B_Boolean isMissing() const;

    //----------------------------------------------------------------------------------------------------       
    // Method: 
    //     Schreiben der der eigentlichen Objektdaten im binaeren Format in einen Stream
    // Return Value: 
    //     B_true  ==  Objekt und Stream sind gueltig
    //     B_false ==  Objekt oder Stream sind ungueltig
    // Note: 
    //
    B_Boolean streamw(ostream& ostr, B_Shrt opnemode) const;

    //----------------------------------------------------------------------------------------------------       
    // Method: 
    //     Lesen der der eigentlichen Objektdaten im binaeren Format in einen Stream
    // Return Value: 
    //     B_true  ==  Objekt und Stream sind gueltig
    //     B_false ==  Objekt oder Stream sind ungueltig
    // Note: 
    //
    B_Boolean streamr(istream& istr, B_Shrt opnemode);

	//----------------------------------------------------------------------------------------------------       
    // Method: operator<<	INSERTION
    //     Schreiben der eigentlichen Objektdaten im Textformat in einen Stream
    // Return Value: 
    //	   Instanz der abgeleiten fstream-Klasse der Datei
    // Note: 
	//	   CT131296
	//	   ersetzt die alte Methode streamp()
    //
	friend B_fstream& operator<< (B_fstream& ostr, B_Currency& rhs);

	//----------------------------------------------------------------------------------------------------       
    // Method: operator>>	EXTRACTION
    //     Lesen der eigentlichen Objektdaten im Textformat aus einem Stream
    // Return Value: 
    //	   Instanz der abgeleiten fstream-Klasse der Datei
    // Note: 
	//	   CT131296
	//	   ersetzt die alte Methode streamg()
    //
	friend B_fstream& operator>> (B_fstream& istr, B_Currency& rhs);

  private:
    //----------------------------------------------------------------------------------------------------       
    // Method:
    //     Postfix   Inkrement/Dekrement
    // Parameter:  
    // Return Value: 
    // Note:      
    //     Da es beim ueberladen keinen wirkliche Postfixoperatoren gibt wurden diese gesperrt
    B_Currency& operator++(int);
    B_Currency& operator--(int);
    
  //==================== MEMBER ===============================================================================    
  //
  private:
    B_Dbl value;   // in VB sind Variablen vom Datentyp Currency werden intern als 64-Bit-Zahlen (8 Bytes)
                   // in einem ganzzahligen Format dargestellt und durch 10.000 dividiert, was eine 
                   // Festkommazahl mit 15 Vorkomma- und 4 Nachkommastellen ergibt. 
                   // Diese Darstellung ergibt einen Wertebereich von 
                   // -922.337.203.685.477,5808 bis 922.337.203.685.477,5807
                   // Bei uns ist der Datentyp als Double implementiert
                   // ACHTUNG: wie auch schon beim Single/Float Datentyp koennen sich je nach Compiler die 
                   //          Wertebereiche der Datentypen unterscheiden.
    B_Flag optional;

  //==================== FRIENDS ============================================================================
  //
  friend class B_Byte;
  friend class B_Integer;
  friend class B_Long;
  friend class B_Single;
  friend class B_Double;
  friend class B_String;

  friend DLL_DECL B_Currency operator+ (const B_Currency&, const B_Currency&);
#ifdef B_VB_COMPATIBLE
  friend DLL_DECL B_Currency operator+ (const B_Double&,   const B_Currency&); 
  friend DLL_DECL B_Currency operator+ (const B_Currency&, const B_Double&);
  friend DLL_DECL B_Currency operator+ (const B_Single&,   const B_Currency&); 
  friend DLL_DECL B_Currency operator+ (const B_Currency&, const B_Single&);
  friend DLL_DECL B_Currency operator+ (const B_Long&,     const B_Currency&); 
  friend DLL_DECL B_Currency operator+ (const B_Currency&, const B_Long&);
  friend DLL_DECL B_Currency operator+ (const B_Integer&,  const B_Currency&);
  friend DLL_DECL B_Currency operator+ (const B_Currency&, const B_Integer&);
  friend DLL_DECL B_Currency operator+ (const B_Byte&,     const B_Currency&);
  friend DLL_DECL B_Currency operator+ (const B_Currency&, const B_Byte&);
#endif // B_VB_COMPATIBLE
  friend DLL_DECL B_Currency operator+ (const B_Boolean&,  const B_Currency&);
  friend DLL_DECL B_Currency operator+ (const B_Currency&, const B_Boolean&);
  friend DLL_DECL B_Currency operator+ (const B_Dbl,       const B_Currency&); 
  friend DLL_DECL B_Currency operator+ (const B_Currency&, const B_Dbl);
  friend DLL_DECL B_Currency operator+ (const B_Flt,       const B_Currency&); 
  friend DLL_DECL B_Currency operator+ (const B_Currency&, const B_Flt);
  friend DLL_DECL B_Currency operator+ (const B_Lng,       const B_Currency&); 
  friend DLL_DECL B_Currency operator+ (const B_Currency&, const B_Lng);
  friend DLL_DECL B_Currency operator+ (const B_Int,       const B_Currency&);
  friend DLL_DECL B_Currency operator+ (const B_Currency&, const B_Int);

  friend DLL_DECL B_Currency operator- (const B_Currency&,   const B_Currency&);
#ifdef B_VB_COMPATIBLE
  friend DLL_DECL B_Currency operator- (const B_Double&,     const B_Currency&); 
  friend DLL_DECL B_Currency operator- (const B_Currency&,   const B_Double&);
  friend DLL_DECL B_Currency operator- (const B_Single&,     const B_Currency&); 
  friend DLL_DECL B_Currency operator- (const B_Currency&,   const B_Single&);
  friend DLL_DECL B_Currency operator- (const B_Long&,       const B_Currency&); 
  friend DLL_DECL B_Currency operator- (const B_Currency&,   const B_Long&);
  friend DLL_DECL B_Currency operator- (const B_Integer&,    const B_Currency&);
  friend DLL_DECL B_Currency operator- (const B_Currency&,   const B_Integer&);
  friend DLL_DECL B_Currency operator- (const B_Byte&,       const B_Currency&);
  friend DLL_DECL B_Currency operator- (const B_Currency&,   const B_Byte&);
#endif // B_VB_COMPATIBLE
  friend DLL_DECL B_Currency operator- (const B_Boolean&,    const B_Currency&);
  friend DLL_DECL B_Currency operator- (const B_Currency&,   const B_Boolean&);
  friend DLL_DECL B_Currency operator- (const B_Empty&,      const B_Currency&);
  friend DLL_DECL B_Currency operator- (const B_Currency&,   const B_Empty&);
  friend DLL_DECL B_Currency operator- (const B_Dbl,       const B_Currency&); 
  friend DLL_DECL B_Currency operator- (const B_Currency&, const B_Dbl);
  friend DLL_DECL B_Currency operator- (const B_Flt,       const B_Currency&); 
  friend DLL_DECL B_Currency operator- (const B_Currency&, const B_Flt);
  friend DLL_DECL B_Currency operator- (const B_Lng,       const B_Currency&); 
  friend DLL_DECL B_Currency operator- (const B_Currency&, const B_Lng);
  friend DLL_DECL B_Currency operator- (const B_Int,       const B_Currency&);
  friend DLL_DECL B_Currency operator- (const B_Currency&, const B_Int);

  friend DLL_DECL B_Currency operator* (const B_Currency&, const B_Currency&);
#ifdef B_VB_COMPATIBLE
  friend DLL_DECL B_Currency operator* (const B_Double&,   const B_Currency&); 
  friend DLL_DECL B_Currency operator* (const B_Currency&, const B_Double&);
  friend DLL_DECL B_Currency operator* (const B_Single&,   const B_Currency&); 
  friend DLL_DECL B_Currency operator* (const B_Currency&, const B_Single&);
  friend DLL_DECL B_Currency operator* (const B_Long&,     const B_Currency&); 
  friend DLL_DECL B_Currency operator* (const B_Currency&, const B_Long&);
  friend DLL_DECL B_Currency operator* (const B_Integer&,  const B_Currency&);
  friend DLL_DECL B_Currency operator* (const B_Currency&, const B_Integer&);
  friend DLL_DECL B_Currency operator* (const B_Byte&,     const B_Currency&);
  friend DLL_DECL B_Currency operator* (const B_Currency&, const B_Byte&);
#endif // B_VB_COMPATIBLE
  friend DLL_DECL B_Currency operator* (const B_Boolean&,  const B_Currency&);
  friend DLL_DECL B_Currency operator* (const B_Currency&, const B_Boolean&);
  friend DLL_DECL B_Currency operator* (const B_Dbl,       const B_Currency&); 
  friend DLL_DECL B_Currency operator* (const B_Currency&, const B_Dbl);
  friend DLL_DECL B_Currency operator* (const B_Flt,       const B_Currency&); 
  friend DLL_DECL B_Currency operator* (const B_Currency&, const B_Flt);
  friend DLL_DECL B_Currency operator* (const B_Lng,       const B_Currency&); 
  friend DLL_DECL B_Currency operator* (const B_Currency&, const B_Lng);
  friend DLL_DECL B_Currency operator* (const B_Int,       const B_Currency&);
  friend DLL_DECL B_Currency operator* (const B_Currency&, const B_Int);


#ifdef B_VB_COMPATIBLE
  friend DLL_DECL B_Double  operator/ (const B_Currency&,   const B_Currency&);
  friend DLL_DECL B_Double  operator/ (const B_Double&,     const B_Currency&); 
  friend DLL_DECL B_Double  operator/ (const B_Currency&,   const B_Double&);
  friend DLL_DECL B_Double  operator/ (const B_Single&,     const B_Currency&); 
  friend DLL_DECL B_Double  operator/ (const B_Currency&,   const B_Single&);
  friend DLL_DECL B_Double  operator/ (const B_Long&,       const B_Currency&); 
  friend DLL_DECL B_Double  operator/ (const B_Currency&,   const B_Long&);
  friend DLL_DECL B_Double  operator/ (const B_Integer&,    const B_Currency&);
  friend DLL_DECL B_Double  operator/ (const B_Currency&,   const B_Integer&);
  friend DLL_DECL B_Double  operator/ (const B_Byte&,       const B_Currency&);
  friend DLL_DECL B_Double  operator/ (const B_Currency&,   const B_Byte&);
  friend DLL_DECL B_Double  operator/ (const B_Boolean&,    const B_Currency&);
  friend DLL_DECL B_Double  operator/ (const B_Currency&,   const B_Boolean&);
  friend DLL_DECL B_Double  operator/ (const B_Empty&,      const B_Currency&);
  friend DLL_DECL B_Double  operator/ (const B_Dbl,       const B_Currency&); 
  friend DLL_DECL B_Double  operator/ (const B_Currency&, const B_Dbl);
  friend DLL_DECL B_Double  operator/ (const B_Flt,       const B_Currency&); 
  friend DLL_DECL B_Double  operator/ (const B_Currency&, const B_Flt);
  friend DLL_DECL B_Double  operator/ (const B_Lng,       const B_Currency&); 
  friend DLL_DECL B_Double  operator/ (const B_Currency&, const B_Lng);
  friend DLL_DECL B_Double  operator/ (const B_Int,       const B_Currency&);
  friend DLL_DECL B_Double  operator/ (const B_Currency&, const B_Int);
#else
  friend DLL_DECL B_Dbl  operator/ (const B_Currency&,   const B_Currency&);
  friend DLL_DECL B_Dbl  operator/ (const B_Boolean&,    const B_Currency&);
  friend DLL_DECL B_Dbl  operator/ (const B_Currency&,   const B_Boolean&);
  friend DLL_DECL B_Dbl  operator/ (const B_Empty&,      const B_Currency&);
  friend DLL_DECL B_Dbl  operator/ (const B_Dbl,       const B_Currency&); 
  friend DLL_DECL B_Dbl  operator/ (const B_Currency&, const B_Dbl);
  friend DLL_DECL B_Dbl  operator/ (const B_Flt,       const B_Currency&); 
  friend DLL_DECL B_Dbl  operator/ (const B_Currency&, const B_Flt);
  friend DLL_DECL B_Dbl  operator/ (const B_Lng,       const B_Currency&); 
  friend DLL_DECL B_Dbl  operator/ (const B_Currency&, const B_Lng);
  friend DLL_DECL B_Dbl  operator/ (const B_Int,       const B_Currency&);
  friend DLL_DECL B_Dbl  operator/ (const B_Currency&, const B_Int);
#endif // B_VB_COMPATIBLE  

  
#ifdef B_VB_COMPATIBLE
	friend DLL_DECL B_Long  operator% (const B_Currency&,  const B_Currency&);
  friend DLL_DECL B_Long  operator% (const B_Double&,    const B_Currency&);
  friend DLL_DECL B_Long  operator% (const B_Currency&,  const B_Double&);
  friend DLL_DECL B_Long  operator% (const B_Single&,    const B_Currency&);
  friend DLL_DECL B_Long  operator% (const B_Currency&,  const B_Single&);
  friend DLL_DECL B_Long  operator% (const B_Long&,      const B_Currency&);
  friend DLL_DECL B_Long  operator% (const B_Currency&,  const B_Long&);
  friend DLL_DECL B_Long  operator% (const B_Integer&,   const B_Currency&);
  friend DLL_DECL B_Long  operator% (const B_Currency&,  const B_Integer&);
  friend DLL_DECL B_Long  operator% (const B_Byte&,      const B_Currency&);
  friend DLL_DECL B_Long  operator% (const B_Currency&,  const B_Byte&);
  friend DLL_DECL B_Long  operator% (const B_Boolean&,   const B_Currency&);
  friend DLL_DECL B_Long  operator% (const B_Currency&,  const B_Boolean&);
  friend DLL_DECL B_Long  operator% (const B_Empty&,     const B_Currency&);
  friend DLL_DECL B_Long  operator% (const B_Currency&,  const B_Empty&);
  friend DLL_DECL B_Long  operator% (const B_Dbl,        const B_Currency&); 
  friend DLL_DECL B_Long  operator% (const B_Currency&,  const B_Dbl);
  friend DLL_DECL B_Long  operator% (const B_Flt,        const B_Currency&); 
  friend DLL_DECL B_Long  operator% (const B_Currency&,  const B_Flt);
  friend DLL_DECL B_Long  operator% (const B_Lng,        const B_Currency&); 
  friend DLL_DECL B_Long  operator% (const B_Currency&,  const B_Lng);
  friend DLL_DECL B_Long  operator% (const B_Int,        const B_Currency&);
  friend DLL_DECL B_Long  operator% (const B_Currency&,  const B_Int);
#else
	friend DLL_DECL B_Lng  operator% (const B_Currency&,  const B_Currency&);
  friend DLL_DECL B_Lng  operator% (const B_Boolean&,   const B_Currency&);
  friend DLL_DECL B_Lng  operator% (const B_Currency&,  const B_Boolean&);
  friend DLL_DECL B_Lng  operator% (const B_Empty&,     const B_Currency&);
  friend DLL_DECL B_Lng  operator% (const B_Currency&,  const B_Empty&);
  friend DLL_DECL B_Lng  operator% (const B_Dbl,        const B_Currency&); 
  friend DLL_DECL B_Lng  operator% (const B_Currency&,  const B_Dbl);
  friend DLL_DECL B_Lng  operator% (const B_Flt,        const B_Currency&); 
  friend DLL_DECL B_Lng  operator% (const B_Currency&,  const B_Flt);
  friend DLL_DECL B_Lng  operator% (const B_Lng,        const B_Currency&); 
  friend DLL_DECL B_Lng  operator% (const B_Currency&,  const B_Lng);
  friend DLL_DECL B_Lng  operator% (const B_Int,        const B_Currency&);
  friend DLL_DECL B_Lng  operator% (const B_Currency&,  const B_Int);
#endif // B_VB_COMPATIBLE

#ifdef B_VB_COMPATIBLE
	friend DLL_DECL B_Long B_Div(const B_Currency&, const B_Currency&);
  friend DLL_DECL B_Long B_Div(const B_Double&,   const B_Currency&);
  friend DLL_DECL B_Long B_Div(const B_Currency&, const B_Double&);
  friend DLL_DECL B_Long B_Div(const B_Single&,   const B_Currency&);
  friend DLL_DECL B_Long B_Div(const B_Currency&, const B_Single&);
  friend DLL_DECL B_Long B_Div(const B_Long&,     const B_Currency&);
  friend DLL_DECL B_Long B_Div(const B_Currency&, const B_Long&);
  friend DLL_DECL B_Long B_Div(const B_Integer&,  const B_Currency&);
  friend DLL_DECL B_Long B_Div(const B_Currency&, const B_Integer&);
  friend DLL_DECL B_Long B_Div(const B_Byte&,     const B_Currency&);
  friend DLL_DECL B_Long B_Div(const B_Currency&, const B_Byte&);
  friend DLL_DECL B_Long B_Div(const B_Boolean&,  const B_Currency&);
  friend DLL_DECL B_Long B_Div(const B_Currency&, const B_Boolean&);
  friend DLL_DECL B_Long B_Div(const B_Empty&,    const B_Currency&);
  friend DLL_DECL B_Long B_Div(const B_Currency&, const B_Empty&);
  friend DLL_DECL B_Long B_Div(const B_Dbl,       const B_Currency&); 
  friend DLL_DECL B_Long B_Div(const B_Currency&, const B_Dbl);
  friend DLL_DECL B_Long B_Div(const B_Flt,       const B_Currency&); 
  friend DLL_DECL B_Long B_Div(const B_Currency&, const B_Flt);
  friend DLL_DECL B_Long B_Div(const B_Lng,       const B_Currency&); 
  friend DLL_DECL B_Long B_Div(const B_Currency&, const B_Lng);
  friend DLL_DECL B_Long B_Div(const B_Int,       const B_Currency&);
  friend DLL_DECL B_Long B_Div(const B_Currency&, const B_Int);
#else
  friend DLL_DECL B_Lng B_Div(const B_Currency&, const B_Currency&);
  friend DLL_DECL B_Lng B_Div(const B_Boolean&,  const B_Currency&);
  friend DLL_DECL B_Lng B_Div(const B_Currency&, const B_Boolean&);
  friend DLL_DECL B_Lng B_Div(const B_Empty&,    const B_Currency&);
  friend DLL_DECL B_Lng B_Div(const B_Currency&, const B_Empty&);
  friend DLL_DECL B_Lng B_Div(const B_Dbl,       const B_Currency&); 
  friend DLL_DECL B_Lng B_Div(const B_Currency&, const B_Dbl);
  friend DLL_DECL B_Lng B_Div(const B_Flt,       const B_Currency&); 
  friend DLL_DECL B_Lng B_Div(const B_Currency&, const B_Flt);
  friend DLL_DECL B_Lng B_Div(const B_Lng,       const B_Currency&); 
  friend DLL_DECL B_Lng B_Div(const B_Currency&, const B_Lng);
  friend DLL_DECL B_Lng B_Div(const B_Int,       const B_Currency&);
  friend DLL_DECL B_Lng B_Div(const B_Currency&, const B_Int);
#endif // B_VB_COMPATIBLE

  
#ifdef B_VB_COMPATIBLE
  friend DLL_DECL B_Double B_Pow(const B_Currency&,   const B_Currency&);
  friend DLL_DECL B_Double B_Pow(const B_Double&,     const B_Currency&);
  friend DLL_DECL B_Double B_Pow(const B_Currency&,   const B_Double&);
  friend DLL_DECL B_Double B_Pow(const B_Single&,     const B_Currency&);
  friend DLL_DECL B_Double B_Pow(const B_Currency&,   const B_Single&);
  friend DLL_DECL B_Double B_Pow(const B_Long&,       const B_Currency&);
  friend DLL_DECL B_Double B_Pow(const B_Currency&,   const B_Long&);
  friend DLL_DECL B_Double B_Pow(const B_Integer&,    const B_Currency&);
  friend DLL_DECL B_Double B_Pow(const B_Currency&,   const B_Integer&);
  friend DLL_DECL B_Double B_Pow(const B_Byte&,       const B_Currency&);
  friend DLL_DECL B_Double B_Pow(const B_Currency&,   const B_Byte&);
  friend DLL_DECL B_Double B_Pow(const B_Boolean&,    const B_Currency&);
  friend DLL_DECL B_Double B_Pow(const B_Currency&,   const B_Boolean&);
  friend DLL_DECL B_Double B_Pow(const B_Empty&,      const B_Currency&); 
  friend DLL_DECL B_Double B_Pow(const B_Currency&,   const B_Empty&);   
  friend DLL_DECL B_Double B_Pow(const B_Dbl,       const B_Currency&); 
  friend DLL_DECL B_Double B_Pow(const B_Currency&, const B_Dbl);
  friend DLL_DECL B_Double B_Pow(const B_Flt,       const B_Currency&); 
  friend DLL_DECL B_Double B_Pow(const B_Currency&, const B_Flt);
  friend DLL_DECL B_Double B_Pow(const B_Lng,       const B_Currency&); 
  friend DLL_DECL B_Double B_Pow(const B_Currency&, const B_Lng);
  friend DLL_DECL B_Double B_Pow(const B_Int,       const B_Currency&);
  friend DLL_DECL B_Double B_Pow(const B_Currency&, const B_Int);
#else
  friend DLL_DECL B_Dbl B_Pow(const B_Currency&,   const B_Currency&);
  friend DLL_DECL B_Dbl B_Pow(const B_Boolean&,    const B_Currency&);
  friend DLL_DECL B_Dbl B_Pow(const B_Currency&,   const B_Boolean&);
  friend DLL_DECL B_Dbl B_Pow(const B_Empty&,      const B_Currency&); 
  friend DLL_DECL B_Dbl B_Pow(const B_Currency&,   const B_Empty&);   
  friend DLL_DECL B_Dbl B_Pow(const B_Dbl,       const B_Currency&); 
  friend DLL_DECL B_Dbl B_Pow(const B_Currency&, const B_Dbl);
  friend DLL_DECL B_Dbl B_Pow(const B_Flt,       const B_Currency&); 
  friend DLL_DECL B_Dbl B_Pow(const B_Currency&, const B_Flt);
  friend DLL_DECL B_Dbl B_Pow(const B_Lng,       const B_Currency&); 
  friend DLL_DECL B_Dbl B_Pow(const B_Currency&, const B_Lng);
  friend DLL_DECL B_Dbl B_Pow(const B_Int,       const B_Currency&);
  friend DLL_DECL B_Dbl B_Pow(const B_Currency&, const B_Int);
#endif // B_VB_COMPATIBLE

#ifdef B_VB_COMPATIBLE
  friend DLL_DECL B_Long operator&& (const B_Currency&,  const B_Currency&);
  friend DLL_DECL B_Long operator&& (const B_Double&,    const B_Currency&);
  friend DLL_DECL B_Long operator&& (const B_Currency&,  const B_Double&);
  friend DLL_DECL B_Long operator&& (const B_Single&,    const B_Currency&);
  friend DLL_DECL B_Long operator&& (const B_Currency&,  const B_Single&);
  friend DLL_DECL B_Long operator&& (const B_Long&,      const B_Currency&);
  friend DLL_DECL B_Long operator&& (const B_Currency&,  const B_Long&);
  friend DLL_DECL B_Long operator&& (const B_Integer&,   const B_Currency&);
  friend DLL_DECL B_Long operator&& (const B_Currency&,  const B_Integer&);
  friend DLL_DECL B_Long operator&& (const B_Byte&,      const B_Currency&);
  friend DLL_DECL B_Long operator&& (const B_Currency&,  const B_Byte&);
  friend DLL_DECL B_Long operator&& (const B_Boolean&,   const B_Currency&);
  friend DLL_DECL B_Long operator&& (const B_Currency&,  const B_Boolean&);
  friend DLL_DECL B_Long operator&& (const B_Empty&,     const B_Currency&);
  friend DLL_DECL B_Long operator&& (const B_Currency&,  const B_Empty&); 
  friend DLL_DECL B_Long operator&& (const B_Dbl,       const B_Currency&); 
  friend DLL_DECL B_Long operator&& (const B_Currency&, const B_Dbl);
  friend DLL_DECL B_Long operator&& (const B_Flt,       const B_Currency&); 
  friend DLL_DECL B_Long operator&& (const B_Currency&, const B_Flt);
  friend DLL_DECL B_Long operator&& (const B_Lng,       const B_Currency&); 
  friend DLL_DECL B_Long operator&& (const B_Currency&, const B_Lng);
  friend DLL_DECL B_Long operator&& (const B_Int,       const B_Currency&);
  friend DLL_DECL B_Long operator&& (const B_Currency&, const B_Int);
#else
  friend DLL_DECL B_Lng operator&& (const B_Currency&,  const B_Currency&);
  friend DLL_DECL B_Lng operator&& (const B_Boolean&,   const B_Currency&);
  friend DLL_DECL B_Lng operator&& (const B_Currency&,  const B_Boolean&);
  friend DLL_DECL B_Lng operator&& (const B_Empty&,     const B_Currency&);
  friend DLL_DECL B_Lng operator&& (const B_Currency&,  const B_Empty&); 
  friend DLL_DECL B_Lng operator&& (const B_Dbl,       const B_Currency&); 
  friend DLL_DECL B_Lng operator&& (const B_Currency&, const B_Dbl);
  friend DLL_DECL B_Lng operator&& (const B_Flt,       const B_Currency&); 
  friend DLL_DECL B_Lng operator&& (const B_Currency&, const B_Flt);
  friend DLL_DECL B_Lng operator&& (const B_Lng,       const B_Currency&); 
  friend DLL_DECL B_Lng operator&& (const B_Currency&, const B_Lng);
  friend DLL_DECL B_Lng operator&& (const B_Int,       const B_Currency&);
  friend DLL_DECL B_Lng operator&& (const B_Currency&, const B_Int);
#endif // B_VB_COMPATIBLE
  friend DLL_DECL B_Null operator&& (const B_Null&,      const B_Currency&);
  friend DLL_DECL B_Null operator&& (const B_Currency&,  const B_Null&); 

#ifdef B_VB_COMPATIBLE
  friend DLL_DECL B_Long operator|| (const B_Currency&,  const B_Currency&);
  friend DLL_DECL B_Long operator|| (const B_Double&,    const B_Currency&);
  friend DLL_DECL B_Long operator|| (const B_Currency&,  const B_Double&);
  friend DLL_DECL B_Long operator|| (const B_Single&,    const B_Currency&);
  friend DLL_DECL B_Long operator|| (const B_Currency&,  const B_Single&);
  friend DLL_DECL B_Long operator|| (const B_Long&,      const B_Currency&);
  friend DLL_DECL B_Long operator|| (const B_Currency&,  const B_Long&);
  friend DLL_DECL B_Long operator|| (const B_Integer&,   const B_Currency&);
  friend DLL_DECL B_Long operator|| (const B_Currency&,  const B_Integer&);
  friend DLL_DECL B_Long operator|| (const B_Byte&,      const B_Currency&);
  friend DLL_DECL B_Long operator|| (const B_Currency&,  const B_Byte&);
  friend DLL_DECL B_Long operator|| (const B_Boolean&,   const B_Currency&);
  friend DLL_DECL B_Long operator|| (const B_Currency&,  const B_Boolean&);
  friend DLL_DECL B_Long operator|| (const B_Empty&,     const B_Currency&);
  friend DLL_DECL B_Long operator|| (const B_Currency&,  const B_Empty&);
  friend DLL_DECL B_Long operator|| (const B_Null&,      const B_Currency&);
  friend DLL_DECL B_Long operator|| (const B_Currency&,  const B_Null&);
  friend DLL_DECL B_Long operator|| (const B_Dbl,       const B_Currency&); 
  friend DLL_DECL B_Long operator|| (const B_Currency&, const B_Dbl);
  friend DLL_DECL B_Long operator|| (const B_Flt,       const B_Currency&); 
  friend DLL_DECL B_Long operator|| (const B_Currency&, const B_Flt);
  friend DLL_DECL B_Long operator|| (const B_Lng,       const B_Currency&); 
  friend DLL_DECL B_Long operator|| (const B_Currency&, const B_Lng);
  friend DLL_DECL B_Long operator|| (const B_Int,       const B_Currency&);
  friend DLL_DECL B_Long operator|| (const B_Currency&, const B_Int);
#else
  friend DLL_DECL B_Lng operator|| (const B_Currency&,  const B_Currency&);
  friend DLL_DECL B_Lng operator|| (const B_Boolean&,   const B_Currency&);
  friend DLL_DECL B_Lng operator|| (const B_Currency&,  const B_Boolean&);
  friend DLL_DECL B_Lng operator|| (const B_Empty&,     const B_Currency&);
  friend DLL_DECL B_Lng operator|| (const B_Currency&,  const B_Empty&);
  friend DLL_DECL B_Lng operator|| (const B_Null&,      const B_Currency&);
  friend DLL_DECL B_Lng operator|| (const B_Currency&,  const B_Null&);
  friend DLL_DECL B_Lng operator|| (const B_Dbl,       const B_Currency&); 
  friend DLL_DECL B_Lng operator|| (const B_Currency&, const B_Dbl);
  friend DLL_DECL B_Lng operator|| (const B_Flt,       const B_Currency&); 
  friend DLL_DECL B_Lng operator|| (const B_Currency&, const B_Flt);
  friend DLL_DECL B_Lng operator|| (const B_Lng,       const B_Currency&); 
  friend DLL_DECL B_Lng operator|| (const B_Currency&, const B_Lng);
  friend DLL_DECL B_Lng operator|| (const B_Int,       const B_Currency&);
  friend DLL_DECL B_Lng operator|| (const B_Currency&, const B_Int);
#endif // B_VB_COMPATIBLE


#ifdef B_VB_COMPATIBLE
  friend DLL_DECL B_Long operator^ (const B_Currency&, const B_Currency&);
  friend DLL_DECL B_Long operator^ (const B_Double&,   const B_Currency&);
  friend DLL_DECL B_Long operator^ (const B_Currency&, const B_Double&);
  friend DLL_DECL B_Long operator^ (const B_Single&,   const B_Currency&);
  friend DLL_DECL B_Long operator^ (const B_Currency&, const B_Single&);
  friend DLL_DECL B_Long operator^ (const B_Long&,     const B_Currency&);
  friend DLL_DECL B_Long operator^ (const B_Currency&, const B_Long&);
  friend DLL_DECL B_Long operator^ (const B_Integer&,  const B_Currency&);
  friend DLL_DECL B_Long operator^ (const B_Currency&, const B_Integer&);
  friend DLL_DECL B_Long operator^ (const B_Byte&,     const B_Currency&);
  friend DLL_DECL B_Long operator^ (const B_Currency&, const B_Byte&);
  friend DLL_DECL B_Long operator^ (const B_Boolean&,  const B_Currency&);
  friend DLL_DECL B_Long operator^ (const B_Currency&, const B_Boolean&); 
  friend DLL_DECL B_Long operator^ (const B_Empty&,    const B_Currency&);
  friend DLL_DECL B_Long operator^ (const B_Currency&, const B_Empty&); 
  friend DLL_DECL B_Long operator^ (const B_Dbl,       const B_Currency&); 
  friend DLL_DECL B_Long operator^ (const B_Currency&, const B_Dbl);
  friend DLL_DECL B_Long operator^ (const B_Flt,       const B_Currency&); 
  friend DLL_DECL B_Long operator^ (const B_Currency&, const B_Flt);
  friend DLL_DECL B_Long operator^ (const B_Lng,       const B_Currency&); 
  friend DLL_DECL B_Long operator^ (const B_Currency&, const B_Lng);
  friend DLL_DECL B_Long operator^ (const B_Int,       const B_Currency&);
  friend DLL_DECL B_Long operator^ (const B_Currency&, const B_Int);
#else
  friend DLL_DECL B_Lng operator^ (const B_Currency&, const B_Currency&);
  friend DLL_DECL B_Lng operator^ (const B_Boolean&,  const B_Currency&);
  friend DLL_DECL B_Lng operator^ (const B_Currency&, const B_Boolean&); 
  friend DLL_DECL B_Lng operator^ (const B_Empty&,    const B_Currency&);
  friend DLL_DECL B_Lng operator^ (const B_Currency&, const B_Empty&); 
  friend DLL_DECL B_Lng operator^ (const B_Dbl,       const B_Currency&); 
  friend DLL_DECL B_Lng operator^ (const B_Currency&, const B_Dbl);
  friend DLL_DECL B_Lng operator^ (const B_Flt,       const B_Currency&); 
  friend DLL_DECL B_Lng operator^ (const B_Currency&, const B_Flt);
  friend DLL_DECL B_Lng operator^ (const B_Lng,       const B_Currency&); 
  friend DLL_DECL B_Lng operator^ (const B_Currency&, const B_Lng);
  friend DLL_DECL B_Lng operator^ (const B_Int,       const B_Currency&);
  friend DLL_DECL B_Lng operator^ (const B_Currency&, const B_Int);
#endif // B_VB_COMPATIBLE
  friend DLL_DECL B_Null operator^ (const B_Null&,     const B_Currency&);
  friend DLL_DECL B_Null operator^ (const B_Currency&, const B_Null&); 

  friend DLL_DECL B_Boolean operator== (const B_Currency&, const B_Currency&);
#ifdef B_VB_COMPATIBLE
  friend DLL_DECL B_Boolean operator== (const B_Double&,   const B_Currency&);
  friend DLL_DECL B_Boolean operator== (const B_Currency&, const B_Double&);
  friend DLL_DECL B_Boolean operator== (const B_Single&,   const B_Currency&);
  friend DLL_DECL B_Boolean operator== (const B_Currency&, const B_Single&);
  friend DLL_DECL B_Boolean operator== (const B_Long&,     const B_Currency&);
  friend DLL_DECL B_Boolean operator== (const B_Currency&, const B_Long&);
  friend DLL_DECL B_Boolean operator== (const B_Integer&,  const B_Currency&);
  friend DLL_DECL B_Boolean operator== (const B_Currency&, const B_Integer&);
  friend DLL_DECL B_Boolean operator== (const B_Byte&,     const B_Currency&);
  friend DLL_DECL B_Boolean operator== (const B_Currency&, const B_Byte&);
#endif // B_VB_COMPATIBLE
  friend DLL_DECL B_Boolean operator== (const B_Empty&,    const B_Currency&); 
  friend DLL_DECL B_Boolean operator== (const B_Currency&, const B_Empty&);  
  friend DLL_DECL B_Boolean operator== (const B_Boolean&,  const B_Currency&);
  friend DLL_DECL B_Boolean operator== (const B_Currency&, const B_Boolean&);
  friend DLL_DECL B_Boolean operator== (const B_Dbl,       const B_Currency&); 
  friend DLL_DECL B_Boolean operator== (const B_Currency&, const B_Dbl);
  friend DLL_DECL B_Boolean operator== (const B_Flt,       const B_Currency&); 
  friend DLL_DECL B_Boolean operator== (const B_Currency&, const B_Flt);
  friend DLL_DECL B_Boolean operator== (const B_Lng,       const B_Currency&); 
  friend DLL_DECL B_Boolean operator== (const B_Currency&, const B_Lng);
  friend DLL_DECL B_Boolean operator== (const B_Int,       const B_Currency&);
  friend DLL_DECL B_Boolean operator== (const B_Currency&, const B_Int);


  friend DLL_DECL B_Boolean operator!= (const B_Currency&,   const B_Currency&);
#ifdef B_VB_COMPATIBLE
  friend DLL_DECL B_Boolean operator!= (const B_Double&,     const B_Currency&);
  friend DLL_DECL B_Boolean operator!= (const B_Currency&,   const B_Double&);
  friend DLL_DECL B_Boolean operator!= (const B_Single&,     const B_Currency&);
  friend DLL_DECL B_Boolean operator!= (const B_Currency&,   const B_Single&);
  friend DLL_DECL B_Boolean operator!= (const B_Long&,       const B_Currency&);
  friend DLL_DECL B_Boolean operator!= (const B_Currency&,   const B_Long&);
  friend DLL_DECL B_Boolean operator!= (const B_Integer&,    const B_Currency&);
  friend DLL_DECL B_Boolean operator!= (const B_Currency&,   const B_Integer&);
  friend DLL_DECL B_Boolean operator!= (const B_Byte&,       const B_Currency&);
  friend DLL_DECL B_Boolean operator!= (const B_Currency&,   const B_Byte&);
#endif // B_VB_COMPATIBLE
  friend DLL_DECL B_Boolean operator!= (const B_Empty&,      const B_Currency&); 
  friend DLL_DECL B_Boolean operator!= (const B_Currency&,   const B_Empty&);  
  friend DLL_DECL B_Boolean operator!= (const B_Boolean&,    const B_Currency&);
  friend DLL_DECL B_Boolean operator!= (const B_Currency&,   const B_Boolean&);
  friend DLL_DECL B_Boolean operator!= (const B_Dbl,       const B_Currency&); 
  friend DLL_DECL B_Boolean operator!= (const B_Currency&, const B_Dbl);
  friend DLL_DECL B_Boolean operator!= (const B_Flt,       const B_Currency&); 
  friend DLL_DECL B_Boolean operator!= (const B_Currency&, const B_Flt);
  friend DLL_DECL B_Boolean operator!= (const B_Lng,       const B_Currency&); 
  friend DLL_DECL B_Boolean operator!= (const B_Currency&, const B_Lng);
  friend DLL_DECL B_Boolean operator!= (const B_Int,       const B_Currency&);
  friend DLL_DECL B_Boolean operator!= (const B_Currency&, const B_Int);

  friend DLL_DECL B_Boolean operator< (const B_Currency&,   const B_Currency&);
#ifdef B_VB_COMPATIBLE
  friend DLL_DECL B_Boolean operator< (const B_Double&,     const B_Currency&);
  friend DLL_DECL B_Boolean operator< (const B_Currency&,   const B_Double&);
  friend DLL_DECL B_Boolean operator< (const B_Single&,     const B_Currency&);
  friend DLL_DECL B_Boolean operator< (const B_Currency&,   const B_Single&);
  friend DLL_DECL B_Boolean operator< (const B_Long&,       const B_Currency&);
  friend DLL_DECL B_Boolean operator< (const B_Currency&,   const B_Long&);
  friend DLL_DECL B_Boolean operator< (const B_Integer&,    const B_Currency&);
  friend DLL_DECL B_Boolean operator< (const B_Currency&,   const B_Integer&);
  friend DLL_DECL B_Boolean operator< (const B_Byte&,       const B_Currency&);
  friend DLL_DECL B_Boolean operator< (const B_Currency&,   const B_Byte&);
#endif // B_VB_COMPATIBLE
  friend DLL_DECL B_Boolean operator< (const B_Empty&,      const B_Currency&); 
  friend DLL_DECL B_Boolean operator< (const B_Currency&,   const B_Empty&);  
  friend DLL_DECL B_Boolean operator< (const B_Boolean&,    const B_Currency&);
  friend DLL_DECL B_Boolean operator< (const B_Currency&,   const B_Boolean&);
  friend DLL_DECL B_Boolean operator< (const B_Dbl,       const B_Currency&); 
  friend DLL_DECL B_Boolean operator< (const B_Currency&, const B_Dbl);
  friend DLL_DECL B_Boolean operator< (const B_Flt,       const B_Currency&); 
  friend DLL_DECL B_Boolean operator< (const B_Currency&, const B_Flt);
  friend DLL_DECL B_Boolean operator< (const B_Lng,       const B_Currency&); 
  friend DLL_DECL B_Boolean operator< (const B_Currency&, const B_Lng);
  friend DLL_DECL B_Boolean operator< (const B_Int,       const B_Currency&);
  friend DLL_DECL B_Boolean operator< (const B_Currency&, const B_Int);

  friend DLL_DECL B_Boolean operator<= (const B_Currency&,   const B_Currency&);
#ifdef B_VB_COMPATIBLE
  friend DLL_DECL B_Boolean operator<= (const B_Double&,     const B_Currency&);
  friend DLL_DECL B_Boolean operator<= (const B_Currency&,   const B_Double&);
  friend DLL_DECL B_Boolean operator<= (const B_Single&,     const B_Currency&);
  friend DLL_DECL B_Boolean operator<= (const B_Currency&,   const B_Single&);
  friend DLL_DECL B_Boolean operator<= (const B_Long&,       const B_Currency&);
  friend DLL_DECL B_Boolean operator<= (const B_Currency&,   const B_Long&);
  friend DLL_DECL B_Boolean operator<= (const B_Integer&,    const B_Currency&);
  friend DLL_DECL B_Boolean operator<= (const B_Currency&,   const B_Integer&);
  friend DLL_DECL B_Boolean operator<= (const B_Byte&,       const B_Currency&);
  friend DLL_DECL B_Boolean operator<= (const B_Currency&,   const B_Byte&);
#endif // B_VB_COMPATIBLE
  friend DLL_DECL B_Boolean operator<= (const B_Empty&,      const B_Currency&); 
  friend DLL_DECL B_Boolean operator<= (const B_Currency&,   const B_Empty&);  
  friend DLL_DECL B_Boolean operator<= (const B_Boolean&,    const B_Currency&);
  friend DLL_DECL B_Boolean operator<= (const B_Currency&,   const B_Boolean&);
  friend DLL_DECL B_Boolean operator<= (const B_Dbl,       const B_Currency&); 
  friend DLL_DECL B_Boolean operator<= (const B_Currency&, const B_Dbl);
  friend DLL_DECL B_Boolean operator<= (const B_Flt,       const B_Currency&); 
  friend DLL_DECL B_Boolean operator<= (const B_Currency&, const B_Flt);
  friend DLL_DECL B_Boolean operator<= (const B_Lng,       const B_Currency&); 
  friend DLL_DECL B_Boolean operator<= (const B_Currency&, const B_Lng);
  friend DLL_DECL B_Boolean operator<= (const B_Int,       const B_Currency&);
  friend DLL_DECL B_Boolean operator<= (const B_Currency&, const B_Int);


  friend DLL_DECL B_Boolean operator> (const B_Currency&, const B_Currency&);
#ifdef B_VB_COMPATIBLE  
  friend DLL_DECL B_Boolean operator> (const B_Double&,   const B_Currency&);
  friend DLL_DECL B_Boolean operator> (const B_Currency&, const B_Double&);
  friend DLL_DECL B_Boolean operator> (const B_Single&,   const B_Currency&);
  friend DLL_DECL B_Boolean operator> (const B_Currency&, const B_Single&);
  friend DLL_DECL B_Boolean operator> (const B_Long&,     const B_Currency&);
  friend DLL_DECL B_Boolean operator> (const B_Currency&, const B_Long&);
  friend DLL_DECL B_Boolean operator> (const B_Integer&,  const B_Currency&);
  friend DLL_DECL B_Boolean operator> (const B_Currency&, const B_Integer&);
  friend DLL_DECL B_Boolean operator> (const B_Byte&,     const B_Currency&);
  friend DLL_DECL B_Boolean operator> (const B_Currency&, const B_Byte&);
#endif // B_VB_COMPATIBLE
  friend DLL_DECL B_Boolean operator> (const B_Empty&,    const B_Currency&); 
  friend DLL_DECL B_Boolean operator> (const B_Currency&, const B_Empty&);  
  friend DLL_DECL B_Boolean operator> (const B_Boolean&,  const B_Currency&);
  friend DLL_DECL B_Boolean operator> (const B_Currency&, const B_Boolean&);
  friend DLL_DECL B_Boolean operator> (const B_Dbl,       const B_Currency&); 
  friend DLL_DECL B_Boolean operator> (const B_Currency&, const B_Dbl);
  friend DLL_DECL B_Boolean operator> (const B_Flt,       const B_Currency&); 
  friend DLL_DECL B_Boolean operator> (const B_Currency&, const B_Flt);
  friend DLL_DECL B_Boolean operator> (const B_Lng,       const B_Currency&); 
  friend DLL_DECL B_Boolean operator> (const B_Currency&, const B_Lng);
  friend DLL_DECL B_Boolean operator> (const B_Int,       const B_Currency&);
  friend DLL_DECL B_Boolean operator> (const B_Currency&, const B_Int);

  friend DLL_DECL B_Boolean operator>= (const B_Currency&,   const B_Currency&);
#ifdef B_VB_COMPATIBLE
  friend DLL_DECL B_Boolean operator>= (const B_Double&,     const B_Currency&);
  friend DLL_DECL B_Boolean operator>= (const B_Currency&,   const B_Double&);
  friend DLL_DECL B_Boolean operator>= (const B_Single&,     const B_Currency&);
  friend DLL_DECL B_Boolean operator>= (const B_Currency&,   const B_Single&);
  friend DLL_DECL B_Boolean operator>= (const B_Long&,       const B_Currency&);
  friend DLL_DECL B_Boolean operator>= (const B_Currency&,   const B_Long&);
  friend DLL_DECL B_Boolean operator>= (const B_Integer&,    const B_Currency&);
  friend DLL_DECL B_Boolean operator>= (const B_Currency&,   const B_Integer&);
  friend DLL_DECL B_Boolean operator>= (const B_Byte&,       const B_Currency&);
  friend DLL_DECL B_Boolean operator>= (const B_Currency&,   const B_Byte&);
#endif // B_VB_COMPATBILE
  friend DLL_DECL B_Boolean operator>= (const B_Empty&,      const B_Currency&); 
  friend DLL_DECL B_Boolean operator>= (const B_Currency&,   const B_Empty&);  
  friend DLL_DECL B_Boolean operator>= (const B_Boolean&,    const B_Currency&);
  friend DLL_DECL B_Boolean operator>= (const B_Currency&,   const B_Boolean&);
  friend DLL_DECL B_Boolean operator>= (const B_Dbl,       const B_Currency&); 
  friend DLL_DECL B_Boolean operator>= (const B_Currency&, const B_Dbl);
  friend DLL_DECL B_Boolean operator>= (const B_Flt,       const B_Currency&); 
  friend DLL_DECL B_Boolean operator>= (const B_Currency&, const B_Flt);
  friend DLL_DECL B_Boolean operator>= (const B_Lng,       const B_Currency&); 
  friend DLL_DECL B_Boolean operator>= (const B_Currency&, const B_Lng);
  friend DLL_DECL B_Boolean operator>= (const B_Int,       const B_Currency&);
  friend DLL_DECL B_Boolean operator>= (const B_Currency&, const B_Int);
  
  }; // B_Currency

DLL_DECL extern const B_Currency B_CurrencyMax;
DLL_DECL extern const B_Currency B_CurrencyEpsilon;
DLL_DECL extern const B_UChar    B_CurrencyDigits;



//----------------------------------Arithmetische Operatoren -----------------------------------------

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Der +Operator = Addition

DLL_DECL B_Currency   operator+ (const B_Currency&,     const B_Currency&) throw(B_Overflow);
#ifdef B_VB_COMPATIBLE
DLL_DECL B_Currency   operator+ (const B_Double&,       const B_Currency&) throw(B_Overflow); 
DLL_DECL B_Currency   operator+ (const B_Currency&,     const B_Double&)   throw(B_Overflow);
DLL_DECL B_Currency   operator+ (const B_Single&,       const B_Currency&) throw(B_Overflow); 
DLL_DECL B_Currency   operator+ (const B_Currency&,     const B_Single&)   throw(B_Overflow);
DLL_DECL B_Currency   operator+ (const B_Long&,         const B_Currency&) throw(B_Overflow);  
DLL_DECL B_Currency   operator+ (const B_Currency&,     const B_Long&)     throw(B_Overflow);
DLL_DECL B_Currency   operator+ (const B_Integer&,      const B_Currency&) throw(B_Overflow);
DLL_DECL B_Currency   operator+ (const B_Currency&,     const B_Integer&)  throw(B_Overflow);
DLL_DECL B_Currency   operator+ (const B_Byte&,         const B_Currency&) throw(B_Overflow);
DLL_DECL B_Currency   operator+ (const B_Currency&,     const B_Byte&)     throw(B_Overflow);
#endif // B_VB_COMPATIBLE
DLL_DECL B_Currency   operator+ (const B_Boolean&,      const B_Currency&) throw(B_Overflow); 
DLL_DECL B_Currency   operator+ (const B_Currency&,     const B_Boolean&)  throw(B_Overflow);    
DLL_DECL B_Currency   operator+ (const B_Empty&,        const B_Currency&); 
DLL_DECL B_Currency   operator+ (const B_Currency&,     const B_Empty&);    
DLL_DECL B_Null       operator+ (const B_Null&,         const B_Currency&); 
DLL_DECL B_Null       operator+ (const B_Currency&,     const B_Null&);    
DLL_DECL B_Currency   operator+ (const B_Dbl,        const B_Currency&) throw(B_Overflow); 
DLL_DECL B_Currency   operator+ (const B_Currency&,  const B_Dbl)       throw(B_Overflow);
DLL_DECL B_Currency   operator+ (const B_Flt,        const B_Currency&) throw(B_Overflow); 
DLL_DECL B_Currency   operator+ (const B_Currency&,  const B_Flt)       throw(B_Overflow);
DLL_DECL B_Currency   operator+ (const B_Lng,        const B_Currency&) throw(B_Overflow);  
DLL_DECL B_Currency   operator+ (const B_Currency&,  const B_Lng)       throw(B_Overflow);
DLL_DECL B_Currency   operator+ (const B_Int,        const B_Currency&) throw(B_Overflow);
DLL_DECL B_Currency   operator+ (const B_Currency&,  const B_Int)       throw(B_Overflow);


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Der -Operator = Subtraktion
DLL_DECL B_Currency   operator- (const B_Currency&,     const B_Currency&) throw(B_Overflow); 
#ifdef B_VB_COMPATIBLE
DLL_DECL B_Currency   operator- (const B_Double&,       const B_Currency&) throw(B_Overflow);
DLL_DECL B_Currency   operator- (const B_Currency&,     const B_Double&)   throw(B_Overflow);
DLL_DECL B_Currency   operator- (const B_Single&,       const B_Currency&) throw(B_Overflow);
DLL_DECL B_Currency   operator- (const B_Currency&,     const B_Single&)   throw(B_Overflow);
DLL_DECL B_Currency   operator- (const B_Long&,         const B_Currency&) throw(B_Overflow);
DLL_DECL B_Currency   operator- (const B_Currency&,     const B_Long&)     throw(B_Overflow);
DLL_DECL B_Currency   operator- (const B_Integer&,      const B_Currency&) throw(B_Overflow);
DLL_DECL B_Currency   operator- (const B_Currency&,     const B_Integer&)  throw(B_Overflow);
DLL_DECL B_Currency   operator- (const B_Byte&,         const B_Currency&) throw(B_Overflow);
DLL_DECL B_Currency   operator- (const B_Currency&,     const B_Byte&)     throw(B_Overflow);
#endif // B_VB_COMPATIBLE
DLL_DECL B_Currency   operator- (const B_Boolean&,      const B_Currency&) throw(B_Overflow);  
DLL_DECL B_Currency   operator- (const B_Currency&,     const B_Boolean&)  throw(B_Overflow);     
DLL_DECL B_Currency   operator- (const B_Empty&,        const B_Currency&);  
DLL_DECL B_Currency   operator- (const B_Currency&,     const B_Empty&);     
DLL_DECL B_Null       operator- (const B_Null&,         const B_Currency&); 
DLL_DECL B_Null       operator- (const B_Currency&,     const B_Null&);    
DLL_DECL B_Currency   operator- (const B_Dbl,        const B_Currency&) throw(B_Overflow); 
DLL_DECL B_Currency   operator- (const B_Currency&,  const B_Dbl)       throw(B_Overflow);
DLL_DECL B_Currency   operator- (const B_Flt,        const B_Currency&) throw(B_Overflow); 
DLL_DECL B_Currency   operator- (const B_Currency&,  const B_Flt)       throw(B_Overflow);
DLL_DECL B_Currency   operator- (const B_Lng,        const B_Currency&) throw(B_Overflow);  
DLL_DECL B_Currency   operator- (const B_Currency&,  const B_Lng)       throw(B_Overflow);
DLL_DECL B_Currency   operator- (const B_Int,        const B_Currency&) throw(B_Overflow);
DLL_DECL B_Currency   operator- (const B_Currency&,  const B_Int)       throw(B_Overflow);
 
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Der *Operator = Multiplikation   
//   Kein B_Double da *Operator andere Standardumwnadlungsregel hat in VB
DLL_DECL B_Currency   operator* (const B_Currency&,    const B_Currency&) throw(B_Overflow);
#ifdef B_VB_COMPATIBLE
DLL_DECL B_Currency   operator* (const B_Single&,      const B_Currency&) throw(B_Overflow); 
DLL_DECL B_Currency   operator* (const B_Currency&,    const B_Single&)   throw(B_Overflow);
DLL_DECL B_Currency   operator* (const B_Long&,        const B_Currency&) throw(B_Overflow); 
DLL_DECL B_Currency   operator* (const B_Currency&,    const B_Long&)     throw(B_Overflow);
DLL_DECL B_Currency   operator* (const B_Integer&,     const B_Currency&) throw(B_Overflow);
DLL_DECL B_Currency   operator* (const B_Currency&,    const B_Integer&)  throw(B_Overflow);
DLL_DECL B_Currency   operator* (const B_Byte&,        const B_Currency&) throw(B_Overflow);
DLL_DECL B_Currency   operator* (const B_Currency&,    const B_Byte&)     throw(B_Overflow);
#endif // B_VB_COMPATIBLE
DLL_DECL B_Currency   operator* (const B_Boolean&,     const B_Currency&);
DLL_DECL B_Currency   operator* (const B_Currency&,    const B_Boolean&);   
DLL_DECL B_Currency   operator* (const B_Empty&,       const B_Currency&);
DLL_DECL B_Currency   operator* (const B_Currency&,    const B_Empty&);   
DLL_DECL B_Null       operator* (const B_Null&,        const B_Currency&); 
DLL_DECL B_Null       operator* (const B_Currency&,    const B_Null&);    
DLL_DECL B_Currency   operator* (const B_Dbl,        const B_Currency&) throw(B_Overflow); 
DLL_DECL B_Currency   operator* (const B_Currency&,  const B_Dbl)       throw(B_Overflow);
DLL_DECL B_Currency   operator* (const B_Flt,        const B_Currency&) throw(B_Overflow); 
DLL_DECL B_Currency   operator* (const B_Currency&,  const B_Flt)       throw(B_Overflow);
DLL_DECL B_Currency   operator* (const B_Lng,        const B_Currency&) throw(B_Overflow);  
DLL_DECL B_Currency   operator* (const B_Currency&,  const B_Lng)       throw(B_Overflow);
DLL_DECL B_Currency   operator* (const B_Int,        const B_Currency&) throw(B_Overflow);
DLL_DECL B_Currency   operator* (const B_Currency&,  const B_Int)       throw(B_Overflow);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Der /Operator = Division deren Ergebniss immer ein Fliesskommawert ergibt
//   Fehler wenn Bereich von Single ueberschritten wird
#ifdef B_VB_COMPATIBLE
DLL_DECL B_Double  operator/ (const B_Currency&,    const B_Currency&) throw(B_ZeroDivide);
DLL_DECL B_Double  operator/ (const B_Double&,      const B_Currency&) throw(B_ZeroDivide); 
DLL_DECL B_Double  operator/ (const B_Currency&,    const B_Double&)   throw(B_ZeroDivide);
DLL_DECL B_Double  operator/ (const B_Single&,      const B_Currency&) throw(B_ZeroDivide); 
DLL_DECL B_Double  operator/ (const B_Currency&,    const B_Single&)   throw(B_ZeroDivide);
DLL_DECL B_Double  operator/ (const B_Long&,        const B_Currency&) throw(B_ZeroDivide); 
DLL_DECL B_Double  operator/ (const B_Currency&,    const B_Long&)     throw(B_ZeroDivide);
DLL_DECL B_Double  operator/ (const B_Integer&,     const B_Currency&) throw(B_ZeroDivide);
DLL_DECL B_Double  operator/ (const B_Currency&,    const B_Integer&)  throw(B_ZeroDivide);
DLL_DECL B_Double  operator/ (const B_Byte&,        const B_Currency&) throw(B_ZeroDivide);
DLL_DECL B_Double  operator/ (const B_Currency&,    const B_Byte&)     throw(B_ZeroDivide);
DLL_DECL B_Double  operator/ (const B_Empty&,       const B_Currency&) throw(B_ZeroDivide);
DLL_DECL B_Double  operator/ (const B_Currency&,    const B_Empty&)    throw(B_ZeroDivide);   
DLL_DECL B_Double  operator/ (const B_Dbl,        const B_Currency&) throw(B_ZeroDivide); 
DLL_DECL B_Double  operator/ (const B_Currency&,  const B_Dbl)       throw(B_ZeroDivide);
DLL_DECL B_Double  operator/ (const B_Flt,        const B_Currency&) throw(B_ZeroDivide); 
DLL_DECL B_Double  operator/ (const B_Currency&,  const B_Flt)       throw(B_ZeroDivide);
DLL_DECL B_Double  operator/ (const B_Lng,        const B_Currency&) throw(B_ZeroDivide);  
DLL_DECL B_Double  operator/ (const B_Currency&,  const B_Lng)       throw(B_ZeroDivide);
DLL_DECL B_Double  operator/ (const B_Int,        const B_Currency&) throw(B_ZeroDivide);
DLL_DECL B_Double  operator/ (const B_Currency&,  const B_Int)       throw(B_ZeroDivide);
#else
DLL_DECL B_Dbl  operator/ (const B_Currency&,    const B_Currency&) throw(B_ZeroDivide);
DLL_DECL B_Dbl  operator/ (const B_Empty&,       const B_Currency&) throw(B_ZeroDivide);
DLL_DECL B_Dbl  operator/ (const B_Currency&,    const B_Empty&)    throw(B_ZeroDivide);   
DLL_DECL B_Dbl  operator/ (const B_Dbl,        const B_Currency&) throw(B_ZeroDivide); 
DLL_DECL B_Dbl  operator/ (const B_Currency&,  const B_Dbl)       throw(B_ZeroDivide);
DLL_DECL B_Dbl  operator/ (const B_Flt,        const B_Currency&) throw(B_ZeroDivide); 
DLL_DECL B_Dbl  operator/ (const B_Currency&,  const B_Flt)       throw(B_ZeroDivide);
DLL_DECL B_Dbl  operator/ (const B_Lng,        const B_Currency&) throw(B_ZeroDivide);  
DLL_DECL B_Dbl  operator/ (const B_Currency&,  const B_Lng)       throw(B_ZeroDivide);
DLL_DECL B_Dbl  operator/ (const B_Int,        const B_Currency&) throw(B_ZeroDivide);
DLL_DECL B_Dbl  operator/ (const B_Currency&,  const B_Int)       throw(B_ZeroDivide);
#endif B_VB_COMPATIBLE
DLL_DECL B_Null    operator/ (const B_Null&,        const B_Currency&); 
DLL_DECL B_Null    operator/ (const B_Currency&,    const B_Null&);    


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Der %Operator = Modulo Operation, gibt den Wert einer ganzahligen Division zurueck
//   entsprich MOD-Operator in VB
//   Mit single und double typen arbeitet der Modulo-Operator solange korrekt wie der
//   Wertebereich des Single/Double Parameters den eines B_Long nicht ueberschreitet
//   Ist ein Single/Float/Double Datentyp zu gross, dann wird in das Logfile eine Warnung mit
//   hoechster Prioritaetstufe 
//   VB bricht mit Laufzeitfehler ab wenn ein Datentyp schon ueber den Wertebereich eines
//   Long hinausgeht und nicht erst wenn das Ergebenis den Rahmen eines Long sprengen wuerde
//   C++ hat fuer den %operator die gleiche Bedingungen.
//   Eine Funktione fMod() die sich das gleiche verhalten wie die fmod()-Fkt. der C/C++ bibliothek
//   hat steht fuer alle andren Faelle zur Verfuegung
#ifdef B_VB_COMPATIBLE
DLL_DECL B_Long  operator% (const B_Currency&,    const B_Currency&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Double&,      const B_Currency&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Currency&,    const B_Double&)    throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Single&,      const B_Currency&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Currency&,    const B_Single&)    throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Long&,        const B_Currency&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Currency&,    const B_Long&)      throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Integer&,     const B_Currency&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Currency&,    const B_Integer&)   throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Byte&,        const B_Currency&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Currency&,    const B_Byte&)      throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Boolean&,     const B_Currency&)  throw(B_Overflow, B_ZeroDivide); 
DLL_DECL B_Long  operator% (const B_Currency&,    const B_Boolean&)   throw(B_Overflow, B_ZeroDivide);    
DLL_DECL B_Long  operator% (const B_Empty&,       const B_Currency&)  throw(B_Overflow, B_ZeroDivide); 
DLL_DECL B_Long  operator% (const B_Currency&,    const B_Empty&)     throw(B_ZeroDivide);    
DLL_DECL B_Long  operator% (const B_Dbl,        const B_Currency&) throw(B_Overflow, B_ZeroDivide); 
DLL_DECL B_Long  operator% (const B_Currency&,  const B_Dbl)       throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Flt,        const B_Currency&) throw(B_Overflow, B_ZeroDivide); 
DLL_DECL B_Long  operator% (const B_Currency&,  const B_Flt)       throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Lng,        const B_Currency&) throw(B_Overflow, B_ZeroDivide);  
DLL_DECL B_Long  operator% (const B_Currency&,  const B_Lng)       throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Int,        const B_Currency&) throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Currency&,  const B_Int)       throw(B_Overflow, B_ZeroDivide);
#else
DLL_DECL B_Lng  operator% (const B_Currency&,    const B_Currency&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng  operator% (const B_Boolean&,     const B_Currency&)  throw(B_Overflow, B_ZeroDivide); 
DLL_DECL B_Lng  operator% (const B_Currency&,    const B_Boolean&)   throw(B_Overflow, B_ZeroDivide);    
DLL_DECL B_Lng  operator% (const B_Empty&,       const B_Currency&)  throw(B_Overflow, B_ZeroDivide); 
DLL_DECL B_Lng  operator% (const B_Currency&,    const B_Empty&)     throw(B_ZeroDivide);    
DLL_DECL B_Lng  operator% (const B_Dbl,        const B_Currency&) throw(B_Overflow, B_ZeroDivide); 
DLL_DECL B_Lng  operator% (const B_Currency&,  const B_Dbl)       throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng  operator% (const B_Flt,        const B_Currency&) throw(B_Overflow, B_ZeroDivide); 
DLL_DECL B_Lng  operator% (const B_Currency&,  const B_Flt)       throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng  operator% (const B_Lng,        const B_Currency&) throw(B_Overflow, B_ZeroDivide);  
DLL_DECL B_Lng  operator% (const B_Currency&,  const B_Lng)       throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng  operator% (const B_Int,        const B_Currency&) throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng  operator% (const B_Currency&,  const B_Int)       throw(B_Overflow, B_ZeroDivide);
#endif // B_VB_COMPATIBLE
DLL_DECL B_Null  operator% (const B_Null&,        const B_Currency&);
DLL_DECL B_Null  operator% (const B_Currency&,    const B_Null&);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Ganzahldivision entspricht dem \Operator in VB, da in C++ kein geeigneter Operator zu Verfuegung steht
//   wird dieser Operator als Funktion realisiert
//   Mit single und double typen arbeitet der Ganzahldivisor-Operator solange korrekt wie der
//   Wertebereich des Single/Double Parameters den eines B_Long nicht ueberschreitet
//   Fliesskommawerte werden korrekt gerundet. d.h. <0.5 auf kleineren Wert und ab
//   >=0.5 wird aufgerundet auf die naechst groessere Ganzzahl
//   Ist ein Single/Float/Double Datentyp zu gross, dann wird in das Logfile eine Warnung mit
//   hoechster Prioritaetstufe 
//   VB bricht mit Laufzeitfehler ab wenn ein Datentyp schon ueber den Wertebereich eines
//   Long hinausgeht und nicht erst wenn das Ergebenis den Rahmen eines Long sprengen wuerde
//   C++ hat fuer den %operator die gleiche Bedingungen.
#ifdef B_VB_COMPATIBLE
DLL_DECL B_Long B_Div(const B_Currency&,   const B_Currency&) throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Double&,     const B_Currency&) throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Currency&,   const B_Double&)   throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Single&,     const B_Currency&) throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Currency&,   const B_Single&)   throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Integer&,    const B_Currency&) throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Currency&,   const B_Long&)     throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Long&,       const B_Currency&) throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Currency&,   const B_Integer&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Byte&,       const B_Currency&) throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Currency&,   const B_Byte&)     throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Boolean&,    const B_Currency&) throw(B_Overflow, B_ZeroDivide);  
DLL_DECL B_Long B_Div(const B_Currency&,   const B_Boolean&)  throw(B_Overflow, B_ZeroDivide);     
DLL_DECL B_Long B_Div(const B_Empty&,      const B_Currency&) throw(B_Overflow, B_ZeroDivide);  
DLL_DECL B_Long B_Div(const B_Currency&,   const B_Empty&)    throw(B_ZeroDivide);     
DLL_DECL B_Long B_Div(const B_Dbl,         const B_Currency&) throw(B_Overflow, B_ZeroDivide); 
DLL_DECL B_Long B_Div(const B_Currency&,   const B_Dbl)       throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Flt,         const B_Currency&) throw(B_Overflow, B_ZeroDivide); 
DLL_DECL B_Long B_Div(const B_Currency&,   const B_Flt)       throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Lng,         const B_Currency&) throw(B_Overflow, B_ZeroDivide);  
DLL_DECL B_Long B_Div(const B_Currency&,   const B_Lng)       throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Int,         const B_Currency&) throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Currency&,   const B_Int)       throw(B_Overflow, B_ZeroDivide);
#else
DLL_DECL B_Lng B_Div(const B_Currency&,   const B_Currency&) throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng B_Div(const B_Boolean&,    const B_Currency&) throw(B_Overflow, B_ZeroDivide);  
DLL_DECL B_Lng B_Div(const B_Currency&,   const B_Boolean&)  throw(B_Overflow, B_ZeroDivide);     
DLL_DECL B_Lng B_Div(const B_Empty&,      const B_Currency&) throw(B_Overflow, B_ZeroDivide);  
DLL_DECL B_Lng B_Div(const B_Currency&,   const B_Empty&)    throw(B_ZeroDivide);     
DLL_DECL B_Lng B_Div(const B_Dbl,         const B_Currency&) throw(B_Overflow, B_ZeroDivide); 
DLL_DECL B_Lng B_Div(const B_Currency&,   const B_Dbl)       throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng B_Div(const B_Flt,         const B_Currency&) throw(B_Overflow, B_ZeroDivide); 
DLL_DECL B_Lng B_Div(const B_Currency&,   const B_Flt)       throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng B_Div(const B_Lng,         const B_Currency&) throw(B_Overflow, B_ZeroDivide);  
DLL_DECL B_Lng B_Div(const B_Currency&,   const B_Lng)       throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng B_Div(const B_Int,         const B_Currency&) throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng B_Div(const B_Currency&,   const B_Int)       throw(B_Overflow, B_ZeroDivide);
#endif // B_VB_COMPATIBLE
DLL_DECL B_Null B_Div(const B_Null&,       const B_Currency&);  
DLL_DECL B_Null B_Div(const B_Currency&,   const B_Null&);     

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Dient zum Potenzieren einer Zahl mit einem Exponenten
//   Erg = Zahl^Exponent  -> Erg = Pow(zahl, exponent)
//   Das Argument Zahl darf nur negativ sein, wenn Exponent ein ganzzahliger Wert ist. Werden in einem einzigen 
//   Ausdruck mehrere Potenzierungen ausgefhrt, so wird der Operator ^ jeweils in der Reihenfolge seines 
//   Auftretens von links nach rechts ausgewertet.
//   Ergebnis hat den Datentyp Double  Ist jedoch entweder Zahl oder Exponent ein Ausdruck mit dem Wert Null, 
//   so ist das Ergebnis ebenfalls Null.
//   Negative zahl-Werte koennen verstaendlicherweise nicht verwandt werden wenn der Exponent auch eine
//   Floatwert hat da das Ergebnis sonst eine Komplexe Zahl waere.
#ifdef B_VB_COMPATIBLE
DLL_DECL B_Double B_Pow(const B_Currency&,   const B_Currency&) throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Double&,     const B_Currency&) throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Currency&,   const B_Double&)   throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Single&,     const B_Currency&) throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Currency&,   const B_Single&)   throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Long&,       const B_Currency&) throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Currency&,   const B_Long&)     throw(B_Overflow);
DLL_DECL B_Double B_Pow(const B_Integer&,    const B_Currency&) throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Currency&,   const B_Integer&)  throw(B_Overflow);
DLL_DECL B_Double B_Pow(const B_Byte&,       const B_Currency&) throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Currency&,   const B_Byte&)     throw(B_Overflow);
DLL_DECL B_Double B_Pow(const B_Empty&,      const B_Currency&);  
DLL_DECL B_Double B_Pow(const B_Currency&,   const B_Empty&);      
DLL_DECL B_Double B_Pow(const B_Dbl,         const B_Currency&) throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Currency&,   const B_Dbl)       throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Flt,         const B_Currency&) throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Currency&,   const B_Flt)       throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Lng,         const B_Currency&) throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Currency&,   const B_Lng)       throw(B_Overflow);
DLL_DECL B_Double B_Pow(const B_Int,         const B_Currency&) throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Currency&,   const B_Int)       throw(B_Overflow);
#else
DLL_DECL B_Dbl B_Pow(const B_Currency&,   const B_Currency&) throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Dbl B_Pow(const B_Empty&,      const B_Currency&);  
DLL_DECL B_Dbl B_Pow(const B_Currency&,   const B_Empty&);      
DLL_DECL B_Dbl B_Pow(const B_Dbl,         const B_Currency&) throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Dbl B_Pow(const B_Currency&,   const B_Dbl)       throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Dbl B_Pow(const B_Flt,         const B_Currency&) throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Dbl B_Pow(const B_Currency&,   const B_Flt)       throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Dbl B_Pow(const B_Lng,         const B_Currency&) throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Dbl B_Pow(const B_Currency&,   const B_Lng)       throw(B_Overflow);
DLL_DECL B_Dbl B_Pow(const B_Int,         const B_Currency&) throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Dbl B_Pow(const B_Currency&,   const B_Int)       throw(B_Overflow);
#endif // B_VB_COMPATIBLE
DLL_DECL B_Null   B_Pow(const B_Null&,       const B_Currency&);  
DLL_DECL B_Null   B_Pow(const B_Currency&,   const B_Null&);      

//----------------------------------------------------------------------------------------------------
//---------------------------------- Logische Operatoren ---------------------------------------------
//--- Logische Operatoren haben als Ruekgabewert immer den Datentyp B_Long
//    Fliesskommawerte werden ab (<0.5) bzw. aufgerundet (>=0.5) und dann als entsprechender
//    Ganzahlwert normal Bitweise verarbeitet
//    Solange der Wertebereich von B_Long nicht durch die Fliesskommawerte ueberschritten wird
//    arbeiten die Funktionen korrekt.
//    Wird durch einen Flieskommawert der Wertebereich des Long ueberschritten wird dies in der 
//    Logdatei protokolliert und fuehrt zu einem Laufzeitfehler.
//    Hierbei reicht es aus wenn ein Operand den Werteereich ueberschreitet, d.h. selbst wenn das
//    Ergebnis noch in einen Long passen wuerde wird schon bei der Operatoruebergabe abgebrochen
//    mit dem Laufzeitfehler(6) = Ueberlauf

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Der &&Operator entspricht AND in VB , 
//   Bit in Ausdruck1 	Bit in Ausdruck2 	Ergebnis 
//       0	                  0            	0
//       0	                  1           	0
//       1                  	0           	0
//       1                   	1            	1
//   ACHTUNG alle C/C++ Programmierer: in VB werden numerische Typen immer logisch bitweise und verknpft
//                                     Der Einsatz von & war nicht moeglich da stellenweise erst zur Lauf-
//                                     zeit das Verhalten bestimmt werden kann was der Konverter nicht 
//                                     bestimmen kann
#ifdef B_VB_COMPATIBLE
DLL_DECL B_Long operator&& (const B_Currency&,    const B_Currency&)  throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Double&,      const B_Currency&)  throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Currency&,    const B_Double&)    throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Single&,      const B_Currency&)  throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Currency&,    const B_Single&)    throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Long&,        const B_Currency&)  throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Currency&,    const B_Long&)      throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Integer&,     const B_Currency&)  throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Currency&,    const B_Integer&)   throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Byte&,        const B_Currency&)  throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Currency&,    const B_Byte&)      throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Boolean&,     const B_Currency&)  throw(B_Overflow); 
DLL_DECL B_Long operator&& (const B_Currency&,    const B_Boolean&)   throw(B_Overflow);    
DLL_DECL B_Long operator&& (const B_Empty&,       const B_Currency&)  throw(B_Overflow); 
DLL_DECL B_Long operator&& (const B_Currency&,    const B_Empty&)     throw(B_Overflow);    
DLL_DECL B_Long operator&& (const B_Dbl,          const B_Currency&)  throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Currency&,    const B_Dbl)        throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Flt,          const B_Currency&)  throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Currency&,    const B_Flt)        throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Lng,          const B_Currency&)  throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Currency&,    const B_Lng)        throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Int,          const B_Currency&)  throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Currency&,    const B_Int)        throw(B_Overflow);
#else
DLL_DECL B_Lng operator&& (const B_Currency&,    const B_Currency&)  throw(B_Overflow);
DLL_DECL B_Lng operator&& (const B_Boolean&,     const B_Currency&)  throw(B_Overflow); 
DLL_DECL B_Lng operator&& (const B_Currency&,    const B_Boolean&)   throw(B_Overflow);    
DLL_DECL B_Lng operator&& (const B_Empty&,       const B_Currency&)  throw(B_Overflow); 
DLL_DECL B_Lng operator&& (const B_Currency&,    const B_Empty&)     throw(B_Overflow);    
DLL_DECL B_Lng operator&& (const B_Dbl,          const B_Currency&)  throw(B_Overflow);
DLL_DECL B_Lng operator&& (const B_Currency&,    const B_Dbl)        throw(B_Overflow);
DLL_DECL B_Lng operator&& (const B_Flt,          const B_Currency&)  throw(B_Overflow);
DLL_DECL B_Lng operator&& (const B_Currency&,    const B_Flt)        throw(B_Overflow);
DLL_DECL B_Lng operator&& (const B_Lng,          const B_Currency&)  throw(B_Overflow);
DLL_DECL B_Lng operator&& (const B_Currency&,    const B_Lng)        throw(B_Overflow);
DLL_DECL B_Lng operator&& (const B_Int,          const B_Currency&)  throw(B_Overflow);
DLL_DECL B_Lng operator&& (const B_Currency&,    const B_Int)        throw(B_Overflow);
#endif // B_VB_COMPATIBLE
DLL_DECL B_Null operator&& (const B_Null&,        const B_Currency&)  throw(B_Overflow); 
DLL_DECL B_Null operator&& (const B_Currency&,    const B_Null&)      throw(B_Overflow);     


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Der ||Operator entspricht OR in VB , 
//   Bit in Ausdruck1 	Bit in Ausdruck2 	Ergebnis 
//       0	                  0            	0
//       0	                  1           	1
//       1                  	0           	1
//       1                   	1            	1
//   ACHTUNG alle C/C++ Programmierer: in VB werden numerische Typen immer logisch bitweise und verknpft
//                                     Der Einsatz von | war nicht moeglich da stellenweise erst zur Lauf-
//                                     zeit das Verhalten bestimmt werden kann was der Konverter nicht 
//                                     bestimmen kann
#ifdef B_VB_COMPATIBLE
DLL_DECL B_Long operator|| (const B_Currency&,    const B_Currency&) throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Double&,      const B_Currency&) throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Currency&,    const B_Double&)   throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Single&,      const B_Currency&) throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Currency&,    const B_Single&)   throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Long&,        const B_Currency&) throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Currency&,    const B_Long&)     throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Integer&,     const B_Currency&) throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Currency&,    const B_Integer&)  throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Byte&,        const B_Currency&) throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Currency&,    const B_Byte&)     throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Boolean&,     const B_Currency&) throw(B_Overflow); 
DLL_DECL B_Long operator|| (const B_Currency&,    const B_Boolean&)  throw(B_Overflow);    
DLL_DECL B_Long operator|| (const B_Empty&,       const B_Currency&) throw(B_Overflow); 
DLL_DECL B_Long operator|| (const B_Currency&,    const B_Empty&)    throw(B_Overflow);    
DLL_DECL B_Long operator|| (const B_Null&,        const B_Currency&) throw(B_Overflow); 
DLL_DECL B_Long operator|| (const B_Currency&,    const B_Null&)     throw(B_Overflow);    
DLL_DECL B_Long operator|| (const B_Dbl,          const B_Currency&)  throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Currency&,    const B_Dbl)        throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Flt,          const B_Currency&)  throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Currency&,    const B_Flt)        throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Lng,          const B_Currency&)  throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Currency&,    const B_Lng)        throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Int,          const B_Currency&)  throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Currency&,    const B_Int)        throw(B_Overflow);
#else
DLL_DECL B_Lng operator|| (const B_Currency&,    const B_Currency&) throw(B_Overflow);
DLL_DECL B_Lng operator|| (const B_Boolean&,     const B_Currency&) throw(B_Overflow); 
DLL_DECL B_Lng operator|| (const B_Currency&,    const B_Boolean&)  throw(B_Overflow);    
DLL_DECL B_Lng operator|| (const B_Empty&,       const B_Currency&) throw(B_Overflow); 
DLL_DECL B_Lng operator|| (const B_Currency&,    const B_Empty&)    throw(B_Overflow);    
DLL_DECL B_Lng operator|| (const B_Null&,        const B_Currency&) throw(B_Overflow); 
DLL_DECL B_Lng operator|| (const B_Currency&,    const B_Null&)     throw(B_Overflow);    
DLL_DECL B_Lng operator|| (const B_Dbl,          const B_Currency&)  throw(B_Overflow);
DLL_DECL B_Lng operator|| (const B_Currency&,    const B_Dbl)        throw(B_Overflow);
DLL_DECL B_Lng operator|| (const B_Flt,          const B_Currency&)  throw(B_Overflow);
DLL_DECL B_Lng operator|| (const B_Currency&,    const B_Flt)        throw(B_Overflow);
DLL_DECL B_Lng operator|| (const B_Lng,          const B_Currency&)  throw(B_Overflow);
DLL_DECL B_Lng operator|| (const B_Currency&,    const B_Lng)        throw(B_Overflow);
DLL_DECL B_Lng operator|| (const B_Int,          const B_Currency&)  throw(B_Overflow);
DLL_DECL B_Lng operator|| (const B_Currency&,    const B_Int)        throw(B_Overflow);
#endif // B_VB_COMPATIBLE

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Der ^Operator entspricht XOR in VB 
//   Bit in Ausdruck1 	Bit in Ausdruck2 	Ergebnis 
//       0	                  0            	0
//       0	                  1           	1
//       1                  	0           	1
//       1                   	1            	0
//   ACHTUNG alle VB Programmierer:    In C++ bedeutet der ^Operator ein bitweises XOR auf numerische
//                                     Operanden und nicht wie in VB eine Potenzierung. Der ^Operator
//                                     wurde nicht zur Potenzierung verwandt da dies nicht C++ Stil
//                                     entspricht.
//   ACHTUNG alle C/C++ Programmierer: In VB werden numerische Typen immer logisch bitweise und verknpft
//                                     Dies hat fuer ^Operator die Folge, dass er bei nicht numerischen
//                                     Ausdreucken sich wie ein logisches XOR verhaelt
#ifdef B_VB_COMPATIBLE
DLL_DECL B_Long operator^ (const B_Currency&,     const B_Currency&) throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Double&,       const B_Currency&) throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Currency&,     const B_Double&)   throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Single&,       const B_Currency&) throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Currency&,     const B_Single&)   throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Long&,         const B_Currency&) throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Currency&,     const B_Long&)     throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Integer&,      const B_Currency&) throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Currency&,     const B_Integer&)  throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Byte&,         const B_Currency&) throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Currency&,     const B_Byte&)     throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Boolean&,      const B_Currency&) throw(B_Overflow); 
DLL_DECL B_Long operator^ (const B_Currency&,     const B_Boolean&)  throw(B_Overflow);    
DLL_DECL B_Long operator^ (const B_Empty&,        const B_Currency&) throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Currency&,     const B_Empty&)    throw(B_Overflow);   
DLL_DECL B_Long operator^ (const B_Dbl,           const B_Currency&) throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Currency&,     const B_Dbl)       throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Flt,           const B_Currency&) throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Currency&,     const B_Flt)       throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Lng,           const B_Currency&) throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Currency&,     const B_Lng)       throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Int,           const B_Currency&) throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Currency&,     const B_Int)       throw(B_Overflow);
#else
DLL_DECL B_Lng operator^ (const B_Currency&,     const B_Currency&) throw(B_Overflow);
DLL_DECL B_Lng operator^ (const B_Boolean&,      const B_Currency&) throw(B_Overflow); 
DLL_DECL B_Lng operator^ (const B_Currency&,     const B_Boolean&)  throw(B_Overflow);    
DLL_DECL B_Lng operator^ (const B_Empty&,        const B_Currency&) throw(B_Overflow);
DLL_DECL B_Lng operator^ (const B_Currency&,     const B_Empty&)    throw(B_Overflow);   
DLL_DECL B_Lng operator^ (const B_Dbl,           const B_Currency&) throw(B_Overflow);
DLL_DECL B_Lng operator^ (const B_Currency&,     const B_Dbl)       throw(B_Overflow);
DLL_DECL B_Lng operator^ (const B_Flt,           const B_Currency&) throw(B_Overflow);
DLL_DECL B_Lng operator^ (const B_Currency&,     const B_Flt)       throw(B_Overflow);
DLL_DECL B_Lng operator^ (const B_Lng,           const B_Currency&) throw(B_Overflow);
DLL_DECL B_Lng operator^ (const B_Currency&,     const B_Lng)       throw(B_Overflow);
DLL_DECL B_Lng operator^ (const B_Int,           const B_Currency&) throw(B_Overflow);
DLL_DECL B_Lng operator^ (const B_Currency&,     const B_Int)       throw(B_Overflow);
#endif
DLL_DECL B_Null operator^ (const B_Null&,         const B_Currency&) throw(B_Overflow); 
DLL_DECL B_Null operator^ (const B_Currency&,     const B_Null&)     throw(B_Overflow);    

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Der !Operator entspricht NOT in VB 
//   Bit in Ausdruck1 	 Ergebnis
//       0	                 1
//       1                   0
//   ACHTUNG alle C/C++ Programmierer: In VB werden numerische Typen immer logisch bitweise und verknpft
//                                     Dies hat fuer !Operator die Folge, dass er bei nicht numerischen
//                                     Ausdreucken sich wie ein logisches NOT verhaelt
// fuer den Fall, dass B_Emtpy uebergeben wird ist fuer alle Datentypen die Funktion 
// B_Currency operator! (const B_Empty) in bc_int.hpp verantwortlich
// Die Variante B_Null operator!( const B_Null&) ist in B_Byte-Klasse abgehandelt
// B_Long operator! (const B_Currency&);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Die Operatoren Imp (=logische Implikation) und Eqv (=logische quivalenz) werden vom Konverter
// in folgende Basisoperatorkonstrukte umgesetzt, da in C++ keine quivalenten Operatoren zur Verfgung
// stehen.
// a Imp b    ->  (!a || b)
// a Eqv b    ->  !(a ^ b)


//----------------------------------------------------------------------------------------------------
//---------------------------------- Vergleichs Operatoren -------------------------------------------

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Verlgeich auf Gleichheit der Operanden, es findet ein numerischer Vergleich statt
// Ausdruck1 == Ausdruck2 -> B_True
// Ausdruck1 != Ausdruck2 -> B_False
// ACHTUNG alle VB Programmierer:  In C++ wird mit '==' auf Gleichheit abgefragt und nicht mit '='
//                                 Der '=' Operator wird nur fuer Zuweisungen verwendet.
// ACHTUNG wird ein Double mit einem Single verglichen so wird der Double auf die genauigkeit eines
//         Single gebracht, so dass zwei eignetlich ungleiche Werte als gleich angesehen werden 
//         koennen ( Dies ist das original VB verhalten)
//         Fuer jede dieser Operationen wird eine Warnung ausgegeben.
DLL_DECL B_Boolean operator== (const B_Currency&,    const B_Currency&);
#ifdef B_VB_COMPATIBLE
DLL_DECL B_Boolean operator== (const B_Double&,      const B_Currency&);
DLL_DECL B_Boolean operator== (const B_Currency&,    const B_Double&);
DLL_DECL B_Boolean operator== (const B_Single&,      const B_Currency&);
DLL_DECL B_Boolean operator== (const B_Currency&,    const B_Single&);
DLL_DECL B_Boolean operator== (const B_Long&,        const B_Currency&);
DLL_DECL B_Boolean operator== (const B_Currency&,    const B_Long&);
DLL_DECL B_Boolean operator== (const B_Integer&,     const B_Currency&);
DLL_DECL B_Boolean operator== (const B_Currency&,    const B_Integer&);
DLL_DECL B_Boolean operator== (const B_Byte&,        const B_Currency&);
DLL_DECL B_Boolean operator== (const B_Currency&,    const B_Byte&);
#endif // B_VB_COMPATIBLE
DLL_DECL B_Boolean operator== (const B_Boolean&,     const B_Currency&);   
DLL_DECL B_Boolean operator== (const B_Currency&,    const B_Boolean&);      
DLL_DECL B_Boolean operator== (const B_Empty&,       const B_Currency&);   
DLL_DECL B_Boolean operator== (const B_Currency&,    const B_Empty&);      
DLL_DECL B_Null    operator== (const B_Null&,        const B_Currency&);   
DLL_DECL B_Null    operator== (const B_Currency&,    const B_Null&);      
DLL_DECL B_Boolean operator== (const B_Dbl,          const B_Currency&);
DLL_DECL B_Boolean operator== (const B_Currency&,    const B_Dbl);
DLL_DECL B_Boolean operator== (const B_Flt,          const B_Currency&);
DLL_DECL B_Boolean operator== (const B_Currency&,    const B_Flt);
DLL_DECL B_Boolean operator== (const B_Lng,          const B_Currency&);
DLL_DECL B_Boolean operator== (const B_Currency&,    const B_Lng);
DLL_DECL B_Boolean operator== (const B_Int,          const B_Currency&);
DLL_DECL B_Boolean operator== (const B_Currency&,    const B_Int);


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Verlgeich auf Ungleichheit der Operanden, es findet ein numerischer Vergleich statt
// Ausdruck1 != Ausdruck2 -> B_True
// Ausdruck1 == Ausdruck2 -> B_False
// ACHTUNG alle VB Programmierer:  In C++ wird mit '!=' auf Ungleichheit abgefragt und nicht mit '<>'
//                                 Der '<>' Operator existiert nicht in C++.
DLL_DECL B_Boolean operator!= (const B_Currency&,    const B_Currency&);
#ifdef B_VB_COMPATIBLE
DLL_DECL B_Boolean operator!= (const B_Double&,      const B_Currency&);
DLL_DECL B_Boolean operator!= (const B_Currency&,    const B_Double&);
DLL_DECL B_Boolean operator!= (const B_Single&,      const B_Currency&);
DLL_DECL B_Boolean operator!= (const B_Currency&,    const B_Single&);
DLL_DECL B_Boolean operator!= (const B_Long&,        const B_Currency&);
DLL_DECL B_Boolean operator!= (const B_Currency&,    const B_Long&);
DLL_DECL B_Boolean operator!= (const B_Integer&,     const B_Currency&);
DLL_DECL B_Boolean operator!= (const B_Currency&,    const B_Integer&);
DLL_DECL B_Boolean operator!= (const B_Byte&,        const B_Currency&);
DLL_DECL B_Boolean operator!= (const B_Currency&,    const B_Byte&);
#endif // B_VB_COMPATIBLE
DLL_DECL B_Boolean operator!= (const B_Boolean&,     const B_Currency&);   
DLL_DECL B_Boolean operator!= (const B_Currency&,    const B_Boolean&);      
DLL_DECL B_Boolean operator!= (const B_Empty&,       const B_Currency&);   
DLL_DECL B_Boolean operator!= (const B_Currency&,    const B_Empty&);      
DLL_DECL B_Null    operator!= (const B_Null&,        const B_Currency&);   
DLL_DECL B_Null    operator!= (const B_Currency&,    const B_Null&);      
DLL_DECL B_Boolean operator!= (const B_Dbl,        const B_Currency&);
DLL_DECL B_Boolean operator!= (const B_Currency&,  const B_Dbl);
DLL_DECL B_Boolean operator!= (const B_Flt,        const B_Currency&);
DLL_DECL B_Boolean operator!= (const B_Currency&,  const B_Flt);
DLL_DECL B_Boolean operator!= (const B_Lng,        const B_Currency&);
DLL_DECL B_Boolean operator!= (const B_Currency&,  const B_Lng);
DLL_DECL B_Boolean operator!= (const B_Int,        const B_Currency&);
DLL_DECL B_Boolean operator!= (const B_Currency&,  const B_Int);


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Verlgeich auf Kleiner der Operanden, es findet ein numerischer Vergleich statt
// Ausdruck1 <  Ausdruck2 -> B_True
// Ausdruck1 >= Ausdruck2 -> B_False
DLL_DECL B_Boolean operator< (const B_Currency&,    const B_Currency&);
#ifdef B_VB_COMPATIBLE
DLL_DECL B_Boolean operator< (const B_Double&,      const B_Currency&);
DLL_DECL B_Boolean operator< (const B_Currency&,    const B_Double&);
DLL_DECL B_Boolean operator< (const B_Single&,      const B_Currency&);
DLL_DECL B_Boolean operator< (const B_Currency&,    const B_Single&);
DLL_DECL B_Boolean operator< (const B_Long&,        const B_Currency&);
DLL_DECL B_Boolean operator< (const B_Currency&,    const B_Long&);
DLL_DECL B_Boolean operator< (const B_Integer&,     const B_Currency&);
DLL_DECL B_Boolean operator< (const B_Currency&,    const B_Integer&);
DLL_DECL B_Boolean operator< (const B_Byte&,        const B_Currency&);
DLL_DECL B_Boolean operator< (const B_Currency&,    const B_Byte&);
#endif // B_VB_COMPATIBLE
DLL_DECL B_Boolean operator< (const B_Boolean&,     const B_Currency&);   
DLL_DECL B_Boolean operator< (const B_Currency&,    const B_Boolean&);      
DLL_DECL B_Boolean operator< (const B_Empty&,       const B_Currency&);   
DLL_DECL B_Boolean operator< (const B_Currency&,    const B_Empty&);      
DLL_DECL B_Null    operator< (const B_Null&,        const B_Currency&);   
DLL_DECL B_Null    operator< (const B_Currency&,    const B_Null&);      
DLL_DECL B_Boolean operator< (const B_Dbl,        const B_Currency&);
DLL_DECL B_Boolean operator< (const B_Currency&,  const B_Dbl);
DLL_DECL B_Boolean operator< (const B_Flt,        const B_Currency&);
DLL_DECL B_Boolean operator< (const B_Currency&,  const B_Flt);
DLL_DECL B_Boolean operator< (const B_Lng,        const B_Currency&);
DLL_DECL B_Boolean operator< (const B_Currency&,  const B_Lng);
DLL_DECL B_Boolean operator< (const B_Int,        const B_Currency&);
DLL_DECL B_Boolean operator< (const B_Currency&,  const B_Int);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Verlgeich auf Kleiner/Gleich der Operanden, es findet ein numerischer Vergleich statt
// Ausdruck1 <=  Ausdruck2 -> B_True
// Ausdruck1 >   Ausdruck2 -> B_False
DLL_DECL B_Boolean operator<= (const B_Currency&,    const B_Currency&);
#ifdef B_VB_COMPATIBLE
DLL_DECL B_Boolean operator<= (const B_Double&,      const B_Currency&);
DLL_DECL B_Boolean operator<= (const B_Currency&,    const B_Double&);
DLL_DECL B_Boolean operator<= (const B_Single&,      const B_Currency&);
DLL_DECL B_Boolean operator<= (const B_Currency&,    const B_Single&);
DLL_DECL B_Boolean operator<= (const B_Long&,        const B_Currency&);
DLL_DECL B_Boolean operator<= (const B_Currency&,    const B_Long&);
DLL_DECL B_Boolean operator<= (const B_Integer&,     const B_Currency&);
DLL_DECL B_Boolean operator<= (const B_Currency&,    const B_Integer&);
DLL_DECL B_Boolean operator<= (const B_Byte&,        const B_Currency&);
DLL_DECL B_Boolean operator<= (const B_Currency&,    const B_Byte&);
#endif // B_VB_COMPATIBLE
DLL_DECL B_Boolean operator<= (const B_Boolean&,     const B_Currency&);   
DLL_DECL B_Boolean operator<= (const B_Currency&,    const B_Boolean&);      
DLL_DECL B_Boolean operator<= (const B_Empty&,       const B_Currency&);   
DLL_DECL B_Boolean operator<= (const B_Currency&,    const B_Empty&);      
DLL_DECL B_Null    operator<= (const B_Null&,        const B_Currency&);   
DLL_DECL B_Null    operator<= (const B_Currency&,    const B_Null&);      
DLL_DECL B_Boolean operator<= (const B_Dbl,        const B_Currency&);
DLL_DECL B_Boolean operator<= (const B_Currency&,  const B_Dbl);
DLL_DECL B_Boolean operator<= (const B_Flt,        const B_Currency&);
DLL_DECL B_Boolean operator<= (const B_Currency&,  const B_Flt);
DLL_DECL B_Boolean operator<= (const B_Lng,        const B_Currency&);
DLL_DECL B_Boolean operator<= (const B_Currency&,  const B_Lng);
DLL_DECL B_Boolean operator<= (const B_Int,        const B_Currency&);
DLL_DECL B_Boolean operator<= (const B_Currency&,  const B_Int);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Verlgeich auf Groesser der Operanden, es findet ein numerischer Vergleich statt
// Ausdruck1 >   Ausdruck2 -> B_True
// Ausdruck1 <=  Ausdruck2 -> B_False
DLL_DECL B_Boolean operator> (const B_Currency&,    const B_Currency&);
#ifdef B_VB_COMPATIBLE
DLL_DECL B_Boolean operator> (const B_Double&,      const B_Currency&);
DLL_DECL B_Boolean operator> (const B_Currency&,    const B_Double&);
DLL_DECL B_Boolean operator> (const B_Single&,      const B_Currency&);
DLL_DECL B_Boolean operator> (const B_Currency&,    const B_Single&);
DLL_DECL B_Boolean operator> (const B_Long&,        const B_Currency&);
DLL_DECL B_Boolean operator> (const B_Currency&,    const B_Long&);
DLL_DECL B_Boolean operator> (const B_Integer&,     const B_Currency&);
DLL_DECL B_Boolean operator> (const B_Currency&,    const B_Integer&);
DLL_DECL B_Boolean operator> (const B_Byte&,        const B_Currency&);
DLL_DECL B_Boolean operator> (const B_Currency&,    const B_Byte&);
#endif // B_VB_COMPATIBLE
DLL_DECL B_Boolean operator> (const B_Boolean&,     const B_Currency&);   
DLL_DECL B_Boolean operator> (const B_Currency&,    const B_Boolean&);      
DLL_DECL B_Boolean operator> (const B_Empty&,       const B_Currency&);   
DLL_DECL B_Boolean operator> (const B_Currency&,    const B_Empty&);      
DLL_DECL B_Null    operator> (const B_Null&,        const B_Currency&);   
DLL_DECL B_Null    operator> (const B_Currency&,    const B_Null&);      
DLL_DECL B_Boolean operator> (const B_Dbl,        const B_Currency&);
DLL_DECL B_Boolean operator> (const B_Currency&,  const B_Dbl);
DLL_DECL B_Boolean operator> (const B_Flt,        const B_Currency&);
DLL_DECL B_Boolean operator> (const B_Currency&,  const B_Flt);
DLL_DECL B_Boolean operator> (const B_Lng,        const B_Currency&);
DLL_DECL B_Boolean operator> (const B_Currency&,  const B_Lng);
DLL_DECL B_Boolean operator> (const B_Int,        const B_Currency&);
DLL_DECL B_Boolean operator> (const B_Currency&,  const B_Int);


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Verlgeich auf Groesser/Gleich der Operanden, es findet ein numerischer Vergleich statt
// Ausdruck1 >=  Ausdruck2 -> B_True
// Ausdruck1 <   Ausdruck2 -> B_False
DLL_DECL B_Boolean operator>= (const B_Currency&,    const B_Currency&);
#ifdef B_VB_COMPATIBLE
DLL_DECL B_Boolean operator>= (const B_Double&,      const B_Currency&);
DLL_DECL B_Boolean operator>= (const B_Currency&,    const B_Double&);
DLL_DECL B_Boolean operator>= (const B_Single&,      const B_Currency&);
DLL_DECL B_Boolean operator>= (const B_Currency&,    const B_Single&);
DLL_DECL B_Boolean operator>= (const B_Long&,        const B_Currency&);
DLL_DECL B_Boolean operator>= (const B_Currency&,    const B_Long&);
DLL_DECL B_Boolean operator>= (const B_Integer&,     const B_Currency&);
DLL_DECL B_Boolean operator>= (const B_Currency&,    const B_Integer&);
DLL_DECL B_Boolean operator>= (const B_Byte&,        const B_Currency&);
DLL_DECL B_Boolean operator>= (const B_Currency&,    const B_Byte&);
#endif // B_VB_COMPATIBLE
DLL_DECL B_Boolean operator>= (const B_Boolean&,     const B_Currency&);   
DLL_DECL B_Boolean operator>= (const B_Currency&,    const B_Boolean&);      
DLL_DECL B_Boolean operator>= (const B_Empty&,       const B_Currency&);   
DLL_DECL B_Boolean operator>= (const B_Currency&,    const B_Empty&);      
DLL_DECL B_Null    operator>= (const B_Null&,        const B_Currency&);   
DLL_DECL B_Null    operator>= (const B_Currency&,    const B_Null&);      
DLL_DECL B_Boolean operator>= (const B_Dbl,        const B_Currency&);
DLL_DECL B_Boolean operator>= (const B_Currency&,  const B_Dbl);
DLL_DECL B_Boolean operator>= (const B_Flt,        const B_Currency&);
DLL_DECL B_Boolean operator>= (const B_Currency&,  const B_Flt);
DLL_DECL B_Boolean operator>= (const B_Lng,        const B_Currency&);
DLL_DECL B_Boolean operator>= (const B_Currency&,  const B_Lng);
DLL_DECL B_Boolean operator>= (const B_Int,        const B_Currency&);
DLL_DECL B_Boolean operator>= (const B_Currency&,  const B_Int);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Streamoperatoren
DLL_DECL ostream& operator<<(ostream& ostr, const B_Currency& rhs);
DLL_DECL istream& operator>>(istream& istr, B_Currency& rhs);


//================================ Inlinefunktionen =========================================================
//
#if defined _DEBUG || defined B_VB_CONTRACT
  #define B_NOINLINE
#else
  #undef B_NOINLINE
#endif

#ifndef B_NOINLINE                 // festlegen wenn Debuger keine Inlines debuggen kann
  #define B_INLINE inline
  #ifndef  BI_CURR_HPP
    #include "bi_curr.hpp"
  #endif
#endif


//===========================================================================================================
//================================ End Of Header ============================================================

#endif //THALESPLUS	
#endif // BC_CURR_HPP

