#ifndef BC_DBG_HPP
#define BC_DBG_HPP
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Project:                 VB nach C/C++ Konverter Klassenbibliothek
// Modul:                   Klassen die das Errorhandling der Bibliothek realisieren
// Filename:                bc_dbg.hpp
// Version:                 0.0
// Status:                  beta
//
// Copyright:               (C) 1995
//                          Cicerosoft GmbH
//                          Ballweilerstr. 7
//                          66399 Erfweiler-Ehlingen
//
// Operation System(s):     Win95 
// Compiler:                VC++ 4.1
//
// Author:                  Jochen Diener JD
// Creation Date::          JD 04.06.96
// Last Modification:       JD 04.06.96
//
// Description:             Beinhaltet alle Klassen / Hilfskt. die im Zusammenhang mit der VB
//                          Konvertierung, fuer die Bereitstellung des Errorhandlings der Bilbiothek benoetigt werden
//                          Hierbei werden Klassen fuer Zusicherungen, Tracing und Warnings bereitgestellt
//
// Dependencies:            bc_dbg.cpp   -> Klassenimpl.
//                          bi_dbg.hpp   -> Inline (Member)Funktionen der Klasse
//
// Remarks:
//
//
// Revision(s):
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

// VBnC
#ifndef BD_LIB_HPP
  #include "bd_lib.hpp"
#endif

#ifndef BD_INTYP_HPP
  #include "bd_intyp.hpp"
#endif

#ifndef BC_BOOL_HPP
  #define B_TRACE(lvl, msg) //zuruecksetzen wegen mehrdeutigkeiten
  #include "bc_bool.hpp"
#endif
 
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Description:                                                                           (C) CiceroSoft 1995
//     B_Assure  Basisklasse fuer Zusicherungen
// Hierachy:    
// Inheritance: 
// Errorhandling:
// Note: 
// Impl.: 
//     Fuer Debug, Trace, Warning bekommt Anwender das inline.hpp File mitgeliefert damit er in der Lage ist
//     auch fuer seine Funktionen und dem NDEBUG-Schalter diese Klassen vollstndig aus seinem Code zu entfernen
//     da er zugriff auf die Inline-Klasse hat. Dies kann problemlos gestattet werden da ja keine Fkt. davon implementiert
//     ist.
class DLL_DECL B_Assure
  {
  //==================== PROXY-CLASSES ====================================================================== 
  //
  public:
    class DLL_DECL Device
      {
      //================ MANAGEMENT =========================================================================
      //
      private:
        //---------------------------------------------------------------------------------------------------------       
        // Method:
        //     ctor
        // Parameter:  
        // Return Value:
        // Errorhandling:
        // Note:      
        Device(const B_UChar& devNbr);

        //---------------------------------------------------------------------------------------------------------       
        // Method:
        //     cctor
        // Parameter:  
        // Return Value:
        // Errorhandling:
        // Note:      
        Device(const Device&); // default

        //---------------------------------------------------------------------------------------------------------       
        // Method:
        //     Zuweisungsop.
        // Parameter:  
        // Return Value:
        // Errorhandling:
        // Note:      
        Device& operator=(const Device&); //default

      public:
        //---------------------------------------------------------------------------------------------------------       
        // Method:
        //     dtor
        // Parameter:  
        // Return Value:
        // Errorhandling:
        // Note:      
        ~Device(); //default


      //================ MEMBER =============================================================================
      //
      private:
        B_UChar deviceNbr;
        
      //================ FRIENDS ============================================================================
      //
      friend class B_Assure;
      }; // Device
  
    class DLL_DECL Level
      {
      //================ MANAGEMENT =========================================================================
      //
      private:
        //---------------------------------------------------------------------------------------------------------       
        // Method:
        //     ctor
        // Parameter:  
        // Return Value:
        // Errorhandling:
        // Note:      
        Level(const B_Char& lvlNbr);

        //---------------------------------------------------------------------------------------------------------       
        // Method:
        //     cctor
        // Parameter:  
        // Return Value:
        // Errorhandling:
        // Note:      
        Level(const Level&); // default

        //---------------------------------------------------------------------------------------------------------       
        // Method:
        //     Zuweisungsop.
        // Parameter:  
        // Return Value:
        // Errorhandling:
        // Note:      
        Level& operator=(const Level&); // default

      public:
        //---------------------------------------------------------------------------------------------------------       
        // Method:
        //     dtor
        // Parameter:  
        // Return Value:
        // Errorhandling:
        // Note:      
        ~Level(); //default

      //================ MEMBER =============================================================================
      //
      private:
        B_Char levelNbr;

      //================ FRIENDS ============================================================================
      //
      friend class B_Assure;
      }; // Level

  //================ MANAGEMENT =========================================================================
  //
  public:
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     ctor
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //     setzt den default-Level
    B_Assure();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     dtor
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note: 
    ~B_Assure(); 

  private:
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     cctor
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    B_Assure(const B_Assure&);

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Zuweisungsop.
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    B_Assure& operator=(const B_Assure&);

  //==================== INTERFACE ============================================================================
  //  
  public:
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Legt das Ausgabe-Device fuer die Assurence fest
    // Parameter:  
    //     Der Parameter legt fest ob die Ausgabe:
    //     console = In das Debugwindow der Lib ausgegeben wird.
    //     file    = In eine Datei (frei bestimmbar s. .fileName())
    //     Voreingestellt ist die Dateiausgabe im akt.VZ in HOMER.DBG
    // Return Value:
    // Errorhandling:
    // Note:      
    //     Die Einstellungen der Umgebungsvariablen B_DBG_DEV hat eine hoehere Prioritaet als die Einstellungen
    //     mit dieser Methode. Nur wenn B_DBG_DEV nicht definiert ist oder keine gueltige Levelangabe enthaelt
    //     werden die Methodenvorgaben genommen.
    // Impl.:
    //     staische Fkt. mit der Anwender global das Verhalten aller Debugmethoden einstellen kann.
    //     hierbei hat der Wert der Umgebunsvariablen einen hhere Prioritt B_DBG_DEV (abkuerzen da Umgebunsspeicher
    //     kostbar und meist begrenzt
    static void device(const Device& dev);
    static Device device();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Legt den Level fest welche Assuraces behandelt werden sollen
    // Parameter:  
    //     Ueber den Parameter lvl kann der Assure-Level festgelegt werden. Hierbei schliesst ein Level sich 
    //     selbst und alle groesseren Levels ein. Die Umgebungsvariable B_DBG_LVL hat hoehere Prioritaet als 
    //     die Methode, wenn sie auf einen gueltigen Wert gesetzt wurde.
    // Return Value:
    // Errorhandling:
    // Note:      
    static void level(const Level& lvl); 
    static Level level(); // damit Anwender in eigenen Klassen abfragen kann was eingestellt ist

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Legt den Dateinamen fuer die Ausgabe fest wenn device auf file gesetzt wurde.
    // Parameter:  
    //     Ein gueltiger Pfad fuer die Ausgabedatei. Die Umgebungsvariable B_DBG_FILE hat eine hoehere Prioritaet.
    //     Standardwert ist homer.dbg im aktuellen VZ
    // Return Value:
    // Errorhandling:
    // Note:      
    static void fileName(B_cCStr path);
    static B_CStr fileName();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Bestimmung von Preconditions = Vorbedingungen
    // Parameter:  
    //     Der boolsche Ausdruck wird getestet. Ergibt er B_False so wird die EH B_Assure ausgeworfen.
    //     Die EH enthaelt die message, welche bei auftreten der EH in das Debugfile ausgegeben wird.
    // Return Value:
    // Errorhandling:
    // Note:      
    //     Der Einsatz dieser Methode ist nur sinnvoll in Verbingung mit dem Makro B_PRECOND() s.unten
    // file = "" -> ersetzten durch file.isOptional usw. 
    static void require (const B_BOOLEAN expression, B_cCStr message, const B_Assure::Level& level = dfltLvl, B_cCStr file = "", const B_ULng line = 0);
    //static void require (const B_Boolean expression, const B_String& message, const B_Assure::Level& level, const B_String& file, const B_ULng line = 0);

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Bestimmung von Postconditions = Nachbedingungen
    // Parameter:  
    //     Der boolsche Ausdruck wird getestet. Ergibt er B_False so wird die EH B_Assure ausgeworfen.
    //     Die EH enthaelt die message, welche bei auftreten der EH in das Debugfile ausgegeben wird.
    // Return Value:
    // Errorhandling:
    // Note:      
    //     Der Einsatz dieser Methode ist nur sinnvoll in Verbingung mit dem Makro B_POSTCOND() s.unten
    static void ensure (const B_BOOLEAN expression,  B_cCStr message, const B_Assure::Level& level = dfltLvl, B_cCStr file = "", const B_ULng line = 0);
    //static void ensure (const B_Boolean expression,  const B_String& message, const B_Assure::Level& level, const B_String& file, const B_ULng line = 0);

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Bestimmung von Assertions = allg. Zusicherung
    // Parameter:  
    //     Der boolsche Ausdruck wird getestet. Ergibt er B_False so wird die EH B_Assure ausgeworfen.
    //     Die EH enthaelt die message, welche bei auftreten der EH in das Debugfile ausgegeben wird.
    // Return Value:
    // Errorhandling:
    // Note:      
    //     Der Einsatz dieser Methode ist nur sinnvoll in Verbingung mit dem Makro B_ASSERT() s.unten
    static void assertion (const B_BOOLEAN expression, B_cCStr message, const B_Assure::Level& level = dfltLvl, B_cCStr file = "", const B_ULng line = 0);
    //static void assertion (const B_Boolean expression,  const B_String& message, const B_Assure::Level& level, const B_String& file, const B_ULng line = 0);

  //==================== HELPER ===============================================================================
  //

  //==================== TYPES & CONSTANTS ==================================================================
  //
  public:
    static const B_Assure::Device console;
    static const B_Assure::Device file; 
    // Fuehrt der Benutzer eigene Levels ein kann er diese nicht mehr ueber die Umgebungsvariable steuern
    static const B_Assure::Level dfltLvl;
    static const B_Assure::Level lowLvl;
    static const B_Assure::Level lvl1;
    static const B_Assure::Level lvl2;
    static const B_Assure::Level lvl3;
    static const B_Assure::Level lvl4;
    static const B_Assure::Level highLvl;
  private:
    static B_Assure::Device   aktDevice;
    static B_Assure::Level    aktLevel;
    static B_Char aktFileName[MAX_FILE_NAME];
  }; // B_Assure


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Makros damit der Anwender die Debugklasse sinnvoll anwenden kann
// Der Vorteil gegenueber reinen Markos wie bei der Generic liegt darin dass die implementierung geaendert
// werden kann ohne dass der Anwender seine Sourcen neu compilieren muss da der code in der DLL liegt.

#ifndef NDEBUG
  #define B_REQUIRE_LVL(expr, lvl) B_Assure::require(expr, #expr, lvl, __FILE__, __LINE__)
  #define B_ENSURE_LVL(expr, lvl)  B_Assure::ensure(expr,  #expr, lvl, __FILE__, __LINE__)
  #define B_ASSERT_LVL(expr, lvl)  B_Assure::assertion(expr,  #expr, lvl, __FILE__, __LINE__)
  #define B_REQUIRE(expr) B_Assure::require(expr, #expr, B_Assure::dfltLvl, __FILE__, __LINE__)
  #define B_ENSURE(expr)  B_Assure::ensure(expr,  #expr, B_Assure::dfltLvl, __FILE__, __LINE__)
  #define B_ASSERT(expr)  B_Assure::assertion(expr,  #expr, B_Assure::dfltLvl, __FILE__, __LINE__)
#else
  #define B_REQUIRE_LVL(expr, lvl) 
  #define B_ENSURE_LVL(expr, lvl) 
  #define B_ASSERT_LVL(expr, lvl) 
  #define B_REQUIRE(expr) 
  #define B_ENSURE(expr) 
  #define B_ASSERT(expr) 
#endif

#ifdef NDEBUG
  #define B_OLD(name)   
  #define B_REMEMBER(type, name)
  #define B_REMEMBER_VALUE(type, name, expression)
#else
  #define B_OLD(name)                               name ## __remember     
  #define B_REMEMBER(type, name)                    type B_OLD(name)(name)
  #define B_REMEMBER_VALUE(type, name, expression)  type B_OLD(name)(expression) // in Generic expression ohne umschliessende Klammern -> Fehler
#endif


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Description:                                                                           (C) CiceroSoft 1995
//     B_Trace  Basisklasse fuer Trace-Meldungen
// Hierachy:    
// Inheritance: 
// Errorhandling:
// Note: 
// Impl.: 
class DLL_DECL B_Trace
  {
  //==================== PROXY-CLASSES ====================================================================== 
  //
  public:
    class DLL_DECL Device
      {
      //================ MANAGEMENT =========================================================================
      //
      private:
        //---------------------------------------------------------------------------------------------------------       
        // Method:
        //     ctor
        // Parameter:  
        // Return Value:
        // Errorhandling:
        // Note:      
        Device(const B_UChar& devNbr);

        //---------------------------------------------------------------------------------------------------------       
        // Method:
        //     cctor
        // Parameter:  
        // Return Value:
        // Errorhandling:
        // Note:      
        Device(const Device&); // default

        //---------------------------------------------------------------------------------------------------------       
        // Method:
        //     Zuweisungsop.
        // Parameter:  
        // Return Value:
        // Errorhandling:
        // Note:      
        Device& operator=(const Device&); //default

      public:  
        //---------------------------------------------------------------------------------------------------------       
        // Method:
        //     dtor
        // Parameter:  
        // Return Value:
        // Errorhandling:
        // Note:      
        ~Device(); //default


      //================ MEMBER =============================================================================
      //
      private:
        B_UChar deviceNbr;
        
      //================ FRIENDS ============================================================================
      //
      friend class B_Trace;
      friend class B_Tracer;
      }; // Device
  
    class DLL_DECL Level
      {
      //================ MANAGEMENT =========================================================================
      //
      private:
        //---------------------------------------------------------------------------------------------------------       
        // Method:
        //     ctor
        // Parameter:  
        // Return Value:
        // Errorhandling:
        // Note:      
        Level(const B_Char = 4);

        //---------------------------------------------------------------------------------------------------------       
        // Method:
        //     cctor
        // Parameter:  
        // Return Value:
        // Errorhandling:
        // Note:      
        Level(const Level&); // default

        //---------------------------------------------------------------------------------------------------------       
        // Method:
        //     Zuweisungsop.
        // Parameter:  
        // Return Value:
        // Errorhandling:
        // Note:      
        Level& operator=(const Level&); // default

      public:
        //---------------------------------------------------------------------------------------------------------       
        // Method:
        //     dtor
        // Parameter:  
        // Return Value:
        // Errorhandling:
        // Note:      
        ~Level(); //default

      //================ MEMBER =============================================================================
      //
      private:
        B_Char levelNbr;

      //================ FRIENDS ============================================================================
      //
      friend class B_Trace;
      friend class B_Tracer;
      friend DLL_DECL B_BOOLEAN operator<=(const Level&, const Level&);
      }; // Level

  //================ MANAGEMENT =========================================================================
  //
  public:
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     ctor
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //     setzt den default-Level
    B_Trace();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     dtor
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note: 
    ~B_Trace(); 

  private:
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     cctor
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    B_Trace(const B_Trace&);

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Zuweisungsop.
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    B_Trace& operator=(const B_Trace&);

  //==================== INTERFACE ============================================================================
  //  
  public:
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Legt das Ausgabe-Device fuer die Traceausgaben fest
    // Parameter:  
    //     Der Parameter legt fest ob die Ausgabe:
    //     console = In das Debugwindow der Lib ausgegeben wird.
    //     file    = In eine Datei (frei bestimmbar s. .fileName())
    //     Voreingestellt ist die Dateiausgabe im akt.VZ in HOMER.TRC
    // Return Value:
    // Errorhandling:
    // Note:      
    //     Die Einstellungen der Umgebungsvariablen B_TRC_DEV hat eine hoehere Prioritaet als die Einstellungen
    //     mit dieser Methode. Nur wenn B_TRC_DEV nicht definiert ist oder keine gueltige Levelangabe enthaelt
    //     werden die Methodenvorgaben genommen.
    // Impl.:
    //     staische Fkt. mit der Anwender global das Verhalten aller Debugmethoden einstellen kann.
    //     hierbei hat der Wert der Umgebunsvariablen einen hhere Prioritt B_TRC_DEV (abkuerzen da Umgebunsspeicher
    //     kostbar und meist begrenzt
    static void device(const Device& dev);
    static Device device();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Legt den Level fest welche Assuraces behandelt werden sollen
    // Parameter:  
    //     Ueber den Parameter lvl kann der Assure-Level festgelegt werden. Hierbei schliesst ein Level sich 
    //     selbst und alle groesseren Levels ein. Die Umgebungsvariable B_TRC_LVL hat hoehere Prioritaet als 
    //     die Methode, wenn sie auf einen gueltigen Wert gesetzt wurde.
    // Return Value:
    // Errorhandling:
    // Note:      
    static void level(const Level& lvl); 
    static Level level(); // damit Anwender in eigenen Klassen abfragen kann was eingestellt ist

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Legt den Dateinamen fuer die Ausgabe fest wenn device auf file gesetzt wurde.
    // Parameter:  
    //     Ein gueltiger Pfad fuer die Ausgabedatei. Die Umgebungsvariable B_TRC_FILE hat eine hoehere Prioritaet.
    //     Standardwert ist homer.dbg im aktuellen VZ
    // Return Value:
    // Errorhandling:
    // Note:      
    static void fileName(B_cCStr path);
    static B_CStr fileName();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Gibt den uebergebene Ausdruck aus
    // Parameter:  
    //     lvl legt den Trace-Level fest der ueber level()-Methode oder B_TRC_LVL gesteuert werden kann.
    //     msg bildet einen printf()-Like string der ausgegeben wird. Diese Methode erspart die Erzeugung
    //     eines Stringstreamobjektes
    // Return Value:
    // Errorhandling:
    // Note:      
    static void message(const Level& lvl, B_cCStr msg); // const char* -> B_cStr
    static void message(const char* msg, ...);

  //==================== TYPES & CONSTANTS ==================================================================
  //
  public:
    static const B_Trace::Device console;
    static const B_Trace::Device file; 
    // Fuehrt der Benutzer eigene Levels ein kann er diese nicht mehr ueber die Umgebungsvariable steuern
    static const B_Trace::Level lowLvl;		//alle mglichen Fehlermeldungen
    static const B_Trace::Level lvl1;
    static const B_Trace::Level lvl2;
    static const B_Trace::Level lvl3;
    static const B_Trace::Level lvl4;    
    static const B_Trace::Level lvl5;    
    static const B_Trace::Level lvl6;    
    static const B_Trace::Level highLvl;	//kaum Fehlermeldungen

  //==================== MEMBER =============================================================================
  private:
    static B_Trace::Device   aktDevice;
    static B_Trace::Level    aktLevel;
    static B_Char aktFileName[MAX_FILE_NAME];
  }; // B_Trace


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Description:                                                                           (C) CiceroSoft 1995
//     B_Tracer  Basisklasse fuer Tracer-Meldungen
// Hierachy:    
// Inheritance: 
// Errorhandling:
// Note: 
//     Fuer ein und austritt aus Funktionen und Methoden zu automatisieren
// Impl.: 
class DLL_DECL B_Tracer
  {
  //================ MANAGEMENT =========================================================================
  //
  public:
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     ctor
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    B_Tracer(const B_Trace::Level& lvl, B_cCStr message);

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     dtor
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    ~B_Tracer();

  //================ MEMBER =============================================================================
  //
  private:
    B_Trace::Level aktLevel;
    B_CStr message;
  }; // B_Tracer

DLL_DECL B_BOOLEAN operator<=(const B_Trace::Level&, const B_Trace::Level&);

#undef B_TRACE
#undef B_TRACER

#ifndef NDEBUG
  static B_Char bg_levelNumber;

# define B_TRACE(lvl, msgfmt) \
   if (B_Trace::level() <= lvl) B_Trace::message msgfmt ;
# define B_TRACER(lvl, msg) B_Tracer _tmpTracer_(lvl, msg)

#else

# define B_TRACE(lvl, msg)
# define B_TRACER(lvl, msg) 
#endif


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Description:                                                                           (C) CiceroSoft 1995
//     B_Warning  Basisklasse fuer Warnungs-Meldungen
// Hierachy:    
// Inheritance: 
// Errorhandling:
// Note: 
// Impl.: 
class DLL_DECL B_Warning
  {
  //==================== PROXY-CLASSES ====================================================================== 
  //
  public:
    class DLL_DECL Device
      {
      //================ MANAGEMENT =========================================================================
      //
      private:
        //---------------------------------------------------------------------------------------------------------       
        // Method:
        //     ctor
        // Parameter:  
        // Return Value:
        // Errorhandling:
        // Note:      
        Device(const B_UChar& devNbr);

        //---------------------------------------------------------------------------------------------------------       
        // Method:
        //     cctor
        // Parameter:  
        // Return Value:
        // Errorhandling:
        // Note:      
        Device(const Device&); // default

        //---------------------------------------------------------------------------------------------------------       
        // Method:
        //     Zuweisungsop.
        // Parameter:  
        // Return Value:
        // Errorhandling:
        // Note:      
        Device& operator=(const Device&); //default

      public:
        //---------------------------------------------------------------------------------------------------------       
        // Method:
        //     dtor
        // Parameter:  
        // Return Value:
        // Errorhandling:
        // Note:      
        ~Device(); //default


      //================ MEMBER =============================================================================
      //
      private:
        B_UChar deviceNbr;
        
      //================ FRIENDS ============================================================================
      //
      friend class B_Warning;
      }; // Device
  
    class DLL_DECL Level
      {
      //================ MANAGEMENT =========================================================================
      //
      private:
        //---------------------------------------------------------------------------------------------------------       
        // Method:
        //     ctor
        // Parameter:  
        // Return Value:
        // Errorhandling:
        // Note:      
        Level(const B_Char& lvlNbr);

        //---------------------------------------------------------------------------------------------------------       
        // Method:
        //     cctor
        // Parameter:  
        // Return Value:
        // Errorhandling:
        // Note:      
        Level(const Level&); // default

        //---------------------------------------------------------------------------------------------------------       
        // Method:
        //     Zuweisungsop.
        // Parameter:  
        // Return Value:
        // Errorhandling:
        // Note:      
        Level& operator=(const Level&); // default

      public:
        //---------------------------------------------------------------------------------------------------------       
        // Method:
        //     dtor
        // Parameter:  
        // Return Value:
        // Errorhandling:
        // Note:      
        ~Level(); //default

      //================ MEMBER =============================================================================
      //
      private:
        B_Char levelNbr;

      //================ FRIENDS ============================================================================
      //
      friend class B_Warning;
      }; // Level

  //================ MANAGEMENT =========================================================================
  //
  public:
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     ctor
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //     setzt den default-Level
    B_Warning();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     dtor
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note: 
    ~B_Warning(); 

  private:
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     cctor
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    B_Warning(const B_Warning&);

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Zuweisungsop.
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    B_Warning& operator=(const B_Warning&);

  //==================== INTERFACE ============================================================================
  //  
  public:
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Legt das Ausgabe-Device fuer die Traceausgaben fest
    // Parameter:  
    //     Der Parameter legt fest ob die Ausgabe:
    //     console = In das Debugwindow der Lib ausgegeben wird.
    //     file    = In eine Datei (frei bestimmbar s. .fileName())
    //     Voreingestellt ist die Dateiausgabe im akt.VZ in HOMER.WRN
    // Return Value:
    // Errorhandling:
    // Note:      
    //     Die Einstellungen der Umgebungsvariablen B_WRN_DEV hat eine hoehere Prioritaet als die Einstellungen
    //     mit dieser Methode. Nur wenn B_WRN_DEV nicht definiert ist oder keine gueltige Levelangabe enthaelt
    //     werden die Methodenvorgaben genommen.
    // Impl.:
    //     staische Fkt. mit der Anwender global das Verhalten aller Debugmethoden einstellen kann.
    //     hierbei hat der Wert der Umgebunsvariablen einen hhere Prioritt B_WRN_DEV (abkuerzen da Umgebunsspeicher
    //     kostbar und meist begrenzt
    static void device(const Device& dev);
    static Device device();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Legt den Level fest welche Assuraces behandelt werden sollen
    // Parameter:  
    //     Ueber den Parameter lvl kann der Assure-Level festgelegt werden. Hierbei schliesst ein Level sich 
    //     selbst und alle groesseren Levels ein. Die Umgebungsvariable B_WRN_LVL hat hoehere Prioritaet als 
    //     die Methode, wenn sie auf einen gueltigen Wert gesetzt wurde.
    // Return Value:
    // Errorhandling:
    // Note:      
    static void level(const Level& lvl); 
    static Level level(); // damit Anwender in eigenen Klassen abfragen kann was eingestellt ist

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Legt den Dateinamen fuer die Ausgabe fest wenn device auf file gesetzt wurde.
    // Parameter:  
    //     Ein gueltiger Pfad fuer die Ausgabedatei. Die Umgebungsvariable B_WRN_FILE hat eine hoehere Prioritaet.
    //     Standardwert ist homer.dbg im aktuellen VZ
    // Return Value:
    // Errorhandling:
    // Note:      
    static void fileName(B_cCStr path);
    static B_CStr fileName();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Gibt den uebergebene Ausdruck aus
    // Parameter:  
    //     lvl legt den Warning-Level fest der ueber level()-Methode oder B_WRN_LVL gesteuert werden kann.
    //     msg bildet einen printf()-Like string der ausgegeben wird. Diese Methode erspart die Erzeugung
    //     eines Stringstreamobjektes
    // Return Value:
    // Errorhandling:
    // Note:      
    static void message(const Level& lvl, B_cCStr msg);

  //==================== TYPES & CONSTANTS ==================================================================
  //
  public:
    static const B_Warning::Device console;
    static const B_Warning::Device file; 
    // Fuehrt der Benutzer eigene Levels ein kann er diese nicht mehr ueber die Umgebungsvariable steuern
    static const B_Warning::Level lowLvl;
    static const B_Warning::Level lvl1;
    static const B_Warning::Level lvl2;
    static const B_Warning::Level lvl3;
    static const B_Warning::Level lvl4;
    static const B_Warning::Level highLvl;

  //==================== MEMBER =============================================================================
  private:
    static B_Warning::Device   aktDevice;
    static B_Warning::Level    aktLevel;
    static B_Char aktFileName[MAX_FILE_NAME];
  }; // B_Warning


#ifndef NDEBUG
  #define B_WARNING(lvl, msg) B_Warning::message(lvl, msg)
#else
  #define B_WARNING(lvl, msg)
#endif

//================================ Inlinefunktionen =========================================================
//
#if defined _DEBUG // || defined B_VB_CONTRACT JD060896
  #define B_NOINLINE  
#else
  #undef B_NOINLINE
#endif

#ifndef B_NOINLINE // #ifdef NDEBUG
  #define B_INLINE inline
  #ifndef BI_DBG_HPP
    #include "bi_dbg.hpp"
  #endif
#endif

/*
class B_DebugInit
  {
  public:
    B_DebugInit();
    ~B_DebugInit();
  private:
    static B_UShrt defCounter;
  }; // B_DebugInit

static B_DebugInit B_debugInit;
*/

//===========================================================================================================
//================================ End Of Header ============================================================
#endif // BC_DBG_HPP
