#ifdef B_VB_COMPATIBLE

#ifndef BC_DBL_HPP
#define BC_DBL_HPP
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Project:                 VB nach C/C++ Konverter Klassenbibliothek
// Modul:                   VB Klasse fuer VB Double Datentyp
// Filename:                bc_dbl.hpp
// Version:                 1.0
// Status:                  beta
//
// Copyright:               (C)
//                          Cicerosoft GmbH,
//                          Ballweilerstr. 7,
//                          66399 Erfweiler-Ehlingen
//
// Operating System(s):     Win95 
// Compiler:                VC++ 4.1
//
// Author:                  Jochen Diener JD
// Creation Date:           18.12.95
// Last modification:       JD 03.07.96
//
// Description:             Beinhaltet die Implementierung der B_Single Klasee
//
//
// Dependencies:            bi_dbl.cpp   -> Inline-Fkt
//                          bc_dbl.hpp   -> Deklaration 
//
// Remarks:
//
// Revision(s):
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

//================================= Defintionsabhaengigkeiten ===============================================
//
#include <iostream.h>

#ifndef BD_INTYP_HPP       
  #include "bd_intyp.hpp"       // alias der Standardatentypen
#endif

#ifndef BC_BOOL_HPP
  #include "bc_bool.hpp"  
#endif

#ifndef BC_EMPTY_HPP
  #include "bc_empty.hpp" 
#endif

#ifndef BC_NULL_HPP
  #include "bc_null.hpp"  
#endif

#ifndef BC_BYTE_HPP
  #include "bc_byte.hpp"
#endif

#ifndef BC_INT_HPP
  #include "bc_int.hpp"
#endif

#ifndef BC_LONG_HPP
  #include "bc_long.hpp"
#endif

#ifndef BC_SNGLE_HPP
  #include "bc_sngle.hpp"
#endif

//================================= Export =================================================================
//
class B_Currency;
class B_String;
class B_fstream;						// CT131296 Fuer FileIO abgeleitete fstream-Klasse

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Description:                                                                           (C) CiceroSoft 1995
//     B_Double    Emuliert VB-Datentyp Double
// Hierachy:    
// Inheritance: 
// Errorhandling:
// Note: 
//
class DLL_DECL B_Double
  {
  //==================== MANGAEMENT =========================================================================
  //
  public: 
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     ctor
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Double(); 

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     ctor' fuer Bibliotheksdatentypen
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Double(const B_String&); // throw(B_TypeMismatch);
    B_Double(const B_Currency&);
    B_Double(const B_Single&);
    B_Double(const B_Long&);
    B_Double(const B_Integer&);
    B_Double(const B_Byte&);
    B_Double(const B_Boolean&);
    B_Double(const B_Empty&); 
    B_Double(const B_Null&);   // throw(B_InvalidNull);  
    
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     ctor' fuer C-Standarddatentypen
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Double(B_cCStr,      const B_Explicit&);  // throw (B_TypeMismatch)
    B_Double(const B_Dbl,  const B_Explicit&);
    B_Double(const B_Flt,  const B_Explicit&); 
    B_Double(const B_Lng,  const B_Explicit&); 
    B_Double(const B_UInt, const B_Explicit&); 
    B_Double(const B_Int,  const B_Explicit&);   


    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     cctor
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Double(const B_Double&);

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Zuweisungsop.
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Double& operator=(const B_Double&);

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     dtor
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    ~B_Double();

  //==================== INTERFACE ============================================================================
  //
  public:
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Zuweisungsop. fuer Bibliotheksdatentypen
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Double& operator=(const B_String&)   throw (B_TypeMismatch);  
    B_Double& operator=(const B_Currency&);
    B_Double& operator=(const B_Single&);
    B_Double& operator=(const B_Long&);
    B_Double& operator=(const B_Integer&);    
    B_Double& operator=(const B_Byte&);
    B_Double& operator=(const B_Boolean&);
    B_Double& operator=(const B_Empty&);  
    B_Double& operator=(const B_Null&)     throw(B_InvalidNull);   

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Zuweisungsop. fuer C-Standarddatentypen
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Double& operator=(const B_Int);   
    B_Double& operator=(const B_UInt);   
    B_Double& operator=(const B_Lng);
    B_Double& operator=(const B_Flt);
    B_Double& operator=(const B_Dbl); 
    B_Double& operator=(B_cCStr)      throw (B_TypeMismatch);  


    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Addition des Wertes selbst mit einem anderen Wert. Entspricht x = x + y
    // Parameter:  
    //     Wert der hinzuaddiert werden soll (Entspricht y)
    // Return Value:
    //     Das Ergebnis der Addition
    // Errorhandling:
    // Note:      
    //
    B_Double& operator+=(const B_Double&)  throw(B_Overflow);
    B_Double& operator+=(const B_Single&)  throw(B_Overflow);
    B_Double& operator+=(const B_Long&)    throw(B_Overflow);
    B_Double& operator+=(const B_Integer&) throw(B_Overflow);
    B_Double& operator+=(const B_Byte&)    throw(B_Overflow);
    B_Double& operator+=(const B_Boolean&) throw(B_Overflow);
    B_Double& operator+=(const B_Empty&);
    B_Double& operator+=(const B_Null&)    throw(B_InvalidNull);
    B_Double& operator+=(const B_Dbl)      throw(B_Overflow);
    
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Subtraktion des Wertes selbst mit einem anderen Wert. Entspricht x = x - y
    // Parameter:  
    //     Wert der subtrahiert werden soll (Entspricht y)
    // Return Value:
    //     Das Ergebnis der Subtraktion
    // Errorhandling:
    // Note:      
    //
    B_Double& operator-=(const B_Double&)  throw(B_Overflow);
    B_Double& operator-=(const B_Single&)  throw(B_Overflow);
    B_Double& operator-=(const B_Long&)    throw(B_Overflow);
    B_Double& operator-=(const B_Integer&) throw(B_Overflow); 
    B_Double& operator-=(const B_Byte&)    throw(B_Overflow);
    B_Double& operator-=(const B_Boolean&) throw(B_Overflow);
    B_Double& operator-=(const B_Empty&);
    B_Double& operator-=(const B_Null&)    throw(B_InvalidNull);
    B_Double& operator-=(const B_Dbl)      throw(B_Overflow);
    
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Multiplikation des Wertes selbst mit einem anderen Wert. Entspricht x = x * y
    // Parameter:  
    //     Wert der multipliziert werden soll (Entspricht y)
    // Return Value:
    //     Das Ergebnis der Multiplikation
    // Errorhandling:
    // Note:      
    //
    B_Double& operator*=(const B_Double&)  throw(B_Overflow, B_Underflow);
    B_Double& operator*=(const B_Single&)  throw(B_Overflow, B_Underflow);
    B_Double& operator*=(const B_Long&)    throw(B_Overflow, B_Underflow);
    B_Double& operator*=(const B_Integer&) throw(B_Overflow, B_Underflow);
    B_Double& operator*=(const B_Byte&)    throw(B_Overflow, B_Underflow);
    B_Double& operator*=(const B_Boolean&);
    B_Double& operator*=(const B_Empty&);
    B_Double& operator*=(const B_Null&)    throw(B_InvalidNull);
    B_Double& operator*=(const B_Dbl)      throw(B_Overflow, B_Underflow);

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Division des Wertes selbst mit einem anderen Wert. Entspricht x = x / y
    // Parameter:  
    //     Wert der dividiert werden soll (Entspricht y)
    // Return Value:
    //     Das Ergebnis der Division
    // Errorhandling:
    // Note:      
    //
    B_Double& operator/=(const B_Double&)  throw(B_ZeroDivide, B_Underflow);
    B_Double& operator/=(const B_Single&)  throw(B_ZeroDivide, B_Underflow);
    B_Double& operator/=(const B_Long&)    throw(B_ZeroDivide, B_Underflow);    
    B_Double& operator/=(const B_Integer&) throw(B_ZeroDivide, B_Underflow);
    B_Double& operator/=(const B_Byte&)    throw(B_ZeroDivide, B_Underflow);
    B_Double& operator/=(const B_Boolean&) throw(B_ZeroDivide);
    B_Double& operator/=(const B_Empty&)   throw(B_ZeroDivide);
    B_Double& operator/=(const B_Null&)    throw(B_InvalidNull);
    B_Double& operator/=(const B_Dbl)      throw(B_ZeroDivide, B_Underflow);

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Modulo Operation = Restwert einer Division. Entspricht x = x % y
    // Parameter:  
    //     Wert der dividiert werden soll (Entspricht y)
    // Return Value:
    //     Restwert der Division
    // Errorhandling:
    // Note:      
    //     Im Gegensatz zum Binaren-Operator wird hier der ganze Double-Wertebereich
    //     unterstuetzt (in VB muessen die Operanden im Long-Wertebereich liegen sonst
    //     wird eine EH B_Overflow ausgeloest),
    B_Double& operator%=(const B_Double&)  throw(B_ZeroDivide, B_Underflow);
    B_Double& operator%=(const B_Single&)  throw(B_ZeroDivide, B_Underflow);
    B_Double& operator%=(const B_Long&)    throw(B_ZeroDivide, B_Underflow);    
    B_Double& operator%=(const B_Integer&) throw(B_ZeroDivide, B_Underflow);
    B_Double& operator%=(const B_Byte&)    throw(B_ZeroDivide, B_Underflow);
    B_Double& operator%=(const B_Boolean&) throw(B_ZeroDivide);
    B_Double& operator%=(const B_Empty&)   throw(B_ZeroDivide);
    B_Double& operator%=(const B_Null&)    throw(B_InvalidNull);
    B_Double& operator%=(const B_Dbl)      throw(B_ZeroDivide, B_Underflow);

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     operator!   Nicht-Operator
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Long operator!() const throw(B_Overflow);

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Unaeres Minus
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Double operator-() const;

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Inkrement/dekrement des Objektes. Entspricht: x = x + 1;/ x = x -1
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Double& operator++() throw(B_Overflow);
    B_Double& operator--() throw(B_Overflow);

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Konvertierungsop. fuer C-Standarddatentyp
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    operator B_Dbl() const;

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Rundet den Wert des Objekts auf die angegebene Stellenzahl.
    //     Diese Zahl muss 0 < x <= MAX_DIGITS der genauigkeitsangabe des Objekttyps sein
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Double& rnd(const B_Byte& digits);
    
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //      Konvertiert das Objekt in seinen ganzzahligen Anteil.  Bei negativen Zahlen 
    //      konvertiert Int das Objekt in diejenige negative ganze Zahl, die kleiner oder 
    //      gleich dem Objektwert ist. 
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //     Die Methoden geben B_Single zurueck die Funktionen (B_int()) aus Kompatibilitaet zu VB korrekterweise B_Double    
    //     ACHTUNG an alle C++ Programmierer int ist nicht vergleichbar mit den mathe Bibliotheksfkt. floor/ceil von C/C++.
    //     int( 2.8)  = floor(2.8)   -> 2
    //     int(-2.8)  = floor(-2.8)  -> -3
    //     Die Funktion ist aus Kompatibilitaetsgruenden zu VB enthalten
    B_Double& intf();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Konvertiert das Objekt in seinen ganzzahligen Anteil.  Bei negativen Zahlen 
    //     konvertiert Fix das Objekt in diejenige negative ganze Zahl, die groesser oder 
    //     gleich dem Objektwert ist. 
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //     Die Methoden geben B_Single zurueck die Funktionen aus Kompatibilitaet zu VB korrekterweise B_Double
    //     ACHTUNG an alle C++ Programmierer int ist nicht vergleichbar mit den mathe  Bibliotheksfkt. floor/ceil von C/C++.
    //     fix( 2.8)  = floor(2.8)   ->  2
    //     fix(-2.8)  = ceil(-2.8)   -> -2
    //     Fix(Zahl) entspricht also in C/C++ dem folgenden Ausdruck: Sgn(Zahl) * Int(Abs(Zahl))
    B_Double& fix();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Konvertiert das Objekt in seine Fractional=Nachkomma Darstellung. D.h dass der 
    //     Vorkommaanteil der Zahl abgeschnitten (zu 0 gestzt) wird.
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //     123.45678 -> 0.45678
    //     Die Funktion dient zur Ergaenzung der int und fix Funktionennt(Abs(Zahl))
    B_Double& fract();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Konvertiert das Objekt in seine groesste Integerdarstellung die kleiner oder
    //     gleich ist als der akt. Wert des Objektes.
    //     floor(2.8)  ->  2
    //     floor(-2.8) -> -3   
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Double& floor();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Konvertiert das Objekt in seine kleinste Integerdarstellung die groesser oder
    //     gleich ist als der akt. Wert des Objektes.
    //     ceil(2.8)  ->  3
    //     ceil(-2.8) -> -2   
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Double& ceil();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Wandelt den Wert des Objektes in einen Absoluten Wert um, d.h 
    //     negativer Objektwert -> positiv
    //     positiver Objektwert -> bleibt positiv
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Double& abs();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Gibt den Wert des Objektes als entsprechenden C/C++ Datentyp zurueck
    // Parameter:  
    // Return Value:
    //     Kopie des Objetkwertes als B_Lng
    // Errorhandling:
    // Note:      
    //     Den genauen Typ von B_Flt kann man in bd_intyp.hpp feststellen, in der alle C/C++ Datentypen definiert sind.
    //     Diese Funktion soll den Datenaustausch zwischen Klassen der Klassenbibliothek
    //     und den mit den C++ Standarddatentypen geschriebenen Funktionen ermoeglichen
    //     wenn diese keine Klassen als Parameter erlauben.
    B_Dbl getValue() const;

    //----------------------------------------------------------------------------------------------------       
    // Method:
    //     Gibt die Groesse des Wert des Objektes als entsprechenden C/C++ Datentyp zurueck
    // Return Value:
    //     Groesse in Byte
    // Note:
    //     Den genauen Typ und somit seine groesse koennen zwischen den C/C++ Datentypen der
    //     Compiler unterschiedlich sein, deshalb wurde diese Method eingefuegt die eine
    //     portable Programmierung aehnlich sizeof() ermoeglichen soll.
    B_ULng  getValueSize() const;  
    
    //----------------------------------------------------------------------------------------------------       
    // Method: 
    //     Gibt die Groesse des Objktes zurueck, diese entspricht der durch das Objekt belegten
    //     Speicherplatz
    // Return Value: 
    //     Groesse in Byte
    // Note: 
    //     Den genauen Typ und somit seine groesse koennen zwischen den C/C++ Compiler 
    //     unterschiedlich sein. Auch koennte sich die Klassenimplementierung aendern so
    //     dass aeltere Programme nur mit Aenderungsprogramm lauffaehig waeren, deshalb 
    //     wurde diese Method eingefuegt die eine portable Programmierung aehnlich 
    //     sizeof() ermoeglichen soll.
    B_ULng getSize() const;       

    //----------------------------------------------------------------------------------------------------       
    // Method: 
    //     Setzt den internen Status des Objektes auf optional. Somit kann mit isMissing der Status
    //     abgefragt werden und die Emulation des gleichnamigen VB Befehls wird moeglich.
    // Return Value: 
    // Note: 
    //
    B_Double& isOptional();

    //----------------------------------------------------------------------------------------------------       
    // Method: 
    //     Abfragen des internen Objektstatus ob das Argument einer Funktion optional ist oder nicht
    // Return Value: 
    // Note: 
    //
    B_Boolean isMissing() const;

    //----------------------------------------------------------------------------------------------------       
    // Method: 
    //     Schreiben der der eigentlichen Objektdaten im binaeren Format in einen Stream
    // Return Value: 
    //     B_true  ==  Objekt und Stream sind gueltig
    //     B_false ==  Objekt oder Stream sind ungueltig
    // Note: 
    //
    B_Boolean streamw(ostream& ostr, B_Shrt openmode) const;

    //----------------------------------------------------------------------------------------------------       
    // Method: 
    //     Lesen der der eigentlichen Objektdaten im binaeren Format in einen Stream
    // Return Value: 
    //     B_true  ==  Objekt und Stream sind gueltig
    //     B_false ==  Objekt oder Stream sind ungueltig
    // Note: 
    //
    B_Boolean streamr(istream& istr, B_Shrt openmode);

  private:
    //----------------------------------------------------------------------------------------------------       
    // Method:
    //     Postfix   Inkrement/Dekrement
    // Parameter:  
    // Return Value: 
    // Note:      
    //     Da es beim ueberladen keinen wirkliche Postfixoperatoren gibt wurden diese gesperrt
    B_Double& operator++(int);
    B_Double& operator--(int);
    
  //==================== MEMBER ===============================================================================    
  //
  private:
    B_Dbl value;  // im VB Wertebereich: 4,94065645841247E-324 bis 1,79769313486232E308 (lt. VBHilfe nach IEEE)
                  // VB verwendet IEEE Format 64bit -> sign=1bit, exponent=11bit, mantisse=52bit (1bit impl.) 
                  // ACHTUNG: wie auch schon beim Single/Float Datentyp koennen sich je nach Compiler die 
                  //          Wertebereiche der Datentypen unterscheiden.
                  // 2.2250738585072014E-308	bis 1.7976931348623158E+308   16bit und 32bit 15Digits (VC++40, WC++105, SC++72)
                  //   	             1.7E-308 bis 1.7E+308      (64 bits)   16bit und 32bit 15Digits (VC++22, BC++45)
                  // Somit sind nur die zuletzt genannten Werte sichere Werte
    B_Flag optional;
    
  //==================== FRIENDS ============================================================================
  //
  friend class B_Currency;
  friend class B_Single;
  friend class B_Long;
  friend class B_Integer;
  friend class B_Byte;
  friend class B_String;
  
  friend DLL_DECL B_Double operator+ (const B_Double&,   const B_Double&) ;
  friend DLL_DECL B_Double operator+ (const B_Single&,   const B_Double&) ; 
  friend DLL_DECL B_Double operator+ (const B_Double&,   const B_Single&) ;
  friend DLL_DECL B_Double operator+ (const B_Long&,     const B_Double&) ; 
  friend DLL_DECL B_Double operator+ (const B_Double&,   const B_Long&)  ;
  friend DLL_DECL B_Double operator+ (const B_Integer&,  const B_Double&) ;
  friend DLL_DECL B_Double operator+ (const B_Double&,   const B_Integer&);
  friend DLL_DECL B_Double operator+ (const B_Byte&,     const B_Double&);
  friend DLL_DECL B_Double operator+ (const B_Double&,   const B_Byte&);
  friend DLL_DECL B_Double operator+ (const B_Boolean&,  const B_Double&);
  friend DLL_DECL B_Double operator+ (const B_Double&,   const B_Boolean&);
  friend DLL_DECL B_Double operator+ (const B_Double&,   const B_Dbl) ;
  friend DLL_DECL B_Double operator+ (const B_Dbl,       const B_Double&) ;
  friend DLL_DECL B_Double operator+ (const B_Single&,   const B_Dbl) ; 
  friend DLL_DECL B_Double operator+ (const B_Dbl,       const B_Single&) ;
  friend DLL_DECL B_Double operator+ (const B_Long&,     const B_Dbl) ; 
  friend DLL_DECL B_Double operator+ (const B_Dbl,       const B_Long&)  ;
  friend DLL_DECL B_Double operator+ (const B_Integer&,  const B_Dbl) ;
  friend DLL_DECL B_Double operator+ (const B_Dbl,       const B_Integer&);
  friend DLL_DECL B_Double operator+ (const B_Byte&,     const B_Dbl);
  friend DLL_DECL B_Double operator+ (const B_Dbl,       const B_Byte&);
  friend DLL_DECL B_Double operator+ (const B_Double&,   const B_Int) ;
  friend DLL_DECL B_Double operator+ (const B_Int,       const B_Double&) ;

  friend DLL_DECL B_Double operator- (const B_Double&,   const B_Double&);
  friend DLL_DECL B_Double operator- (const B_Single&,   const B_Double&); 
  friend DLL_DECL B_Double operator- (const B_Double&,   const B_Single&);
  friend DLL_DECL B_Double operator- (const B_Long&,     const B_Double&); 
  friend DLL_DECL B_Double operator- (const B_Double&,   const B_Long&);
  friend DLL_DECL B_Double operator- (const B_Integer&,  const B_Double&);
  friend DLL_DECL B_Double operator- (const B_Double&,   const B_Integer&);
  friend DLL_DECL B_Double operator- (const B_Byte&,     const B_Double&);
  friend DLL_DECL B_Double operator- (const B_Double&,   const B_Byte&);
  friend DLL_DECL B_Double operator- (const B_Boolean&,  const B_Double&);
  friend DLL_DECL B_Double operator- (const B_Double&,   const B_Boolean&);
  friend DLL_DECL B_Double operator- (const B_Empty&,    const B_Double&);
  friend DLL_DECL B_Double operator- (const B_Double&,   const B_Empty&);
  friend DLL_DECL B_Double operator- (const B_Double&,   const B_Dbl) ;
  friend DLL_DECL B_Double operator- (const B_Dbl,       const B_Double&) ;
  friend DLL_DECL B_Double operator- (const B_Single&,   const B_Dbl) ; 
  friend DLL_DECL B_Double operator- (const B_Dbl,       const B_Single&) ;
  friend DLL_DECL B_Double operator- (const B_Long&,     const B_Dbl) ; 
  friend DLL_DECL B_Double operator- (const B_Dbl,       const B_Long&)  ;
  friend DLL_DECL B_Double operator- (const B_Integer&,  const B_Dbl) ;
  friend DLL_DECL B_Double operator- (const B_Dbl,       const B_Integer&);
  friend DLL_DECL B_Double operator- (const B_Byte&,     const B_Dbl);
  friend DLL_DECL B_Double operator- (const B_Dbl,       const B_Byte&);
  friend DLL_DECL B_Double operator- (const B_Double&,   const B_Int) ;
  friend DLL_DECL B_Double operator- (const B_Int,       const B_Double&) ;

  friend DLL_DECL B_Double operator* (const B_Double&,  const B_Double&);
  friend DLL_DECL B_Double operator* (const B_Single&,  const B_Double&); 
  friend DLL_DECL B_Double operator* (const B_Double&,  const B_Single&);
  friend DLL_DECL B_Double operator* (const B_Long&,    const B_Double&); 
  friend DLL_DECL B_Double operator* (const B_Double&,  const B_Long&);
  friend DLL_DECL B_Double operator* (const B_Integer&, const B_Double&);
  friend DLL_DECL B_Double operator* (const B_Double&,  const B_Integer&);
  friend DLL_DECL B_Double operator* (const B_Byte&,    const B_Double&);
  friend DLL_DECL B_Double operator* (const B_Double&,  const B_Byte&);
  friend DLL_DECL B_Double operator* (const B_Boolean&, const B_Double&);
  friend DLL_DECL B_Double operator* (const B_Double&,  const B_Boolean&);
  friend DLL_DECL B_Double operator* (const B_Double&,  const B_Dbl);
  friend DLL_DECL B_Double operator* (const B_Dbl,      const B_Double&);
  friend DLL_DECL B_Double operator* (const B_Single&,  const B_Dbl); 
  friend DLL_DECL B_Double operator* (const B_Dbl,      const B_Single&);
  friend DLL_DECL B_Double operator* (const B_Long&,    const B_Dbl); 
  friend DLL_DECL B_Double operator* (const B_Dbl,      const B_Long&);
  friend DLL_DECL B_Double operator* (const B_Integer&, const B_Dbl);
  friend DLL_DECL B_Double operator* (const B_Dbl,      const B_Integer&);
  friend DLL_DECL B_Double operator* (const B_Byte&,    const B_Dbl);
  friend DLL_DECL B_Double operator* (const B_Dbl,      const B_Byte&);
  friend DLL_DECL B_Double operator* (const B_Double&,  const B_Int);
  friend DLL_DECL B_Double operator* (const B_Int,      const B_Double&) ;

  friend DLL_DECL B_Double  operator/ (const B_Double&,   const B_Double&);
  friend DLL_DECL B_Double  operator/ (const B_Single&,   const B_Double&); 
  friend DLL_DECL B_Double  operator/ (const B_Double&,   const B_Single&);
  friend DLL_DECL B_Double  operator/ (const B_Long&,     const B_Double&); 
  friend DLL_DECL B_Double  operator/ (const B_Double&,   const B_Long&);
  friend DLL_DECL B_Double  operator/ (const B_Integer&,  const B_Double&);
  friend DLL_DECL B_Double  operator/ (const B_Double&,   const B_Integer&);
  friend DLL_DECL B_Double  operator/ (const B_Byte&,     const B_Double&);
  friend DLL_DECL B_Double  operator/ (const B_Double&,   const B_Byte&);
  friend DLL_DECL B_Double  operator/ (const B_Boolean&,  const B_Double&);
  friend DLL_DECL B_Double  operator/ (const B_Double&,   const B_Boolean&);
  friend DLL_DECL B_Double  operator/ (const B_Empty&,    const B_Double&);
  friend DLL_DECL B_Double  operator/ (const B_Double&,   const B_Dbl) ;
  friend DLL_DECL B_Double  operator/ (const B_Dbl,       const B_Double&) ;
  friend DLL_DECL B_Double  operator/ (const B_Single&,   const B_Dbl) ; 
  friend DLL_DECL B_Double  operator/ (const B_Dbl,       const B_Single&) ;
  friend DLL_DECL B_Double  operator/ (const B_Long&,     const B_Dbl) ; 
  friend DLL_DECL B_Double  operator/ (const B_Dbl,       const B_Long&)  ;
  friend DLL_DECL B_Double  operator/ (const B_Integer&,  const B_Dbl) ;
  friend DLL_DECL B_Double  operator/ (const B_Dbl,       const B_Integer&);
  friend DLL_DECL B_Double  operator/ (const B_Byte&,     const B_Dbl);
  friend DLL_DECL B_Double  operator/ (const B_Dbl,       const B_Byte&);
  friend DLL_DECL B_Double  operator/ (const B_Double&,   const B_Int) ;
  friend DLL_DECL B_Double  operator/ (const B_Int,       const B_Double&) ;

  friend DLL_DECL B_Long  operator% (const B_Double&,  const B_Double&);
  friend DLL_DECL B_Long  operator% (const B_Single&,  const B_Double&);
  friend DLL_DECL B_Long  operator% (const B_Double&,  const B_Single&);
  friend DLL_DECL B_Long  operator% (const B_Long&,    const B_Double&);
  friend DLL_DECL B_Long  operator% (const B_Double&,  const B_Long&);
  friend DLL_DECL B_Long  operator% (const B_Integer&, const B_Double&);
  friend DLL_DECL B_Long  operator% (const B_Double&,  const B_Integer&);
  friend DLL_DECL B_Long  operator% (const B_Byte&,    const B_Double&);
  friend DLL_DECL B_Long  operator% (const B_Double&,  const B_Byte&);
  friend DLL_DECL B_Long  operator% (const B_Boolean&, const B_Double&);
  friend DLL_DECL B_Long  operator% (const B_Double&,  const B_Boolean&);
  friend DLL_DECL B_Long  operator% (const B_Empty&,   const B_Double&);
  friend DLL_DECL B_Long  operator% (const B_Double&,  const B_Empty&);
  friend DLL_DECL B_Long  operator% (const B_Double&,  const B_Dbl) ;
  friend DLL_DECL B_Long  operator% (const B_Dbl,      const B_Double&) ;
  friend DLL_DECL B_Long  operator% (const B_Double&,  const B_Int) ;
  friend DLL_DECL B_Long  operator% (const B_Int,      const B_Double&) ;

  friend DLL_DECL B_Long B_Div(const B_Double&,   const B_Double&);
  friend DLL_DECL B_Long B_Div(const B_Single&,   const B_Double&);
  friend DLL_DECL B_Long B_Div(const B_Double&,   const B_Single&);
  friend DLL_DECL B_Long B_Div(const B_Long&,     const B_Double&);
  friend DLL_DECL B_Long B_Div(const B_Double&,   const B_Long&);
  friend DLL_DECL B_Long B_Div(const B_Integer&,  const B_Double&);
  friend DLL_DECL B_Long B_Div(const B_Double&,   const B_Integer&);
  friend DLL_DECL B_Long B_Div(const B_Byte&,     const B_Double&);
  friend DLL_DECL B_Long B_Div(const B_Double&,   const B_Byte&);
  friend DLL_DECL B_Long B_Div(const B_Boolean&,  const B_Double&);
  friend DLL_DECL B_Long B_Div(const B_Double&,   const B_Boolean&);
  friend DLL_DECL B_Long B_Div(const B_Empty&,    const B_Double&);
  friend DLL_DECL B_Long B_Div(const B_Double&,   const B_Empty&);
  friend DLL_DECL B_Long B_Div(const B_Double&,   const B_Dbl) ;
  friend DLL_DECL B_Long B_Div(const B_Dbl,       const B_Double&) ;
  friend DLL_DECL B_Long B_Div(const B_Double&,   const B_Int) ;
  friend DLL_DECL B_Long B_Div(const B_Int,       const B_Double&) ;

  friend DLL_DECL B_Double B_Pow(const B_Double&,   const B_Double&);
  friend DLL_DECL B_Double B_Pow(const B_Single&,   const B_Double&);
  friend DLL_DECL B_Double B_Pow(const B_Double&,   const B_Single&);
  friend DLL_DECL B_Double B_Pow(const B_Long&,     const B_Double&);
  friend DLL_DECL B_Double B_Pow(const B_Double&,   const B_Long&);
  friend DLL_DECL B_Double B_Pow(const B_Integer&,  const B_Double&);
  friend DLL_DECL B_Double B_Pow(const B_Double&,   const B_Integer&);
  friend DLL_DECL B_Double B_Pow(const B_Byte&,     const B_Double&);
  friend DLL_DECL B_Double B_Pow(const B_Double&,   const B_Byte&);
  friend DLL_DECL B_Double B_Pow(const B_Boolean&,  const B_Double&);
  friend DLL_DECL B_Double B_Pow(const B_Double&,   const B_Boolean&);
  friend DLL_DECL B_Double B_Pow(const B_Empty&,    const B_Double&); 
  friend DLL_DECL B_Double B_Pow(const B_Double&,   const B_Empty&);   
  friend DLL_DECL B_Double B_Pow(const B_Double&,   const B_Dbl) ;
  friend DLL_DECL B_Double B_Pow(const B_Dbl,       const B_Double&) ;
  friend DLL_DECL B_Double B_Pow(const B_Double&,   const B_Int) ;
  friend DLL_DECL B_Double B_Pow(const B_Int,       const B_Double&) ;

  friend DLL_DECL B_Long operator&& (const B_Double&,    const B_Double&);
  friend DLL_DECL B_Long operator&& (const B_Single&,    const B_Double&);
  friend DLL_DECL B_Long operator&& (const B_Double&,    const B_Single&);
  friend DLL_DECL B_Long operator&& (const B_Long&,      const B_Double&);
  friend DLL_DECL B_Long operator&& (const B_Double&,    const B_Long&);
  friend DLL_DECL B_Long operator&& (const B_Integer&,   const B_Double&);
  friend DLL_DECL B_Long operator&& (const B_Double&,    const B_Integer&);
  friend DLL_DECL B_Long operator&& (const B_Byte&,      const B_Double&);
  friend DLL_DECL B_Long operator&& (const B_Double&,    const B_Byte&);
  friend DLL_DECL B_Long operator&& (const B_Boolean&,   const B_Double&);
  friend DLL_DECL B_Long operator&& (const B_Double&,    const B_Boolean&);
  friend DLL_DECL B_Long operator&& (const B_Empty&,     const B_Double&);
  friend DLL_DECL B_Long operator&& (const B_Double&,    const B_Empty&); 
  friend DLL_DECL B_Null operator&& (const B_Null&,      const B_Double&);
  friend DLL_DECL B_Null operator&& (const B_Double&,    const B_Null&); 
  friend DLL_DECL B_Long operator&& (const B_Double&,   const B_Dbl) ;
  friend DLL_DECL B_Long operator&& (const B_Dbl,       const B_Double&) ;
  friend DLL_DECL B_Long operator&& (const B_Double&,   const B_Int) ;
  friend DLL_DECL B_Long operator&& (const B_Int,       const B_Double&) ;

  friend DLL_DECL B_Long operator|| (const B_Double&,    const B_Double&);
  friend DLL_DECL B_Long operator|| (const B_Single&,    const B_Double&);
  friend DLL_DECL B_Long operator|| (const B_Double&,    const B_Single&);
  friend DLL_DECL B_Long operator|| (const B_Long&,      const B_Double&);
  friend DLL_DECL B_Long operator|| (const B_Double&,    const B_Long&);
  friend DLL_DECL B_Long operator|| (const B_Integer&,   const B_Double&);
  friend DLL_DECL B_Long operator|| (const B_Double&,    const B_Integer&);
  friend DLL_DECL B_Long operator|| (const B_Byte&,      const B_Double&);
  friend DLL_DECL B_Long operator|| (const B_Double&,    const B_Byte&);
  friend DLL_DECL B_Long operator|| (const B_Boolean&,   const B_Double&);
  friend DLL_DECL B_Long operator|| (const B_Double&,    const B_Boolean&);
  friend DLL_DECL B_Long operator|| (const B_Empty&,     const B_Double&);
  friend DLL_DECL B_Long operator|| (const B_Double&,    const B_Empty&);
  friend DLL_DECL B_Long operator|| (const B_Null&,      const B_Double&);
  friend DLL_DECL B_Long operator|| (const B_Double&,    const B_Null&);
  friend DLL_DECL B_Long operator|| (const B_Double&,   const B_Dbl) ;
  friend DLL_DECL B_Long operator|| (const B_Dbl,       const B_Double&) ;
  friend DLL_DECL B_Long operator|| (const B_Double&,   const B_Int) ;
  friend DLL_DECL B_Long operator|| (const B_Int,       const B_Double&) ;

  friend DLL_DECL B_Long operator^ (const B_Double&,   const B_Double&);
  friend DLL_DECL B_Long operator^ (const B_Single&,   const B_Double&);
  friend DLL_DECL B_Long operator^ (const B_Double&,   const B_Single&);
  friend DLL_DECL B_Long operator^ (const B_Long&,     const B_Double&);
  friend DLL_DECL B_Long operator^ (const B_Double&,   const B_Long&);
  friend DLL_DECL B_Long operator^ (const B_Integer&,  const B_Double&);
  friend DLL_DECL B_Long operator^ (const B_Double&,   const B_Integer&);
  friend DLL_DECL B_Long operator^ (const B_Byte&,     const B_Double&);
  friend DLL_DECL B_Long operator^ (const B_Double&,   const B_Byte&);
  friend DLL_DECL B_Long operator^ (const B_Boolean&,  const B_Double&);
  friend DLL_DECL B_Long operator^ (const B_Double&,   const B_Boolean&); 
  friend DLL_DECL B_Long operator^ (const B_Empty&,    const B_Double&);
  friend DLL_DECL B_Long operator^ (const B_Double&,   const B_Empty&); 
  friend DLL_DECL B_Null operator^ (const B_Null&,     const B_Double&);
  friend DLL_DECL B_Null operator^ (const B_Double&,   const B_Null&); 
  friend DLL_DECL B_Long operator^ (const B_Double&,   const B_Dbl) ;
  friend DLL_DECL B_Long operator^ (const B_Dbl,       const B_Double&) ;
  friend DLL_DECL B_Long operator^ (const B_Double&,   const B_Int) ;
  friend DLL_DECL B_Long operator^ (const B_Int,       const B_Double&) ;

  friend DLL_DECL B_Boolean operator== (const B_Double&,   const B_Double&);
  friend DLL_DECL B_Boolean operator== (const B_Single&,   const B_Double&);
  friend DLL_DECL B_Boolean operator== (const B_Double&,   const B_Single&);
  friend DLL_DECL B_Boolean operator== (const B_Long&,     const B_Double&);
  friend DLL_DECL B_Boolean operator== (const B_Double&,   const B_Long&);
  friend DLL_DECL B_Boolean operator== (const B_Integer&,  const B_Double&);
  friend DLL_DECL B_Boolean operator== (const B_Double&,   const B_Integer&);
  friend DLL_DECL B_Boolean operator== (const B_Byte&,     const B_Double&);
  friend DLL_DECL B_Boolean operator== (const B_Double&,   const B_Byte&);
  friend DLL_DECL B_Boolean operator== (const B_Empty&,    const B_Double&); 
  friend DLL_DECL B_Boolean operator== (const B_Double&,   const B_Empty&);  
  friend DLL_DECL B_Boolean operator== (const B_Boolean&,  const B_Double&);
  friend DLL_DECL B_Boolean operator== (const B_Double&,   const B_Boolean&);
  friend DLL_DECL B_Boolean operator== (const B_Double&,   const B_Dbl) ;
  friend DLL_DECL B_Boolean operator== (const B_Dbl,       const B_Double&) ;
  friend DLL_DECL B_Boolean operator== (const B_Single&,   const B_Dbl) ; 
  friend DLL_DECL B_Boolean operator== (const B_Dbl,       const B_Single&) ;
  friend DLL_DECL B_Boolean operator== (const B_Long&,     const B_Dbl) ; 
  friend DLL_DECL B_Boolean operator== (const B_Dbl,       const B_Long&)  ;
  friend DLL_DECL B_Boolean operator== (const B_Integer&,  const B_Dbl) ;
  friend DLL_DECL B_Boolean operator== (const B_Dbl,       const B_Integer&);
  friend DLL_DECL B_Boolean operator== (const B_Byte&,     const B_Dbl);
  friend DLL_DECL B_Boolean operator== (const B_Dbl,       const B_Byte&);
  friend DLL_DECL B_Boolean operator== (const B_Double&,   const B_Int) ;
  friend DLL_DECL B_Boolean operator== (const B_Int,       const B_Double&) ;

  friend DLL_DECL B_Boolean operator!= (const B_Double&,   const B_Double&);
  friend DLL_DECL B_Boolean operator!= (const B_Single&,   const B_Double&);
  friend DLL_DECL B_Boolean operator!= (const B_Double&,   const B_Single&);
  friend DLL_DECL B_Boolean operator!= (const B_Long&,     const B_Double&);
  friend DLL_DECL B_Boolean operator!= (const B_Double&,   const B_Long&);
  friend DLL_DECL B_Boolean operator!= (const B_Integer&,  const B_Double&);
  friend DLL_DECL B_Boolean operator!= (const B_Double&,   const B_Integer&);
  friend DLL_DECL B_Boolean operator!= (const B_Byte&,     const B_Double&);
  friend DLL_DECL B_Boolean operator!= (const B_Double&,   const B_Byte&);
  friend DLL_DECL B_Boolean operator!= (const B_Empty&,    const B_Double&); 
  friend DLL_DECL B_Boolean operator!= (const B_Double&,   const B_Empty&);  
  friend DLL_DECL B_Boolean operator!= (const B_Boolean&,  const B_Double&);
  friend DLL_DECL B_Boolean operator!= (const B_Double&,   const B_Boolean&);
  friend DLL_DECL B_Boolean operator!= (const B_Double&,   const B_Dbl);
  friend DLL_DECL B_Boolean operator!= (const B_Dbl,       const B_Double&);
  friend DLL_DECL B_Boolean operator!= (const B_Single&,   const B_Dbl); 
  friend DLL_DECL B_Boolean operator!= (const B_Dbl,       const B_Single&);
  friend DLL_DECL B_Boolean operator!= (const B_Long&,     const B_Dbl); 
  friend DLL_DECL B_Boolean operator!= (const B_Dbl,       const B_Long&);
  friend DLL_DECL B_Boolean operator!= (const B_Integer&,  const B_Dbl);
  friend DLL_DECL B_Boolean operator!= (const B_Dbl,       const B_Integer&);
  friend DLL_DECL B_Boolean operator!= (const B_Byte&,     const B_Dbl);
  friend DLL_DECL B_Boolean operator!= (const B_Dbl,       const B_Byte&);
  friend DLL_DECL B_Boolean operator!= (const B_Double&,   const B_Int);
  friend DLL_DECL B_Boolean operator!= (const B_Int,       const B_Double&);

  friend DLL_DECL B_Boolean operator< (const B_Double&,   const B_Double&);
  friend DLL_DECL B_Boolean operator< (const B_Single&,   const B_Double&);
  friend DLL_DECL B_Boolean operator< (const B_Double&,   const B_Single&);
  friend DLL_DECL B_Boolean operator< (const B_Long&,     const B_Double&);
  friend DLL_DECL B_Boolean operator< (const B_Double&,   const B_Long&);
  friend DLL_DECL B_Boolean operator< (const B_Integer&,  const B_Double&);
  friend DLL_DECL B_Boolean operator< (const B_Double&,   const B_Integer&);
  friend DLL_DECL B_Boolean operator< (const B_Byte&,     const B_Double&);
  friend DLL_DECL B_Boolean operator< (const B_Double&,   const B_Byte&);
  friend DLL_DECL B_Boolean operator< (const B_Empty&,    const B_Double&); 
  friend DLL_DECL B_Boolean operator< (const B_Double&,   const B_Empty&);  
  friend DLL_DECL B_Boolean operator< (const B_Boolean&,  const B_Double&);
  friend DLL_DECL B_Boolean operator< (const B_Double&,   const B_Boolean&);
  friend DLL_DECL B_Boolean operator< (const B_Double&,   const B_Dbl) ;
  friend DLL_DECL B_Boolean operator< (const B_Dbl,       const B_Double&) ;
  friend DLL_DECL B_Boolean operator< (const B_Single&,   const B_Dbl) ; 
  friend DLL_DECL B_Boolean operator< (const B_Dbl,       const B_Single&) ;
  friend DLL_DECL B_Boolean operator< (const B_Long&,     const B_Dbl) ; 
  friend DLL_DECL B_Boolean operator< (const B_Dbl,       const B_Long&)  ;
  friend DLL_DECL B_Boolean operator< (const B_Integer&,  const B_Dbl) ;
  friend DLL_DECL B_Boolean operator< (const B_Dbl,       const B_Integer&);
  friend DLL_DECL B_Boolean operator< (const B_Byte&,     const B_Dbl);
  friend DLL_DECL B_Boolean operator< (const B_Dbl,       const B_Byte&);
  friend DLL_DECL B_Boolean operator< (const B_Double&,   const B_Int) ;
  friend DLL_DECL B_Boolean operator< (const B_Int,       const B_Double&) ;

  friend DLL_DECL B_Boolean operator<= (const B_Double&,   const B_Double&);
  friend DLL_DECL B_Boolean operator<= (const B_Single&,   const B_Double&);
  friend DLL_DECL B_Boolean operator<= (const B_Double&,   const B_Single&);
  friend DLL_DECL B_Boolean operator<= (const B_Long&,     const B_Double&);
  friend DLL_DECL B_Boolean operator<= (const B_Double&,   const B_Long&);
  friend DLL_DECL B_Boolean operator<= (const B_Integer&,  const B_Double&);
  friend DLL_DECL B_Boolean operator<= (const B_Double&,   const B_Integer&);
  friend DLL_DECL B_Boolean operator<= (const B_Byte&,     const B_Double&);
  friend DLL_DECL B_Boolean operator<= (const B_Double&,   const B_Byte&);
  friend DLL_DECL B_Boolean operator<= (const B_Empty&,    const B_Double&); 
  friend DLL_DECL B_Boolean operator<= (const B_Double&,   const B_Empty&);  
  friend DLL_DECL B_Boolean operator<= (const B_Boolean&,  const B_Double&);
  friend DLL_DECL B_Boolean operator<= (const B_Double&,   const B_Boolean&);
  friend DLL_DECL B_Boolean operator<= (const B_Double&,   const B_Dbl) ;
  friend DLL_DECL B_Boolean operator<= (const B_Dbl,       const B_Double&) ;
  friend DLL_DECL B_Boolean operator<= (const B_Single&,   const B_Dbl) ; 
  friend DLL_DECL B_Boolean operator<= (const B_Dbl,       const B_Single&) ;
  friend DLL_DECL B_Boolean operator<= (const B_Long&,     const B_Dbl) ; 
  friend DLL_DECL B_Boolean operator<= (const B_Dbl,       const B_Long&)  ;
  friend DLL_DECL B_Boolean operator<= (const B_Integer&,  const B_Dbl) ;
  friend DLL_DECL B_Boolean operator<= (const B_Dbl,       const B_Integer&);
  friend DLL_DECL B_Boolean operator<= (const B_Byte&,     const B_Dbl);
  friend DLL_DECL B_Boolean operator<= (const B_Dbl,       const B_Byte&);
  friend DLL_DECL B_Boolean operator<= (const B_Double&,   const B_Int) ;
  friend DLL_DECL B_Boolean operator<= (const B_Int,       const B_Double&) ;

  friend DLL_DECL B_Boolean operator> (const B_Double&,   const B_Double&);
  friend DLL_DECL B_Boolean operator> (const B_Single&,   const B_Double&);
  friend DLL_DECL B_Boolean operator> (const B_Double&,   const B_Single&);
  friend DLL_DECL B_Boolean operator> (const B_Long&,     const B_Double&);
  friend DLL_DECL B_Boolean operator> (const B_Double&,   const B_Long&);
  friend DLL_DECL B_Boolean operator> (const B_Integer&,  const B_Double&);
  friend DLL_DECL B_Boolean operator> (const B_Double&,   const B_Integer&);
  friend DLL_DECL B_Boolean operator> (const B_Byte&,     const B_Double&);
  friend DLL_DECL B_Boolean operator> (const B_Double&,   const B_Byte&);
  friend DLL_DECL B_Boolean operator> (const B_Empty&,    const B_Double&); 
  friend DLL_DECL B_Boolean operator> (const B_Double&,   const B_Empty&);  
  friend DLL_DECL B_Boolean operator> (const B_Boolean&,  const B_Double&);
  friend DLL_DECL B_Boolean operator> (const B_Double&,   const B_Boolean&);
  friend DLL_DECL B_Boolean operator> (const B_Double&,   const B_Dbl) ;
  friend DLL_DECL B_Boolean operator> (const B_Dbl,       const B_Double&) ;
  friend DLL_DECL B_Boolean operator> (const B_Single&,   const B_Dbl) ; 
  friend DLL_DECL B_Boolean operator> (const B_Dbl,       const B_Single&) ;
  friend DLL_DECL B_Boolean operator> (const B_Long&,     const B_Dbl) ; 
  friend DLL_DECL B_Boolean operator> (const B_Dbl,       const B_Long&)  ;
  friend DLL_DECL B_Boolean operator> (const B_Integer&,  const B_Dbl) ;
  friend DLL_DECL B_Boolean operator> (const B_Dbl,       const B_Integer&);
  friend DLL_DECL B_Boolean operator> (const B_Byte&,     const B_Dbl);
  friend DLL_DECL B_Boolean operator> (const B_Dbl,       const B_Byte&);
  friend DLL_DECL B_Boolean operator> (const B_Double&,   const B_Int) ;
  friend DLL_DECL B_Boolean operator> (const B_Int,       const B_Double&) ;

  friend DLL_DECL B_Boolean operator>= (const B_Double&,   const B_Double&);
  friend DLL_DECL B_Boolean operator>= (const B_Single&,   const B_Double&);
  friend DLL_DECL B_Boolean operator>= (const B_Double&,   const B_Single&);
  friend DLL_DECL B_Boolean operator>= (const B_Long&,     const B_Double&);
  friend DLL_DECL B_Boolean operator>= (const B_Double&,   const B_Long&);
  friend DLL_DECL B_Boolean operator>= (const B_Integer&,  const B_Double&);
  friend DLL_DECL B_Boolean operator>= (const B_Double&,   const B_Integer&);
  friend DLL_DECL B_Boolean operator>= (const B_Byte&,     const B_Double&);
  friend DLL_DECL B_Boolean operator>= (const B_Double&,   const B_Byte&);
  friend DLL_DECL B_Boolean operator>= (const B_Empty&,    const B_Double&); 
  friend DLL_DECL B_Boolean operator>= (const B_Double&,   const B_Empty&);  
  friend DLL_DECL B_Boolean operator>= (const B_Boolean&,  const B_Double&);
  friend DLL_DECL B_Boolean operator>= (const B_Double&,   const B_Boolean&);
  friend DLL_DECL B_Boolean operator>= (const B_Double&,   const B_Dbl);
  friend DLL_DECL B_Boolean operator>= (const B_Dbl,       const B_Double&);
  friend DLL_DECL B_Boolean operator>= (const B_Single&,   const B_Dbl); 
  friend DLL_DECL B_Boolean operator>= (const B_Dbl,       const B_Single&);
  friend DLL_DECL B_Boolean operator>= (const B_Long&,     const B_Dbl); 
  friend DLL_DECL B_Boolean operator>= (const B_Dbl,       const B_Long&);
  friend DLL_DECL B_Boolean operator>= (const B_Integer&,  const B_Dbl);
  friend DLL_DECL B_Boolean operator>= (const B_Dbl,       const B_Integer&);
  friend DLL_DECL B_Boolean operator>= (const B_Byte&,     const B_Dbl);
  friend DLL_DECL B_Boolean operator>= (const B_Dbl,       const B_Byte&);
  friend DLL_DECL B_Boolean operator>= (const B_Double&,   const B_Int);
  friend DLL_DECL B_Boolean operator>= (const B_Int,       const B_Double&);

  //----------------------------------------------------------------------------------------------------       
  // Method: operator<<	INSERTION
  //     Schreiben der eigentlichen Objektdaten im Textformat in einen Stream
  // Return Value: 
  //	   Instanz der abgeleiten fstream-Klasse der Datei
  // Note: 
  //	   CT131296
  //	   ersetzt die alte Methode streamp()
  //
  friend DLL_DECL B_fstream& operator<< (B_fstream& ostr, B_Double& rhs);

  //----------------------------------------------------------------------------------------------------       
  // Method: operator>>	EXTRACTION
  //     Lesen der eigentlichen Objektdaten im Textformat aus einem Stream
  // Return Value: 
  //	   Instanz der abgeleiten fstream-Klasse der Datei
  // Note: 
  //	   CT131296
  //	   ersetzt die alte Methode streamg()
  //
  friend DLL_DECL B_fstream& operator>> (B_fstream& istr, B_Double& rhs);


  };// B_Double


DLL_DECL extern const B_Double B_DoubleMin;
DLL_DECL extern const B_Double B_DoubleMax;
DLL_DECL extern const B_Double B_DoubleEpsilon;
DLL_DECL extern const B_UChar  B_DoubleDigits;




//----------------------------------Arithmetische Operatoren -----------------------------------------

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Der +Operator = Addition
DLL_DECL B_Double operator+ (const B_Double&,   const B_Double&)   throw(B_Overflow);
DLL_DECL B_Double operator+ (const B_Single&,   const B_Double&)   throw(B_Overflow); 
DLL_DECL B_Double operator+ (const B_Double&,   const B_Single&)   throw(B_Overflow);
DLL_DECL B_Double operator+ (const B_Long&,     const B_Double&)   throw(B_Overflow); 
DLL_DECL B_Double operator+ (const B_Double&,   const B_Long&)     throw(B_Overflow);

DLL_DECL B_Double operator+ (const B_Integer&,  const B_Double&)   throw(B_Overflow);
DLL_DECL B_Double operator+ (const B_Double&,   const B_Integer&)  throw(B_Overflow);
DLL_DECL B_Double operator+ (const B_Integer&,  const B_Dbl)       throw(B_Overflow);
DLL_DECL B_Double operator+ (const B_Dbl,       const B_Integer&)  throw(B_Overflow);


DLL_DECL B_Double operator+ (const B_Byte&,     const B_Double&)   throw(B_Overflow);
DLL_DECL B_Double operator+ (const B_Double&,   const B_Byte&)     throw(B_Overflow);
DLL_DECL B_Double operator+ (const B_Boolean&,  const B_Double&)   throw(B_Overflow);
DLL_DECL B_Double operator+ (const B_Double&,   const B_Boolean&)  throw(B_Overflow);
DLL_DECL B_Double operator+ (const B_Empty&,    const B_Double&);
DLL_DECL B_Double operator+ (const B_Double&,   const B_Empty&);
DLL_DECL B_Null   operator+ (const B_Null&,     const B_Double&);
DLL_DECL B_Null   operator+ (const B_Double&,   const B_Null&);

DLL_DECL B_Double operator+ (const B_Long&,     const B_Single&); // VB gibt bei single + long -> Double zurueck
DLL_DECL B_Double operator+ (const B_Single&,   const B_Long&);

DLL_DECL B_Double operator+ (const B_Empty&,    const B_Dbl); 
DLL_DECL B_Double operator+ (const B_Dbl,       const B_Empty&);
DLL_DECL B_Double operator+ (const B_Double&,   const B_Dbl)       throw(B_Overflow);
DLL_DECL B_Double operator+ (const B_Dbl,       const B_Double&)   throw(B_Overflow);
DLL_DECL B_Double operator+ (const B_Single&,   const B_Dbl)       throw(B_Overflow); 
DLL_DECL B_Double operator+ (const B_Dbl&,      const B_Single&)   throw(B_Overflow);
DLL_DECL B_Double operator+ (const B_Long&,     const B_Dbl)       throw(B_Overflow); 
DLL_DECL B_Double operator+ (const B_Dbl,       const B_Long&)     throw(B_Overflow);
DLL_DECL B_Double operator+ (const B_Integer&,  const B_Dbl)       throw(B_Overflow);
DLL_DECL B_Double operator+ (const B_Dbl,       const B_Integer&)  throw(B_Overflow);
DLL_DECL B_Double operator+ (const B_Byte&,     const B_Dbl)       throw(B_Overflow);
DLL_DECL B_Double operator+ (const B_Dbl,       const B_Byte&)     throw(B_Overflow);
DLL_DECL B_Double operator+ (const B_Double&,   const B_Int)       throw(B_Overflow);
DLL_DECL B_Double operator+ (const B_Int,       const B_Double&)   throw(B_Overflow);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Der -Operator = Subtraktion
DLL_DECL B_Double   operator- (const B_Double&,   const B_Double&)   throw(B_Overflow);
DLL_DECL B_Double   operator- (const B_Single&,   const B_Double&)   throw(B_Overflow);
DLL_DECL B_Double   operator- (const B_Double&,   const B_Single&)   throw(B_Overflow);
DLL_DECL B_Double   operator- (const B_Long&,     const B_Double&)   throw(B_Overflow);
DLL_DECL B_Double   operator- (const B_Double&,   const B_Long&)     throw(B_Overflow);
DLL_DECL B_Double   operator- (const B_Integer&,  const B_Double&)   throw(B_Overflow);
DLL_DECL B_Double   operator- (const B_Double&,   const B_Integer&)  throw(B_Overflow);
DLL_DECL B_Double   operator- (const B_Byte&,     const B_Double&)   throw(B_Overflow);
DLL_DECL B_Double   operator- (const B_Double&,   const B_Byte&)     throw(B_Overflow);
DLL_DECL B_Double   operator- (const B_Boolean&,  const B_Double&)   throw(B_Overflow);
DLL_DECL B_Double   operator- (const B_Double&,   const B_Boolean&)  throw(B_Overflow);
DLL_DECL B_Double   operator- (const B_Empty&,    const B_Double&);
DLL_DECL B_Double   operator- (const B_Double&,   const B_Empty&);
DLL_DECL B_Null     operator- (const B_Null&,     const B_Double&);
DLL_DECL B_Null     operator- (const B_Double&,   const B_Null&);

DLL_DECL B_Double   operator- (const B_Long&,     const B_Single&);
DLL_DECL B_Double   operator- (const B_Single&,   const B_Long&);

DLL_DECL B_Double operator- (const B_Empty&,    const B_Dbl); 
DLL_DECL B_Double operator- (const B_Dbl,       const B_Empty&);
DLL_DECL B_Double operator- (const B_Double&,   const B_Dbl)       throw(B_Overflow);
DLL_DECL B_Double operator- (const B_Dbl,       const B_Double&)   throw(B_Overflow);
DLL_DECL B_Double operator- (const B_Single&,   const B_Dbl)       throw(B_Overflow); 
DLL_DECL B_Double operator- (const B_Dbl&,      const B_Single&)   throw(B_Overflow);
DLL_DECL B_Double operator- (const B_Long&,     const B_Dbl)       throw(B_Overflow); 
DLL_DECL B_Double operator- (const B_Dbl,       const B_Long&)     throw(B_Overflow);
DLL_DECL B_Double operator- (const B_Integer&,  const B_Dbl)       throw(B_Overflow);
DLL_DECL B_Double operator- (const B_Dbl,       const B_Integer&)  throw(B_Overflow);
DLL_DECL B_Double operator- (const B_Byte&,     const B_Dbl)       throw(B_Overflow);
DLL_DECL B_Double operator- (const B_Dbl,       const B_Byte&)     throw(B_Overflow);
DLL_DECL B_Double operator- (const B_Double&,   const B_Int)       throw(B_Overflow);
DLL_DECL B_Double operator- (const B_Int,       const B_Double&)   throw(B_Overflow);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Der *Operator = Multiplikation   
DLL_DECL B_Double operator* (const B_Double&,  const B_Double&)  throw(B_Overflow, B_Underflow);
//B_Double   operator* (const B_Currency&,  const B_Double&);   // Hier hat * in VB eine andere aufeinanderfolge  der Genauigkeit wie /.
//B_Double   operator* (const B_Double&,    const B_Currency&);
DLL_DECL B_Double operator* (const B_Single&,  const B_Double&)  throw(B_Overflow, B_Underflow); 
DLL_DECL B_Double operator* (const B_Double&,  const B_Single&)  throw(B_Overflow, B_Underflow);
DLL_DECL B_Double operator* (const B_Long&,    const B_Double&)  throw(B_Overflow, B_Underflow); 
DLL_DECL B_Double operator* (const B_Double&,  const B_Long&)    throw(B_Overflow, B_Underflow);
DLL_DECL B_Double operator* (const B_Integer&, const B_Double&)  throw(B_Overflow, B_Underflow);
DLL_DECL B_Double operator* (const B_Double&,  const B_Integer&) throw(B_Overflow, B_Underflow);
DLL_DECL B_Double operator* (const B_Byte&,    const B_Double&)  throw(B_Overflow, B_Underflow);
DLL_DECL B_Double operator* (const B_Double&,  const B_Byte&)    throw(B_Overflow, B_Underflow);
DLL_DECL B_Double operator* (const B_Boolean&, const B_Double&);
DLL_DECL B_Double operator* (const B_Double&,  const B_Boolean&);
DLL_DECL B_Double operator* (const B_Empty&,   const B_Double&);
DLL_DECL B_Double operator* (const B_Double&,  const B_Empty&);
DLL_DECL B_Null   operator* (const B_Null&,    const B_Double&);
DLL_DECL B_Null   operator* (const B_Double&,  const B_Null&);

DLL_DECL B_Double operator* (const B_Long&,    const B_Single&);  
DLL_DECL B_Double operator* (const B_Single&,  const B_Long&);

DLL_DECL B_Double operator* (const B_Empty&,   const B_Dbl); 
DLL_DECL B_Double operator* (const B_Dbl,      const B_Empty&);
DLL_DECL B_Double operator* (const B_Dbl,      const B_Double&)  throw(B_Overflow, B_Underflow);
DLL_DECL B_Double operator* (const B_Double&,  const B_Dbl)      throw(B_Overflow, B_Underflow);
DLL_DECL B_Double operator* (const B_Single&,  const B_Dbl)      throw(B_Overflow, B_Underflow); 
DLL_DECL B_Double operator* (const B_Dbl,      const B_Single&)  throw(B_Overflow, B_Underflow);
DLL_DECL B_Double operator* (const B_Long&,    const B_Dbl)      throw(B_Overflow, B_Underflow); 
DLL_DECL B_Double operator* (const B_Dbl,      const B_Long&)    throw(B_Overflow, B_Underflow);
DLL_DECL B_Double operator* (const B_Integer&, const B_Dbl)      throw(B_Overflow, B_Underflow);
DLL_DECL B_Double operator* (const B_Dbl,      const B_Integer&) throw(B_Overflow, B_Underflow);
DLL_DECL B_Double operator* (const B_Byte&,    const B_Dbl)      throw(B_Overflow, B_Underflow);
DLL_DECL B_Double operator* (const B_Dbl,      const B_Byte&)    throw(B_Overflow, B_Underflow);
DLL_DECL B_Double operator* (const B_Int,      const B_Double&)  throw(B_Overflow, B_Underflow);
DLL_DECL B_Double operator* (const B_Double&,  const B_Int)      throw(B_Overflow, B_Underflow);


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Der /Operator = Division deren Ergebniss immer ein Fliesskommawert ergibt
//   Fehler wenn Bereich von Single ueberschritten wird
DLL_DECL B_Double  operator/ (const B_Double&,   const B_Double&)  throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Double  operator/ (const B_Single&,   const B_Double&)  throw(B_ZeroDivide, B_Underflow); 
DLL_DECL B_Double  operator/ (const B_Double&,   const B_Single&)  throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Double  operator/ (const B_Long&,     const B_Double&)  throw(B_ZeroDivide, B_Underflow); 
DLL_DECL B_Double  operator/ (const B_Double&,   const B_Long&)    throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Double  operator/ (const B_Integer&,  const B_Double&)  throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Double  operator/ (const B_Double&,   const B_Integer&) throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Double  operator/ (const B_Byte&,     const B_Double&)  throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Double  operator/ (const B_Double&,   const B_Byte&)    throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Double  operator/ (const B_Boolean&,  const B_Double&)  throw(B_ZeroDivide);
DLL_DECL B_Double  operator/ (const B_Double&,   const B_Boolean&) throw(B_ZeroDivide);
DLL_DECL B_Double  operator/ (const B_Empty&,    const B_Double&)  throw(B_ZeroDivide);
DLL_DECL B_Double  operator/ (const B_Double&,   const B_Empty&)   throw(B_ZeroDivide);
DLL_DECL B_Null    operator/ (const B_Null&,     const B_Double&);
DLL_DECL B_Null    operator/ (const B_Double&,   const B_Null&);

DLL_DECL B_Double  operator/ (const B_Long&,     const B_Boolean&) throw(B_ZeroDivide);
DLL_DECL B_Double  operator/ (const B_Boolean&,  const B_Long&)    throw(B_ZeroDivide);
DLL_DECL B_Double  operator/ (const B_Empty&,    const B_Long&)    throw(B_ZeroDivide);
DLL_DECL B_Double  operator/ (const B_Long&,     const B_Empty&)   throw(B_ZeroDivide);

DLL_DECL B_Double  operator/ (const B_Lng,       const B_Empty&)   throw(B_ZeroDivide);
DLL_DECL B_Double  operator/ (const B_Flt,       const B_Empty&)   throw(B_ZeroDivide);
DLL_DECL B_Double  operator/ (const B_Empty&,    const B_Dbl)      throw(B_ZeroDivide); 
DLL_DECL B_Double  operator/ (const B_Dbl,       const B_Empty&)   throw(B_ZeroDivide);

DLL_DECL B_Double  operator/ (const B_Dbl,       const B_Double&)  throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Double  operator/ (const B_Double&,   const B_Dbl)      throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Double  operator/ (const B_Single&,   const B_Dbl)      throw(B_ZeroDivide, B_Underflow); 
DLL_DECL B_Double  operator/ (const B_Dbl,       const B_Single&)  throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Double  operator/ (const B_Long&,     const B_Dbl)      throw(B_ZeroDivide, B_Underflow); 
DLL_DECL B_Double  operator/ (const B_Dbl,       const B_Long&)    throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Double  operator/ (const B_Integer&,  const B_Dbl)      throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Double  operator/ (const B_Dbl,       const B_Integer&) throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Double  operator/ (const B_Byte&,     const B_Dbl)      throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Double  operator/ (const B_Dbl,       const B_Byte&)    throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Double  operator/ (const B_Int,       const B_Double&)  throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Double  operator/ (const B_Double&,   const B_Int)      throw(B_ZeroDivide, B_Underflow);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Der %Operator = Modulo Operation, gibt den Wert einer ganzahligen Division zurueck
//   entsprich MOD-Operator in VB
//   Mit single und double typen arbeitet der Modulo-Operator solange korrekt wie der
//   Wertebereich des Single/Double Parameters den eines B_Long nicht ueberschreitet
//   Ist ein Single/Float/Double Datentyp zu gross, dann wird in das Logfile eine Warnung mit
//   hoechster Prioritaetstufe 
//   VB bricht mit Laufzeitfehler ab wenn ein Datentyp schon ueber den Wertebereich eines
//   Long hinausgeht und nicht erst wenn das Ergebenis den Rahmen eines Long sprengen wuerde
//   C++ hat fuer den %operator die gleiche Bedingungen.
//   Eine Funktione fMod() die sich das gleiche verhalten wie die fmod()-Fkt. der C/C++ bibliothek
//   hat steht fuer alle anderen Faelle zur Verfuegung
DLL_DECL B_Long  operator% (const B_Double&,  const B_Double&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Single&,  const B_Double&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Double&,  const B_Single&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Long&,    const B_Double&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Double&,  const B_Long&)    throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Integer&, const B_Double&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Double&,  const B_Integer&) throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Byte&,    const B_Double&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Double&,  const B_Byte&)    throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Boolean&, const B_Double&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Double&,  const B_Boolean&) throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Empty&,   const B_Double&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Double&,  const B_Empty&)   throw(B_ZeroDivide);
DLL_DECL B_Null  operator% (const B_Null&,    const B_Double&);
DLL_DECL B_Null  operator% (const B_Double&,  const B_Null&);

DLL_DECL B_Long  operator% (const B_Dbl,      const B_Double&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Double&,  const B_Dbl)      throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Single&,  const B_Dbl)      throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Dbl,      const B_Single&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Int,      const B_Double&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Double&,  const B_Int)      throw(B_Overflow, B_ZeroDivide);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Ganzahldivision entspricht dem \Operator in VB, da in C++ kein geeigneter Operator zu Verfuegung steht
//   wird dieser Operator als Funktion realisiert
//   Mit single und double typen arbeitet der Ganzahldivisor-Operator solange korrekt wie der
//   Wertebereich des Single/Double Parameters den eines B_Long nicht ueberschreitet
//   Ist ein Single/Float/Double Datentyp zu gross, dann wird in das Logfile eine Warnung mit
//   hoechster Prioritaetstufe 
//   VB bricht mit Laufzeitfehler ab wenn ein Datentyp schon ueber den Wertebereich eines
//   Long hinausgeht und nicht erst wenn das Ergebenis den Rahmen eines Long sprengen wuerde
//   C++ hat fuer den %operator die gleiche Bedingungen.
DLL_DECL B_Long B_Div(const B_Double&,   const B_Double&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Single&,   const B_Double&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Double&,   const B_Single&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Long&,     const B_Double&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Double&,   const B_Long&)    throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Integer&,  const B_Double&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Double&,   const B_Integer&) throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Byte&,     const B_Double&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Double&,   const B_Byte&)    throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Boolean&,  const B_Double&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Double&,   const B_Boolean&) throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Empty&,    const B_Double&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Double&,   const B_Empty&)   throw(B_ZeroDivide);
DLL_DECL B_Null B_Div(const B_Null&,     const B_Double&);
DLL_DECL B_Null B_Div(const B_Double&,   const B_Null&);

DLL_DECL B_Long B_Div(const B_Double&,   const B_Dbl)      throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Dbl,       const B_Double&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Single&,   const B_Dbl)      throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Dbl,       const B_Single&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Double&,   const B_Int)      throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Int,       const B_Double&)  throw(B_Overflow, B_ZeroDivide);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Dient zum Potenzieren einer Zahl mit einem Exponenten
//   Erg = Zahl^Exponent  -> Erg = Pow(zahl, exponent)
//   Das Argument Zahl darf nur negativ sein, wenn Exponent ein ganzzahliger Wert ist. Werden in einem einzigen 
//   Ausdruck mehrere Potenzierungen ausgefhrt, so wird der Operator ^ jeweils in der Reihenfolge seines 
//   Auftretens von links nach rechts ausgewertet.
//   Ergebnis hat den Datentyp Double  Ist jedoch entweder Zahl oder Exponent ein Ausdruck mit dem Wert Null, 
//   so ist das Ergebnis ebenfalls Null.
//   Negative zahl-Werte koennen verstaendlicherweise nicht verwandt werden wenn der Exponent auch eine
//   Floatwert hat da das Ergebnis sonst eine Komplexe Zahl waere.
DLL_DECL B_Double B_Pow(const B_Double&,   const B_Double&)  throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Single&,   const B_Double&)  throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Double&,   const B_Single&)  throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Long&,     const B_Double&)  throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Double&,   const B_Long&)    throw(B_Overflow);
DLL_DECL B_Double B_Pow(const B_Integer&,  const B_Double&)  throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Double&,   const B_Integer&) throw(B_Overflow);
DLL_DECL B_Double B_Pow(const B_Byte&,     const B_Double&)  throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Double&,   const B_Byte&)    throw(B_Overflow);
DLL_DECL B_Double B_Pow(const B_Boolean&,  const B_Double&);
DLL_DECL B_Double B_Pow(const B_Double&,   const B_Boolean&);
DLL_DECL B_Double B_Pow(const B_Empty&,    const B_Double&); 
DLL_DECL B_Double B_Pow(const B_Double&,   const B_Empty&);   
DLL_DECL B_Null   B_Pow(const B_Null&,     const B_Double&); 
DLL_DECL B_Null   B_Pow(const B_Double&,   const B_Null&);   

DLL_DECL B_Double B_Pow(const B_Empty&,   const B_Single&);
DLL_DECL B_Double B_Pow(const B_Single&,  const B_Empty&);
DLL_DECL B_Double B_Pow(const B_Empty&,   const B_Long&);
DLL_DECL B_Double B_Pow(const B_Long&,    const B_Empty&);
DLL_DECL B_Double B_Pow(const B_Empty&,   const B_Integer&);
DLL_DECL B_Double B_Pow(const B_Integer&, const B_Empty&);
DLL_DECL B_Double B_Pow(const B_Empty&,   const B_Byte&);
DLL_DECL B_Double B_Pow(const B_Byte&,    const B_Empty&);

DLL_DECL B_Double B_Pow(const B_Empty&,   const B_Empty&);
DLL_DECL B_Double B_Pow(const B_Byte&,    const B_Byte&);
DLL_DECL B_Double B_Pow(const B_Integer&, const B_Integer&) throw(B_Overflow);
DLL_DECL B_Double B_Pow(const B_Long&,    const B_Long&)    throw(B_Overflow);
DLL_DECL B_Double B_Pow(const B_Single&,  const B_Single&)  throw(B_InvalidArgument, B_Overflow);

DLL_DECL B_Double B_Pow(const B_Integer&,  const B_Long&)    throw(B_Overflow);
DLL_DECL B_Double B_Pow(const B_Long&,     const B_Integer&) throw(B_Overflow);
DLL_DECL B_Double B_Pow(const B_Byte&,     const B_Long&)    throw(B_Overflow);
DLL_DECL B_Double B_Pow(const B_Long&,     const B_Byte&)    throw(B_Overflow);
DLL_DECL B_Double B_Pow(const B_Long&,     const B_Boolean&);
DLL_DECL B_Double B_Pow(const B_Boolean&,  const B_Long&);

DLL_DECL B_Double B_Pow(const B_Integer&,  const B_Single&)  throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Single&,   const B_Integer&) throw(B_Overflow);
DLL_DECL B_Double B_Pow(const B_Byte&,     const B_Single&)  throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Single&,   const B_Byte&)    throw(B_Overflow);

DLL_DECL B_Double B_Pow(const B_Empty&,   const B_Boolean&);
DLL_DECL B_Double B_Pow(const B_Boolean&, const B_Empty&);
DLL_DECL B_Double B_Pow(const B_Boolean&, const B_Integer&);
DLL_DECL B_Double B_Pow(const B_Boolean&, const B_Byte&);

// C-Standardtypen
DLL_DECL B_Double B_Pow(const B_Dbl,      const B_Empty&);
DLL_DECL B_Double B_Pow(const B_Empty&,   const B_Dbl);
DLL_DECL B_Double B_Pow(const B_Flt,      const B_Empty&);
DLL_DECL B_Double B_Pow(const B_Empty&,   const B_Flt);
DLL_DECL B_Double B_Pow(const B_Lng,      const B_Empty&);
DLL_DECL B_Double B_Pow(const B_Empty&,   const B_Lng);
DLL_DECL B_Double B_Pow(const B_UInt,     const B_Empty&);
DLL_DECL B_Double B_Pow(const B_Empty&,   const B_UInt);
DLL_DECL B_Double B_Pow(const B_Int,      const B_Empty&);
DLL_DECL B_Double B_Pow(const B_Empty&,   const B_Int);

DLL_DECL B_Double B_Pow(const B_Dbl,       const B_Double&)  throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Double&,   const B_Dbl)      throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Single&,   const B_Dbl)      throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Dbl,       const B_Single&)  throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Long&,     const B_Dbl)      throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Dbl,       const B_Long&)    throw(B_Overflow);
DLL_DECL B_Double B_Pow(const B_Integer&,  const B_Dbl)      throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Dbl,       const B_Integer&) throw(B_Overflow);
DLL_DECL B_Double B_Pow(const B_Byte&,     const B_Dbl)      throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Dbl,       const B_Byte&)    throw(B_Overflow);
DLL_DECL B_Double B_Pow(const B_Int,       const B_Double&)  throw(B_InvalidArgument, B_Overflow);
DLL_DECL B_Double B_Pow(const B_Double&,   const B_Int)      throw(B_InvalidArgument, B_Overflow);

//----------------------------------------------------------------------------------------------------
//---------------------------------- Logische Operatoren ---------------------------------------------
//--- Logische Operatoren haben als Ruekgabewert immer den Datentyp B_Long
//    Solange der Wertebereich von B_Long nicht durch die Fliesskommawerte ueberschritten wird
//    arbeiten die Funktionen korrekt.
//    Wird durch einen Flieskommawert der Wertebereich des Long ueberschritten wird dies in der 
//    Logdatei protokolliert und fuehrt zu einem Laufzeitfehler.
//    Hierbei reicht es aus wenn ein Operand den Werteereich ueberschreitet, d.h. selbst wenn das
//    Ergebnis noch in einen Long passen wuerde wird schon bei der Operatoruebergabe abgebrochen
//    mit dem Laufzeitfehler(6) = Ueberlauf

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Der &&Operator entspricht AND in VB , 
//   Bit in Ausdruck1 	Bit in Ausdruck2 	Ergebnis 
//       0	                  0            	0
//       0	                  1           	0
//       1                  	0           	0
//       1                   	1            	1
//   ACHTUNG alle C/C++ Programmierer: in VB werden numerische Typen immer logisch bitweise und verknpft
//                                     Der Einsatz von & war nicht moeglich da stellenweise erst zur Lauf-
//                                     zeit das Verhalten bestimmt werden kann was der Konverter nicht 
//                                     bestimmen kann
DLL_DECL B_Long operator&& (const B_Double&,    const B_Double&)  throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Single&,    const B_Double&)  throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Double&,    const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Long&,      const B_Double&)  throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Double&,    const B_Long&)    throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Integer&,   const B_Double&)  throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Double&,    const B_Integer&) throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Byte&,      const B_Double&)  throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Double&,    const B_Byte&)    throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Boolean&,   const B_Double&)  throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Double&,    const B_Boolean&) throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Empty&,     const B_Double&)  throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Double&,    const B_Empty&)   throw(B_Overflow); 
DLL_DECL B_Null operator&& (const B_Null&,      const B_Double&)  throw(B_Overflow);
DLL_DECL B_Null operator&& (const B_Double&,    const B_Null&)    throw(B_Overflow); 

DLL_DECL B_Long operator&& (const B_Double&,    const B_Dbl)      throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Dbl,        const B_Double&)  throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Single&,    const B_Dbl)      throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Dbl,        const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Double&,    const B_Int)      throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Int,        const B_Double&)  throw(B_Overflow);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Der ||Operator entspricht OR in VB , 
//   Bit in Ausdruck1 	Bit in Ausdruck2 	Ergebnis 
//       0	                  0            	0
//       0	                  1           	1
//       1                  	0           	1
//       1                   	1            	1
//   ACHTUNG alle C/C++ Programmierer: in VB werden numerische Typen immer logisch bitweise und verknpft
//                                     Der Einsatz von | war nicht moeglich da stellenweise erst zur Lauf-
//                                     zeit das Verhalten bestimmt werden kann was der Konverter nicht 
//                                     bestimmen kann
DLL_DECL B_Long operator|| (const B_Double&,    const B_Double&)  throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Single&,    const B_Double&)  throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Double&,    const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Long&,      const B_Double&)  throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Double&,    const B_Long&)    throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Integer&,   const B_Double&)  throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Double&,    const B_Integer&) throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Byte&,      const B_Double&)  throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Double&,    const B_Byte&)    throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Boolean&,   const B_Double&)  throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Double&,    const B_Boolean&) throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Empty&,     const B_Double&)  throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Double&,    const B_Empty&)   throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Null&,      const B_Double&)  throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Double&,    const B_Null&)    throw(B_Overflow);

DLL_DECL B_Long operator|| (const B_Double&,    const B_Dbl)      throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Dbl,        const B_Double&)  throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Single&,    const B_Dbl)      throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Dbl,        const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Double&,    const B_Int)      throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Int,        const B_Double&)  throw(B_Overflow);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Der ^Operator entspricht XOR in VB 
//   Bit in Ausdruck1 	Bit in Ausdruck2 	Ergebnis 
//       0	                  0            	0
//       0	                  1           	1
//       1                  	0           	1
//       1                   	1            	0
//   ACHTUNG alle VB Programmierer:    In C++ bedeutet der ^Operator ein bitweises XOR auf numerische
//                                     Operanden und nicht wie in VB eine Potenzierung. Der ^Operator
//                                     wurde nicht zur Potenzierung verwandt da dies nicht C++ Stil
//                                     entspricht.
//   ACHTUNG alle C/C++ Programmierer: In VB werden numerische Typen immer logisch bitweise und verknpft
//                                     Dies hat fuer ^Operator die Folge, dass er bei nicht numerischen
//                                     Ausdreucken sich wie ein logisches XOR verhaelt
DLL_DECL B_Long operator^ (const B_Double&,   const B_Double&)  throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Single&,   const B_Double&)  throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Double&,   const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Long&,     const B_Double&)  throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Double&,   const B_Long&)    throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Integer&,  const B_Double&)  throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Double&,   const B_Integer&) throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Byte&,     const B_Double&)  throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Double&,   const B_Byte&)    throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Boolean&,  const B_Double&)  throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Double&,   const B_Boolean&) throw(B_Overflow);  
DLL_DECL B_Long operator^ (const B_Empty&,    const B_Double&)  throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Double&,   const B_Empty&)   throw(B_Overflow); 
DLL_DECL B_Null operator^ (const B_Null&,     const B_Double&)  throw(B_Overflow);
DLL_DECL B_Null operator^ (const B_Double&,   const B_Null&)    throw(B_Overflow); 

DLL_DECL B_Long operator^ (const B_Double&,   const B_Dbl)      throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Dbl,       const B_Double&)  throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Single&,   const B_Dbl)      throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Dbl,       const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Double&,   const B_Int)      throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Int,       const B_Double&)  throw(B_Overflow);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Der !Operator entspricht NOT in VB 
//   Bit in Ausdruck1 	 Ergebnis
//       0	                 1
//       1                   0
//   ACHTUNG alle C/C++ Programmierer: In VB werden numerische Typen immer logisch bitweise und verknpft
//                                     Dies hat fuer !Operator die Folge, dass er bei nicht numerischen
//                                     Ausdreucken sich wie ein logisches NOT verhaelt
// fuer den Fall, dass B_Emtpy uebergeben wird ist fuer alle Datentypen die Funktion 
// B_Double operator! (const B_Empty) in bc_int.hpp verantwortlich


// Die Operatoren Imp (=logische Implikation) und Eqv (=logische quivalenz) werden vom Konverter
// in folgende Basisoperatorkonstrukte umgesetzt, da in C++ keine quivalenten Operatoren zur Verfgung
// stehen.
// a Imp b    ->  (!a || b)
// a Eqv b    ->  !(a ^ b)

//----------------------------------------------------------------------------------------------------
//---------------------------------- Vergleichs Operatoren -------------------------------------------

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Verlgeich auf Gleichheit der Operanden, es findet ein numerischer Vergleich statt
// Ausdruck1 == Ausdruck2 -> B_True
// Ausdruck1 != Ausdruck2 -> B_False
// ACHTUNG alle VB Programmierer:  In C++ wird mit '==' auf Gleichheit abgefragt und nicht mit '='
//                                 Der '=' Operator wird nur fuer Zuweisungen verwendet.
// ACHTUNG wird ein Double mit einem Single verglichen so wird der Double auf die genauigkeit eines
//         Single gebracht, so dass zwei eignetlich ungleiche Werte als gleich angesehen werden 
//         koennen ( Dies ist das original VB verhalten)
//         Fuer jede dieser Operationen wird eine Warnung ausgegeben.
DLL_DECL B_Boolean operator== (const B_Double&,   const B_Double&);
DLL_DECL B_Boolean operator== (const B_Single&,   const B_Double&);
DLL_DECL B_Boolean operator== (const B_Double&,   const B_Single&);
DLL_DECL B_Boolean operator== (const B_Long&,     const B_Double&);
DLL_DECL B_Boolean operator== (const B_Double&,   const B_Long&);
DLL_DECL B_Boolean operator== (const B_Integer&,  const B_Double&);
DLL_DECL B_Boolean operator== (const B_Double&,   const B_Integer&);
DLL_DECL B_Boolean operator== (const B_Byte&,     const B_Double&);
DLL_DECL B_Boolean operator== (const B_Double&,   const B_Byte&);
DLL_DECL B_Boolean operator== (const B_Empty&,    const B_Double&); 
DLL_DECL B_Boolean operator== (const B_Double&,   const B_Empty&);  
DLL_DECL B_Boolean operator== (const B_Boolean&,  const B_Double&);
DLL_DECL B_Boolean operator== (const B_Double&,   const B_Boolean&);
DLL_DECL B_Null    operator== (const B_Null&,     const B_Double&);
DLL_DECL B_Null    operator== (const B_Double&,   const B_Null&);

DLL_DECL B_Boolean operator== (const B_Double&,   const B_Dbl);
DLL_DECL B_Boolean operator== (const B_Dbl,       const B_Double&);
DLL_DECL B_Boolean operator== (const B_Single&,   const B_Dbl);
DLL_DECL B_Boolean operator== (const B_Dbl,       const B_Single&);
DLL_DECL B_Boolean operator== (const B_Long&,     const B_Dbl);
DLL_DECL B_Boolean operator== (const B_Dbl,       const B_Long&);
DLL_DECL B_Boolean operator== (const B_Integer&,  const B_Dbl);
DLL_DECL B_Boolean operator== (const B_Dbl,       const B_Integer&);
DLL_DECL B_Boolean operator== (const B_Byte&,     const B_Dbl);
DLL_DECL B_Boolean operator== (const B_Dbl,       const B_Byte&);
DLL_DECL B_Boolean operator== (const B_Double&,   const B_Int);
DLL_DECL B_Boolean operator== (const B_Int,       const B_Double&);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Verlgeich auf Ungleichheit der Operanden, es findet ein numerischer Vergleich statt
// Ausdruck1 != Ausdruck2 -> B_True
// Ausdruck1 == Ausdruck2 -> B_False
// ACHTUNG alle VB Programmierer:  In C++ wird mit '!=' auf Ungleichheit abgefragt und nicht mit '<>'
//                                 Der '<>' Operator existiert nicht in C++.
DLL_DECL B_Boolean operator!= (const B_Double&,   const B_Double&);
DLL_DECL B_Boolean operator!= (const B_Single&,   const B_Double&);
DLL_DECL B_Boolean operator!= (const B_Double&,   const B_Single&);
DLL_DECL B_Boolean operator!= (const B_Long&,     const B_Double&);
DLL_DECL B_Boolean operator!= (const B_Double&,   const B_Long&);
DLL_DECL B_Boolean operator!= (const B_Integer&,  const B_Double&);
DLL_DECL B_Boolean operator!= (const B_Double&,   const B_Integer&);
DLL_DECL B_Boolean operator!= (const B_Byte&,     const B_Double&);
DLL_DECL B_Boolean operator!= (const B_Double&,   const B_Byte&);
DLL_DECL B_Boolean operator!= (const B_Empty&,    const B_Double&); 
DLL_DECL B_Boolean operator!= (const B_Double&,   const B_Empty&);  
DLL_DECL B_Boolean operator!= (const B_Boolean&,  const B_Double&);
DLL_DECL B_Boolean operator!= (const B_Double&,   const B_Boolean&);
DLL_DECL B_Null    operator!= (const B_Null&,     const B_Double&);
DLL_DECL B_Null    operator!= (const B_Double&,   const B_Null&);

DLL_DECL B_Boolean operator!= (const B_Double&,   const B_Dbl);
DLL_DECL B_Boolean operator!= (const B_Dbl,       const B_Double&);
DLL_DECL B_Boolean operator!= (const B_Single&,   const B_Dbl);
DLL_DECL B_Boolean operator!= (const B_Dbl,       const B_Single&);
DLL_DECL B_Boolean operator!= (const B_Long&,     const B_Dbl);
DLL_DECL B_Boolean operator!= (const B_Dbl,       const B_Long&);
DLL_DECL B_Boolean operator!= (const B_Integer&,  const B_Dbl);
DLL_DECL B_Boolean operator!= (const B_Dbl,       const B_Integer&);
DLL_DECL B_Boolean operator!= (const B_Byte&,     const B_Dbl);
DLL_DECL B_Boolean operator!= (const B_Dbl,       const B_Byte&);
DLL_DECL B_Boolean operator!= (const B_Double&,   const B_Int);
DLL_DECL B_Boolean operator!= (const B_Int,       const B_Double&);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Verlgeich auf Kleiner der Operanden, es findet ein numerischer Vergleich statt
// Ausdruck1 <  Ausdruck2 -> B_True
// Ausdruck1 >= Ausdruck2 -> B_False
DLL_DECL B_Boolean operator< (const B_Double&,   const B_Double&);
DLL_DECL B_Boolean operator< (const B_Single&,   const B_Double&);
DLL_DECL B_Boolean operator< (const B_Double&,   const B_Single&);
DLL_DECL B_Boolean operator< (const B_Long&,     const B_Double&);
DLL_DECL B_Boolean operator< (const B_Double&,   const B_Long&);
DLL_DECL B_Boolean operator< (const B_Integer&,  const B_Double&);
DLL_DECL B_Boolean operator< (const B_Double&,   const B_Integer&);
DLL_DECL B_Boolean operator< (const B_Byte&,     const B_Double&);
DLL_DECL B_Boolean operator< (const B_Double&,   const B_Byte&);
DLL_DECL B_Boolean operator< (const B_Empty&,    const B_Double&); 
DLL_DECL B_Boolean operator< (const B_Double&,   const B_Empty&);  
DLL_DECL B_Boolean operator< (const B_Boolean&,  const B_Double&);
DLL_DECL B_Boolean operator< (const B_Double&,   const B_Boolean&);
DLL_DECL B_Null    operator< (const B_Null&,     const B_Double&);
DLL_DECL B_Null    operator< (const B_Double&,   const B_Null&);

DLL_DECL B_Boolean operator< (const B_Double&,   const B_Dbl);
DLL_DECL B_Boolean operator< (const B_Dbl,       const B_Double&);
DLL_DECL B_Boolean operator< (const B_Single&,   const B_Dbl);
DLL_DECL B_Boolean operator< (const B_Dbl,       const B_Single&);
DLL_DECL B_Boolean operator< (const B_Long&,     const B_Dbl);
DLL_DECL B_Boolean operator< (const B_Dbl,       const B_Long&);
DLL_DECL B_Boolean operator< (const B_Integer&,  const B_Dbl);
DLL_DECL B_Boolean operator< (const B_Dbl,       const B_Integer&);
DLL_DECL B_Boolean operator< (const B_Byte&,     const B_Dbl);
DLL_DECL B_Boolean operator< (const B_Dbl,       const B_Byte&);
DLL_DECL B_Boolean operator< (const B_Double&,   const B_Int);
DLL_DECL B_Boolean operator< (const B_Int,       const B_Double&);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Verlgeich auf Kleiner/Gleich der Operanden, es findet ein numerischer Vergleich statt
// Ausdruck1 <=  Ausdruck2 -> B_True
// Ausdruck1 >   Ausdruck2 -> B_False
DLL_DECL B_Boolean operator<= (const B_Double&,   const B_Double&);
DLL_DECL B_Boolean operator<= (const B_Single&,   const B_Double&);
DLL_DECL B_Boolean operator<= (const B_Double&,   const B_Single&);
DLL_DECL B_Boolean operator<= (const B_Long&,     const B_Double&);
DLL_DECL B_Boolean operator<= (const B_Double&,   const B_Long&);
DLL_DECL B_Boolean operator<= (const B_Integer&,  const B_Double&);
DLL_DECL B_Boolean operator<= (const B_Double&,   const B_Integer&);
DLL_DECL B_Boolean operator<= (const B_Byte&,     const B_Double&);
DLL_DECL B_Boolean operator<= (const B_Double&,   const B_Byte&);
DLL_DECL B_Boolean operator<= (const B_Empty&,    const B_Double&); 
DLL_DECL B_Boolean operator<= (const B_Double&,   const B_Empty&);  
DLL_DECL B_Boolean operator<= (const B_Boolean&,  const B_Double&);
DLL_DECL B_Boolean operator<= (const B_Double&,   const B_Boolean&);
DLL_DECL B_Null    operator<= (const B_Null&,     const B_Double&);
DLL_DECL B_Null    operator<= (const B_Double&,   const B_Null&);

DLL_DECL B_Boolean operator<= (const B_Double&,   const B_Dbl);
DLL_DECL B_Boolean operator<= (const B_Dbl,       const B_Double&);
DLL_DECL B_Boolean operator<= (const B_Single&,   const B_Dbl);
DLL_DECL B_Boolean operator<= (const B_Dbl,       const B_Single&);
DLL_DECL B_Boolean operator<= (const B_Long&,     const B_Dbl);
DLL_DECL B_Boolean operator<= (const B_Dbl,       const B_Long&);
DLL_DECL B_Boolean operator<= (const B_Integer&,  const B_Dbl);
DLL_DECL B_Boolean operator<= (const B_Dbl,       const B_Integer&);
DLL_DECL B_Boolean operator<= (const B_Byte&,     const B_Dbl);
DLL_DECL B_Boolean operator<= (const B_Dbl,       const B_Byte&);
DLL_DECL B_Boolean operator<= (const B_Double&,   const B_Int);
DLL_DECL B_Boolean operator<= (const B_Int,       const B_Double&);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Verlgeich auf Groesser der Operanden, es findet ein numerischer Vergleich statt
// Ausdruck1 >   Ausdruck2 -> B_True
// Ausdruck1 <=  Ausdruck2 -> B_False
DLL_DECL B_Boolean operator> (const B_Double&,   const B_Double&);
DLL_DECL B_Boolean operator> (const B_Single&,   const B_Double&);
DLL_DECL B_Boolean operator> (const B_Double&,   const B_Single&);
DLL_DECL B_Boolean operator> (const B_Long&,     const B_Double&);
DLL_DECL B_Boolean operator> (const B_Double&,   const B_Long&);
DLL_DECL B_Boolean operator> (const B_Integer&,  const B_Double&);
DLL_DECL B_Boolean operator> (const B_Double&,   const B_Integer&);
DLL_DECL B_Boolean operator> (const B_Byte&,     const B_Double&);
DLL_DECL B_Boolean operator> (const B_Double&,   const B_Byte&);
DLL_DECL B_Boolean operator> (const B_Empty&,    const B_Double&); 
DLL_DECL B_Boolean operator> (const B_Double&,   const B_Empty&);  
DLL_DECL B_Boolean operator> (const B_Boolean&,  const B_Double&);
DLL_DECL B_Boolean operator> (const B_Double&,   const B_Boolean&);
DLL_DECL B_Null    operator> (const B_Null&,     const B_Double&);
DLL_DECL B_Null    operator> (const B_Double&,   const B_Null&);

DLL_DECL B_Boolean operator> (const B_Double&,   const B_Dbl);
DLL_DECL B_Boolean operator> (const B_Dbl,       const B_Double&);
DLL_DECL B_Boolean operator> (const B_Single&,   const B_Dbl);
DLL_DECL B_Boolean operator> (const B_Dbl,       const B_Single&);
DLL_DECL B_Boolean operator> (const B_Long&,     const B_Dbl);
DLL_DECL B_Boolean operator> (const B_Dbl,       const B_Long&);
DLL_DECL B_Boolean operator> (const B_Integer&,  const B_Dbl);
DLL_DECL B_Boolean operator> (const B_Dbl,       const B_Integer&);
DLL_DECL B_Boolean operator> (const B_Byte&,     const B_Dbl);
DLL_DECL B_Boolean operator> (const B_Dbl,       const B_Byte&);
DLL_DECL B_Boolean operator> (const B_Double&,   const B_Int);
DLL_DECL B_Boolean operator> (const B_Int,       const B_Double&);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Verlgeich auf Groesser/Gleich der Operanden, es findet ein numerischer Vergleich statt
// Ausdruck1 >=  Ausdruck2 -> B_True
// Ausdruck1 <   Ausdruck2 -> B_False
DLL_DECL B_Boolean operator>= (const B_Double&,   const B_Double&);
DLL_DECL B_Boolean operator>= (const B_Single&,   const B_Double&);
DLL_DECL B_Boolean operator>= (const B_Double&,   const B_Single&);
DLL_DECL B_Boolean operator>= (const B_Long&,     const B_Double&);
DLL_DECL B_Boolean operator>= (const B_Double&,   const B_Long&);
DLL_DECL B_Boolean operator>= (const B_Integer&,  const B_Double&);
DLL_DECL B_Boolean operator>= (const B_Double&,   const B_Integer&);
DLL_DECL B_Boolean operator>= (const B_Byte&,     const B_Double&);
DLL_DECL B_Boolean operator>= (const B_Double&,   const B_Byte&);
DLL_DECL B_Boolean operator>= (const B_Empty&,    const B_Double&); 
DLL_DECL B_Boolean operator>= (const B_Double&,   const B_Empty&);  
DLL_DECL B_Boolean operator>= (const B_Boolean&,  const B_Double&);
DLL_DECL B_Boolean operator>= (const B_Double&,   const B_Boolean&);
DLL_DECL B_Null    operator>= (const B_Null&,     const B_Double&);
DLL_DECL B_Null    operator>= (const B_Double&,   const B_Null&);

DLL_DECL B_Boolean operator>= (const B_Double&,   const B_Dbl);
DLL_DECL B_Boolean operator>= (const B_Dbl,       const B_Double&);
DLL_DECL B_Boolean operator>= (const B_Single&,   const B_Dbl);
DLL_DECL B_Boolean operator>= (const B_Dbl,       const B_Single&);
DLL_DECL B_Boolean operator>= (const B_Long&,     const B_Dbl);
DLL_DECL B_Boolean operator>= (const B_Dbl,       const B_Long&);
DLL_DECL B_Boolean operator>= (const B_Integer&,  const B_Dbl);
DLL_DECL B_Boolean operator>= (const B_Dbl,       const B_Integer&);
DLL_DECL B_Boolean operator>= (const B_Byte&,     const B_Dbl);
DLL_DECL B_Boolean operator>= (const B_Dbl,       const B_Byte&);
DLL_DECL B_Boolean operator>= (const B_Double&,   const B_Int);
DLL_DECL B_Boolean operator>= (const B_Int,       const B_Double&);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Streamoperatoren
DLL_DECL ostream& operator<<(ostream& ostr, const B_Double& rhs);
DLL_DECL istream& operator>>(istream& istr, B_Double& rhs);

//================================ Inlinefunktionen =========================================================
//
#if defined _DEBUG || defined B_VB_CONTRACT
  #define B_NOINLINE
#else
  #undef B_NOINLINE
#endif

#ifndef B_NOINLINE                 // festlegen wenn Debuger keine Inlines debuggen kann
  #define B_INLINE inline  
  #ifndef  BI_DBL_HPP
    #include "bi_dbl.hpp"
  #endif
#endif


//===========================================================================================================
//================================ End Of Header ============================================================
#endif // BC_DBL_HPP

#endif // B_VB_COMPATIBLE
