#ifndef BC_EMPTY_HPP
#define BC_EMPTY_HPP
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Project:                 VB nach C/C++ Konverter Klassenbibliothek
// Modul:                   VB Klasse fuer den Datentyp B_Empty
// Filename:                bc_empty.hpp
// Version:                 0.0
// Status:                  beta
//
// Copyright:               (C) 1995
//                          Cicerosoft GmbH
//                          Ballweilerstr. 7
//                          66399 Erfeiler-Ehlingen
//
// Operating System(s):     Win95
// Compiler:                VC++ 4.1
//
// Author(s):               Jochen Diener JD
// Creation Date:           JD 20.12.95
// Last Modification:       JD 20.12.95
//
// Description:             Beinhaltet alle Klassen / Hilfskt. die im Zusammenhang mit der VB
//                          Konvertierung, fuer die Bereitstellung des Datentyps Null benoetigt
//                          werden.
//
// Dependencies:            bc_empty.cpp   -> Klassenimpl.
//                          bi_empty.hpp   -> Inline (Member)Funktionen der Klasse
//
// Remarks:
//
//
// Revision(s):
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

//================================= Defintionsabhaengigkeiten ===============================================
//
#ifndef BD_INTYP_HPP
  #include "bd_intyp.hpp"       // alias der Standardatentypen
#endif

#ifndef BC_BOOL_HPP
  #include "bc_bool.hpp"
#endif

//================================= Export =================================================================
//

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Description:                                                                           (C) CiceroSoft 1995
//     B_Empty   Empty-Datentyp von VB zur Kennzeichung nicht initialisierter Werte
// Hierachy:    
// Inheritance: 
// Errorhandling:
// Note: 
// Impl.: 
class DLL_DECL B_Empty
  {
  //================ MANAGEMENT =========================================================================
  //
  public:
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     ctor
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:  
    //     keine Konstruktoren fuer Standardtypen und Libtpyen da emtpy nicht als Fktsparameter gueltig ist.
    //     default
    B_Empty();   

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     dtor
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:  
    //     default
    ~B_Empty();

  private:
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     cctor
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:  
    //     default
    B_Empty(const B_Empty&); 

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Zuweisungsop.
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:  
    //
    B_Empty& operator=(const B_Empty&);
    
  //==================== FRIENDS ============================================================================
  //
  }; // B_Empty


DLL_DECL extern const B_Empty B_empty;  // default Typ den auch VB zur Verfuegung stellt


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// fuer alle gleich
DLL_DECL B_Boolean operator== (const B_Empty&, const B_Empty&);

// C-Standardtypen
DLL_DECL B_Boolean operator== (const B_Dbl,    const B_Empty&);
DLL_DECL B_Boolean operator== (const B_Empty&, const B_Dbl);
DLL_DECL B_Boolean operator== (const B_Flt,    const B_Empty&);
DLL_DECL B_Boolean operator== (const B_Empty&, const B_Flt);
DLL_DECL B_Boolean operator== (const B_Empty&, const B_Lng);
DLL_DECL B_Boolean operator== (const B_Lng,    const B_Empty&);
DLL_DECL B_Boolean operator== (const B_UInt,   const B_Empty&);
DLL_DECL B_Boolean operator== (const B_Empty&, const B_UInt);
DLL_DECL B_Boolean operator== (const B_Int,    const B_Empty&);
DLL_DECL B_Boolean operator== (const B_Empty&, const B_Int);

// Bibliothekstypen
DLL_DECL B_Boolean operator== (const B_Empty&,   const B_Boolean&);
DLL_DECL B_Boolean operator== (const B_Boolean&, const B_Empty&);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// fuer alle gleich
DLL_DECL B_Boolean operator!= (const B_Empty&, const B_Empty&);

// C-Standardtypen
DLL_DECL B_Boolean operator!= (const B_Dbl,    const B_Empty&);
DLL_DECL B_Boolean operator!= (const B_Empty&, const B_Dbl);
DLL_DECL B_Boolean operator!= (const B_Flt,    const B_Empty&);
DLL_DECL B_Boolean operator!= (const B_Empty&, const B_Flt);
DLL_DECL B_Boolean operator!= (const B_Empty&, const B_Lng);
DLL_DECL B_Boolean operator!= (const B_Lng,    const B_Empty&);
DLL_DECL B_Boolean operator!= (const B_UInt,   const B_Empty&);
DLL_DECL B_Boolean operator!= (const B_Empty&, const B_UInt);
DLL_DECL B_Boolean operator!= (const B_Int,    const B_Empty&);
DLL_DECL B_Boolean operator!= (const B_Empty&, const B_Int);

// Bibliothekstypen
DLL_DECL B_Boolean operator!= (const B_Empty&,   const B_Boolean&);
DLL_DECL B_Boolean operator!= (const B_Boolean&, const B_Empty&);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// fuer alle gleich
DLL_DECL B_Boolean operator<  (const B_Empty&, const B_Empty&);

// C-Standardtypen
DLL_DECL B_Boolean operator<  (const B_Dbl,    const B_Empty&);
DLL_DECL B_Boolean operator<  (const B_Empty&, const B_Dbl);
DLL_DECL B_Boolean operator<  (const B_Flt,    const B_Empty&);
DLL_DECL B_Boolean operator<  (const B_Empty&, const B_Flt);
DLL_DECL B_Boolean operator<  (const B_Empty&, const B_Lng);
DLL_DECL B_Boolean operator<  (const B_Lng,    const B_Empty&);
DLL_DECL B_Boolean operator<  (const B_UInt,   const B_Empty&);
DLL_DECL B_Boolean operator<  (const B_Empty&, const B_UInt);
DLL_DECL B_Boolean operator<  (const B_Int,    const B_Empty&);
DLL_DECL B_Boolean operator<  (const B_Empty&, const B_Int);

// Bibliothekstypen
DLL_DECL B_Boolean operator<  (const B_Empty&,   const B_Boolean&);
DLL_DECL B_Boolean operator<  (const B_Boolean&, const B_Empty&);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// fuer alle gleich
DLL_DECL B_Boolean operator<=(const B_Empty&,  const B_Empty&);

// C-Standardtypen
DLL_DECL B_Boolean operator<= (const B_Dbl,    const B_Empty&);
DLL_DECL B_Boolean operator<= (const B_Empty&, const B_Dbl);
DLL_DECL B_Boolean operator<= (const B_Flt,    const B_Empty&);
DLL_DECL B_Boolean operator<= (const B_Empty&, const B_Flt);
DLL_DECL B_Boolean operator<= (const B_Empty&, const B_Lng);
DLL_DECL B_Boolean operator<= (const B_Lng,    const B_Empty&);
DLL_DECL B_Boolean operator<= (const B_UInt,   const B_Empty&);
DLL_DECL B_Boolean operator<= (const B_Empty&, const B_UInt);
DLL_DECL B_Boolean operator<= (const B_Int,    const B_Empty&);
DLL_DECL B_Boolean operator<= (const B_Empty&, const B_Int);

// Bibliothekstypen
DLL_DECL B_Boolean operator<= (const B_Empty&,   const B_Boolean&);
DLL_DECL B_Boolean operator<= (const B_Boolean&, const B_Empty&);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// fuer alle gleich
DLL_DECL B_Boolean operator>(const B_Empty&,  const B_Empty&);

// C-Standardtypen
DLL_DECL B_Boolean operator> (const B_Dbl,    const B_Empty&);
DLL_DECL B_Boolean operator> (const B_Empty&, const B_Dbl);
DLL_DECL B_Boolean operator> (const B_Flt,    const B_Empty&);
DLL_DECL B_Boolean operator> (const B_Empty&, const B_Flt);
DLL_DECL B_Boolean operator> (const B_Empty&, const B_Lng);
DLL_DECL B_Boolean operator> (const B_Lng,    const B_Empty&);
DLL_DECL B_Boolean operator> (const B_UInt,   const B_Empty&);
DLL_DECL B_Boolean operator> (const B_Empty&, const B_UInt);
DLL_DECL B_Boolean operator> (const B_Int,    const B_Empty&);
DLL_DECL B_Boolean operator> (const B_Empty&, const B_Int);

// Bibliothekstypen
DLL_DECL B_Boolean operator> (const B_Empty&,   const B_Boolean&);
DLL_DECL B_Boolean operator> (const B_Boolean&, const B_Empty&);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// fuer alle gleich
DLL_DECL B_Boolean operator>=(const B_Empty&,  const B_Empty&);

// C-Standardtypen
DLL_DECL B_Boolean operator>= (const B_Dbl,    const B_Empty&);
DLL_DECL B_Boolean operator>= (const B_Empty&, const B_Dbl);
DLL_DECL B_Boolean operator>= (const B_Flt,    const B_Empty&);
DLL_DECL B_Boolean operator>= (const B_Empty&, const B_Flt);
DLL_DECL B_Boolean operator>= (const B_Empty&, const B_Lng);
DLL_DECL B_Boolean operator>= (const B_Lng,    const B_Empty&);
DLL_DECL B_Boolean operator>= (const B_UInt,   const B_Empty&);
DLL_DECL B_Boolean operator>= (const B_Empty&, const B_UInt);
DLL_DECL B_Boolean operator>= (const B_Int,    const B_Empty&);
DLL_DECL B_Boolean operator>= (const B_Empty&, const B_Int);

// Bibliothekstypen
DLL_DECL B_Boolean operator>= (const B_Empty&,   const B_Boolean&);
DLL_DECL B_Boolean operator>= (const B_Boolean&, const B_Empty&);

//================================ Inlinefunktionen =========================================================
//
#if defined _DEBUG || defined B_VB_CONTRACT
  #define B_NOINLINE
#else
  #undef B_NOINLINE
#endif

#ifndef B_NOINLINE                // festlegen wenn Debuger keine Inlines debuggen kann
  #define B_INLINE inline
  #ifndef BI_EMPTY_HPP
    #include "bi_empty.hpp"
  #endif
#endif

//===========================================================================================================
//================================ End Of Header ============================================================
#endif // BC_EMPTY_HPP

