#ifdef B_VB_COMPATIBLE

#ifndef BC_SNGLE_HPP
#define BC_SNGLE_HPP
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Project:                 VB nach C/C++ Konverter Klassenbibliothek
// Modul:                   VB Klasse fuer VB Single Datentyp
// Filename:                bc_sngle.hpp
// Version:                 1.0
// Status:                  beta
//
// Copyright:               (C)
//                          Cicerosoft GmbH,
//                          Ballweilerstr. 7,
//                          66399 Erfweiler-Ehlingen
//
// Operating System(s):     Win95 
// Compiler:                VC++ 4.1
//
// Author:                  Jochen Diener JD
// Creation Date:           18.12.95
// Last modification:       JD 02.07.96
//
// Description:             Beinhaltet die Implementierung der B_Single Klasee
//
//
// Dependencies:            bi_sngle.hpp   -> Inline Fkt.
//                          bc_sngle.hpp   -> Deklaration von B_Single
//
// Remarks:
//
// Revision(s):
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

//================================= Defintionsabhaengigkeiten ===============================================
//
#include <iostream.h>

#ifndef BD_INTYP_HPP       
  #include "bd_intyp.hpp"       // alias der Standardatentypen
#endif

#ifndef BC_BOOL_HPP
  #include "bc_bool.hpp"        // VB Boolean Typ
#endif

#ifndef BC_NULL_HPP
  #include "bc_null.hpp"
#endif

#ifndef BC_EMPTY_HPP
  #include "bc_empty.hpp"
#endif

#ifndef BC_BYTE_HPP
  #include "bc_byte.hpp"
#endif

#ifndef BC_INT_HPP
  #include "bc_int.hpp"
#endif

#ifndef BC_LONG_HPP
  #include "bc_long.hpp"
#endif

//================================= Export =================================================================
//
class B_Double;
class B_Currency;
class B_String;
class B_fstream;						// CT131296 Fuer FileIO abgeleitete fstream-Klasse

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Description:                                                                           (C) CiceroSoft 1995
//     B_Single     Emuliert VB-Datentyp Single
// Hierachy:    
// Inheritance: 
// Errorhandling:
// Note: 
//
class DLL_DECL B_Single
  {
  //==================== MANGAEMENT =========================================================================
  //
  public: 
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     ctor
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Single(); 

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     cctor
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Single(const B_Single&);

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     ctor's fuer Bibliotheksdatentypen
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Single(const B_String&);   // throw(B_TypeMismatch, B_Overflow, B_Underflow);
    B_Single(const B_Currency&); // throw(B_Overflow, B_Underflow);
    B_Single(const B_Double&);   // throw(B_Overflow, B_Underflow);
    B_Single(const B_Long&);
    B_Single(const B_Integer&);
    B_Single(const B_Byte&);
    B_Single(const B_Boolean&);
    B_Single(const B_Empty&); 
    B_Single(const B_Null&);    // throw(B_InvalidNull);  
    
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     ctor's fuer C-Standardatentypen
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Single(B_cCStr,      const B_Explicit&); // throw(B_TypeMismatch, B_Overflow, B_Underflow);
    B_Single(const B_Flt,  const B_Explicit&); 
    B_Single(const B_Dbl,  const B_Explicit&); // throw(B_Overflow, B_Underflow);
    B_Single(const B_Lng,  const B_Explicit&); 
    B_Single(const B_UInt, const B_Explicit&);
    B_Single(const B_Int,  const B_Explicit&);

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     dtor
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    ~B_Single();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Zuweisungsop.
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Single& operator=(const B_Single&);

  //==================== INTERFACE ============================================================================
  //
  public:
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Zuweisungsop. fuer Bibliotheksdatentypen
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Single& operator=(const B_String&)   throw(B_TypeMismatch, B_Overflow, B_Underflow);    
    B_Single& operator=(const B_Currency&) throw(B_Overflow, B_Underflow);
    B_Single& operator=(const B_Double&)   throw(B_Overflow, B_Underflow);
    B_Single& operator=(const B_Long&);
    B_Single& operator=(const B_Integer&);
    B_Single& operator=(const B_Byte&);
    B_Single& operator=(const B_Boolean&);
    B_Single& operator=(const B_Empty&);
    B_Single& operator=(const B_Null&)     throw(B_InvalidNull); 

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Zuweisungsop. fuer C-Standarddatentypen
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Single& operator=(const B_Int);   
    B_Single& operator=(const B_UInt);   
    B_Single& operator=(const B_Lng);
    B_Single& operator=(const B_Dbl)  throw(B_Overflow, B_Underflow);
    B_Single& operator=(const B_Flt);
    B_Single& operator=(B_cCStr)      throw(B_TypeMismatch, B_Overflow, B_Underflow);
    
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Addition des Wertes selbst mit einem anderen Wert. Entspricht x = x + y
    // Parameter:  
    //     Wert der hinzuaddiert werden soll (Entspricht y)
    // Return Value:
    //     Das Ergebnis der Addition
    // Errorhandling:
    // Note:      
    //
    B_Single& operator+=(const B_Single&)   throw(B_Overflow);
    B_Single& operator+=(const B_Long&)     throw(B_Overflow);
    B_Single& operator+=(const B_Integer&)  throw(B_Overflow);
    B_Single& operator+=(const B_Byte&)     throw(B_Overflow);
    B_Single& operator+=(const B_Boolean&)  throw(B_Overflow);
    B_Single& operator+=(const B_Empty&);
    B_Single& operator+=(const B_Null&)     throw(B_InvalidNull);
    B_Single& operator+=(const B_Flt)       throw(B_Overflow);
    
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Subtraktion des Wertes selbst mit einem anderen Wert. Entspricht x = x - y
    // Parameter:  
    //     Wert der subtrahiert werden soll (Entspricht y)
    // Return Value:
    //     Das Ergebnis der Subtraktion
    // Errorhandling:
    // Note:      
    //
    B_Single& operator-=(const B_Single&)  throw(B_Overflow);
    B_Single& operator-=(const B_Long&)    throw(B_Overflow); 
    B_Single& operator-=(const B_Integer&) throw(B_Overflow);
    B_Single& operator-=(const B_Byte&)    throw(B_Overflow);
    B_Single& operator-=(const B_Boolean&) throw(B_Overflow);
    B_Single& operator-=(const B_Empty&);
    B_Single& operator-=(const B_Null&)    throw(B_InvalidNull);
    B_Single& operator-=(const B_Flt)      throw(B_Overflow);    

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Multiplikation des Wertes selbst mit einem anderen Wert. Entspricht x = x * y
    // Parameter:  
    //     Wert der multipliziert werden soll (Entspricht y)
    // Return Value:
    //     Das Ergebnis der Multiplikation
    // Errorhandling:
    // Note:      
    //
    B_Single& operator*=(const B_Single&)  throw(B_Overflow, B_Underflow);
    B_Single& operator*=(const B_Long&)    throw(B_Overflow, B_Underflow);
    B_Single& operator*=(const B_Integer&) throw(B_Overflow, B_Underflow);
    B_Single& operator*=(const B_Byte&)    throw(B_Overflow, B_Underflow);
    B_Single& operator*=(const B_Boolean&);
    B_Single& operator*=(const B_Empty&);
    B_Single& operator*=(const B_Null&)    throw(B_InvalidNull);
    B_Single& operator*=(const B_Flt)      throw(B_Overflow, B_Underflow);

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Division des Wertes selbst mit einem anderen Wert. Entspricht x = x / y
    // Parameter:  
    //     Wert der dividiert werden soll (Entspricht y)
    // Return Value:
    //     Das Ergebnis der Division
    // Errorhandling:
    // Note:      
    //
    B_Single& operator/=(const B_Single&)  throw(B_ZeroDivide, B_Underflow);
    B_Single& operator/=(const B_Long&)    throw(B_ZeroDivide, B_Underflow);    
    B_Single& operator/=(const B_Integer&) throw(B_ZeroDivide, B_Underflow);
    B_Single& operator/=(const B_Byte&)    throw(B_ZeroDivide, B_Underflow);
    B_Single& operator/=(const B_Boolean&) throw(B_ZeroDivide);
    B_Single& operator/=(const B_Empty&)   throw(B_ZeroDivide);
    B_Single& operator/=(const B_Null&)    throw(B_InvalidNull);
    B_Single& operator/=(const B_Flt)      throw(B_ZeroDivide, B_Underflow);

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Modulo Operation = Restwert einer Division. Entspricht x = x % y
    // Parameter:  
    //     Wert der dividiert werden soll (Entspricht y)
    // Return Value:
    //     Restwert der Division
    // Errorhandling:
    // Note:      
    //     Im Gegensatz zum Binaren-Operator wird hier der ganze Single-Wertebereich
    //     unterstuetzt (in VB muessen die Operanden im Long-Wertebereich liegen sonst
    //     wird eine EH B_Overflow ausgeloest),
    B_Single& operator%=(const B_Single&)  throw(B_ZeroDivide, B_Underflow);
    B_Single& operator%=(const B_Long&)    throw(B_ZeroDivide, B_Underflow);    
    B_Single& operator%=(const B_Integer&) throw(B_ZeroDivide, B_Underflow);
    B_Single& operator%=(const B_Byte&)    throw(B_ZeroDivide, B_Underflow);
    B_Single& operator%=(const B_Boolean&) throw(B_ZeroDivide);
    B_Single& operator%=(const B_Empty&)   throw(B_ZeroDivide);
    B_Single& operator%=(const B_Null&)    throw(B_InvalidNull);
    B_Single& operator%=(const B_Flt)      throw(B_ZeroDivide, B_Underflow);

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     operator!   Nicht-Operator
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Long operator!() const throw(B_Overflow);

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Konvertierungsop. fuer C-Standarddatentyp
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    operator B_Flt() const;

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Unaeres Minus
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Single operator-() const;

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Inkrement/dekrement des Objektes. Entspricht: x = x + 1;/ x = x -1
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Single& operator++() throw(B_Overflow);
    B_Single& operator--() throw(B_Overflow);

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Rundet den Wert des Objekts auf die angegebene Stellenzahl.
    //     Diese Zahl muss 0 < x <= MAX_DIGITS der genauigkeitsangabe des Objekttyps sein
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Single& rnd(const B_Byte& digits);
    
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //      Konvertiert das Objekt in seinen ganzzahligen Anteil.  Bei negativen Zahlen 
    //      konvertiert Int das Objekt in diejenige negative ganze Zahl, die kleiner oder 
    //      gleich dem Objektwert ist. 
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //     Die Methoden geben B_Single zurueck die Funktionen (B_int()) aus Kompatibilitaet zu VB korrekterweise B_Double    
    //     ACHTUNG an alle C++ Programmierer int ist nicht vergleichbar mit den mathe Bibliotheksfkt. floor/ceil von C/C++.
    //     int( 2.8)  = floor(2.8)   -> 2
    //     int(-2.8)  = floor(-2.8)  -> -3
    //     Die Funktion ist aus Kompatibilitaetsgruenden zu VB enthalten
    B_Single& intf();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Konvertiert das Objekt in seinen ganzzahligen Anteil.  Bei negativen Zahlen 
    //     konvertiert Fix das Objekt in diejenige negative ganze Zahl, die groesser oder 
    //     gleich dem Objektwert ist. 
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //     Die Methoden geben B_Single zurueck die Funktionen aus Kompatibilitaet zu VB korrekterweise B_Double
    //     ACHTUNG an alle C++ Programmierer int ist nicht vergleichbar mit den mathe  Bibliotheksfkt. floor/ceil von C/C++.
    //     fix( 2.8)  = floor(2.8)   ->  2
    //     fix(-2.8)  = ceil(-2.8)   -> -2
    //     Fix(Zahl) entspricht also in C/C++ dem folgenden Ausdruck: Sgn(Zahl) * Int(Abs(Zahl))
    B_Single& fix();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Konvertiert das Objekt in seine Fractional=Nachkomma Darstellung. D.h dass der 
    //     Vorkommaanteil der Zahl abgeschnitten (zu 0 gestzt) wird.
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //     123.45678 -> 0.45678
    //     Die Funktion dient zur Ergaenzung der int und fix Funktionennt(Abs(Zahl))
    B_Single& fract();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Konvertiert das Objekt in seine groesste Integerdarstellung die kleiner oder
    //     gleich ist als der akt. Wert des Objektes.
    //     floor(2.8)  ->  2
    //     floor(-2.8) -> -3   
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Single& floor();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Konvertiert das Objekt in seine kleinste Integerdarstellung die groesser oder
    //     gleich ist als der akt. Wert des Objektes.
    //     ceil(2.8)  ->  3
    //     ceil(-2.8) -> -2   
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Single& ceil();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Wandelt den Wert des Objektes in einen Absoluten Wert um, d.h 
    //     negativer Objektwert -> positiv
    //     positiver Objektwert -> bleibt positiv
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_Single& abs();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Gibt den Wert des Objektes als entsprechenden C/C++ Datentyp zurueck
    // Parameter:  
    // Return Value:
    //     Kopie des Objetkwertes als B_Lng
    // Errorhandling:
    // Note:      
    //     Den genauen Typ von B_Flt kann man in bd_intyp.hpp feststellen, in der alle C/C++ Datentypen definiert sind.
    //     Diese Funktion soll den Datenaustausch zwischen Klassen der Klassenbibliothek
    //     und den mit den C++ Standarddatentypen geschriebenen Funktionen ermoeglichen
    //     wenn diese keine Klassen als Parameter erlauben.
    B_Flt getValue() const;

    //----------------------------------------------------------------------------------------------------       
    // Method:
    //     Gibt die Groesse des Wert des Objektes als entsprechenden C/C++ Datentyp zurueck
    // Return Value:
    //     Groesse in Byte
    // Note:
    //     Den genauen Typ und somit seine groesse koennen zwischen den C/C++ Datentypen der
    //     Compiler unterschiedlich sein, deshalb wurde diese Method eingefuegt die eine
    //     portable Programmierung aehnlich sizeof() ermoeglichen soll.
    B_ULng  getValueSize() const;  
    
    //----------------------------------------------------------------------------------------------------       
    // Method: 
    //     Gibt die Groesse des Objktes zurueck, diese entspricht der durch das Objekt belegten
    //     Speicherplatz
    // Return Value: 
    //     Groesse in Byte
    // Note: 
    //     Den genauen Typ und somit seine groesse koennen zwischen den C/C++ Compiler 
    //     unterschiedlich sein. Auch koennte sich die Klassenimplementierung aendern so
    //     dass aeltere Programme nur mit Aenderungsprogramm lauffaehig waeren, deshalb 
    //     wurde diese Method eingefuegt die eine portable Programmierung aehnlich 
    //     sizeof() ermoeglichen soll.
    B_ULng getSize() const;       

    //----------------------------------------------------------------------------------------------------       
    // Method: 
    //     Setzt den internen Status des Objektes auf optional. Somit kann mit isMissing der Status
    //     abgefragt werden und die Emulation des gleichnamigen VB Befehls wird moeglich.
    // Return Value: 
    // Note: 
    //
    B_Single& isOptional();

    //----------------------------------------------------------------------------------------------------       
    // Method: 
    //     Abfragen des internen Objektstatus ob das Argument einer Funktion optional ist oder nicht
    // Return Value: 
    // Note: 
    //
    B_Boolean isMissing() const;

    //----------------------------------------------------------------------------------------------------       
    // Method: 
    //     Schreiben der der eigentlichen Objektdaten im binaeren Format in einen Stream
    // Return Value: 
    //     B_true  ==  Objekt und Stream sind gueltig
    //     B_false ==  Objekt oder Stream sind ungueltig
    // Note: 
    //
    B_Boolean streamw(ostream& ostr, B_Shrt openmode) const;

    //----------------------------------------------------------------------------------------------------       
    // Method: 
    //     Lesen der der eigentlichen Objektdaten im binaeren Format in einen Stream
    // Return Value: 
    //     B_true  ==  Objekt und Stream sind gueltig
    //     B_false ==  Objekt oder Stream sind ungueltig
    // Note: 
    //
    B_Boolean streamr(istream& istr, B_Shrt openmode);
	
  private:
    //----------------------------------------------------------------------------------------------------       
    // Method:
    //     Postfix   Inkrement/Dekrement
    // Parameter:  
    // Return Value: 
    // Note:      
    //     Da es beim ueberladen keinen wirkliche Postfixoperatoren gibt wurden diese gesperrt
    B_Single& operator++(int);
    B_Single& operator--(int);


  //==================== MEMBER ===============================================================================    
  //
  private:
    B_Flt value;  // da VB Wertebereich   -1,401298E-45 bis 3,402823E+38
                  // VB benutz IEEE 32bit FloatingPoint Format sign=1bit, exp.=8bit, mantisse=23bit (1bit impl.)
                  // Die miesten C++ Compiler haben einen Wertebereich von 3.4E+/-38  7Digits (VC++22, BC++45) 
                  // Jedoch gibt es bei den Compilern unterschiede! Sicher sind nur die Werte 
                  // 1.175494E-38 bis 3.402823E+38 mit 6Digits nach IEEE (WC++105,SC++72, VC++40)    
                  // ACHTUNG: Somit unterscheiden sich die Wertebereiche des VB Single Typs und des 
                  // vergleichbaren C/C++ Datentyps Float
    B_Flag optional;

  //==================== FRIENDS ============================================================================
  //
  friend class B_Byte;
  friend class B_Integer;
  friend class B_Long;  
  friend class B_Double;
  friend class B_Currency;
  friend class B_String;

  friend DLL_DECL  B_Single operator+ (const B_Single&,  const B_Single&);
  friend DLL_DECL  B_Single operator+ (const B_Integer&, const B_Single&);
  friend DLL_DECL  B_Single operator+ (const B_Single&,  const B_Integer&);
  friend DLL_DECL  B_Single operator+ (const B_Byte&,    const B_Single&);
  friend DLL_DECL  B_Single operator+ (const B_Single&,  const B_Byte&);
  friend DLL_DECL  B_Single operator+ (const B_Boolean&, const B_Single&);
  friend DLL_DECL  B_Single operator+ (const B_Single&,  const B_Boolean&);
  friend DLL_DECL  B_Single operator+ (const B_Empty&,   const B_Single&);
  friend DLL_DECL  B_Single operator+ (const B_Single&,  const B_Empty&);
  friend DLL_DECL  B_Single operator+ (const B_Single&,  const B_Flt);
  friend DLL_DECL  B_Single operator+ (const B_Flt,      const B_Single&);
  friend DLL_DECL  B_Single operator+ (const B_Int,      const B_Single&);
  friend DLL_DECL  B_Single operator+ (const B_Single&,  const B_Int);

  friend DLL_DECL  B_Single  operator- (const B_Single&,  const B_Single&);
  friend DLL_DECL  B_Single  operator- (const B_Integer&, const B_Single&);
  friend DLL_DECL  B_Single  operator- (const B_Single&,  const B_Integer&);
  friend DLL_DECL  B_Single  operator- (const B_Byte&,    const B_Single&);
  friend DLL_DECL  B_Single  operator- (const B_Single&,  const B_Byte&);
  friend DLL_DECL  B_Single  operator- (const B_Boolean&, const B_Single&);
  friend DLL_DECL  B_Single  operator- (const B_Single&,  const B_Boolean&);
  friend DLL_DECL  B_Single  operator- (const B_Empty&,   const B_Single&);
  friend DLL_DECL  B_Single  operator- (const B_Single&,  const B_Empty&);
  friend DLL_DECL  B_Single  operator- (const B_Single&,  const B_Flt);
  friend DLL_DECL  B_Single  operator- (const B_Flt,      const B_Single&);
  friend DLL_DECL  B_Single  operator- (const B_Int,      const B_Single&);
  friend DLL_DECL  B_Single  operator- (const B_Single&,  const B_Int);

  friend DLL_DECL  B_Single operator* (const B_Single&,  const B_Single&);
  friend DLL_DECL  B_Single operator* (const B_Integer&, const B_Single&);
  friend DLL_DECL  B_Single operator* (const B_Single&,  const B_Integer&);
  friend DLL_DECL  B_Single operator* (const B_Byte&,    const B_Single&);
  friend DLL_DECL  B_Single operator* (const B_Single&,  const B_Byte&);
  friend DLL_DECL  B_Single operator* (const B_Single&,  const B_Boolean&);
  friend DLL_DECL  B_Single operator* (const B_Boolean&, const B_Single&);
  friend DLL_DECL  B_Single operator* (const B_Empty&,   const B_Single&);
  friend DLL_DECL  B_Single operator* (const B_Single&,  const B_Empty&);
  friend DLL_DECL  B_Single operator* (const B_Single&,  const B_Flt);
  friend DLL_DECL  B_Single operator* (const B_Flt,      const B_Single&);
  friend DLL_DECL  B_Single operator* (const B_Int,      const B_Single&);
  friend DLL_DECL  B_Single operator* (const B_Single&,  const B_Int);

  friend DLL_DECL  B_Single  operator/ (const B_Single&,   const B_Single&);
  friend DLL_DECL  B_Single  operator/ (const B_Long&,     const B_Single&); 
  friend DLL_DECL  B_Single  operator/ (const B_Single&,   const B_Long&);
  friend DLL_DECL  B_Single  operator/ (const B_Integer&,  const B_Single&);
  friend DLL_DECL  B_Single  operator/ (const B_Single&,   const B_Integer&);
  friend DLL_DECL  B_Single  operator/ (const B_Byte&,     const B_Single&);
  friend DLL_DECL  B_Single  operator/ (const B_Single&,   const B_Byte&);
  friend DLL_DECL  B_Single  operator/ (const B_Boolean&,  const B_Single&);
  friend DLL_DECL  B_Single  operator/ (const B_Single&,   const B_Boolean&);
  friend DLL_DECL  B_Single  operator/ (const B_Empty&,    const B_Single&);
  friend DLL_DECL  B_Single  operator/ (const B_Single&,   const B_Empty&);
  friend DLL_DECL  B_Single  operator/ (const B_Single&,   const B_Flt);
  friend DLL_DECL  B_Single  operator/ (const B_Flt,       const B_Single&);
  friend DLL_DECL  B_Single  operator/ (const B_Lng,       const B_Single&); 
  friend DLL_DECL  B_Single  operator/ (const B_Single&,   const B_Lng);
  friend DLL_DECL  B_Single  operator/ (const B_Int,       const B_Single&);
  friend DLL_DECL  B_Single  operator/ (const B_Single&,   const B_Int);

  friend DLL_DECL  B_Long  operator% (const B_Single&,   const B_Single&);
  friend DLL_DECL  B_Long  operator% (const B_Long&,     const B_Single&);
  friend DLL_DECL  B_Long  operator% (const B_Single&,   const B_Long&);
  friend DLL_DECL  B_Long  operator% (const B_Integer&,  const B_Single&);
  friend DLL_DECL  B_Long  operator% (const B_Single&,   const B_Integer&);
  friend DLL_DECL  B_Long  operator% (const B_Byte&,     const B_Single&);
  friend DLL_DECL  B_Long  operator% (const B_Single&,   const B_Byte&);
  friend DLL_DECL  B_Long  operator% (const B_Boolean&,  const B_Single&);
  friend DLL_DECL  B_Long  operator% (const B_Single&,   const B_Boolean&);
  friend DLL_DECL  B_Long  operator% (const B_Empty&,    const B_Single&);
  friend DLL_DECL  B_Long  operator% (const B_Single&,   const B_Empty&);
  friend DLL_DECL  B_Long  operator% (const B_Single&,   const B_Flt);
  friend DLL_DECL  B_Long  operator% (const B_Flt,       const B_Single&);
  friend DLL_DECL  B_Long  operator% (const B_Lng,       const B_Single&);
  friend DLL_DECL  B_Long  operator% (const B_Single&,   const B_Lng);
  friend DLL_DECL  B_Long  operator% (const B_Int,       const B_Single&);
  friend DLL_DECL  B_Long  operator% (const B_Single&,   const B_Int);

  friend DLL_DECL  B_Long B_Div(const B_Single&,  const B_Single&);
  friend DLL_DECL  B_Long B_Div(const B_Long&,    const B_Single&);
  friend DLL_DECL  B_Long B_Div(const B_Single&,  const B_Long&);
  friend DLL_DECL  B_Long B_Div(const B_Integer&, const B_Single&);
  friend DLL_DECL  B_Long B_Div(const B_Single&,  const B_Integer&);
  friend DLL_DECL  B_Long B_Div(const B_Byte&,    const B_Single&);
  friend DLL_DECL  B_Long B_Div(const B_Single&,  const B_Byte&);
  friend DLL_DECL  B_Long B_Div(const B_Boolean&, const B_Single&);
  friend DLL_DECL  B_Long B_Div(const B_Single&,  const B_Boolean&);
  friend DLL_DECL  B_Long B_Div(const B_Empty&,   const B_Single&);
  friend DLL_DECL  B_Long B_Div(const B_Single&,  const B_Empty&);
  friend DLL_DECL  B_Long B_Div(const B_Single&,  const B_Flt);
  friend DLL_DECL  B_Long B_Div(const B_Flt,      const B_Single&);
  friend DLL_DECL  B_Long B_Div(const B_Lng,      const B_Single&);
  friend DLL_DECL  B_Long B_Div(const B_Single&,  const B_Lng);
  friend DLL_DECL  B_Long B_Div(const B_Int,      const B_Single&);
  friend DLL_DECL  B_Long B_Div(const B_Single&,  const B_Int);

  friend DLL_DECL  B_Single B_Pow(const B_Single&,   const B_Boolean&);
  friend DLL_DECL  B_Single B_Pow(const B_Boolean&,  const B_Single&); 

  friend DLL_DECL  B_Long operator&& (const B_Single&,   const B_Single&);
  friend DLL_DECL  B_Long operator&& (const B_Long&,     const B_Single&);
  friend DLL_DECL  B_Long operator&& (const B_Single&,   const B_Long&);
  friend DLL_DECL  B_Long operator&& (const B_Integer&,  const B_Single&);
  friend DLL_DECL  B_Long operator&& (const B_Single&,   const B_Integer&);
  friend DLL_DECL  B_Long operator&& (const B_Byte&,     const B_Single&);
  friend DLL_DECL  B_Long operator&& (const B_Single&,   const B_Byte&);
  friend DLL_DECL  B_Long operator&& (const B_Empty&,    const B_Single&);   
  friend DLL_DECL  B_Long operator&& (const B_Single&,   const B_Empty&);    
  friend DLL_DECL  B_Long operator&& (const B_Boolean&,  const B_Single&);
  friend DLL_DECL  B_Long operator&& (const B_Single&,   const B_Boolean&);
  friend DLL_DECL  B_Null operator&& (const B_Null&,     const B_Single&);
  friend DLL_DECL  B_Null operator&& (const B_Single&,   const B_Null&);
  friend DLL_DECL  B_Long operator&& (const B_Single&,   const B_Flt);
  friend DLL_DECL  B_Long operator&& (const B_Flt,       const B_Single&);
  friend DLL_DECL  B_Long operator&& (const B_Lng,       const B_Single&);
  friend DLL_DECL  B_Long operator&& (const B_Single&,   const B_Lng);
  friend DLL_DECL  B_Long operator&& (const B_Int,       const B_Single&);
  friend DLL_DECL  B_Long operator&& (const B_Single&,   const B_Int);

  friend DLL_DECL  B_Long operator|| (const B_Single&,    const B_Single&);
  friend DLL_DECL  B_Long operator|| (const B_Long&,      const B_Single&);
  friend DLL_DECL  B_Long operator|| (const B_Single&,    const B_Long&);
  friend DLL_DECL  B_Long operator|| (const B_Integer&,   const B_Single&);
  friend DLL_DECL  B_Long operator|| (const B_Single&,    const B_Integer&);
  friend DLL_DECL  B_Long operator|| (const B_Byte&,      const B_Single&);
  friend DLL_DECL  B_Long operator|| (const B_Single&,    const B_Byte&);
  friend DLL_DECL  B_Long operator|| (const B_Empty&,     const B_Single&);  
  friend DLL_DECL  B_Long operator|| (const B_Single&,    const B_Empty&);   
  friend DLL_DECL  B_Long operator|| (const B_Boolean&,   const B_Single&);
  friend DLL_DECL  B_Long operator|| (const B_Single&,    const B_Boolean&);
  friend DLL_DECL  B_Long operator|| (const B_Null&,     const B_Single&);
  friend DLL_DECL  B_Long operator|| (const B_Single&,   const B_Null&);
  friend DLL_DECL  B_Long operator|| (const B_Single&,    const B_Flt);
  friend DLL_DECL  B_Long operator|| (const B_Flt,        const B_Single&);
  friend DLL_DECL  B_Long operator|| (const B_Lng,        const B_Single&);
  friend DLL_DECL  B_Long operator|| (const B_Single&,    const B_Lng);
  friend DLL_DECL  B_Long operator|| (const B_Int,        const B_Single&);
  friend DLL_DECL  B_Long operator|| (const B_Single&,    const B_Int);

  friend DLL_DECL  B_Long operator^ (const B_Single&,   const B_Single&);
  friend DLL_DECL  B_Long operator^ (const B_Long&,     const B_Single&);
  friend DLL_DECL  B_Long operator^ (const B_Single&,   const B_Long&);
  friend DLL_DECL  B_Long operator^ (const B_Integer&,  const B_Single&);
  friend DLL_DECL  B_Long operator^ (const B_Single&,   const B_Integer&);
  friend DLL_DECL  B_Long operator^ (const B_Byte&,     const B_Single&);
  friend DLL_DECL  B_Long operator^ (const B_Single&,   const B_Byte&);
  friend DLL_DECL  B_Long operator^ (const B_Empty&,    const B_Single&);
  friend DLL_DECL  B_Long operator^ (const B_Single&,   const B_Empty&);
  friend DLL_DECL  B_Long operator^ (const B_Boolean&,  const B_Single&);
  friend DLL_DECL  B_Long operator^ (const B_Single&,   const B_Boolean&);
  friend DLL_DECL  B_Null operator^ (const B_Null&,     const B_Single&);
  friend DLL_DECL  B_Null operator^ (const B_Single&,   const B_Null&);
  friend DLL_DECL  B_Long operator^ (const B_Single&,   const B_Flt); 
  friend DLL_DECL  B_Long operator^ (const B_Flt,       const B_Single&); 
  friend DLL_DECL  B_Long operator^ (const B_Lng,       const B_Single&);
  friend DLL_DECL  B_Long operator^ (const B_Single&,   const B_Lng);
  friend DLL_DECL  B_Long operator^ (const B_Int,       const B_Single&);
  friend DLL_DECL  B_Long operator^ (const B_Single&,   const B_Int);

  friend DLL_DECL  B_Boolean operator== (const B_Single&,   const B_Single&);
  friend DLL_DECL  B_Boolean operator== (const B_Long&,     const B_Single&);
  friend DLL_DECL  B_Boolean operator== (const B_Single&,   const B_Long&);
  friend DLL_DECL  B_Boolean operator== (const B_Integer&,  const B_Single&);
  friend DLL_DECL  B_Boolean operator== (const B_Single&,   const B_Integer&);
  friend DLL_DECL  B_Boolean operator== (const B_Byte&,     const B_Single&);
  friend DLL_DECL  B_Boolean operator== (const B_Single&,   const B_Byte&);
  friend DLL_DECL  B_Boolean operator== (const B_Empty&,    const B_Single&);
  friend DLL_DECL  B_Boolean operator== (const B_Single&,   const B_Empty&);  
  friend DLL_DECL  B_Boolean operator== (const B_Boolean&,  const B_Single&);
  friend DLL_DECL  B_Boolean operator== (const B_Single&,   const B_Boolean&);
  friend DLL_DECL  B_Boolean operator== (const B_Single&,   const B_Flt);
  friend DLL_DECL  B_Boolean operator== (const B_Flt,       const B_Single&);
  friend DLL_DECL  B_Boolean operator== (const B_Lng,       const B_Single&);
  friend DLL_DECL  B_Boolean operator== (const B_Single&,   const B_Lng);
  friend DLL_DECL  B_Boolean operator== (const B_Int,       const B_Single&);
  friend DLL_DECL  B_Boolean operator== (const B_Single&,   const B_Int);

  friend DLL_DECL  B_Boolean operator!= (const B_Single&,   const B_Single&);
  friend DLL_DECL  B_Boolean operator!= (const B_Long&,     const B_Single&);
  friend DLL_DECL  B_Boolean operator!= (const B_Single&,   const B_Long&);
  friend DLL_DECL  B_Boolean operator!= (const B_Integer&,  const B_Single&);
  friend DLL_DECL  B_Boolean operator!= (const B_Single&,   const B_Integer&);
  friend DLL_DECL  B_Boolean operator!= (const B_Byte&,     const B_Single&);
  friend DLL_DECL  B_Boolean operator!= (const B_Single&,   const B_Byte&);
  friend DLL_DECL  B_Boolean operator!= (const B_Empty&,    const B_Single&);
  friend DLL_DECL  B_Boolean operator!= (const B_Single&,   const B_Empty&);  
  friend DLL_DECL  B_Boolean operator!= (const B_Boolean&,  const B_Single&);
  friend DLL_DECL  B_Boolean operator!= (const B_Single&,   const B_Boolean&);
  friend DLL_DECL  B_Boolean operator!= (const B_Single&,   const B_Flt);
  friend DLL_DECL  B_Boolean operator!= (const B_Flt,       const B_Single&);
  friend DLL_DECL  B_Boolean operator!= (const B_Lng,       const B_Single&);
  friend DLL_DECL  B_Boolean operator!= (const B_Single&,   const B_Lng);
  friend DLL_DECL  B_Boolean operator!= (const B_Int,       const B_Single&);
  friend DLL_DECL  B_Boolean operator!= (const B_Single&,   const B_Int);

  friend DLL_DECL  B_Boolean operator< (const B_Single&,   const B_Single&);
  friend DLL_DECL  B_Boolean operator< (const B_Long&,     const B_Single&);
  friend DLL_DECL  B_Boolean operator< (const B_Single&,   const B_Long&);
  friend DLL_DECL  B_Boolean operator< (const B_Integer&,  const B_Single&);
  friend DLL_DECL  B_Boolean operator< (const B_Single&,   const B_Integer&);
  friend DLL_DECL  B_Boolean operator< (const B_Byte&,     const B_Single&);
  friend DLL_DECL  B_Boolean operator< (const B_Single&,   const B_Byte&);
  friend DLL_DECL  B_Boolean operator< (const B_Empty&,    const B_Single&);
  friend DLL_DECL  B_Boolean operator< (const B_Single&,   const B_Empty&);  
  friend DLL_DECL  B_Boolean operator< (const B_Boolean&,  const B_Single&);
  friend DLL_DECL  B_Boolean operator< (const B_Single&,   const B_Boolean&);
  friend DLL_DECL  B_Boolean operator< (const B_Single&,   const B_Flt);
  friend DLL_DECL  B_Boolean operator< (const B_Flt,       const B_Single&);
  friend DLL_DECL  B_Boolean operator< (const B_Lng,       const B_Single&);
  friend DLL_DECL  B_Boolean operator< (const B_Single&,   const B_Lng);
  friend DLL_DECL  B_Boolean operator< (const B_Int,       const B_Single&);
  friend DLL_DECL  B_Boolean operator< (const B_Single&,   const B_Int);

  friend DLL_DECL  B_Boolean operator<= (const B_Single&,   const B_Single&);
  friend DLL_DECL  B_Boolean operator<= (const B_Long&,     const B_Single&);
  friend DLL_DECL  B_Boolean operator<= (const B_Single&,   const B_Long&);
  friend DLL_DECL  B_Boolean operator<= (const B_Integer&,  const B_Single&);
  friend DLL_DECL  B_Boolean operator<= (const B_Single&,   const B_Integer&);
  friend DLL_DECL  B_Boolean operator<= (const B_Byte&,     const B_Single&);
  friend DLL_DECL  B_Boolean operator<= (const B_Single&,   const B_Byte&);
  friend DLL_DECL  B_Boolean operator<= (const B_Empty&,    const B_Single&);
  friend DLL_DECL  B_Boolean operator<= (const B_Single&,   const B_Empty&);  
  friend DLL_DECL  B_Boolean operator<= (const B_Boolean&,  const B_Single&);
  friend DLL_DECL  B_Boolean operator<= (const B_Single&,   const B_Boolean&);
  friend DLL_DECL  B_Boolean operator<= (const B_Single&,   const B_Flt);
  friend DLL_DECL  B_Boolean operator<= (const B_Flt,       const B_Single&);
  friend DLL_DECL  B_Boolean operator<= (const B_Lng,       const B_Single&);
  friend DLL_DECL  B_Boolean operator<= (const B_Single&,   const B_Lng);
  friend DLL_DECL  B_Boolean operator<= (const B_Int,       const B_Single&);
  friend DLL_DECL  B_Boolean operator<= (const B_Single&,   const B_Int);

  friend DLL_DECL  B_Boolean operator> (const B_Single&,   const B_Single&);
  friend DLL_DECL  B_Boolean operator> (const B_Long&,     const B_Single&);
  friend DLL_DECL  B_Boolean operator> (const B_Single&,   const B_Long&);
  friend DLL_DECL  B_Boolean operator> (const B_Integer&,  const B_Single&);
  friend DLL_DECL  B_Boolean operator> (const B_Single&,   const B_Integer&);
  friend DLL_DECL  B_Boolean operator> (const B_Byte&,     const B_Single&);
  friend DLL_DECL  B_Boolean operator> (const B_Single&,   const B_Byte&);
  friend DLL_DECL  B_Boolean operator> (const B_Empty&,    const B_Single&);
  friend DLL_DECL  B_Boolean operator> (const B_Single&,   const B_Empty&);  
  friend DLL_DECL  B_Boolean operator> (const B_Boolean&,  const B_Single&);
  friend DLL_DECL  B_Boolean operator> (const B_Single&,   const B_Boolean&);
  friend DLL_DECL  B_Boolean operator> (const B_Single&,   const B_Flt);
  friend DLL_DECL  B_Boolean operator> (const B_Flt,       const B_Single&);
  friend DLL_DECL  B_Boolean operator> (const B_Lng,       const B_Single&);
  friend DLL_DECL  B_Boolean operator> (const B_Single&,   const B_Lng);
  friend DLL_DECL  B_Boolean operator> (const B_Int,       const B_Single&);
  friend DLL_DECL  B_Boolean operator> (const B_Single&,   const B_Int);

  friend DLL_DECL  B_Boolean operator>= (const B_Single&,   const B_Single&);
  friend DLL_DECL  B_Boolean operator>= (const B_Long&,     const B_Single&);
  friend DLL_DECL  B_Boolean operator>= (const B_Single&,   const B_Long&);
  friend DLL_DECL  B_Boolean operator>= (const B_Integer&,  const B_Single&);
  friend DLL_DECL  B_Boolean operator>= (const B_Single&,   const B_Integer&);
  friend DLL_DECL  B_Boolean operator>= (const B_Byte&,     const B_Single&);
  friend DLL_DECL  B_Boolean operator>= (const B_Single&,   const B_Byte&);
  friend DLL_DECL  B_Boolean operator>= (const B_Empty&,    const B_Single&);
  friend DLL_DECL  B_Boolean operator>= (const B_Single&,   const B_Empty&);  
  friend DLL_DECL  B_Boolean operator>= (const B_Boolean&,  const B_Single&);
  friend DLL_DECL  B_Boolean operator>= (const B_Single&,   const B_Boolean&);
  friend DLL_DECL  B_Boolean operator>= (const B_Single&,   const B_Flt);
  friend DLL_DECL  B_Boolean operator>= (const B_Flt,       const B_Single&);
  friend DLL_DECL  B_Boolean operator>= (const B_Lng,       const B_Single&);
  friend DLL_DECL  B_Boolean operator>= (const B_Single&,   const B_Lng);
  friend DLL_DECL  B_Boolean operator>= (const B_Int,       const B_Single&);
  friend DLL_DECL  B_Boolean operator>= (const B_Single&,   const B_Int);

  //----------------------------------------------------------------------------------------------------       
  // Method: operator<<	INSERTION
  //     Schreiben der eigentlichen Objektdaten im Textformat in einen Stream
  // Return Value: 
  //	   Instanz der abgeleiten fstream-Klasse der Datei
  // Note: 
  //	   CT131296
  //	   ersetzt die alte Methode streamp()
  //
  friend DLL_DECL B_fstream& operator<< (B_fstream& ostr, B_Single& rhs);

  //----------------------------------------------------------------------------------------------------       
  // Method: operator>>	EXTRACTION
  //     Lesen der eigentlichen Objektdaten im Textformat aus einem Stream
  // Return Value: 
  //	   Instanz der abgeleiten fstream-Klasse der Datei
  // Note: 
  //	   CT131296
  //	   ersetzt die alte Methode streamg()
  //
  friend DLL_DECL B_fstream& operator>> (B_fstream& istr, B_Single& rhs);

  }; // B_Single


DLL_DECL extern const B_Single B_SingleMin;
DLL_DECL extern const B_Single B_SingleMax;
DLL_DECL extern const B_UChar  B_SingleDigits;
DLL_DECL extern const B_Single B_SingleEpsilon;


//----------------------------------Arithmetische Operatoren -----------------------------------------

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Der +Operator = Addition
DLL_DECL B_Single operator+ (const B_Single&,  const B_Single&)  throw(B_Overflow);
DLL_DECL B_Single operator+ (const B_Integer&, const B_Single&)  throw(B_Overflow);
DLL_DECL B_Single operator+ (const B_Single&,  const B_Integer&) throw(B_Overflow);
DLL_DECL B_Single operator+ (const B_Byte&,    const B_Single&)  throw(B_Overflow);
DLL_DECL B_Single operator+ (const B_Single&,  const B_Byte&)    throw(B_Overflow);
DLL_DECL B_Single operator+ (const B_Boolean&, const B_Single&)  throw(B_Overflow);
DLL_DECL B_Single operator+ (const B_Single&,  const B_Boolean&) throw(B_Overflow);
DLL_DECL B_Single operator+ (const B_Empty&,   const B_Single&);
DLL_DECL B_Single operator+ (const B_Single&,  const B_Empty&);
DLL_DECL B_Null   operator+ (const B_Null&,    const B_Single&);
DLL_DECL B_Null   operator+ (const B_Single&,  const B_Null&);
//-- Bibliotheksdatentypen
DLL_DECL B_Single operator+ (const B_Flt,      const B_Empty&);
DLL_DECL B_Single operator+ (const B_Empty&,   const B_Flt);
DLL_DECL B_Single operator+ (const B_Single&,  const B_Flt)       throw(B_Overflow);
DLL_DECL B_Single operator+ (const B_Flt,      const B_Single&)   throw(B_Overflow);
DLL_DECL B_Single operator+ (const B_Integer&, const B_Flt)       throw(B_Overflow);
DLL_DECL B_Single operator+ (const B_Flt,      const B_Integer&)  throw(B_Overflow);
DLL_DECL B_Single operator+ (const B_Int,      const B_Single&)   throw(B_Overflow);
DLL_DECL B_Single operator+ (const B_Single&,  const B_Int)       throw(B_Overflow);
DLL_DECL B_Single operator+ (const B_Byte&,    const B_Flt)       throw(B_Overflow);
DLL_DECL B_Single operator+ (const B_Flt,      const B_Byte&)     throw(B_Overflow);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Der -Operator = Subtraktion
DLL_DECL B_Single  operator- (const B_Single&,  const B_Single&)  throw(B_Overflow);
DLL_DECL B_Single  operator- (const B_Integer&, const B_Single&)  throw(B_Overflow);
DLL_DECL B_Single  operator- (const B_Single&,  const B_Integer&) throw(B_Overflow);
DLL_DECL B_Single  operator- (const B_Byte&,    const B_Single&)  throw(B_Overflow);
DLL_DECL B_Single  operator- (const B_Single&,  const B_Byte&)    throw(B_Overflow);
DLL_DECL B_Single  operator- (const B_Boolean&, const B_Single&)  throw(B_Overflow);
DLL_DECL B_Single  operator- (const B_Single&,  const B_Boolean&) throw(B_Overflow);
DLL_DECL B_Single  operator- (const B_Empty&,   const B_Single&);
DLL_DECL B_Single  operator- (const B_Single&,  const B_Empty&);
DLL_DECL B_Null    operator- (const B_Null&,    const B_Single&);
DLL_DECL B_Null    operator- (const B_Single&,  const B_Null&);
//-- Bibliotheksdatentypen
DLL_DECL B_Single  operator- (const B_Flt,      const B_Empty&);
DLL_DECL B_Single  operator- (const B_Empty&,   const B_Flt);
DLL_DECL B_Single  operator- (const B_Single&,  const B_Flt)       throw(B_Overflow);
DLL_DECL B_Single  operator- (const B_Flt,      const B_Single&)   throw(B_Overflow);
DLL_DECL B_Single  operator- (const B_Integer&, const B_Flt)       throw(B_Overflow);
DLL_DECL B_Single  operator- (const B_Flt,      const B_Integer&)  throw(B_Overflow);
DLL_DECL B_Single  operator- (const B_Int,      const B_Single&)   throw(B_Overflow);
DLL_DECL B_Single  operator- (const B_Single&,  const B_Int)       throw(B_Overflow);
DLL_DECL B_Single  operator- (const B_Byte&,    const B_Flt)       throw(B_Overflow);
DLL_DECL B_Single  operator- (const B_Flt,      const B_Byte&)     throw(B_Overflow);


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Der *Operator = Multiplikation   
DLL_DECL B_Single  operator* (const B_Single&,  const B_Single&)  throw(B_Overflow, B_Underflow);
DLL_DECL B_Single  operator* (const B_Integer&, const B_Single&)  throw(B_Overflow, B_Underflow);
DLL_DECL B_Single  operator* (const B_Single&,  const B_Integer&) throw(B_Overflow, B_Underflow);
DLL_DECL B_Single  operator* (const B_Byte&,    const B_Single&)  throw(B_Overflow, B_Underflow);
DLL_DECL B_Single  operator* (const B_Single&,  const B_Byte&)    throw(B_Overflow, B_Underflow);
DLL_DECL B_Single  operator* (const B_Single&,  const B_Boolean&);
DLL_DECL B_Single  operator* (const B_Boolean&, const B_Single&);
DLL_DECL B_Single  operator* (const B_Empty&,   const B_Single&);
DLL_DECL B_Single  operator* (const B_Single&,  const B_Empty&);
DLL_DECL B_Null    operator* (const B_Null&,    const B_Single&);
DLL_DECL B_Null    operator* (const B_Single&,  const B_Null&);
//-- Bibliotheksdatenypen
DLL_DECL B_Single  operator* (const B_Flt,      const B_Empty&);
DLL_DECL B_Single  operator* (const B_Empty&,   const B_Flt);
DLL_DECL B_Single  operator* (const B_Single&,  const B_Flt)      throw(B_Overflow, B_Underflow);
DLL_DECL B_Single  operator* (const B_Flt,      const B_Single&)  throw(B_Overflow, B_Underflow);
DLL_DECL B_Single  operator* (const B_Integer&, const B_Flt)      throw(B_Overflow, B_Underflow);
DLL_DECL B_Single  operator* (const B_Flt,      const B_Integer&) throw(B_Overflow, B_Underflow);
DLL_DECL B_Single  operator* (const B_Int,      const B_Single&)  throw(B_Overflow, B_Underflow);
DLL_DECL B_Single  operator* (const B_Single&,  const B_Int)      throw(B_Overflow, B_Underflow);
DLL_DECL B_Single  operator* (const B_Byte&,    const B_Flt)      throw(B_Overflow, B_Underflow);
DLL_DECL B_Single  operator* (const B_Flt,      const B_Byte&)    throw(B_Overflow, B_Underflow);


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Der /Operator = Division deren Ergebniss immer ein Fliesskommawert ergibt
//   Fehler wenn Bereich von Single ueberschritten wird
DLL_DECL B_Single  operator/ (const B_Single&,   const B_Single&)  throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Single  operator/ (const B_Long&,     const B_Single&)  throw(B_ZeroDivide, B_Underflow); 
DLL_DECL B_Single  operator/ (const B_Single&,   const B_Long&)    throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Single  operator/ (const B_Integer&,  const B_Single&)  throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Single  operator/ (const B_Single&,   const B_Integer&) throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Single  operator/ (const B_Byte&,     const B_Single&)  throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Single  operator/ (const B_Single&,   const B_Byte&)    throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Single  operator/ (const B_Boolean&,  const B_Single&)  throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Single&,   const B_Boolean&) throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Empty&,    const B_Single&)  throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Single&,   const B_Empty&)   throw(B_ZeroDivide);
DLL_DECL B_Null    operator/ (const B_Null&,     const B_Single&);
DLL_DECL B_Null    operator/ (const B_Single&,   const B_Null&);
//-- Bibliothekstypen
DLL_DECL B_Single  operator/ (const B_Long&,     const B_Long&)    throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Integer&,  const B_Integer&) throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Byte&,     const B_Byte&)    throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Empty&,    const B_Empty&)   throw(B_ZeroDivide);

DLL_DECL B_Single  operator/ (const B_Integer&,  const B_Boolean&) throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Boolean&,  const B_Integer&) throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Byte&,     const B_Boolean&) throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Boolean&,  const B_Byte&)    throw(B_ZeroDivide);

DLL_DECL B_Single  operator/ (const B_Byte&,     const B_Integer&) throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Integer&,  const B_Byte&)    throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Integer&,  const B_Long&)    throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Long&,     const B_Integer&) throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Byte&,     const B_Long&)    throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Long&,     const B_Byte&)    throw(B_ZeroDivide);

DLL_DECL B_Single  operator/ (const B_Empty&,    const B_Integer&) throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Integer&,  const B_Empty&)   throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Empty&,    const B_Byte&)    throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Byte&,     const B_Empty&)   throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Empty&,    const B_Boolean&) throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Boolean&,  const B_Empty&)   throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Boolean&,  const B_Boolean&) throw(B_ZeroDivide);

DLL_DECL B_Single  operator/ (const B_Empty&,    const B_Flt)      throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Empty&,    const B_Lng)      throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_UInt,      const B_Empty&)   throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Empty&,    const B_UInt)     throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Int,       const B_Empty&)   throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Empty&,    const B_Int)      throw(B_ZeroDivide);

DLL_DECL B_Single  operator/ (const B_Single&,   const B_Flt)      throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Single  operator/ (const B_Flt,       const B_Single&)  throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Single  operator/ (const B_Lng,       const B_Single&)  throw(B_ZeroDivide, B_Underflow); 
DLL_DECL B_Single  operator/ (const B_Single&,   const B_Lng)      throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Single  operator/ (const B_Int,       const B_Single&)  throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Single  operator/ (const B_Single&,   const B_Int)      throw(B_ZeroDivide, B_Underflow);

DLL_DECL B_Single  operator/ (const B_Long&,     const B_Flt)      throw(B_ZeroDivide, B_Underflow); 
DLL_DECL B_Single  operator/ (const B_Flt,       const B_Long&)    throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Single  operator/ (const B_Integer&,  const B_Flt)      throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Single  operator/ (const B_Flt,       const B_Integer&) throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Single  operator/ (const B_Byte&,     const B_Flt)      throw(B_ZeroDivide, B_Underflow);
DLL_DECL B_Single  operator/ (const B_Flt,       const B_Byte&)    throw(B_ZeroDivide, B_Underflow);

DLL_DECL B_Single  operator/ (const B_Long&,     const B_Lng)      throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Lng,       const B_Long&)    throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Integer&,  const B_Int)      throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Int,       const B_Integer&) throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Byte&,     const B_Int)      throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Int,       const B_Byte&)    throw(B_ZeroDivide);

DLL_DECL B_Single  operator/ (const B_Int,       const B_Long&)    throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Long&,     const B_Int)      throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Integer&,  const B_Lng)      throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Lng,       const B_Integer&) throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Byte&,     const B_Lng)      throw(B_ZeroDivide);
DLL_DECL B_Single  operator/ (const B_Lng,       const B_Byte&)    throw(B_ZeroDivide);


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Der %Operator = Modulo Operation, gibt den Wert einer ganzahligen Division zurueck
//   entsprich MOD-Operator in VB
//   Mit single und double typen arbeitet der Modulo-Operator solange korrekt wie der
//   Wertebereich des Single/Double Parameters den eines B_Long nicht ueberschreitet
//   Fliesskommawerte werden korrekt gerundet. d.h. <0.5 auf kleineren Wert und ab
//   >=0.5 wird aufgerundet auf die naechst groessere Ganzzahl
//   Ist ein Single/Float/Double Datentyp zu gross, dann wird in das Logfile eine Warnung mit
//   hoechster Prioritaetstufe 
DLL_DECL B_Long  operator% (const B_Single&,   const B_Single&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Long&,     const B_Single&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Single&,   const B_Long&)    throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Integer&,  const B_Single&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Single&,   const B_Integer&) throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Byte&,     const B_Single&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Single&,   const B_Byte&)    throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Boolean&,  const B_Single&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Single&,   const B_Boolean&) throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Empty&,    const B_Single&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Single&,   const B_Empty&)   throw(B_ZeroDivide);
DLL_DECL B_Null  operator% (const B_Null&,     const B_Single&);
DLL_DECL B_Null  operator% (const B_Single&,   const B_Null&);

DLL_DECL B_Long  operator% (const B_Single&,   const B_Flt)      throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Flt,       const B_Single&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Lng,       const B_Single&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Single&,   const B_Lng)      throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Int,       const B_Single&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long  operator% (const B_Single&,   const B_Int)      throw(B_Overflow, B_ZeroDivide);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Ganzahldivision entspricht dem \Operator in VB, da in C++ kein geeigneter Operator zu Verfuegung steht
//   wird dieser Operator als Funktion realisiert
//   Mit single und double typen arbeitet der Ganzahldivisor-Operator solange korrekt wie der
//   Wertebereich des Single/Double Parameters den eines B_Long nicht ueberschreitet
//   Fliesskommawerte werden korrekt gerundet. d.h. <0.5 auf kleineren Wert und ab
//   >=0.5 wird aufgerundet auf die naechst groessere Ganzzahl
//   Ist ein Single/Float/Double Datentyp zu gross, dann wird in das Logfile eine Warnung mit
//   hoechster Prioritaetstufe 
DLL_DECL B_Long B_Div(const B_Single&,  const B_Single&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Long&,    const B_Single&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Single&,  const B_Long&)    throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Integer&, const B_Single&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Single&,  const B_Integer&) throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Byte&,    const B_Single&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Single&,  const B_Byte&)    throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Empty&,   const B_Single&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Single&,  const B_Empty&)   throw(B_ZeroDivide);
DLL_DECL B_Null B_Div(const B_Null&,    const B_Single&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Null B_Div(const B_Single&,  const B_Null&);

DLL_DECL B_Long B_Div(const B_Single&,  const B_Flt)      throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Flt,      const B_Single&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Lng,      const B_Single&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Single&,  const B_Lng)      throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Int,      const B_Single&)  throw(B_Overflow, B_ZeroDivide);
DLL_DECL B_Long B_Div(const B_Single&,  const B_Int)      throw(B_Overflow, B_ZeroDivide);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Dient zum Potenzieren einer Zahl mit einem Exponenten
//   Erg = Zahl^Exponent  -> Erg = Pow(zahl, exponent)
//   Das Argument Zahl darf nur negativ sein, wenn Exponent ein ganzzahliger Wert ist. Werden in einem einzigen 
//   Ausdruck mehrere Potenzierungen ausgefhrt, so wird der Operator ^ jeweils in der Reihenfolge seines 
//   Auftretens von links nach rechts ausgewertet.
//   Ergebnis hat den Datentyp Double  Ist jedoch entweder Zahl oder Exponent ein Ausdruck mit dem Wert Null, 
//   so ist das Ergebnis ebenfalls Null.
//   Ist zahl ein Floatwert so wird er gerundet <0.5 kleinerer Wert >=0.5 naechst groessere Zahl
//   Negative zahl-Werte koennen verstaendlicherweise nicht verwandt werden wenn der Exponent auch eine
//   Floatwert hat da das Ergebnis sonst eine Komplexe Zahl waere.
//   ACHTUNG: Jedoch kann VB nicht einen Floatwert als zahl und exponent verarbeiten sondern konvertiert
//            einen Floatwert als zahl immer in einen Ganzahlwert
DLL_DECL B_Single B_Pow(const B_Boolean&, const B_Boolean&);
DLL_DECL B_Single B_Pow(const B_Single&,   const B_Boolean&);
DLL_DECL B_Single B_Pow(const B_Boolean&,  const B_Single&);   // hier nicht double-Rueckgabe wie unten
// Gengenstuecke bei Double
DLL_DECL B_Single B_Pow(const B_Integer&,  const B_Boolean&);
DLL_DECL B_Single B_Pow(const B_Byte&,     const B_Boolean&);
DLL_DECL B_Null   B_Pow(const B_Null&,     const B_Single&);
DLL_DECL B_Null   B_Pow(const B_Single&,   const B_Null&);

//----------------------------------------------------------------------------------------------------
//---------------------------------- Logische Operatoren ---------------------------------------------
//--- Logische Operatoren haben als Ruekgabewert immer den Datentyp B_Long
//    Fliesskommawerte werden ab (<0.5) bzw. aufgerundet (>=0.5) und dann als entsprechender
//    Ganzahlwert normal Bitweise verarbeitet
//    Solange der Wertebereich von B_Long nicht durch die Fliesskommawerte ueberschritten wird
//    arbeiten die Funktionen korrekt.
//    Wird durch einen Flieskommawert der Wertebereich des Long uebershritten wird dies in der 
//    Logdatei protokolliert

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Der &&Operator entspricht AND in VB , 
//   Bit in Ausdruck1 	Bit in Ausdruck2 	Ergebnis 
//       0	                  0            	0
//       0	                  1           	0
//       1                  	0           	0
//       1                   	1            	1
//   ACHTUNG alle C/C++ Programmierer: in VB werden numerische Typen immer logisch bitweise und verknpft
//                                     Der Einsatz von & war nicht moeglich da stellenweise erst zur Lauf-
//                                     zeit das Verhalten bestimmt werden kann was der Konverter nicht 
//                                     bestimmen kann
DLL_DECL B_Long operator&& (const B_Single&,   const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Long&,     const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Single&,   const B_Long&)    throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Integer&,  const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Single&,   const B_Integer&) throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Byte&,     const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Single&,   const B_Byte&)    throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Empty&,    const B_Single&)  throw(B_Overflow);   
DLL_DECL B_Long operator&& (const B_Single&,   const B_Empty&)   throw(B_Overflow);    
DLL_DECL B_Long operator&& (const B_Boolean&,  const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Single&,   const B_Boolean&) throw(B_Overflow);
DLL_DECL B_Null operator&& (const B_Null&,     const B_Single&)  throw(B_Overflow);
DLL_DECL B_Null operator&& (const B_Single&,   const B_Null&)    throw(B_Overflow);

DLL_DECL B_Long operator&& (const B_Single&,   const B_Flt)      throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Flt,       const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Lng,       const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Single&,   const B_Lng)      throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Int,       const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator&& (const B_Single&,   const B_Int)      throw(B_Overflow);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Der ||Operator entspricht OR in VB , 
//   Bit in Ausdruck1 	Bit in Ausdruck2 	Ergebnis 
//       0	                  0            	0
//       0	                  1           	1
//       1                  	0           	1
//       1                   	1            	1
//   ACHTUNG alle C/C++ Programmierer: in VB werden numerische Typen immer logisch bitweise und verknpft
//                                     Der Einsatz von | war nicht moeglich da stellenweise erst zur Lauf-
//                                     zeit das Verhalten bestimmt werden kann was der Konverter nicht 
//                                     bestimmen kann
DLL_DECL B_Long operator|| (const B_Single&,    const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Long&,      const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Single&,    const B_Long&)    throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Integer&,   const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Single&,    const B_Integer&) throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Byte&,      const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Single&,    const B_Byte&)    throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Empty&,     const B_Single&)  throw(B_Overflow);   
DLL_DECL B_Long operator|| (const B_Single&,    const B_Empty&)   throw(B_Overflow);   
DLL_DECL B_Long operator|| (const B_Boolean&,   const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Single&,    const B_Boolean&) throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Null&,      const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Single&,    const B_Null&)    throw(B_Overflow);

DLL_DECL B_Long operator|| (const B_Single&,    const B_Flt)      throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Flt,        const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Lng,        const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Single&,    const B_Lng)      throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Int,        const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator|| (const B_Single&,    const B_Int)      throw(B_Overflow);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Der ^Operator entspricht XOR in VB 
//   Bit in Ausdruck1 	Bit in Ausdruck2 	Ergebnis 
//       0	                  0            	0
//       0	                  1           	1
//       1                  	0           	1
//       1                   	1            	0
//   ACHTUNG alle VB Programmierer:    In C++ bedeutet der ^Operator ein bitweises XOR auf numerische
//                                     Operanden und nicht wie in VB eine Potenzierung. Der ^Operator
//                                     wurde nicht zur Potenzierung verwandt da dies nicht C++ Stil
//                                     entspricht.
//   ACHTUNG alle C/C++ Programmierer: In VB werden numerische Typen immer logisch bitweise und verknpft
//                                     Dies hat fuer ^Operator die Folge, dass er bei nicht numerischen
//                                     Ausdreucken sich wie ein logisches XOR verhaelt
DLL_DECL B_Long operator^ (const B_Single&,   const B_Single&)  throw(B_Overflow); 
DLL_DECL B_Long operator^ (const B_Long&,     const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Single&,   const B_Long&)    throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Integer&,  const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Single&,   const B_Integer&) throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Byte&,     const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Single&,   const B_Byte&)    throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Empty&,    const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Single&,   const B_Empty&)   throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Boolean&,  const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Single&,   const B_Boolean&) throw(B_Overflow);
DLL_DECL B_Null operator^ (const B_Null&,     const B_Single&)  throw(B_Overflow);
DLL_DECL B_Null operator^ (const B_Single&,   const B_Null&)    throw(B_Overflow);

DLL_DECL B_Long operator^ (const B_Single&,   const B_Flt)      throw(B_Overflow); 
DLL_DECL B_Long operator^ (const B_Flt,       const B_Single&)  throw(B_Overflow); 
DLL_DECL B_Long operator^ (const B_Lng,       const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Single&,   const B_Lng)      throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Int,       const B_Single&)  throw(B_Overflow);
DLL_DECL B_Long operator^ (const B_Single&,   const B_Int)      throw(B_Overflow);

//-- Der !Operator entspricht NOT in VB 
//   Bit in Ausdruck1 	 Ergebnis
//       0	                 1
//       1                   0
//   ACHTUNG alle C/C++ Programmierer: In VB werden numerische Typen immer logisch bitweise und verknpft
//                                     Dies hat fuer !Operator die Folge, dass er bei nicht numerischen
//                                     Ausdreucken sich wie ein logisches NOT verhaelt
// fuer den Fall, dass B_Emtpy uebergeben wird ist fuer alle Datentypen die Funktion 
// B_Single operator! (const B_Empty) in bc_int.hpp verantwortlich
// Die Variante B_Null operator!( const B_Null&) ist in B_Byte-Klasse abgehandelt
// B_Long operator! (const B_Single&);



// Die Operatoren Imp (=logische Implikation) und Eqv (=logische quivalenz) werden vom Konverter
// in folgende Basisoperatorkonstrukte umgesetzt, da in C++ keine quivalenten Operatoren zur Verfgung
// stehen.
// a Imp b    ->  (!a || b)
// a Eqv b    ->  !(a ^ b)


//----------------------------------------------------------------------------------------------------
//---------------------------------- Vergleichs Operatoren -------------------------------------------

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Verlgeich auf Gleichheit der Operanden, es findet ein numerischer Vergleich statt
// Ausdruck1 == Ausdruck2 -> B_True
// Ausdruck1 != Ausdruck2 -> B_False
// ACHTUNG alle VB Programmierer:  In C++ wird mit '==' auf Gleichheit abgefragt und nicht mit '='
//                                 Der '=' Operator wird nur fuer Zuweisungen verwendet.
DLL_DECL B_Boolean operator== (const B_Single&,   const B_Single&);
DLL_DECL B_Boolean operator== (const B_Long&,     const B_Single&);
DLL_DECL B_Boolean operator== (const B_Single&,   const B_Long&);
DLL_DECL B_Boolean operator== (const B_Integer&,  const B_Single&);
DLL_DECL B_Boolean operator== (const B_Single&,   const B_Integer&);
DLL_DECL B_Boolean operator== (const B_Byte&,     const B_Single&);
DLL_DECL B_Boolean operator== (const B_Single&,   const B_Byte&);
DLL_DECL B_Boolean operator== (const B_Empty&,    const B_Single&);
DLL_DECL B_Boolean operator== (const B_Single&,   const B_Empty&);  
DLL_DECL B_Boolean operator== (const B_Boolean&,  const B_Single&);
DLL_DECL B_Boolean operator== (const B_Single&,   const B_Boolean&);
DLL_DECL B_Null    operator== (const B_Null&,     const B_Single&);
DLL_DECL B_Null    operator== (const B_Single&,   const B_Null&);

DLL_DECL B_Boolean operator== (const B_Single&,   const B_Flt);
DLL_DECL B_Boolean operator== (const B_Flt,       const B_Single&);
DLL_DECL B_Boolean operator== (const B_Lng,       const B_Single&);
DLL_DECL B_Boolean operator== (const B_Single&,   const B_Lng);
DLL_DECL B_Boolean operator== (const B_Long&,     const B_Flt);
DLL_DECL B_Boolean operator== (const B_Flt,       const B_Long&);
DLL_DECL B_Boolean operator== (const B_Integer&,  const B_Flt);
DLL_DECL B_Boolean operator== (const B_Flt,       const B_Integer&);
DLL_DECL B_Boolean operator== (const B_Int,       const B_Single&);
DLL_DECL B_Boolean operator== (const B_Single&,   const B_Int);
DLL_DECL B_Boolean operator== (const B_Byte&,     const B_Flt);
DLL_DECL B_Boolean operator== (const B_Flt,       const B_Byte&);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Verlgeich auf Ungleichheit der Operanden, es findet ein numerischer Vergleich statt
// Ausdruck1 != Ausdruck2 -> B_True
// Ausdruck1 == Ausdruck2 -> B_False
// ACHTUNG alle VB Programmierer:  In C++ wird mit '!=' auf Ungleichheit abgefragt und nicht mit '<>'
//                                 Der '<>' Operator existiert nicht in C++.
DLL_DECL B_Boolean operator!= (const B_Single&,   const B_Single&);
DLL_DECL B_Boolean operator!= (const B_Long&,     const B_Single&);
DLL_DECL B_Boolean operator!= (const B_Single&,   const B_Long&);
DLL_DECL B_Boolean operator!= (const B_Integer&,  const B_Single&);
DLL_DECL B_Boolean operator!= (const B_Single&,   const B_Integer&);
DLL_DECL B_Boolean operator!= (const B_Byte&,     const B_Single&);
DLL_DECL B_Boolean operator!= (const B_Single&,   const B_Byte&);
DLL_DECL B_Boolean operator!= (const B_Empty&,    const B_Single&);
DLL_DECL B_Boolean operator!= (const B_Single&,   const B_Empty&); 
DLL_DECL B_Boolean operator!= (const B_Boolean&,  const B_Single&);
DLL_DECL B_Boolean operator!= (const B_Single&,   const B_Boolean&);
DLL_DECL B_Null    operator!= (const B_Single&,   const B_Null&);
DLL_DECL B_Null    operator!= (const B_Null&,     const B_Single&);

DLL_DECL B_Boolean operator!= (const B_Single&,   const B_Flt);
DLL_DECL B_Boolean operator!= (const B_Flt,       const B_Single&);
DLL_DECL B_Boolean operator!= (const B_Lng,       const B_Single&);
DLL_DECL B_Boolean operator!= (const B_Single&,   const B_Lng);
DLL_DECL B_Boolean operator!= (const B_Long&,     const B_Flt);
DLL_DECL B_Boolean operator!= (const B_Flt,       const B_Long&);
DLL_DECL B_Boolean operator!= (const B_Integer&,  const B_Flt);
DLL_DECL B_Boolean operator!= (const B_Flt,       const B_Integer&);
DLL_DECL B_Boolean operator!= (const B_Int,       const B_Single&);
DLL_DECL B_Boolean operator!= (const B_Single&,   const B_Int);
DLL_DECL B_Boolean operator!= (const B_Byte&,     const B_Flt);
DLL_DECL B_Boolean operator!= (const B_Flt,       const B_Byte&);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Verlgeich auf Kleiner der Operanden, es findet ein numerischer Vergleich statt
// Ausdruck1 <  Ausdruck2 -> B_True
// Ausdruck1 >= Ausdruck2 -> B_False
DLL_DECL B_Boolean operator< (const B_Single&,   const B_Single&);
DLL_DECL B_Boolean operator< (const B_Long&,     const B_Single&);
DLL_DECL B_Boolean operator< (const B_Single&,   const B_Long&);
DLL_DECL B_Boolean operator< (const B_Integer&,  const B_Single&);
DLL_DECL B_Boolean operator< (const B_Single&,   const B_Integer&);
DLL_DECL B_Boolean operator< (const B_Byte&,     const B_Single&);
DLL_DECL B_Boolean operator< (const B_Single&,   const B_Byte&);
DLL_DECL B_Boolean operator< (const B_Empty&,    const B_Single&);
DLL_DECL B_Boolean operator< (const B_Single&,   const B_Empty&); 
DLL_DECL B_Boolean operator< (const B_Boolean&,  const B_Single&);
DLL_DECL B_Boolean operator< (const B_Single&,   const B_Boolean&);
DLL_DECL B_Null    operator< (const B_Null&,     const B_Single&);
DLL_DECL B_Null    operator< (const B_Single&,   const B_Null&);

DLL_DECL B_Boolean operator< (const B_Single&,   const B_Flt);
DLL_DECL B_Boolean operator< (const B_Flt,       const B_Single&);
DLL_DECL B_Boolean operator< (const B_Lng,       const B_Single&);
DLL_DECL B_Boolean operator< (const B_Single&,   const B_Lng);
DLL_DECL B_Boolean operator< (const B_Long&,     const B_Flt);
DLL_DECL B_Boolean operator< (const B_Flt,       const B_Long&);
DLL_DECL B_Boolean operator< (const B_Integer&,  const B_Flt);
DLL_DECL B_Boolean operator< (const B_Flt,       const B_Integer&);
DLL_DECL B_Boolean operator< (const B_Int,       const B_Single&);
DLL_DECL B_Boolean operator< (const B_Single&,   const B_Int);
DLL_DECL B_Boolean operator< (const B_Byte&,     const B_Flt);
DLL_DECL B_Boolean operator< (const B_Flt,       const B_Byte&);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Verlgeich auf Kleiner/Gleich der Operanden, es findet ein numerischer Vergleich statt
// Ausdruck1 <=  Ausdruck2 -> B_True
// Ausdruck1 >   Ausdruck2 -> B_False
DLL_DECL B_Boolean operator<= (const B_Single&,   const B_Single&);
DLL_DECL B_Boolean operator<= (const B_Long&,     const B_Single&);
DLL_DECL B_Boolean operator<= (const B_Single&,   const B_Long&);
DLL_DECL B_Boolean operator<= (const B_Integer&,  const B_Single&);
DLL_DECL B_Boolean operator<= (const B_Single&,   const B_Integer&);
DLL_DECL B_Boolean operator<= (const B_Byte&,     const B_Single&);
DLL_DECL B_Boolean operator<= (const B_Single&,   const B_Byte&);
DLL_DECL B_Boolean operator<= (const B_Empty&,    const B_Single&);
DLL_DECL B_Boolean operator<= (const B_Single&,   const B_Empty&);
DLL_DECL B_Boolean operator<= (const B_Boolean&,  const B_Single&);
DLL_DECL B_Boolean operator<= (const B_Single&,   const B_Boolean&);
DLL_DECL B_Null    operator<= (const B_Null&,     const B_Single&);
DLL_DECL B_Null    operator<= (const B_Single&,   const B_Null&);

DLL_DECL B_Boolean operator<= (const B_Single&,   const B_Flt);
DLL_DECL B_Boolean operator<= (const B_Flt,       const B_Single&);
DLL_DECL B_Boolean operator<= (const B_Lng,       const B_Single&);
DLL_DECL B_Boolean operator<= (const B_Single&,   const B_Lng);
DLL_DECL B_Boolean operator<= (const B_Long&,     const B_Flt);
DLL_DECL B_Boolean operator<= (const B_Flt,       const B_Long&);
DLL_DECL B_Boolean operator<= (const B_Integer&,  const B_Flt);
DLL_DECL B_Boolean operator<= (const B_Flt,       const B_Integer&);
DLL_DECL B_Boolean operator<= (const B_Int,       const B_Single&);
DLL_DECL B_Boolean operator<= (const B_Single&,   const B_Int);
DLL_DECL B_Boolean operator<= (const B_Byte&,     const B_Flt);
DLL_DECL B_Boolean operator<= (const B_Flt,       const B_Byte&);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Verlgeich auf Groesser der Operanden, es findet ein numerischer Vergleich statt
// Ausdruck1 >   Ausdruck2 -> B_True
// Ausdruck1 <=  Ausdruck2 -> B_False
DLL_DECL B_Boolean operator> (const B_Single&,   const B_Single&);
DLL_DECL B_Boolean operator> (const B_Long&,     const B_Single&);
DLL_DECL B_Boolean operator> (const B_Single&,   const B_Long&);
DLL_DECL B_Boolean operator> (const B_Integer&,  const B_Single&);
DLL_DECL B_Boolean operator> (const B_Single&,   const B_Integer&);
DLL_DECL B_Boolean operator> (const B_Byte&,     const B_Single&);
DLL_DECL B_Boolean operator> (const B_Single&,   const B_Byte&);
DLL_DECL B_Boolean operator> (const B_Empty&,    const B_Single&);  
DLL_DECL B_Boolean operator> (const B_Single&,   const B_Empty&);   
DLL_DECL B_Boolean operator> (const B_Boolean&,  const B_Single&);
DLL_DECL B_Boolean operator> (const B_Single&,   const B_Boolean&);
DLL_DECL B_Null    operator> (const B_Null&,     const B_Single&);
DLL_DECL B_Null    operator> (const B_Single&,   const B_Null&);

DLL_DECL B_Boolean operator> (const B_Single&,   const B_Flt);
DLL_DECL B_Boolean operator> (const B_Flt,       const B_Single&);
DLL_DECL B_Boolean operator> (const B_Lng,       const B_Single&);
DLL_DECL B_Boolean operator> (const B_Single&,   const B_Lng);
DLL_DECL B_Boolean operator> (const B_Long&,     const B_Flt);
DLL_DECL B_Boolean operator> (const B_Flt,       const B_Long&);
DLL_DECL B_Boolean operator> (const B_Integer&,  const B_Flt);
DLL_DECL B_Boolean operator> (const B_Flt,       const B_Integer&);
DLL_DECL B_Boolean operator> (const B_Int,       const B_Single&);
DLL_DECL B_Boolean operator> (const B_Single&,   const B_Int);
DLL_DECL B_Boolean operator> (const B_Byte&,     const B_Flt);
DLL_DECL B_Boolean operator> (const B_Flt,       const B_Byte&);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Verlgeich auf Groesser/Gleich der Operanden, es findet ein numerischer Vergleich statt
// Ausdruck1 >=  Ausdruck2 -> B_True
// Ausdruck1 <   Ausdruck2 -> B_False
DLL_DECL B_Boolean operator>= (const B_Single&,   const B_Single&);
DLL_DECL B_Boolean operator>= (const B_Long&,     const B_Single&);
DLL_DECL B_Boolean operator>= (const B_Single&,   const B_Long&);
DLL_DECL B_Boolean operator>= (const B_Integer&,  const B_Single&);
DLL_DECL B_Boolean operator>= (const B_Single&,   const B_Integer&);
DLL_DECL B_Boolean operator>= (const B_Byte&,     const B_Single&);
DLL_DECL B_Boolean operator>= (const B_Single&,   const B_Byte&);
DLL_DECL B_Boolean operator>= (const B_Empty&,    const B_Single&);  
DLL_DECL B_Boolean operator>= (const B_Single&,   const B_Empty&);   
DLL_DECL B_Boolean operator>= (const B_Boolean&,  const B_Single&);
DLL_DECL B_Boolean operator>= (const B_Single&,   const B_Boolean&);
DLL_DECL B_Null    operator>= (const B_Null&,     const B_Single&);
DLL_DECL B_Null    operator>= (const B_Single&,   const B_Null&);

DLL_DECL B_Boolean operator>= (const B_Single&,   const B_Flt);
DLL_DECL B_Boolean operator>= (const B_Flt,       const B_Single&);
DLL_DECL B_Boolean operator>= (const B_Lng,       const B_Single&);
DLL_DECL B_Boolean operator>= (const B_Single&,   const B_Lng);
DLL_DECL B_Boolean operator>= (const B_Long&,     const B_Flt);
DLL_DECL B_Boolean operator>= (const B_Flt,       const B_Long&);
DLL_DECL B_Boolean operator>= (const B_Integer&,  const B_Flt);
DLL_DECL B_Boolean operator>= (const B_Flt,       const B_Integer&);
DLL_DECL B_Boolean operator>= (const B_Int,       const B_Single&);
DLL_DECL B_Boolean operator>= (const B_Single&,   const B_Int);
DLL_DECL B_Boolean operator>= (const B_Byte&,     const B_Flt);
DLL_DECL B_Boolean operator>= (const B_Flt,       const B_Byte&);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Streamoperatoren
DLL_DECL ostream& operator<<(ostream& ostr, const B_Single& rhs);
DLL_DECL istream& operator>>(istream& istr, B_Single& rhs);


//================================ Inlinefunktionen =========================================================
//
#if defined _DEBUG || defined B_VB_CONTRACT
  #define B_NOINLINE
#else
  #undef B_NOINLINE
#endif

#ifndef B_NOINLINE                 // festlegen wenn Debuger keine Inlines debuggen kann
  #define B_INLINE inline
  #ifndef  BI_SNGLE_HPP
     #include "bi_sngle.hpp"
  #endif
#endif


//===========================================================================================================
//================================ End Of Header ============================================================
#endif // BC_SNGLE_HPP

#endif // B_VB_COMPATIBLE
