//ab.. 14.3.97 Quellenabgleich : angepasst
#ifndef BC_STR_HPP
#define BC_STR_HPP
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Project:                 VB nach C/C++ Konverter
// Modul:                   Klasse fuer VB String-Datentyp
// Filename:                bc_str.hpp
// Version:                 1.0
// Status:                  beta
//
// Copyright:               (C)
//                          Cicerosoft GmbH
//                          Ballweilerstr. 7
//                          66399 Erfweiler-Ehlingen
//
// Operating System(s):     Win95
// Compiler:                VC++ 4.1
//
// Author:                  Jochen Diener JD
// Creation Date:           JD 20.11.95
// Last Modification:       JD 22.07.96
//
// Description:             Beinhaltet die Implementierung aller Klassen und Hilfsfunktionen die fuer die
//                          Beretistellung des String-Datentyps benoetigt werden
//
// Dependencies:            bc_str.cpp   -> Klassendefinition
//                          bi_str.hpp   -> Inline Fkt. der Klasse
//
// Remarks:
// ..CT061296	Fuer neuen Weg der FileIO mu man direkt auf den Speicher zugreifen koennen
//
// Revision(s):
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

//================================= Defintionsabhaengigkeiten ===============================================
//
#include <iostream.h>
#include <stddef.h>               // wegen size_t

#ifndef BD_INTYP_HPP       
  #include "bd_intyp.hpp"       // alias der Standardatentypen
#endif

#ifndef BC_BOOL_HPP
  #include "bc_bool.hpp"
#endif
#ifndef BC_NULL_HPP
  #include "bc_null.hpp"
#endif
#ifndef BC_EMPTY_HPP
  #include "bc_empty.hpp"
#endif
#ifndef BC_BYTE_HPP
  #include "bc_byte.hpp"
#endif
#ifndef BC_INT_HPP
  #include "bc_int.hpp"  
#endif
#ifndef BC_LONG_HPP
  #include "bc_long.hpp"
#endif
#ifndef BC_SNGLE_HPP
  #include "bc_sngle.hpp"
#endif
#ifndef BC_DBL_HPP
  #include "bc_dbl.hpp"   
#endif
#ifndef BC_CURR_HPP
  #include "bc_curr.hpp"
#endif


//================================= Export =================================================================
//

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Description:                                                                           (C) CiceroSoft 1995
//     B_TStringStruct		Hilfsklasse fuer vereinfachten operator+= fuer alle
//							B_TString<> egal welcher Groesse
// Hierachy:    
// Inheritance: 
// Errorhandling:
// Note: 
class DLL_DECL B_TStringStruct
  {

  //==================== MANGAEMENT =========================================================================
  //

  public:
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     ctor
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:     
    B_TStringStruct()						{groesse = 0L; value = NULL;}; 
	B_TStringStruct(B_Lng gr, B_CStr str)	{groesse = gr; value = str;}; 

	//---------------------------------------------------------------------------------------------------------       
    // Method:
    //     ctor
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:     
	~B_TStringStruct()	{groesse = 0L; value = NULL;};

	//---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Copy fuer neue Werte
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:
	void set(const B_String&);
	void set(const B_CStr&);

  //==================== MEMBER ===============================================================================    
  //
  public:
	  B_Lng		groesse;				// Laenge des TYPE-FIX-STRING B_TString
	  B_CStr	value;					// Zeiger auf den Stringinnhalt
  }; // B_TStringStruct


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Description:                                                                           (C) CiceroSoft 1995
//     B_String    Emuliert VB-Datentyp String
// Hierachy:    
// Inheritance: 
// Errorhandling:
// Note: 
//     Normalerweise koennen left, right, midSubStr durch eine Funktion Substr implementiert werden. Dies
//     kommt dem Bestreben einer minimalen und vollstaendigen Schnittstelle am naechsten.
//     Damit der Konverter, die Basic-Programmierer und die Bibliothek besser auf spezifika der einzelenen
//     Funktionen eingehen kann und ein differenzierteres Fehlerhandlng moeglich wird wurde hier mit der
//     Regel bewusst gebrochen.
//     Aus dem selben Grunde wurde auch asc() aufgenommen obwohl es durch toAnsi/toAscii und Deskriptions-
//     operator nachbildbar ist
//     Auch trim == *this.lTrim().rTrim(); ist eigentlich herrlich unnoetig und nur fuer den Konverter da
class DLL_DECL B_String
  {
  public:
  //-- Proxy
    struct B_FixString
      {};

  //==================== MANGAEMENT =========================================================================
  //
  public:
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     ctor
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //     Der Konstruktor zur Konstruktion von Strings fixer Laenge hat einen zweiten Parameter B_TypeSafe
		//     der erforderlich ist um mehrdeutigkeiten mit dem Konstruktor fr B_Long-variablen zu ermoeglichen.
		//     z.B.  B_String str1(8, B_FixString)  entspricht in VB   Dim str1 As String * 8
    B_String(); 
#ifdef B_VB_COMPATIBLE		
    B_String(const B_Long&, const struct B_FixString&);
    B_String(      B_Char,  const B_Long&);
#endif
    B_String(const B_Lng,   const struct B_FixString&);
    B_String(      B_cCStr, const B_Explicit&); //  throw(B_InvalidArgument); 
    B_String(      B_Char,  B_Lng);

#ifdef THALESPLUS						// Konstruktor fuer Copy eines B_TString
	B_String(const B_TStringStruct&);
#endif	// THALESPLUS

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     ctor's fuer Bibliotheksdatentypen
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
#ifdef B_VB_COMPATIBLE
    B_String(const B_Byte&);
    B_String(const B_Integer&);
    B_String(const B_Long&);
    B_String(const B_Single&);
    B_String(const B_Double&);
#endif // B_VB_COMPATIBLE
    B_String(const B_Currency&);
    B_String(const B_Boolean&);
    B_String(const B_Empty&);
    B_String(const B_Null&); // throw B_InvalidNull
    //B_String(const B_Date&);
    B_String(const B_Dbl, const B_Explicit&);
    B_String(const B_Flt, const B_Explicit&);
    B_String(const B_Lng, const B_Explicit&);
    B_String(const B_Int, const B_Explicit&);

    //----------------------------------------------------------------------------------------------------   
    // Method: 
    //     ctor's fuer OLE
    // Parameter:
    // Return Value:
    // Errorhandling:
    // Note:   
    //
    B_String(const VARIANT FAR& rhs); // noetig fuer 32bit OLE
    B_String(const BSTR rhs); // fuer 16bit OLE, evtl. fuer DAO

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     cctor
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_String(const B_String&);
    
    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     dtor
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    ~B_String(); 

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Zuweisungsop.
    // Parameter:  
    // Return Value:
    // Errorhandling:
    // Note:      
    //
    B_String& operator=(const B_String&);

  //==================== INTERFACE ============================================================================
  //
  public:
    //----------------------------------------------------------------------------------------------------   
    // Method: 
    //     operator=() C-Standardatentypen
    // Parameter:
    // Return Value:
    // Errorhandling:
    // Note:   
    //
    B_String& operator=(B_cCStr) throw(B_InvalidArgument);
    B_String& operator=(const B_Char); // ein Zeichen

    //----------------------------------------------------------------------------------------------------   
    // Method: 
    //     operator=() fuer Bibliotheksdatentypen
    // Parameter:
    // Return Value:
    // Errorhandling:
    // Note:   
    //
    B_String& operator=(const B_Empty&);
    B_String& operator=(const B_Null&)     throw(B_InvalidNull);
    B_String& operator=(const B_Boolean&);
    //B_String& operator=(const B_Date&);
#ifdef B_VB_COMPATIBLE    
    B_String& operator=(const B_Byte&);
    B_String& operator=(const B_Integer&);
    B_String& operator=(const B_Long&);
    B_String& operator=(const B_Single&);
    B_String& operator=(const B_Double&);
#endif
    B_String& operator=(const B_Currency&);
    B_String& operator=(const B_Dbl);
    B_String& operator=(const B_Flt);
    B_String& operator=(const B_Lng);
    B_String& operator=(const B_Int);

#ifdef THALESPLUS	// Zuweisungen von B_TString an B_String
	B_String& operator=(const B_TStringStruct rhs);
#endif

	// CT061296 Ich weiss nicht wie ich die Template B_TString-Klasse hier zuweisen soll
	// template<int groesse> B_String& operator=(const B_TString<groesse>&);
	// geht nicht und der operator = muss immer Bestandteil der Klasse sein!
	// --> friend operator= geht auch nicht.

    //----------------------------------------------------------------------------------------------------   
    // Method: 
    //     operator=() fuer OLE
    // Parameter:
    // Return Value:
    // Errorhandling:
    // Note:   
    //
    B_String& operator=(const VARIANT FAR& rhs); // noetig fuer 32bit OLE
    B_String& operator=(const BSTR rhs); // fuer 16bit OLE, evtl. fuer DAO

    //----------------------------------------------------------------------------------------------------   
    // Method: 
    //     operator+=() Strinkonkatenation  Entspricht: str1 = str1 + str2;
    // Parameter:
    // Return Value:
    // Errorhandling:
    // Note:   
    //
    B_String& operator+=(const B_String&);
    B_String& operator+=(B_cCStr) throw(B_InvalidArgument);
    B_String& operator+=(const B_Char);
    B_String& operator+=(const VARIANT FAR& rhs); // noetig fuer 32bit OLE
    B_String& operator+=(const BSTR rhs); // fuer 16bit OLE, evtl. fuer DAO

#ifdef THALESPLUS
	B_String& operator+=(const B_TStringStruct&);
#endif	// THALESPLUS

    //----------------------------------------------------------------------------------------------------   
    // Method: 
    //     length    Gibt die Laenge des Strings in Zeichen zureuck.
    // Parameter:
    // Return Value:
    //     Laenge des Strings als Zahl, 
    // Errorhandling:
    // Note:   
    //     fuer VB benoetigt
#ifdef B_VB_COMPATIBLE
    B_Long len() const;
#else 
    B_Lng len() const;
#endif // B_VB_COMPATIBLE

    //----------------------------------------------------------------------------------------------------   
    // Method:
    //     Vergleicht B_String mit dem uebergebenen String mit . Die Art des Vergleiches kann ueber den 
    //     compareType Parameter festgelegt werden
    // Parameter:   
    //     string1: 
    //     jeder gueltige Zeichenfolgenausdruck
    //         compareType:
    //         0 = binaer -> der Zeichenfolgenvgl. basiert auf der Sortierreihenfolge, die 
    //                       durch die interne binaere Darstellung der Zeichen festgelegt ist.
    //                       Die Sortierreihenfolge wird durch die Code-Seite festgelegt.
    //                       (case sensitiv)
    //         1 = text   -> fuehrt zu einem Zeichenfolgenvgl. bei denen die im Gebietsschema
    //                       des Systems festgelegte Sortierreihenfolge fuer Zeichen verwendet
    //                       wird (ohne Unterschiede in der Gro- oder Kleinschreibung zu 
    //                       beruecksichtigen). 
    //         wird compareType nicht explizit angegeben wird die aktuelle Einstellung
    //         von Option Compare genommen (Standardeinstellung 0)
    //                              
    // Return Value:
    //     -1        *this (<) liegt im  Alphabet vor string2
    //      0        *this (=) entspricht string2
    //      1        *this (>) liegt im Alphabet hinter string2
    // Note:  
    //     fuer VB direkt benoetigt. vgl. B_strComp
#ifdef B_VB_COMPATIBLE
    B_Integer compare(const B_String&, const B_Long& compare = B_OPTION_COMPARE) const throw(B_InvalidArgument);
    B_Integer compare(B_cCStr, const B_Long& compare = B_OPTION_COMPARE) const throw(B_InvalidArgument);

    B_Integer compare(const B_String&, const B_Lng compare) const throw(B_InvalidArgument);
    B_Integer compare(B_cCStr, const B_Lng compare) const throw(B_InvalidArgument);
#else
    B_Int compare(const B_String&, const B_Lng compare = B_OPTION_COMPARE) const throw(B_InvalidArgument);
    B_Int compare(B_cCStr, const B_Lng compare = B_OPTION_COMPARE) const throw(B_InvalidArgument);
#endif
    
  
    //----------------------------------------------------------------------------------------------------   
    // Method: 
    //     Sucht die Zeichenkette=searchForString im Objekt
    // Parameter:   
    //     searchFor: 
    //         Die Zeichenkette die in searchInto-String(=Objekt) gesucht wird  
    //     startPos: 
    //         Legt das Zeichen in searchInto fest ab dem searchFor gesucht wird. Wird 
    //         startPos nicht festgelegt wird ab dem ersten Zeichen in searchInto mit der 
    //         Suche begonnen. 
    //     compareType: 
    //         legt fest wie gesucht wird 
    //         0 = textueller Vergleich
    //         1 = textueller Vergleich ohne beruecksichtigung der Gross/Kleinschreibung       
    // Return Value:
    //     Der Return Value gibt auskunft ueber das Ergebnis der Suche
    //         Objekt hat die Laenge Null         ->  0
    //         searchFor hat die Laenge Null      ->  start       
    //         searchFor ist nicht vorhanden      ->  0
    //         searchFor ist in Objekt enthalten  ->  Position, an der Uebereinstimmung beginnt
    //         startPos > Objekt                  ->  0
    //         searchFor ist Null                 ->  Null         1
    // Note: 
    //     benoetigt  fuer VB. vgl. B_inStr  
    //     INFO:
    //     Die inStr()-Methode mit compare == 0 verwendet einen der derzeit schnellsten Algorithmen 
    //     (Optimal Mismatch) der speziell fuer VB angepasst wurde. D.h. Sie koennne und sollten auch
    //     bei Suchen in Texten diese Methode verwenden. Hierbei kann der Text auch ruhig z.B. 200KB und
    //     groesser werden, da die Stringgroesse (bis 2GB) derzeit nur durch Ihren Hauptspeicher begrenzt
    //     ist. Die Suche wird um so effizienter im vgl. zu anderen Suchmethoden je laenger der Text
    //     (= das Objekt) und je laenger das Muster (= searchFor) sind.
    //     
#ifdef B_VB_COMPATIBLE    
    B_Long inStr(const B_String& searchFor, const B_Long& startPos = B_Long(1L, B_explicit), const B_Long& compare = B_OPTION_COMPARE) const throw(B_InvalidArgument);
    B_Long inStrB(const B_String& searchFor, const B_Long& startPos = B_Long(1L, B_explicit), const B_Long& compare = B_OPTION_COMPARE) const throw(B_InvalidArgument);

    B_Long inStr(const B_String& searchFor, const B_Lng startPos, const B_Lng compare = B_OPTION_COMPARE) const throw(B_InvalidArgument);
    B_Long inStrB(const B_String& searchFor, const B_Lng startPos , const B_Lng compare = B_OPTION_COMPARE) const throw(B_InvalidArgument);

    B_Long inStr(B_cCStr searchFor, const B_Long& startPos = B_Long(1L, B_explicit), const B_Long& compare = B_OPTION_COMPARE) const throw(B_InvalidArgument);
    B_Long inStrB(B_cCStr searchFor, const B_Long& startPos = B_Long(1L, B_explicit), const B_Long& compare = B_OPTION_COMPARE) const throw(B_InvalidArgument);

    B_Long inStr(B_cCStr searchFor, const B_Lng startPos, const B_Lng compare = B_OPTION_COMPARE) const throw(B_InvalidArgument);
    B_Long inStrB(B_cCStr searchFor, const B_Lng startPos , const B_Lng compare = B_OPTION_COMPARE) const throw(B_InvalidArgument);
#else
    B_Lng inStr(const B_String& searchFor, const B_Lng startPos = 1L, const B_Lng compare = B_OPTION_COMPARE) const throw(B_InvalidArgument);
    B_Lng inStrB(const B_String& searchFor, const B_Lng startPos = 1L, const B_Lng compare = B_OPTION_COMPARE) const throw(B_InvalidArgument);

    B_Lng inStr(B_cCStr searchFor, const B_Lng startPos = 1L, const B_Lng compare = B_OPTION_COMPARE) const throw(B_InvalidArgument);
    B_Lng inStrB(B_cCStr searchFor, const B_Lng startPos = 1L, const B_Lng compare = B_OPTION_COMPARE) const throw(B_InvalidArgument);
#endif

    //----------------------------------------------------------------------------------------------------   
    // Method: 
    //     Kopiert aus dem Objekt die Anzahl=nbrCharToCut Zeichen, von links beginnend, und 
    //     gibt den so erzeugten Teilstring als Return Value zurueck.
    // Parameter:  
    //     nbrCutCharacters:
    //        Numerischer Ausdruck, der die Anzahl der zurueckzugebenden Zeichen angibt. 0 fuehrt
    //        zur Rueckgabe einer Null-Zeichenfolge. Ist nbrCutCharacters groesser oder gleich der 
    //        Zeichenanzahl im Objekt, so wird das gesamte Objekt zurueckgegeben.
    // Note:
    //     benoetigt fuer VB, vgl. B_leftS   
#ifdef B_VB_COMPATIBLE    
    B_String left(const B_Long& nbrCharToCut) const throw(B_InvalidArgument); 
    B_String leftB(const B_Long& nbrByteToCut) const throw(B_InvalidArgument); 
#endif
    B_String left(const B_Lng nbrCharToCut) const throw(B_InvalidArgument); 
    B_String leftB(const B_Lng nbrByteToCut) const throw(B_InvalidArgument); 

    //----------------------------------------------------------------------------------------------------   
    // Method:  
    //     Kopiert aus dem Objekt die Anzahl=nbrCharToCut Zeichen, von rechts beginnend, und 
    //     gibt den so erzeugten Teilstring als Return Value zurueck.
    // Parameter:
    //     nbrCharToCut:
    //        Numerischer Ausdruck, der die Anzahl der zurueckzugebenden Zeichen angibt. 0 fuehrt
    //        zur Rueckgabe einer Null-Zeichenfolge. Ist nbrCharToCut groesser oder gleich der 
    //        Zeichenanzahl im Objekt, so wird das gesamte Objekt zurueckgegeben.
    // Note:  
    //     benoetigt fuer VB, vgl. B_rightS   
#ifdef B_VB_COMPATIBLE
    B_String right(const B_Long& nbrCharToCut) const throw(B_InvalidArgument); 
    B_String rightB(const B_Long& nbrByteToCut) const throw(B_InvalidArgument); 
#endif
    B_String right(const B_Lng nbrCharToCut) const throw(B_InvalidArgument); 
    B_String rightB(const B_Lng nbrByteToCut) const throw(B_InvalidArgument); 

    //----------------------------------------------------------------------------------------------------       
    // Method:    
    //     Gibt die die Anzahl nbrCharToCut Zeichen des Objekts ab der Position startPos in einer 
    //     Zeichenkette als Return Value zurueck.
    // Parameter:   
    //     startPos:
    //         Position des Zeichens in cutString ab dem der Teilstring extrahiert wird. 
    //     nbrCharToCut:
    //         Anzahl der Zeichen die ab startPos aus dem Objekt rauskopiert werden sollen. Wird
    //         nbrCharToCut nicht angegeben wird das Objekt von startPso bis zu dessen Ende kopiert. 
    //         Ist nbrCharToCut groesser als die maximale Laenge des Objekts wird bis zum ende von 
    //         des Objekts ohne Fehlermeldung kopiert.
    // Return Value:
    //    Zeichenkette die eine Kopie der extrahierten Zeichen enthaelt.
    // Note: 
    //    benoetigt fuer VB, vgl. B_midS
    //    Entspricht der substr()-Methode in C++ Stringklassen
#ifdef B_VB_COMPATIBLE
    B_String  mid(const B_Long& startPos, const B_Long& nbrCharToCut = B_Long(1073741822, B_explicit)) const throw(B_InvalidArgument); 
    //     Fuegt den gebildeten Substring des Objektes in dest ein und gibt eine Referenz 
    //     auf dest zurueck.
    B_String& mid(B_String& dest, const B_Long& startPos, const B_Long& nbrCharToCut) const throw(B_InvalidArgument);
    B_String  midB(const B_Long& startPos, const B_Long& nbrByteToCut = B_LongMax)      const throw(B_InvalidArgument); 
#endif
    B_String  mid(const B_Lng startPos, const B_Lng nbrCharToCut = 1073741822)    const throw(B_InvalidArgument); 
    B_String& mid(B_String& dest, const B_Lng startPos, const B_Lng nbrCharToCut) const throw(B_InvalidArgument);
    B_String  midB(const B_Lng startPos, const B_Lng nbrByteToCut = B_LngMax)     const throw(B_InvalidArgument); 

    //----------------------------------------------------------------------------------------------------           
    // Method: 
    //     Liefert den Zeichencode des durch charPos spezifizierte Zeichen im Objekt zurueck
    // Paramter:   
    //     charPos:
    //         Default eingestellt auf erstes Zeichen. Dies entspricht dem gleichen verhalten 
    //         wie B_asc unter VB.
    // Return Value:
    //     Der Zeichencode des ersten Buchstabens von string
    // Note:
    //     fuer VB benoetigt, vgl. B_asc
#ifdef B_VB_COMPATIBLE
    B_Integer asc(const B_Long& charPos = B_Long(1L, B_explicit)) const throw(B_InvalidArgument);  
    B_Integer asc(const B_Lng charPos) const throw(B_InvalidArgument);  
#else
    B_Int asc(const B_Lng charPos = 1L) const throw(B_InvalidArgument);  
#endif
    
    //----------------------------------------------------------------------------------------------------       
    // Method:      Not-Operation
    // Return Value: 
    // Note:        ruft in Vb LZF(13) hervor wenn kein Zahlstring
#ifdef B_VB_COMPATIBLE
    B_Long operator!() const throw(B_TypeMismatch);
#else
    B_Lng operator!() const throw(B_TypeMismatch);
#endif

    //----------------------------------------------------------------------------------------------------           
    // Method:
    //     Konvertiert den String in einen C-String (char*)
    // Paramter:
    // Return Value: 
    //     Reuckgabe ist eine Kopie des Objektes
    // Note:    
    // 
    operator B_cCStr() const; 
    //----------------------------------------------------------------------------------------------------           
    // Method:
    //     Konvertiert den String in einen OLECHAR-String
    // Parameter:
    // Return Value: 
    //     Rueckgabe ist eine Kopie des Objektes
    // Note:  
	// Author: MS 970129
    // 
    operator BSTR() const; 

    operator B_Dbl() const throw(B_TypeMismatch, B_Overflow);

    //----------------------------------------------------------------------------------------------------           
    // Method:
    //     Konvertiert den String in einen Double
    // Paramter:
    // Return Value: 
    //     der double Wert
    // Note:    
#ifdef B_VB_COMPATIBLE
    B_Double val() const throw(B_Overflow);
#else
    B_Dbl val() const throw(B_Overflow);
#endif

    //----------------------------------------------------------------------------------------------------           
    // Method:
    //     Liefert B_true wenn es ein String fixer Laenge ist
    // Paramter:
    // Return Value: 
    // Note:    
    B_Boolean isFix() const ;

    //----------------------------------------------------------------------------------------------------           
    // Method:
    //     Liefert B_true wenn in Zahl konvertierbar
    // Paramter:
    // Return Value: 
    // Note:    
    B_Boolean isNumeric() const;
    B_Dbl     getDbl() const;

    //----------------------------------------------------------------------------------------------------       
    // Method:  
    //     Vergleicht B_String mit einem Muster. Das Verhalten des Operators Like haengt von der Option 
    //     Compare-Anweisung ab. 
    // Parameter: 
    //     patternToSearch:
    //     Das Muster, in form einer Zeichenkette, nach dem in searchString gesucht werden soll.
    //     compare:
    //     Bestimmt das Suchverhalten
    //       0 =  Compare Binary basieren Zeichenfolgenvergleiche auf einer Sortierreihenfolge, die durch 
    //            die interne binre Darstellung der Zeichen festgelegt ist. Die Sortierreihenfolge wird 
    //            durch die Codeseite festgelegt. Das folgende Beispiel zeigt eine typische binre Sortier-
    //            reihenfolge: A < B < E < Z < a < b < e < z <  <  <  <  <  < 
    //       1 =  Compare Text fhrt zu Zeichenfolgenvergleichen, die die im Gebietsschema des Systems 
    //            gewhlte Sortierreihenfolge fr Zeichen verwenden (wobei kein Unterschiede in der Gro- 
    //            und Kleinschreibung bercksichtigt werden). Die oben dargestellten Zeichen wrden beim 
    //            Sortieren mit Option Compare Text folgende Reihenfolge erhalten:
    //            (A=a) < (=) < (B=b) < (E=e) < (=) < (Z=z) < (=) 
    // Return Value:
    //     Ist vom Typ B_Boolean
    //         patternToSearch ist in Objekt enthalten           -> True
    //         patternToSearch und Objekt stimmen nicht ueberein -> False
    // Note:  
    //    fuer VB benoetigt, vgl. B_like()
#ifdef B_VB_COMPATIBLE
    B_Boolean like(const B_String& patternToSearch, const B_Long& compare = B_OPTION_COMPARE) const throw(B_InvalidArgument);
    B_Boolean like(B_cCStr patternToSearch, const B_Long& compare  = B_OPTION_COMPARE) const throw(B_InvalidArgument);
#else
    B_Boolean like(const B_String& patternToSearch, const B_Lng compare = B_OPTION_COMPARE) const   throw(B_InvalidArgument);
    B_Boolean like(B_cCStr patternToSearch, const B_Lng compare = B_OPTION_COMPARE) const   throw(B_InvalidArgument);
#endif
    
    //----------------------------------------------------------------------------------------------------       
    // Method: 
    //     Subscription
    //     Rueckgabe des durch [] spezifizierten Zeichens im Objekt.
    // Parameter:  
    //     Index der die Position des rueckzugebenden Zeichens angibt
    // Return Value:
    // Note: 
    //     zusaetzlich, 
#ifdef B_VB_COMPATIBLE    
    B_Char  operator[](const B_Long& index) const    throw(B_SubscriptError); 
    B_Char& operator[](const B_Long& index)          throw(B_SubscriptError); 
    B_Char  getAt(const B_Long& pos) const           throw(B_InvalidArgument);
    void    putAt(const B_Long& pos, const B_Char c) throw(B_InvalidArgument);
#endif
    B_Char  operator[](const B_Lng index) const    throw(B_SubscriptError); 
    B_Char& operator[](const B_Lng index)          throw(B_SubscriptError); 
    B_Char  getAt(const B_Lng pos) const           throw(B_InvalidArgument);
    void    putAt(const B_Lng pos, const B_Char c) throw(B_InvalidArgument);
    
    
    //----------------------------------------------------------------------------------------------------   
    // Method:
    //     replace
    //     ersetzt nbr-Zeichen im Objekt ab position pos durch repStr
    // Parameter:  
    //     pos 
    //         ab hier wird im Objekt mit ersetzung begonnen, (pos >= 1 && pos <= nbrChar)
    //     nbr
    //         anzahl der Zeichen die ersetzt werden (nbr >= 1)
    //     repStr
    //         String der die Zeichen enthaelt durch die die Anzahl nbr Zeichen im Objekt
    //         ersetzt werden
    // Return Value:
    // Note: 
    //    Wenn pos + nbr die Objektlaenge ueberschreitet gilt nbr = len() - pos.
    //    Wenn pos == len() dann wird der String an das Objekt angehaengt
    //    ist repStr ein Zeichen dann wird diese nbr-mal eingefuegt
#ifdef B_VB_COMPATIBLE
    B_String& replace(const B_Long& pos, const B_Long& nbr, const B_String& repStr)                                          throw(B_InvalidArgument);
    B_String& replace(const B_Long& pos, const B_Long& nbr, const B_Char repStr, const B_Long& rep = B_Long(1L, B_explicit)) throw(B_InvalidArgument);  
#endif
    B_String& replace(const B_Lng pos, const B_Lng nbr, const B_String& repStr)                     throw(B_InvalidArgument);
    B_String& replace(const B_Lng pos, const B_Lng nbr, const B_Char repStr, const B_Lng rep = 1L)  throw(B_InvalidArgument);  

    //----------------------------------------------------------------------------------------------------   
    // Method: 
    //     lCase == toLower 
    //     Konvertiert im Objekt alle Buchstaben in Kleinbuchstaben. Lediglich Grossbuchstaben 
    //     werden in Kleinbuchstaben umgewandelt. Alle Kleinbuchstaben und sonstigen Zeichen
    //     bleiben unveraendert.
    // Return Value: 
    // Note:
    //     benoetigt fuer VB. vgl. B_lCase
    B_String& lCase();

    //----------------------------------------------------------------------------------------------------   
    // Method: 
    //     uCase == toUpper
    //     Konvertiert im Objekt alle Buchstaben in Grossbuchstaben. Lediglich Kleinbuchstaben 
    //     werden in Grossbuchstaben umgewandelt. Alle Grossbuchstaben und sonstigen Zeichen
    //     bleiben unveraendert.
    // Return Value:
    // Note:  
    //     benoetigt fuer VB. vgl. B_uCase
    B_String& uCase();   

    //----------------------------------------------------------------------------------------------------   
    // Method: 
    //     lset   
    //     Fuegt die Zeichenkette=insString linksbuendig in das Objekt. Ist insString laenger als 
    //     das Objekt, so werden in das Objekt nur die ersten Zeichen von insString(von links) 
    //     bis zur Laenge des Objekts eingefuegt.
    // Parameter: 
    //     insString:
    //         Zeichenkette deren Zeichen linksbuendig in destString eingefuegt werden
    // Return Value: 
    //     True=Aktion fehlerfrei ausgefuehrt,
    //     False= Ein Fehler ist aufgetreten
    // Note:
    //     Null ist fuer keinen der Parameter erlaubt. Ist ein Parameter ein Variant mit numerischem 
    //     Untertyp ist wird eine Laufzeitfehlermeldung ausgegeben.
    //     fuer VB benoetigt, vgl. B_lSet
    B_String& lSet(const B_String& insString);
    B_String& lSet(B_cCStr insString);

    //----------------------------------------------------------------------------------------------------   
    // Method:
    //     rSet 
    //     Fuegt die Zeichenkette=insString rechtsbuendig in das Objekt. Ist insString laenger als 
    //     das Objekt, so werden in das Objekt nur die ersten Zeichen von insString(von links) 
    //     bis zur Laenge des Objekts eingefuegt.
    // Parameter:  
    //     insString:
    //         Zeichenkette deren Zeichen linksbuendig in destString eingefuegt werden
    // Return Value:
    //     True=Aktion fehlerfrei ausgefuehrt,
    //     False= Ein Fehler ist aufgetreten
    // Note: 
    //     Null ist fuer keinen der Parameter erlaubt. Ist ein Parameter ein Variant mit numerischem 
    //     Untertyp ist wird eine Laufzeitfehlermeldung ausgegeben.
    //     fuer VB benoetigt, vgl. B_lSet
    B_String& rSet(const B_String& insString); 
    B_String& rSet(B_cCStr insString);

    //----------------------------------------------------------------------------------------------------       
    // Method:     
    //     Entfernt im Objekt alle fuehrenden Leerzeichen (whitespaces).
    // Return Value:
    // Note:
    //     benoetigt fuer VB, vgl. B_lTrimS
    B_String& lTrim();    

    //----------------------------------------------------------------------------------------------------       
    // Method: 
    //     Entfernt im Objekt alle am ende befindlichen Leerzeichen (whitespaces)
    // Return Value: 
    // Note: 
    //     benoetigt fuer VB, vgl. B_rTrimS
    B_String& rTrim();

    //----------------------------------------------------------------------------------------------------       
    // Method: 
    //     Entfernt im Objekt alle fuehrenden und nachfolgenden Leerzeichen
    // Return Value:
    // Note:  
    //     benoetigt fuer VB, vgl. B_trimS
    B_String& trim();   

    //----------------------------------------------------------------------------------------------------   
    // Method: 
    //     convert
    //     Konvertiert Objekt in abhaengigkeit vom Parameter convertInType
    // Parameter:
    //     convertInType:
    //         legt die Art der Konvertierung fest, Null ist nicht als Wert erlaubt
    //         vbUpperCase     1   Zeichenfolge in Grobuchstaben umwandeln
    //         vbLowerCase     2   Zeichenfolge in Kleinbuchstaben umwandeln
    //         vbProperCase    3   Anfangsbuchstaben in jedem Wort der Zeichenfolge in 
    //                             Grobuchstaben umwandeln
    //         vbWide          4   Schmale Zeichen (Einzelbyte) in der Zeichenfolge in 
    //                             breite Zeichen (Doppelbyte) umwandeln
    //         vbNarrow        8   Breite Zeichen (Doppelbyte) in der Zeichenfolge in 
    //                             schmale Zeichen (Einzelbyte) umwandeln
    //         vbUnicode      64   Zeichenfolge unter Verwendung der Standard-Codeseite
    //                             des Systems in Unicode umwandeln
    //         vbFromUnicode 128   Zeichenfolge unter Verwendung der Standard-Codeseite 
    //                             des Systems aus Unicode umwandeln
    // Return Value:
    //     True=Aktion fehlerfrei ausgefuehrt,
    //     False= Ein Fehler ist aufgetreten
    // Note:
    //     fuer VB benoetigt. vlg. B_strConv() 
    // B_Boolean convert(const B_Integer& convertInType);     

    //----------------------------------------------------------------------------------------------------       
    // Method: 
    //     toAscii 
    //     Konvertiert das Objekt in einen String im ASCII-Format
    // Return Value: 
    //     True = Aktion fehlerfrei ausgefuehrt,
    //     False= Ein Fehler ist aufgetreten
    // Note: 
    //     zusaetzlich zu VB 
    // B_Boolean toAscii(); 

    //----------------------------------------------------------------------------------------------------       
    // Method: 
    //     toAnsi
    //     Konvertiert das Objekt in einen String im ANSI-Format
    // Return Value: 
    //     True=Aktion fehlerfrei ausgefuehrt, False= Ein Fehler ist aufgetreten
    // Note: 
    //     zusaetzlich zu VB 
    // Impl.:
    //     wie sinnvoll ist das, da ja VB selbst intern alle Konvertierungen normal dem Basic Programmierer
    //     abnimmt
    // B_Boolean toAnsi();

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Gibt einen Zeiger auf die interen Representation des Strings zurueck
    // Parameter:  
    // Return Value:
    //     Zeiger auf interne Stringrepraesentation
    // Errorhandling:
    // Note:      
    //     ACHTUNG: dieser Zeiger kann sich bei jeder Operation auf das Objekt veraendern wenn es 
    //              die Verwaltung aus effizienzgruenden fuer erforderlich haelt.
    //              Niemals constness wegcasten !
    //     Bei einem Bytestring wird nur bis zum Auftretend es ersten '\0' kopiert
    B_cCStr getCStr() const;

    //---------------------------------------------------------------------------------------------------------       
    // Method:
    //     Gibt den Wert des Objektes als entsprechenden C/C++ Datentyp zurueck
    // Parameter:  
    // Return Value:
    //     Kopie des Objetkwertes als char*-String
    // Errorhandling:
    // Note:      
    //     Bei einem Bytestring wird nur bis zum Auftretend es ersten '\0' kopiert.
    //     Die groesse kann nicht mit getValueSize() ermittelt werden da ein Bytestring ja ggf.
    //     groesser sein kann
    B_CStr getValue() const;

    //----------------------------------------------------------------------------------------------------       
    // Method:
    //     Gibt die Groesse des Wert des Objektes als entsprechenden C/C++ Datentyp zurueck
    // Return Value:
    //     Groesse in Byte
    // Note:
    //     Den genauen Typ und somit seine groesse koennen zwischen den C/C++ Datentypen der
    //     Compiler unterschiedlich sein, deshalb wurde diese Method eingefuegt die eine
    //     portable Programmierung aehnlich sizeof() ermoeglichen soll.
    B_ULng getValueSize() const;  
    
    //----------------------------------------------------------------------------------------------------       
    // Method: 
    //     Gibt die Groesse des Objktes zurueck, diese entspricht der durch das Objekt belegten
    //     Speicherplatz
    // Return Value: 
    //     Groesse in Byte
    // Note: 
    //     Den genauen Typ und somit seine groesse koennen zwischen den C/C++ Compiler 
    //     unterschiedlich sein. Auch koennte sich die Klassenimplementierung aendern so
    //     dass aeltere Programme nur mit Aenderungsprogramm lauffaehig waeren, deshalb 
    //     wurde diese Method eingefuegt die eine portable Programmierung aehnlich 
    //     sizeof() ermoeglichen soll.
    B_ULng getSize() const;       

    //----------------------------------------------------------------------------------------------------       
    // Method: 
    //     Setzt den internen Status des Objektes auf optional. Somit kann mit isMissing der Status
    //     abgefragt werden und die Emulation des gleichnamigen VB Befehls wird moeglich.
    // Return Value: 
    // Note: 
    //
    B_String& isOptional();

    //----------------------------------------------------------------------------------------------------       
    // Method: 
    //     Abfragen des internen Objektstatus ob das Argument einer Funktion optional ist oder nicht
    // Return Value: 
    // Note: 
    //
    B_Boolean isMissing() const;


    //----------------------------------------------------------------------------------------------------       
    // Method: 
    //     Schreiben der "eigentlichen" Objektdaten in einen Stream
    // Return Value: 
    //     B_true  ==  Objekt und Stream sind gueltig
    //     B_false ==  Objekt oder Stream sind ungueltig
    // Note: 
    //
    B_Boolean streamp(ostream& ostr) const;
    
    //----------------------------------------------------------------------------------------------------       
    // Method: 
    //     Lesen der eigentlichen Objektdaten aus einem Stream und erzeugen eines gltigen Objektes
    // Return Value: 
    //     B_true  ==  Objekt und Stream sind gueltig
    //     B_false ==  Objekt oder Stream sind ungueltig
    // Note: 
    //
    B_Boolean streamg(istream& istr);

    //----------------------------------------------------------------------------------------------------       
    // Method: 
    //     Schreiben der der eigentlichen Objektdaten im binaeren Format in einen Stream
    // Return Value: 
    //     B_true  ==  Objekt und Stream sind gueltig
    //     B_false ==  Objekt oder Stream sind ungueltig
    // Note: 
    //
    B_Boolean streamw(ostream& ostr) const;

    //----------------------------------------------------------------------------------------------------       
    // Method: 
    //     Lesen der der eigentlichen Objektdaten im binaeren Format in einen Stream
    // Return Value: 
    //     B_true  ==  Objekt und Stream sind gueltig
    //     B_false ==  Objekt oder Stream sind ungueltig
    // Note: 
    //
    B_Boolean streamr(istream& istr);

  //==================== HELPER ===============================================================================    
  //
  protected:
    void allocStr(size_t newSize);
    void reallocStr(size_t newSize);
    void deallocStr();

  //==================== MEMBER ===============================================================================    
  //
  public:			// ..CT061296	Fuer neuen Weg der FileIO mu man direkt auf den Speicher zugreifen koennen
    B_CStr  value;
    B_Lng   nbrChar; // ohne \0, nur B_Lng und nicht B_ULng wegen internen Typkonvertierungen mit Zahldatentypen
                     // Ferner sollten Strings von 2GB Hauptspeichergroesse ausreichen :-)
  private:
    B_Lng   capacity;// dito
    B_Flag  optional;
	B_Flag  fix;
    static B_Char emptyString;


  //==================== FRIENDS ============================================================================
  //
  }; // B_String

DLL_DECL void toVARIANT (VARIANT &, B_String);
DLL_DECL extern struct B_String::B_FixString B_fixed;



//============= Stringfunktionen =================================================================================


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- String + Boolean        String             VB30                 VB40
//                         rein numer.        konkatenation        addition
//                         n. rein numer.     konkatenation        laufzeitfehler
//                         zahlkonstante      konkatentation       addition        -> in B_Boolean behandelt
//   Die Addition addiert 0=False -1=True die Konkatentation konkatentiert die Strings "-1"=True und "0"=False
//   Es werden alse keine Laenderspezifischen Strings fuer den Wahheitswert generiert (z.B. 0=False=Falsch)
//   Rueckgabe Variant da sowohl String als auch Zahl(Double) sein kann.
// 
//-- Einer Numerisch andere String:
//   In VB30/40 wird unterschieden ob eine numerische Variable und eine Stringvariable per operator+
//   und einer Zahlkonstanten und einer Stringvariablen. Hierbei loest eine Zahlkonstante einen Compile(VB30)
//   respektive einen runtime(VB40) Error aus, hingegen werden numerische und Stringvariable addiert.
//   Dies kann der Konverter loesen indem er einfach keine Literale umsetzt in Konstruktoraufrufe.
//   z.B.  intvar + B_Integer(12)
//   Dies muss er normalerweise tun um Mehrdeutigkeiten bei binaeren Operatoren entgegenzuwirken
//   Aus Performancegruenden wird keine implizite Konvertierung ueber Operatoren oder Konstruktoren vorgenommen
//   Eine Verknuepfung mit dem Typ Date ist in VB30/40 nicht moeglich.
//   Auf B_Int, B_Short wird verzichtet -> integrale Promotion zu B_Integer
//                               VB30:                                           VB40:                
//   Kein rein numer. Str.:      compile error                                   runtime error
//   numer. Str.:                compile error                                   numer. Addition
DLL_DECL B_String   operator+ (const B_String&,   const B_String&);
DLL_DECL B_String   operator+ (		 B_cCStr,     const B_String&);
DLL_DECL B_String   operator+ (const B_String&,			B_cCStr);
DLL_DECL B_String   operator+ (const B_Empty&,    const B_String&);
DLL_DECL B_String   operator+ (const B_String&,   const B_Empty&);
DLL_DECL B_Null     operator+ (const B_Null&,     const B_String&);
DLL_DECL B_Null     operator+ (const B_String&,   const B_Null&);

// CT060197	Erweiterung fuer Thales+
#ifdef THALESPLUS
DLL_DECL B_String   operator+ (const B_String&,		  const B_TStringStruct);
DLL_DECL B_String   operator+ (      B_cCStr,		  const B_TStringStruct);
DLL_DECL B_String   operator+ (const B_TStringStruct, const B_String&);
DLL_DECL B_String   operator+ (const B_TStringStruct,       B_cCStr);
#endif	// THALESPLUS

#ifdef B_VB_COMPATIBLE
// Es sind nur Zahlstrings erlaubt ! auch keine Wahrheitsstrings
DLL_DECL B_Double   operator+ (const B_Boolean&,  const B_String&);
DLL_DECL B_Double   operator+ (const B_String&,   const B_Boolean&);
DLL_DECL B_Double   operator+ (const B_Byte&,     const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Double   operator+ (const B_String&,   const B_Byte&)     throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Double   operator+ (const B_Integer&,  const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Double   operator+ (const B_String&,   const B_Integer&)  throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Double   operator+ (const B_Long&,     const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Double   operator+ (const B_String&,   const B_Long&)     throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Double   operator+ (const B_Single&,   const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Double   operator+ (const B_String&,   const B_Single&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Double   operator+ (const B_Double&,   const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Double   operator+ (const B_String&,   const B_Double&)   throw (B_TypeMismatch, B_Overflow);
#else // B_VB_COMPATIBLE
DLL_DECL B_Dbl   operator+ (const B_Boolean&,  const B_String&);
DLL_DECL B_Dbl   operator+ (const B_String&,   const B_Boolean&);
#endif // B_VB_COMPATIBLE
DLL_DECL B_Dbl   operator+ (const B_Int,      const B_String&)  throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Dbl   operator+ (const B_String&,  const B_Int)      throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Dbl   operator+ (const B_Lng,      const B_String&)  throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Dbl   operator+ (const B_String&,  const B_Lng)      throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Dbl   operator+ (const B_Flt,      const B_String&)  throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Dbl   operator+ (const B_String&,  const B_Flt)      throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Dbl   operator+ (const B_Dbl,      const B_String&)  throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Dbl   operator+ (const B_String&,  const B_Dbl)      throw (B_TypeMismatch, B_Overflow);

DLL_DECL B_Currency operator+ (const B_Currency&, const B_String&)   throw (B_TypeMismatch, B_Overflow); 
DLL_DECL B_Currency operator+ (const B_String&,   const B_Currency&) throw (B_TypeMismatch, B_Overflow);

  
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Es sind nur Zahlstrings erlaubt ! auch keine Wahrheitsstrings
DLL_DECL B_Null     operator- (const B_Null&,     const B_String&);
DLL_DECL B_Null     operator- (const B_String&,   const B_Null&);
#ifdef B_VB_COMPATIBLE
DLL_DECL B_Double   operator- (const B_String&,   const B_String&)  throw(B_TypeMismatch, B_Overflow);
DLL_DECL B_Double   operator- (const B_String&,   const B_Boolean&) throw(B_TypeMismatch);
DLL_DECL B_Double   operator- (const B_Boolean&,  const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Double   operator- (const B_Empty&,    const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Double   operator- (const B_String&,   const B_Empty&)   throw(B_TypeMismatch);

DLL_DECL B_Double   operator- (const B_Byte&,     const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Double   operator- (const B_String&,   const B_Byte&)     throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Double   operator- (const B_Integer&,  const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Double   operator- (const B_String&,   const B_Integer&)  throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Double   operator- (const B_Long&,     const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Double   operator- (const B_String&,   const B_Long&)     throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Double   operator- (const B_Single&,   const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Double   operator- (const B_String&,   const B_Single&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Double   operator- (const B_Double&,   const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Double   operator- (const B_String&,   const B_Double&)   throw (B_TypeMismatch, B_Overflow);

#else // B_VB_COMPATIBLE
DLL_DECL B_Dbl   operator- (const B_String&,   const B_String&)  throw(B_TypeMismatch, B_Overflow);
DLL_DECL B_Dbl   operator- (const B_String&,   const B_Boolean&) throw(B_TypeMismatch);
DLL_DECL B_Dbl   operator- (const B_Boolean&,  const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Dbl   operator- (const B_Empty&,    const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Dbl   operator- (const B_String&,   const B_Empty&)   throw(B_TypeMismatch);

#endif // B_VB_COMPATIBLE
DLL_DECL B_Dbl   operator- (const B_Int,      const B_String&)  throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Dbl   operator- (const B_String&,  const B_Int)      throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Dbl   operator- (const B_Lng,      const B_String&)  throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Dbl   operator- (const B_String&,  const B_Lng)      throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Dbl   operator- (const B_Flt,      const B_String&)  throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Dbl   operator- (const B_String&,  const B_Flt)      throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Dbl   operator- (const B_Dbl,      const B_String&)  throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Dbl   operator- (const B_String&,  const B_Dbl)      throw (B_TypeMismatch, B_Overflow);

DLL_DECL B_Currency operator- (const B_Currency&, const B_String&)   throw (B_TypeMismatch, B_Overflow); 
DLL_DECL B_Currency operator- (const B_String&,   const B_Currency&) throw (B_TypeMismatch, B_Overflow);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Es sind nur Zahlstrings erlaubt ! auch keine Wahrheitsstrings
DLL_DECL B_Null     operator* (const B_Null&,     const B_String&);
DLL_DECL B_Null     operator* (const B_String&,   const B_Null&);

#ifdef B_VB_COMPATIBLE
DLL_DECL B_Double  operator* (const B_String&,   const B_String&)  throw(B_TypeMismatch, B_Overflow, B_Underflow);
DLL_DECL B_Double  operator* (const B_String&,   const B_Boolean&) throw(B_TypeMismatch);
DLL_DECL B_Double  operator* (const B_Boolean&,  const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Double  operator* (const B_Empty&,    const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Double  operator* (const B_String&,   const B_Empty&)   throw(B_TypeMismatch);

DLL_DECL B_Double   operator* (const B_Byte&,     const B_String&)   throw (B_TypeMismatch, B_Overflow, B_Underflow);
DLL_DECL B_Double   operator* (const B_String&,   const B_Byte&)     throw (B_TypeMismatch, B_Overflow, B_Underflow);
DLL_DECL B_Double   operator* (const B_Integer&,  const B_String&)   throw (B_TypeMismatch, B_Overflow, B_Underflow);
DLL_DECL B_Double   operator* (const B_String&,   const B_Integer&)  throw (B_TypeMismatch, B_Overflow, B_Underflow);
DLL_DECL B_Double   operator* (const B_Long&,     const B_String&)   throw (B_TypeMismatch, B_Overflow, B_Underflow);
DLL_DECL B_Double   operator* (const B_String&,   const B_Long&)     throw (B_TypeMismatch, B_Overflow, B_Underflow);
DLL_DECL B_Double   operator* (const B_Single&,   const B_String&)   throw (B_TypeMismatch, B_Overflow, B_Underflow);
DLL_DECL B_Double   operator* (const B_String&,   const B_Single&)   throw (B_TypeMismatch, B_Overflow, B_Underflow);
DLL_DECL B_Double   operator* (const B_Double&,   const B_String&)   throw (B_TypeMismatch, B_Overflow, B_Underflow);
DLL_DECL B_Double   operator* (const B_String&,   const B_Double&)   throw (B_TypeMismatch, B_Overflow, B_Underflow);
DLL_DECL B_Double   operator* (const B_Currency&, const B_String&)   throw (B_TypeMismatch, B_Overflow, B_Underflow); 
DLL_DECL B_Double   operator* (const B_String&,   const B_Currency&) throw (B_TypeMismatch, B_Overflow, B_Underflow);

#else // B_VB_COMPATIBLE
DLL_DECL B_Dbl   operator* (const B_String&,   const B_String&)  throw(B_TypeMismatch, B_Overflow, B_Underflow);
DLL_DECL B_Dbl   operator* (const B_String&,   const B_Boolean&) throw(B_TypeMismatch);
DLL_DECL B_Dbl   operator* (const B_Boolean&,  const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Dbl   operator* (const B_Empty&,    const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Dbl   operator* (const B_String&,   const B_Empty&)   throw(B_TypeMismatch);
DLL_DECL B_Dbl   operator* (const B_Currency&, const B_String&)   throw (B_TypeMismatch, B_Overflow, B_Underflow); 
DLL_DECL B_Dbl   operator* (const B_String&,   const B_Currency&) throw (B_TypeMismatch, B_Overflow, B_Underflow);

#endif // B_VB_COMPATIBLE
DLL_DECL B_Dbl   operator* (const B_Int,      const B_String&)  throw (B_TypeMismatch, B_Overflow, B_Underflow);
DLL_DECL B_Dbl   operator* (const B_String&,  const B_Int)      throw (B_TypeMismatch, B_Overflow, B_Underflow);
DLL_DECL B_Dbl   operator* (const B_Lng,      const B_String&)  throw (B_TypeMismatch, B_Overflow, B_Underflow);
DLL_DECL B_Dbl   operator* (const B_String&,  const B_Lng)      throw (B_TypeMismatch, B_Overflow, B_Underflow);
DLL_DECL B_Dbl   operator* (const B_Flt,      const B_String&)  throw (B_TypeMismatch, B_Overflow, B_Underflow);
DLL_DECL B_Dbl   operator* (const B_String&,  const B_Flt)      throw (B_TypeMismatch, B_Overflow, B_Underflow);
DLL_DECL B_Dbl   operator* (const B_Dbl,      const B_String&)  throw (B_TypeMismatch, B_Overflow, B_Underflow);
DLL_DECL B_Dbl   operator* (const B_String&,  const B_Dbl)      throw (B_TypeMismatch, B_Overflow, B_Underflow);


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Es sind nur Zahlstrings erlaubt ! auch keine Wahrheitsstrings
DLL_DECL B_Null   operator/ (const B_Null&,     const B_String&);
DLL_DECL B_Null   operator/ (const B_String&,   const B_Null&);

#ifdef B_VB_COMPATIBLE
DLL_DECL B_Double operator/ (const B_String&,   const B_String&)  throw(B_TypeMismatch, B_ZeroDivide, B_Underflow);
DLL_DECL B_Double operator/ (const B_String&,   const B_Boolean&) throw(B_TypeMismatch, B_ZeroDivide);
DLL_DECL B_Double operator/ (const B_Boolean&,  const B_String&)  throw(B_TypeMismatch, B_ZeroDivide);
DLL_DECL B_Double operator/ (const B_Empty&,    const B_String&)  throw(B_TypeMismatch, B_ZeroDivide);
DLL_DECL B_Double operator/ (const B_String&,   const B_Empty&)   throw(B_TypeMismatch, B_ZeroDivide);

DLL_DECL B_Double   operator/ (const B_Byte&,     const B_String&)   throw (B_TypeMismatch, B_ZeroDivide, B_Underflow);
DLL_DECL B_Double   operator/ (const B_String&,   const B_Byte&)     throw (B_TypeMismatch, B_ZeroDivide, B_Underflow);
DLL_DECL B_Double   operator/ (const B_Integer&,  const B_String&)   throw (B_TypeMismatch, B_ZeroDivide, B_Underflow);
DLL_DECL B_Double   operator/ (const B_String&,   const B_Integer&)  throw (B_TypeMismatch, B_ZeroDivide, B_Underflow);
DLL_DECL B_Double   operator/ (const B_Long&,     const B_String&)   throw (B_TypeMismatch, B_ZeroDivide, B_Underflow);
DLL_DECL B_Double   operator/ (const B_String&,   const B_Long&)     throw (B_TypeMismatch, B_ZeroDivide, B_Underflow);
DLL_DECL B_Double   operator/ (const B_Single&,   const B_String&)   throw (B_TypeMismatch, B_ZeroDivide, B_Underflow);
DLL_DECL B_Double   operator/ (const B_String&,   const B_Single&)   throw (B_TypeMismatch, B_ZeroDivide, B_Underflow);
DLL_DECL B_Double   operator/ (const B_Double&,   const B_String&)   throw (B_TypeMismatch, B_ZeroDivide, B_Underflow);
DLL_DECL B_Double   operator/ (const B_String&,   const B_Double&)   throw (B_TypeMismatch, B_ZeroDivide, B_Underflow);
DLL_DECL B_Double   operator/ (const B_Currency&, const B_String&)   throw (B_TypeMismatch, B_ZeroDivide, B_Underflow); 
DLL_DECL B_Double   operator/ (const B_String&,   const B_Currency&) throw (B_TypeMismatch, B_ZeroDivide, B_Underflow);

#else // B_VB_COMPATIBLE
DLL_DECL B_Dbl operator/ (const B_String&,   const B_String&)  throw(B_TypeMismatch, B_ZeroDivide, B_Underflow);
DLL_DECL B_Dbl operator/ (const B_String&,   const B_Boolean&) throw(B_TypeMismatch, B_ZeroDivide);
DLL_DECL B_Dbl operator/ (const B_Boolean&,  const B_String&)  throw(B_TypeMismatch, B_ZeroDivide);
DLL_DECL B_Dbl operator/ (const B_Empty&,    const B_String&)  throw(B_TypeMismatch, B_ZeroDivide);
DLL_DECL B_Dbl operator/ (const B_String&,   const B_Empty&)   throw(B_TypeMismatch, B_ZeroDivide);
DLL_DECL B_Dbl operator/ (const B_Currency&, const B_String&)   throw (B_TypeMismatch, B_ZeroDivide, B_Underflow); 
DLL_DECL B_Dbl operator/ (const B_String&,   const B_Currency&) throw (B_TypeMismatch, B_ZeroDivide, B_Underflow);

#endif // B_VB_COMPATIBLE
DLL_DECL B_Dbl   operator/ (const B_Int,     const B_String&) throw (B_TypeMismatch, B_ZeroDivide, B_Underflow);
DLL_DECL B_Dbl   operator/ (const B_String&, const B_Int)     throw (B_TypeMismatch, B_ZeroDivide, B_Underflow);
DLL_DECL B_Dbl   operator/ (const B_Lng,     const B_String&) throw (B_TypeMismatch, B_ZeroDivide, B_Underflow);
DLL_DECL B_Dbl   operator/ (const B_String&, const B_Lng)     throw (B_TypeMismatch, B_ZeroDivide, B_Underflow);
DLL_DECL B_Dbl   operator/ (const B_Flt,     const B_String&) throw (B_TypeMismatch, B_ZeroDivide, B_Underflow);
DLL_DECL B_Dbl   operator/ (const B_String&, const B_Flt)     throw (B_TypeMismatch, B_ZeroDivide, B_Underflow);
DLL_DECL B_Dbl   operator/ (const B_Dbl,     const B_String&) throw (B_TypeMismatch, B_ZeroDivide, B_Underflow);
DLL_DECL B_Dbl   operator/ (const B_String&, const B_Dbl)     throw (B_TypeMismatch, B_ZeroDivide, B_Underflow);


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Es sind Zahlstrings und Wahrheitsstrings erlaubt ergebnis immer false
//   andere Strings werden zu LZF(13)
DLL_DECL B_Null    operator% (const B_Null&,     const B_String&);
DLL_DECL B_Null    operator% (const B_String&,   const B_Null&);
#ifdef B_VB_COMPATIBLE
DLL_DECL B_Long    operator% (const B_String&,   const B_String&)  throw(B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Long    operator% (const B_String&,   const B_Boolean&) throw(B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Long    operator% (const B_Boolean&,  const B_String&)  throw(B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Long    operator% (const B_Empty&,    const B_String&)  throw(B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Long    operator% (const B_String&,   const B_Empty&)   throw(B_TypeMismatch, B_ZeroDivide);

DLL_DECL B_Long   operator% (const B_Byte&,     const B_String&)   throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Long   operator% (const B_String&,   const B_Byte&)     throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Long   operator% (const B_Integer&,  const B_String&)   throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Long   operator% (const B_String&,   const B_Integer&)  throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Long   operator% (const B_Long&,     const B_String&)   throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Long   operator% (const B_String&,   const B_Long&)     throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Long   operator% (const B_Single&,   const B_String&)   throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Long   operator% (const B_String&,   const B_Single&)   throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Long   operator% (const B_Double&,   const B_String&)   throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Long   operator% (const B_String&,   const B_Double&)   throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Long   operator% (const B_Currency&, const B_String&)   throw (B_TypeMismatch, B_Overflow, B_ZeroDivide); 
DLL_DECL B_Long   operator% (const B_String&,   const B_Currency&) throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);

#else // B_VB_COMPATIBLE
DLL_DECL B_Lng  operator% (const B_String&,   const B_String&)  throw(B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng  operator% (const B_String&,   const B_Boolean&) throw(B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng  operator% (const B_Boolean&,  const B_String&)  throw(B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng  operator% (const B_Empty&,    const B_String&)  throw(B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng  operator% (const B_String&,   const B_Empty&)   throw(B_TypeMismatch, B_ZeroDivide);
DLL_DECL B_Lng  operator% (const B_Currency&, const B_String&)   throw (B_TypeMismatch, B_Overflow, B_ZeroDivide); 
DLL_DECL B_Lng  operator% (const B_String&,   const B_Currency&) throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);

#endif // B_VB_COMPATIBLE
DLL_DECL B_Lng   operator% (const B_Int,     const B_String&)  throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng   operator% (const B_String&, const B_Int)      throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng   operator% (const B_Lng,     const B_String&)  throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng   operator% (const B_String&, const B_Lng)      throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng   operator% (const B_Flt,     const B_String&)  throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng   operator% (const B_String&, const B_Flt)      throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng   operator% (const B_Dbl,     const B_String&)  throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng   operator% (const B_String&, const B_Dbl)      throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Es sind nur Zahlstrings erlaubt ! auch keine Wahrheitsstrings, das ergebnis ist boolsche !
DLL_DECL B_Boolean B_Div(const B_Boolean&,  const B_String&)  throw(B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Null    B_Div(const B_Null&,     const B_String&);
DLL_DECL B_Null    B_Div(const B_String&,   const B_Null&);

#ifdef B_VB_COMPATIBLE
DLL_DECL B_Long    B_Div(const B_String&,   const B_String&)  throw(B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Long    B_Div(const B_String&,   const B_Boolean&) throw(B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Long    B_Div(const B_Empty&,    const B_String&)  throw(B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Long    B_Div(const B_String&,   const B_Empty&)   throw(B_TypeMismatch, B_ZeroDivide);

DLL_DECL B_Long   B_Div(const B_Byte&,     const B_String&)   throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Long   B_Div(const B_String&,   const B_Byte&)     throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Long   B_Div(const B_Integer&,  const B_String&)   throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Long   B_Div(const B_String&,   const B_Integer&)  throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Long   B_Div(const B_Long&,     const B_String&)   throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Long   B_Div(const B_String&,   const B_Long&)     throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Long   B_Div(const B_Single&,   const B_String&)   throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Long   B_Div(const B_String&,   const B_Single&)   throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Long   B_Div(const B_Double&,   const B_String&)   throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Long   B_Div(const B_String&,   const B_Double&)   throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Long   B_Div(const B_Currency&, const B_String&)   throw (B_TypeMismatch, B_Overflow, B_ZeroDivide); 
DLL_DECL B_Long   B_Div(const B_String&,   const B_Currency&) throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);

#else // B_VB_COMPATIBLE
DLL_DECL B_Lng   B_Div(const B_String&,   const B_String&)  throw(B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng   B_Div(const B_String&,   const B_Boolean&) throw(B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng   B_Div(const B_Empty&,    const B_String&)  throw(B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng   B_Div(const B_String&,   const B_Empty&)   throw(B_TypeMismatch, B_ZeroDivide);
DLL_DECL B_Lng   B_Div(const B_Currency&, const B_String&)   throw (B_TypeMismatch, B_Overflow, B_ZeroDivide); 
DLL_DECL B_Lng   B_Div(const B_String&,   const B_Currency&) throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);

#endif // B_VB_COMPATIBLE
DLL_DECL B_Lng   B_Div(const B_Int,      const B_String&)  throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng   B_Div(const B_String&,  const B_Int)      throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng   B_Div(const B_Lng,      const B_String&)  throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng   B_Div(const B_String&,  const B_Lng)      throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng   B_Div(const B_Flt,      const B_String&)  throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng   B_Div(const B_String&,  const B_Flt)      throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng   B_Div(const B_Dbl,      const B_String&)  throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);
DLL_DECL B_Lng   B_Div(const B_String&,  const B_Dbl)      throw (B_TypeMismatch, B_Overflow, B_ZeroDivide);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Es sind nur Zahlstrings erlaubt ! auch keine Wahrheitsstrings, das ergebnis ist boolsche !
DLL_DECL B_Null    B_Pow(const B_Null&,     const B_String&);
DLL_DECL B_Null    B_Pow(const B_String&,   const B_Null&);

#ifdef B_VB_COMPATIBLE
DLL_DECL B_Double  B_Pow(const B_String&,   const B_String&)  throw(B_TypeMismatch, B_InvalidArgument, B_Overflow);
DLL_DECL B_Double  B_Pow(const B_String&,   const B_Boolean&) throw(B_TypeMismatch);
DLL_DECL B_Double  B_Pow(const B_Boolean&,  const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Double  B_Pow(const B_Empty&,    const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Double  B_Pow(const B_String&,   const B_Empty&)   throw(B_TypeMismatch);

DLL_DECL B_Double   B_Pow(const B_Byte&,     const B_String&)   throw (B_TypeMismatch, B_InvalidArgument, B_Overflow);
DLL_DECL B_Double   B_Pow(const B_String&,   const B_Byte&)     throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Double   B_Pow(const B_Integer&,  const B_String&)   throw (B_TypeMismatch, B_InvalidArgument, B_Overflow);
DLL_DECL B_Double   B_Pow(const B_String&,   const B_Integer&)  throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Double   B_Pow(const B_Long&,     const B_String&)   throw (B_TypeMismatch, B_InvalidArgument, B_Overflow);
DLL_DECL B_Double   B_Pow(const B_String&,   const B_Long&)     throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Double   B_Pow(const B_Single&,   const B_String&)   throw (B_TypeMismatch, B_InvalidArgument, B_Overflow);
DLL_DECL B_Double   B_Pow(const B_String&,   const B_Single&)   throw (B_TypeMismatch, B_InvalidArgument, B_Overflow);
DLL_DECL B_Double   B_Pow(const B_Double&,   const B_String&)   throw (B_TypeMismatch, B_InvalidArgument, B_Overflow);
DLL_DECL B_Double   B_Pow(const B_String&,   const B_Double&)   throw (B_TypeMismatch, B_InvalidArgument, B_Overflow);
DLL_DECL B_Double   B_Pow(const B_Currency&, const B_String&)   throw (B_TypeMismatch, B_InvalidArgument, B_Overflow); 
DLL_DECL B_Double   B_Pow(const B_String&,   const B_Currency&) throw (B_TypeMismatch, B_InvalidArgument, B_Overflow);

#else // B_VB_COMPATIBLE
DLL_DECL B_Dbl  B_Pow(const B_String&,   const B_String&)   throw (B_TypeMismatch, B_InvalidArgument, B_Overflow);
DLL_DECL B_Dbl  B_Pow(const B_String&,   const B_Boolean&)  throw (B_TypeMismatch);
DLL_DECL B_Dbl  B_Pow(const B_Boolean&,  const B_String&)   throw (B_TypeMismatch);
DLL_DECL B_Dbl  B_Pow(const B_Empty&,    const B_String&)   throw (B_TypeMismatch);
DLL_DECL B_Dbl  B_Pow(const B_String&,   const B_Empty&)    throw (B_TypeMismatch);
DLL_DECL B_Dbl  B_Pow(const B_Currency&, const B_String&)   throw (B_TypeMismatch, B_InvalidArgument, B_Overflow); 
DLL_DECL B_Dbl  B_Pow(const B_String&,   const B_Currency&) throw (B_TypeMismatch, B_InvalidArgument, B_Overflow);

#endif // B_VB_COMPATIBLE
DLL_DECL B_Dbl   B_Pow(const B_Int,     const B_String&)  throw (B_TypeMismatch, B_InvalidArgument, B_Overflow);
DLL_DECL B_Dbl   B_Pow(const B_String&, const B_Int)      throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Dbl   B_Pow(const B_Lng,     const B_String&)  throw (B_TypeMismatch, B_InvalidArgument, B_Overflow);
DLL_DECL B_Dbl   B_Pow(const B_String&, const B_Lng)      throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Dbl   B_Pow(const B_Flt,     const B_String&)  throw (B_TypeMismatch, B_InvalidArgument, B_Overflow);
DLL_DECL B_Dbl   B_Pow(const B_String&, const B_Flt)      throw (B_TypeMismatch, B_InvalidArgument, B_Overflow);
DLL_DECL B_Dbl   B_Pow(const B_Dbl,     const B_String&)  throw (B_TypeMismatch, B_InvalidArgument, B_Overflow);
DLL_DECL B_Dbl   B_Pow(const B_String&, const B_Dbl)      throw (B_TypeMismatch, B_InvalidArgument, B_Overflow);


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Bei Strings sind nur Zahlstrings erlaubt (auch keine Wahrheitswertstrings) sonst LZF(13).
DLL_DECL B_Null operator&& (const B_Null&,     const B_String&)  throw(B_TypeMismatch, B_Overflow);
DLL_DECL B_Null operator&& (const B_String&,   const B_Null&)    throw(B_TypeMismatch, B_Overflow);

#ifdef B_VB_COMPATIBLE
DLL_DECL B_Long operator&& (const B_String&,   const B_String&)  throw(B_TypeMismatch, B_Overflow);
DLL_DECL B_Long operator&& (const B_String&,   const B_Boolean&) throw(B_TypeMismatch, B_Overflow);
DLL_DECL B_Long operator&& (const B_Boolean&,  const B_String&)  throw(B_TypeMismatch, B_Overflow);
DLL_DECL B_Long operator&& (const B_Empty&,    const B_String&)  throw(B_TypeMismatch, B_Overflow);
DLL_DECL B_Long operator&& (const B_String&,   const B_Empty&)   throw(B_TypeMismatch, B_Overflow);

DLL_DECL B_Long   operator&& (const B_Byte&,     const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator&& (const B_String&,   const B_Byte&)     throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator&& (const B_Integer&,  const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator&& (const B_String&,   const B_Integer&)  throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator&& (const B_Long&,     const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator&& (const B_String&,   const B_Long&)     throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator&& (const B_Single&,   const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator&& (const B_String&,   const B_Single&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator&& (const B_Double&,   const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator&& (const B_String&,   const B_Double&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator&& (const B_Currency&, const B_String&)   throw (B_TypeMismatch, B_Overflow); 
DLL_DECL B_Long   operator&& (const B_String&,   const B_Currency&) throw (B_TypeMismatch, B_Overflow);

#else // B_VB_COMPATIBLE
DLL_DECL B_Lng operator&& (const B_String&,   const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng operator&& (const B_String&,   const B_Boolean&)  throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng operator&& (const B_Boolean&,  const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng operator&& (const B_Empty&,    const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng operator&& (const B_String&,   const B_Empty&)    throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng operator&& (const B_Currency&, const B_String&)   throw (B_TypeMismatch, B_Overflow); 
DLL_DECL B_Lng operator&& (const B_String&,   const B_Currency&) throw (B_TypeMismatch, B_Overflow);

#endif // B_VB_COMPATIBLE
DLL_DECL B_Lng   operator&& (const B_Int,     const B_String&)  throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng   operator&& (const B_String&, const B_Int)      throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng   operator&& (const B_Lng,     const B_String&)  throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng   operator&& (const B_String&, const B_Lng)      throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng   operator&& (const B_Flt,     const B_String&)  throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng   operator&& (const B_String&, const B_Flt)      throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng   operator&& (const B_Dbl,     const B_String&)  throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng   operator&& (const B_String&, const B_Dbl)      throw (B_TypeMismatch, B_Overflow);


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Bei Strings sind nur Zahlstrings erlaubt (auch keine Wahrheitswertstrings) sonst LZF(13).
#ifdef B_VB_COMPATIBLE
DLL_DECL B_Long operator|| (const B_String&,   const B_String&)  throw(B_TypeMismatch, B_Overflow);
DLL_DECL B_Long operator|| (const B_Boolean&,  const B_String&)  throw(B_TypeMismatch, B_Overflow);
DLL_DECL B_Long operator|| (const B_String&,   const B_Boolean&) throw(B_TypeMismatch, B_Overflow);
DLL_DECL B_Long operator|| (const B_Empty&,    const B_String&)  throw(B_TypeMismatch, B_Overflow);
DLL_DECL B_Long operator|| (const B_String&,   const B_Empty&)   throw(B_TypeMismatch, B_Overflow);
DLL_DECL B_Long operator|| (const B_Null&,     const B_String&)  throw(B_TypeMismatch, B_Overflow);
DLL_DECL B_Long operator|| (const B_String&,   const B_Null&)    throw(B_TypeMismatch, B_Overflow);

DLL_DECL B_Long   operator|| (const B_Byte&,     const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator|| (const B_String&,   const B_Byte&)     throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator|| (const B_Integer&,  const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator|| (const B_String&,   const B_Integer&)  throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator|| (const B_Long&,     const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator|| (const B_String&,   const B_Long&)     throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator|| (const B_Single&,   const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator|| (const B_String&,   const B_Single&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator|| (const B_Double&,   const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator|| (const B_String&,   const B_Double&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator|| (const B_Currency&, const B_String&)   throw (B_TypeMismatch, B_Overflow); 
DLL_DECL B_Long   operator|| (const B_String&,   const B_Currency&) throw (B_TypeMismatch, B_Overflow);

#else // B_VB_COMPATIBLE
DLL_DECL B_Lng operator|| (const B_String&,   const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng operator|| (const B_Boolean&,  const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng operator|| (const B_String&,   const B_Boolean&)  throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng operator|| (const B_Empty&,    const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng operator|| (const B_String&,   const B_Empty&)    throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng operator|| (const B_Null&,     const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng operator|| (const B_String&,   const B_Null&)     throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng operator|| (const B_Currency&, const B_String&)   throw (B_TypeMismatch, B_Overflow); 
DLL_DECL B_Lng operator|| (const B_String&,   const B_Currency&) throw (B_TypeMismatch, B_Overflow);

#endif // B_VB_COMPATIBLE
DLL_DECL B_Lng   operator|| (const B_Int,      const B_String&)  throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng   operator|| (const B_String&,  const B_Int)      throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng   operator|| (const B_Lng,      const B_String&)  throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng   operator|| (const B_String&,  const B_Lng)      throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng   operator|| (const B_Flt,      const B_String&)  throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng   operator|| (const B_String&,  const B_Flt)      throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng   operator|| (const B_Dbl,      const B_String&)  throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng   operator|| (const B_String&,  const B_Dbl)      throw (B_TypeMismatch, B_Overflow);


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Bei Strings sind nur Zahlstrings erlaubt (auch keine Wahrheitswertstrings) sonst LZF(13).
DLL_DECL B_Null operator^ (const B_Null&,     const B_String&)  throw(B_TypeMismatch, B_Overflow);
DLL_DECL B_Null operator^ (const B_String&,   const B_Null&)    throw(B_TypeMismatch, B_Overflow);

#ifdef B_VB_COMPATIBLE
DLL_DECL B_Long operator^ (const B_String&,   const B_String&)  throw(B_TypeMismatch, B_Overflow);
DLL_DECL B_Long operator^ (const B_String&,   const B_Boolean&) throw(B_TypeMismatch, B_Overflow);
DLL_DECL B_Long operator^ (const B_Boolean&,  const B_String&)  throw(B_TypeMismatch, B_Overflow);
DLL_DECL B_Long operator^ (const B_Empty&,    const B_String&)  throw(B_TypeMismatch, B_Overflow); 
DLL_DECL B_Long operator^ (const B_String&,   const B_Empty&)   throw(B_TypeMismatch, B_Overflow);

DLL_DECL B_Long   operator^ (const B_Byte&,     const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator^ (const B_String&,   const B_Byte&)     throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator^ (const B_Integer&,  const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator^ (const B_String&,   const B_Integer&)  throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator^ (const B_Long&,     const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator^ (const B_String&,   const B_Long&)     throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator^ (const B_Single&,   const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator^ (const B_String&,   const B_Single&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator^ (const B_Double&,   const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator^ (const B_String&,   const B_Double&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Long   operator^ (const B_Currency&, const B_String&)   throw (B_TypeMismatch, B_Overflow); 
DLL_DECL B_Long   operator^ (const B_String&,   const B_Currency&) throw (B_TypeMismatch, B_Overflow);

#else // B_VB_COMPATIBLE
DLL_DECL B_Lng operator^ (const B_String&,   const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng operator^ (const B_String&,   const B_Boolean&)  throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng operator^ (const B_Boolean&,  const B_String&)   throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng operator^ (const B_Empty&,    const B_String&)   throw (B_TypeMismatch, B_Overflow); 
DLL_DECL B_Lng operator^ (const B_String&,   const B_Empty&)    throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng operator^ (const B_Currency&, const B_String&)   throw (B_TypeMismatch, B_Overflow); 
DLL_DECL B_Lng operator^ (const B_String&,   const B_Currency&) throw (B_TypeMismatch, B_Overflow);

#endif // B_VB_COMPATIBLE
DLL_DECL B_Lng   operator^ (const B_Int,      const B_String&) throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng   operator^ (const B_String&,  const B_Int)     throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng   operator^ (const B_Lng&,     const B_String&) throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng   operator^ (const B_String&,  const B_Lng&)    throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng   operator^ (const B_Flt,      const B_String&) throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng   operator^ (const B_String&,  const B_Flt)     throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng   operator^ (const B_Dbl,      const B_String&) throw (B_TypeMismatch, B_Overflow);
DLL_DECL B_Lng   operator^ (const B_String&,  const B_Dbl)     throw (B_TypeMismatch, B_Overflow);


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Nur wenn zwei B_Strings ist Ergebnisstyp B_String sonst Variant mit Untertyp String
DLL_DECL B_String  operator& (const B_String&,   const B_String&);
DLL_DECL B_String  operator& (B_cCStr,           const B_String&);
DLL_DECL B_String  operator& (const B_String&,   B_cCStr);
//-- null wird wie Empty als LeerString betrachtet
DLL_DECL B_String  operator& (const B_Null&,     const B_String&);
DLL_DECL B_String  operator& (const B_String&,   const B_Null&);
//-- empty wird als Leerstring betrachtet
DLL_DECL B_String  operator& (const B_Empty&,    const B_String&);
DLL_DECL B_String  operator& (const B_String&,   const B_Empty&);
//-- Boolean wird in 'True' oder 'False' String konvertiert
//   Nicht verwecheln mit Print das Boolean Werte in der jeweiligen Landesprache ausgegeben. z.B in Deutschland Wahr/Falsch
//                                                                                               in Englisch    True/False  
DLL_DECL B_String  operator& (const B_Boolean&,  const B_String&);
DLL_DECL B_String  operator& (const B_String&,   const B_Boolean&);
//-- Zahlen werden bis 2E+15, 2E-16 ausgeschreiben und erst dann in Exponentialschreibweise angegeben

#ifdef B_VB_COMPATIBLE
DLL_DECL B_String  operator& (const B_Byte&,     const B_String&);
DLL_DECL B_String  operator& (const B_String&,   const B_Byte&);
DLL_DECL B_String  operator& (const B_Integer&,  const B_String&);
DLL_DECL B_String  operator& (const B_String&,   const B_Integer&);
DLL_DECL B_String  operator& (const B_Long&,     const B_String&);
DLL_DECL B_String  operator& (const B_String&,   const B_Long&);
DLL_DECL B_String  operator& (const B_Single&,   const B_String&);
DLL_DECL B_String  operator& (const B_String&,   const B_Single&);
DLL_DECL B_String  operator& (const B_Double&,   const B_String&);
DLL_DECL B_String  operator& (const B_String&,   const B_Double&);
#endif
DLL_DECL B_String  operator& (const B_Int,     const B_String&);
DLL_DECL B_String  operator& (const B_String&, const B_Int);
DLL_DECL B_String  operator& (const B_Lng,     const B_String&);
DLL_DECL B_String  operator& (const B_String&, const B_Lng);
DLL_DECL B_String  operator& (const B_Flt,     const B_String&);
DLL_DECL B_String  operator& (const B_String&, const B_Flt);
DLL_DECL B_String  operator& (const B_Dbl,     const B_String&);
DLL_DECL B_String  operator& (const B_String&, const B_Dbl);

DLL_DECL B_String  operator& (const B_Currency&, const B_String&);
DLL_DECL B_String  operator& (const B_String&,   const B_Currency&);
//-- Date wir din Laenderspezifisches Datenformat gebracht in Deu z.B. 14.12.96
// DLL_DECL B_String  operator& (const B_Date&,     const B_String&);
// DLL_DECL B_String  operator& (const B_String&,   const B_Date&);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- Zahl und String der kein reiner Zahlstring ist -> Error LZF(13)  in VB30/40
//   Vergleichsoperatoren gehen nur bei Variant/String  String/String 
//   Numerische Typen koennen nur mit rein numer. strings vgl. werden ab VB40. In VB30 fuehren sie zu 
//   Laufzeitfehlern -> Datentypen Unvertraeglich
//   Variant<->String gehen immer und liefern B_Boolean in VB40, in VB30 B_Integer.
//   Bei Variant als Null oder Error liefern VB30/VB40 Null zurueck -> Aus diesem Grund gegben alle Vgl.OP
//   Variant zurueck. (Eine Aufsplittung in VB30 und VB40 mit unterschiedlichen Reuckgabewerten (B_Integer/
//   B_Boolean) ist nicht moeglich da ja beide auch B_Null zurueckliefern koennen. -> Rueckagbewerte nicht
//   ueberladbar
DLL_DECL B_Boolean operator== (const B_String&, const B_String&);
DLL_DECL B_Boolean operator== (		 B_cCStr,   const B_String&);
DLL_DECL B_Boolean operator== (const B_String&,		  B_cCStr );

#ifdef THALESPLUS
// CT090197 Operatoren zum Vergleich mit B_TString
DLL_DECL B_Boolean operator== (const B_TStringStruct, const B_TStringStruct);
DLL_DECL B_Boolean operator== (const B_String&,		  const B_TStringStruct);
DLL_DECL B_Boolean operator== (const B_TStringStruct, const B_String&);
DLL_DECL B_Boolean operator== (		 B_cCStr,		  const B_TStringStruct);
DLL_DECL B_Boolean operator== (const B_TStringStruct, 		B_cCStr);
#endif	// THALESPLUS

DLL_DECL B_Boolean operator== (const B_String&,   const B_Boolean&)  throw(B_TypeMismatch);
DLL_DECL B_Boolean operator== (const B_Boolean&,  const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean operator== (const B_String&,   const B_Empty&);
DLL_DECL B_Boolean operator== (const B_Empty&,    const B_String&);
DLL_DECL B_Null    operator== (const B_String&,   const B_Null&);
DLL_DECL B_Null    operator== (const B_Null&,     const B_String&);

#ifdef B_VB_COMPATIBLE
DLL_DECL B_Boolean   operator== (const B_Byte&,     const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator== (const B_String&,   const B_Byte&)     throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator== (const B_Integer&,  const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator== (const B_String&,   const B_Integer&)  throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator== (const B_Long&,     const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator== (const B_String&,   const B_Long&)     throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator== (const B_Single&,   const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator== (const B_String&,   const B_Single&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator== (const B_Double&,   const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator== (const B_String&,   const B_Double&)   throw(B_TypeMismatch);
#endif // B_VB_COMPATIBLE
DLL_DECL B_Boolean   operator== (const B_Int,     const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator== (const B_String&, const B_Int)      throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator== (const B_Lng,     const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator== (const B_String&, const B_Lng)      throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator== (const B_Flt,     const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator== (const B_String&, const B_Flt)      throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator== (const B_Dbl,     const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator== (const B_String&, const B_Dbl)      throw(B_TypeMismatch);

DLL_DECL B_Boolean   operator== (const B_Currency&, const B_String&)   throw(B_TypeMismatch); 
DLL_DECL B_Boolean   operator== (const B_String&,   const B_Currency&) throw(B_TypeMismatch);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//-- B_Variant operator==(const B_String&,   const B_Variant&);
//   B_Variant operator==(const B_Variant&,  const B_String&);
//   Numerische Variablen und Strings werden in VB40 vergl. wenn String ein reiner Zahlstring ist
//   Wenn der String kein Zahlstring ist -> Laufzeitfehler Typen Unvertraeglich
//   B_Char, B_Short, B_Int durch Integrale Promotion in B_Long. Weniger Rechenzeit als Methodsaufruf
//   B_Byte, B_Integer genauso, dies sit zwar weniger Flexibel in Bezug auf Austauschbarkeit von
//   B_Integer=int in eine eigenstaendige Klasse jedoch ist der Perfomancegewinn so besser
//   Erweiterte Integerklassen werden als B_PInteger= Precision Integer zur Verfuegung gestellt
//   (-> Stack) oder Inlinefunktion die intern Castet

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Kann auf Boolean nicht verzichten da z.B. nicht False=0 < Zahlstring"123" usw. 
//VB30:   "0"  = False                      VB40:    "0"     = False
//        "-1" = True                                "-1"    = True  
//                                                   "False" = False
//                                                   "123"   = True
//                                                   "-123"  = True
// noch testen auf != == !!!!!!!!!!!!!!!!!!!
DLL_DECL B_Boolean operator!= (const B_String&,   const B_String&);
DLL_DECL B_Boolean operator!= (B_cCStr ,          const B_String&);
DLL_DECL B_Boolean operator!= (const B_String&,   B_cCStr );

#ifdef THALESPLUS
// CT090197 Operatoren zum Vergleich mit B_TString
DLL_DECL B_Boolean operator!= (const B_TStringStruct, const B_TStringStruct);
DLL_DECL B_Boolean operator!= (const B_String&,		  const B_TStringStruct);
DLL_DECL B_Boolean operator!= (const B_TStringStruct, const B_String&);
DLL_DECL B_Boolean operator!= (		 B_cCStr,		  const B_TStringStruct);
DLL_DECL B_Boolean operator!= (const B_TStringStruct, 		B_cCStr);
#endif	// THALESPLUS

DLL_DECL B_Boolean operator!= (const B_String&,   const B_Boolean&)  throw(B_TypeMismatch);
DLL_DECL B_Boolean operator!= (const B_Boolean&,  const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean operator!= (const B_String&,   const B_Empty&);
DLL_DECL B_Boolean operator!= (const B_Empty&,    const B_String&);
DLL_DECL B_Null    operator!= (const B_String&,   const B_Null&);
DLL_DECL B_Null    operator!= (const B_Null&,     const B_String&);
#ifdef B_VB_COMPATIBLE
DLL_DECL B_Boolean   operator!= (const B_Byte&,     const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator!= (const B_String&,   const B_Byte&)     throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator!= (const B_Integer&,  const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator!= (const B_String&,   const B_Integer&)  throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator!= (const B_Long&,     const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator!= (const B_String&,   const B_Long&)     throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator!= (const B_Single&,   const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator!= (const B_String&,   const B_Single&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator!= (const B_Double&,   const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator!= (const B_String&,   const B_Double&)   throw(B_TypeMismatch);
#endif // B_VB_COMPATIBLE
DLL_DECL B_Boolean   operator!= (const B_Int,      const B_String&) throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator!= (const B_String&,  const B_Int)     throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator!= (const B_Lng,      const B_String&) throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator!= (const B_String&,  const B_Lng)     throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator!= (const B_Flt,      const B_String&) throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator!= (const B_String&,  const B_Flt)     throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator!= (const B_Dbl,      const B_String&) throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator!= (const B_String&,  const B_Dbl)     throw(B_TypeMismatch);

DLL_DECL B_Boolean   operator!= (const B_Currency&, const B_String&)   throw(B_TypeMismatch); 
DLL_DECL B_Boolean   operator!= (const B_String&,   const B_Currency&) throw(B_TypeMismatch);

  
DLL_DECL B_Boolean operator<= (const B_String&,   const B_String&);
DLL_DECL B_Boolean operator<= (B_cCStr ,          const B_String&);
DLL_DECL B_Boolean operator<= (const B_String&,   B_cCStr );

#ifdef THALESPLUS
// CT090197 Operatoren zum Vergleich mit B_TString
DLL_DECL B_Boolean operator<= (const B_TStringStruct, const B_TStringStruct);
DLL_DECL B_Boolean operator<= (const B_String&,		  const B_TStringStruct);
DLL_DECL B_Boolean operator<= (const B_TStringStruct, const B_String&);
DLL_DECL B_Boolean operator<= (		 B_cCStr,		  const B_TStringStruct);
DLL_DECL B_Boolean operator<= (const B_TStringStruct, 		B_cCStr);
#endif	// THALESPLUS

DLL_DECL B_Boolean operator<= (const B_String&,   const B_Boolean&) throw(B_TypeMismatch);
DLL_DECL B_Boolean operator<= (const B_Boolean&,  const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Boolean operator<= (const B_String&,   const B_Empty&);
DLL_DECL B_Boolean operator<= (const B_Empty&,    const B_String&);
DLL_DECL B_Null    operator<= (const B_String&,   const B_Null&);
DLL_DECL B_Null    operator<= (const B_Null&,     const B_String&);

#ifdef B_VB_COMPATIBLE
DLL_DECL B_Boolean   operator<= (const B_Byte&,     const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator<= (const B_String&,   const B_Byte&)     throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator<= (const B_Integer&,  const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator<= (const B_String&,   const B_Integer&)  throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator<= (const B_Long&,     const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator<= (const B_String&,   const B_Long&)     throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator<= (const B_Single&,   const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator<= (const B_String&,   const B_Single&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator<= (const B_Double&,   const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator<= (const B_String&,   const B_Double&)   throw(B_TypeMismatch);
#endif 
DLL_DECL B_Boolean   operator<= (const B_Int,     const B_String&) throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator<= (const B_String&, const B_Int)     throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator<= (const B_Lng,     const B_String&) throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator<= (const B_String&, const B_Lng)     throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator<= (const B_Flt,     const B_String&) throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator<= (const B_String&, const B_Flt)     throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator<= (const B_Dbl,     const B_String&) throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator<= (const B_String&, const B_Dbl)     throw(B_TypeMismatch);

DLL_DECL B_Boolean   operator<= (const B_Currency&, const B_String&)   throw(B_TypeMismatch); 
DLL_DECL B_Boolean   operator<= (const B_String&,   const B_Currency&) throw(B_TypeMismatch);


//VB30:   "-123" < False                    VB40:    "123"   < False = True
//        "-1"   < False                             "-123"  < False = True
//                                                   "False" < False = False
//                                                   "-1"    < False = True
//                                                   "1"     < False = True
// sieht nach Zeichenketenvergleich aus und nicht nach Zahlinterpretation ist auch so
// jeder boolsche Wert wird in "Truw" oder "False" String umkonvertiert
// deshalb geht auch kein str1 mit boolwert im Vergleich mit Zahlstrings
DLL_DECL B_Boolean operator< (const B_String&,   const B_String&);
DLL_DECL B_Boolean operator< (B_cCStr,           const B_String&);
DLL_DECL B_Boolean operator< (const B_String&,   B_cCStr );

#ifdef THALESPLUS
// CT090197 Operatoren zum Vergleich mit B_TString
DLL_DECL B_Boolean operator< (const B_TStringStruct, const B_TStringStruct);
DLL_DECL B_Boolean operator< (const B_String&,		 const B_TStringStruct);
DLL_DECL B_Boolean operator< (const B_TStringStruct, const B_String&);
DLL_DECL B_Boolean operator< (		B_cCStr,		 const B_TStringStruct);
DLL_DECL B_Boolean operator< (const B_TStringStruct,	   B_cCStr);
#endif	// THALESPLUS

DLL_DECL B_Boolean operator< (const B_Boolean&,  const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Boolean operator< (const B_String&,   const B_Boolean&) throw(B_TypeMismatch);
DLL_DECL B_Boolean operator< (const B_Empty&,    const B_String&);
DLL_DECL B_Boolean operator< (const B_String&,   const B_Empty&);
DLL_DECL B_Null    operator< (const B_Null&,     const B_String&);
DLL_DECL B_Null    operator< (const B_String&,   const B_Null&);
#ifdef B_VB_COMPATIBLE
DLL_DECL B_Boolean   operator< (const B_Byte&,     const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator< (const B_String&,   const B_Byte&)     throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator< (const B_Integer&,  const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator< (const B_String&,   const B_Integer&)  throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator< (const B_Long&,     const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator< (const B_String&,   const B_Long&)     throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator< (const B_Single&,   const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator< (const B_String&,   const B_Single&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator< (const B_Double&,   const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator< (const B_String&,   const B_Double&)   throw(B_TypeMismatch);
#endif // B_VB_COMPATIBLE
DLL_DECL B_Boolean   operator< (const B_Int,      const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator< (const B_String&,  const B_Int)      throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator< (const B_Lng,      const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator< (const B_String&,  const B_Lng)      throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator< (const B_Flt,      const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator< (const B_String&,  const B_Flt)      throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator< (const B_Dbl,      const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator< (const B_String&,  const B_Dbl)      throw(B_TypeMismatch);

DLL_DECL B_Boolean   operator< (const B_Currency&, const B_String&)   throw(B_TypeMismatch); 
DLL_DECL B_Boolean   operator< (const B_String&,   const B_Currency&) throw(B_TypeMismatch);


DLL_DECL B_Boolean operator>= (const B_String&,   const B_String&);
DLL_DECL B_Boolean operator>= (B_cCStr ,          const B_String&);
DLL_DECL B_Boolean operator>= (const B_String&,   B_cCStr );

#ifdef THALESPLUS
// CT090197 Operatoren zum Vergleich mit B_TString
DLL_DECL B_Boolean operator>= (const B_TStringStruct, const B_TStringStruct);
DLL_DECL B_Boolean operator>= (const B_String&,		  const B_TStringStruct);
DLL_DECL B_Boolean operator>= (const B_TStringStruct, const B_String&);
DLL_DECL B_Boolean operator>= (		 B_cCStr,		  const B_TStringStruct);
DLL_DECL B_Boolean operator>= (const B_TStringStruct, 		B_cCStr);
#endif	// THALESPLUS

DLL_DECL B_Boolean operator>= (const B_String&,   const B_Boolean&) throw(B_TypeMismatch);
DLL_DECL B_Boolean operator>= (const B_Boolean&,  const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Boolean operator>= (const B_String&,   const B_Empty&);
DLL_DECL B_Boolean operator>= (const B_Empty&,    const B_String&);
DLL_DECL B_Null    operator>= (const B_Null&,     const B_String&);
DLL_DECL B_Null    operator>= (const B_String&,   const B_Null&);
#ifdef B_VB_COMPATIBLE
DLL_DECL B_Boolean   operator>= (const B_Byte&,     const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator>= (const B_String&,   const B_Byte&)     throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator>= (const B_Integer&,  const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator>= (const B_String&,   const B_Integer&)  throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator>= (const B_Long&,     const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator>= (const B_String&,   const B_Long&)     throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator>= (const B_Single&,   const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator>= (const B_String&,   const B_Single&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator>= (const B_Double&,   const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator>= (const B_String&,   const B_Double&)   throw(B_TypeMismatch);
#endif // B_VB_COMPATIBLE
DLL_DECL B_Boolean   operator>= (const B_Int,     const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator>= (const B_String&, const B_Int)      throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator>= (const B_Lng,     const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator>= (const B_String&, const B_Lng)      throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator>= (const B_Flt,     const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator>= (const B_String&, const B_Flt)      throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator>= (const B_Dbl,     const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator>= (const B_String&, const B_Dbl)      throw(B_TypeMismatch);

DLL_DECL B_Boolean   operator>= (const B_Currency&, const B_String&)   throw(B_TypeMismatch); 
DLL_DECL B_Boolean   operator>= (const B_String&,   const B_Currency&) throw(B_TypeMismatch);


DLL_DECL B_Boolean operator> (const B_String&,   const B_String&);
DLL_DECL B_Boolean operator> (B_cCStr ,          const B_String&);
DLL_DECL B_Boolean operator> (const B_String&,   B_cCStr );

#ifdef THALESPLUS
// CT090197 Operatoren zum Vergleich mit B_TString
DLL_DECL B_Boolean operator> (const B_TStringStruct, const B_TStringStruct);
DLL_DECL B_Boolean operator> (const B_String&,		 const B_TStringStruct);
DLL_DECL B_Boolean operator> (const B_TStringStruct, const B_String&);
DLL_DECL B_Boolean operator> (		B_cCStr,		 const B_TStringStruct);
DLL_DECL B_Boolean operator> (const B_TStringStruct, 	   B_cCStr);
#endif	// THALESPLUS

DLL_DECL B_Boolean operator> (const B_Boolean&,  const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Boolean operator> (const B_String&,   const B_Boolean&) throw(B_TypeMismatch);
DLL_DECL B_Boolean operator> (const B_Empty&,    const B_String&);
DLL_DECL B_Boolean operator> (const B_String&,   const B_Empty&);
DLL_DECL B_Null    operator> (const B_Null&,     const B_String&);
DLL_DECL B_Null    operator> (const B_String&,   const B_Null&);
//VB30:   "123"   > False                   VB40:    "0" > True
//        "-123"  > False
//        "False" > False
#ifdef B_VB_COMPATIBLE
DLL_DECL B_Boolean   operator> (const B_Byte&,     const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator> (const B_String&,   const B_Byte&)     throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator> (const B_Integer&,  const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator> (const B_String&,   const B_Integer&)  throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator> (const B_Long&,     const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator> (const B_String&,   const B_Long&)     throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator> (const B_Single&,   const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator> (const B_String&,   const B_Single&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator> (const B_Double&,   const B_String&)   throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator> (const B_String&,   const B_Double&)   throw(B_TypeMismatch);
#endif // B_VB_COMPATIBLE
DLL_DECL B_Boolean   operator> (const B_Int,     const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator> (const B_String&, const B_Int)      throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator> (const B_Lng,     const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator> (const B_String&, const B_Lng)      throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator> (const B_Flt,     const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator> (const B_String&, const B_Flt)      throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator> (const B_Dbl,     const B_String&)  throw(B_TypeMismatch);
DLL_DECL B_Boolean   operator> (const B_String&, const B_Dbl)      throw(B_TypeMismatch);

DLL_DECL B_Boolean   operator> (const B_Currency&, const B_String&)   throw(B_TypeMismatch); 
DLL_DECL B_Boolean   operator> (const B_String&,   const B_Currency&) throw(B_TypeMismatch);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Streamoperatoren
DLL_DECL ostream& operator<<(ostream& ostr, const B_String& rhs);
DLL_DECL istream& operator>>(istream& istr, B_String& rhs);


//================================ Inlinefunktionen =========================================================
//
#if defined _DEBUG || defined B_VB_CONTRACT
  #define B_NOINLINE
#else
  #undef B_NOINLINE
#endif

#ifndef B_NOINLINE                 // festlegen wenn Debuger keine Inlines debuggen kann
  #define B_INLINE inline
  #ifndef  BI_STR_HPP
    #include "bi_str.hpp"
  #endif
#endif

//===========================================================================================================
//================================ End Of Header ============================================================
#endif // BC_STR_HPP


