/*************************************************************
* Projekt:	VBNC				
* Modul:	BC_TARR.HPP	Klasse	Array in Typen
* Autor:	Claus Tucher		CiceroSoft GmbH
* Datum:	26.11.1996
**/

#ifndef	BC_TARR_HPP
# define BC_TARR_HPP

/*************************************************************
* I N C L U D E
*/

#ifndef BD_INTYP_HPP       
  #include "bd_intyp.hpp"       // alias der Standardatentypen
#endif


/*************************************************************
* D E F I N E
*/


/*************************************************************
* F U N K T I O N E N
* M O D U L S C H N I T T S T E L L E
*/


/*************************************************************
* F U N K T I O N E N
* M O D U L S C H N I T T S T E L L E
* C O D E
*/

/*************************************************************
* C L A S S E S
*/
// Dimention 1 -----------------------------------------------
template <class T, int low1D, int up1D>
class  B_T1DArray
{
public:
	T	a1D[(up1D - low1D) + 1];
public:
	// Konstruktor
	B_T1DArray() {};

	// Operatoren
	B_T1DArray& operator=  (B_T1DArray& rhs);
	T&			operator[] (B_Lng       index);
	const T&	operator[] (B_Lng       index) const;

	// B_Array kompatibler Indexzugriff
	T& gA(B_Lng dims, B_Lng index);

private:
	// Ueberpruefen der Arraygrenzen
	B_Shrt checkBoundery(B_Lng index);
};

// Dimention 2 -----------------------------------------------
template <class T, int low1D, int up1D, int low2D, int up2D>
class B_T2DArray
{
public:
	T	a2D[(up1D - low1D) + 1][(up2D - low2D) + 1];
public:
	// Konstruktor
	B_T2DArray() {};

	// Operatoren
	B_T2DArray& operator=  (B_T2DArray& rhs );
#if 0	//ab.. 14.5.97 wird ueber gA erledigt
	T&			operator[] (B_Lng index, B_Lng index2D);
	const T&	operator[] (B_Lng index, B_Lng index2D) const;
#endif

	// B_Array kompatibler Indexzugriff
	T& gA(B_Lng dims, B_Lng index, B_Lng index2D);

private:
	// Ueberpruefen der Arraygrenzen
	B_Shrt checkBoundery(B_Lng index, B_Lng index2D);
};

// Dimention 3 -----------------------------------------------
template <class T, int low1D, int up1D, int low2D, int up2D, int low3D, int up3D>
class B_T3DArray
{
public:
	T	a3D[(up1D - low1D) + 1][(up2D - low2D) + 1][(up3D - low3D) + 1];
public:
	// Konstruktor
	B_T3DArray() {};

	// Operatoren
	B_T3DArray& operator=  (B_T3DArray& rhs );
#if 0	//ab.. 14.5.97 wird ueber gA erledigt
	T&			operator[] (B_Lng index, B_Lng index2D, B_Lng index3D);
	const T&	operator[] (B_Lng index, B_Lng index2D, B_Lng index3D) const;
#endif

	// B_Array kompatibler Indexzugriff
	T& gA(B_Lng dims, B_Lng index, B_Lng index2D, B_Lng index3D);

private:
	// Ueberpruefen der Arraygrenzen
	B_Shrt checkBoundery(B_Lng index, B_Lng index2D, B_Lng index3D);
};


#ifndef  BI_TARR_HPP
# include "bi_tarr.hpp"
#endif



#endif	// BC_TARR_HPP

/* E O F */