/*************************************************************
* Projekt:	VBNC				
* Modul:	BC_TSTR.HPP	Klasse	Strings in Typen
* Autor:	Claus Tucher		CiceroSoft GmbH
* Datum:	26.11.1996
**/

#ifndef BC_TSTR_HPP
# define BC_TSTR_HPP

/*************************************************************
* I N C L U D E
*/
#ifndef BD_INTYP_HPP       
  #include "bd_intyp.hpp"       // alias der Standardatentypen
#endif

#ifndef BC_BOOL_HPP
  #include "bc_bool.hpp"
#endif

/*************************************************************
* D E F I N E
*/


/*************************************************************
* F U N K T I O N E N
* M O D U L S C H N I T T S T E L L E
*/

class B_String;
class B_TStringStruct;

/*************************************************************
* C L A S S E S
*/

template <int groesse>
class  B_TString 
{
public:
	// Datum Member
	char  value[groesse]; 

public:
	// Konstruktor
	B_TString();
	B_TString(		B_cCStr			 s);
	B_TString(const B_TStringStruct& s);

	// Stringmethoden
	B_Lng len() const;

	// Zuweisugsoperatoren
	B_TString<groesse>& operator=(const B_String&       rhs);
	B_TString<groesse>& operator=(const B_TStringStruct rhs);
	B_TString<groesse>& operator=(		B_cCStr         rhs);

	// CT060197	alle Verkettungen haben einen B_String als Ergebnis
	//			verlagert nach (BC/BI)_STR.HPP

	// Vergleichsoperatoren
	
	// CT100197 alle Vergleichsoperatoren verwenden intern die 
	//			B_String-Methode "compare()" und sind deshalb nach
	//			(BC/BI)_STR.HPP verlagert
	// Konvertierungsoperatoren
	operator B_TStringStruct() const;
	//operator Bstr() const;


private:
	// Ueberlaufpruefung
	B_Shrt checkOverflow(const B_String&		s);
	B_Shrt checkOverflow(	   B_cCStr			s);
	B_Shrt checkOverflow(const B_TStringStruct& s);

	friend class B_String;
	friend class B_TStringStruct;
};

#if  !defined  BI_TSTR_HPP && defined BI_TSTR_HPP_EINBINDEN
# include "bi_tstr.hpp"
#endif


#endif	// BC_TSTR_HPP

/* E O F */