#ifndef BD_LIB_HPP
#define BD_LIB_HPP
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Project:                 VB nach C/C++ Konverter Klassenbibliothek
// Modul:                   Anpassungen der Klassenbibliothek an diverse OS und Compiler
// Filename:                bd_lib.cpp
// Version:                 0.0
// Status:                  beta
//
// Copyright:               (C) 1995
//                          Cicerosoft GmbH
//                          Ballweilerstr. 7
//                          66399 Erfweiler-Ehlingen
//
// Operation System(s):     Win95 
// Compiler:                VC++ 4.1 
//
// Author:                  Jochen Diener JD
// Creation Date::          JD 01.06.96
// Last Modification:       JD 01.06.96
//
// Description:             Beinhaltet alle #define und Compileroptionsschalter die fuer einen
//                          bestimmten Compiler oder Betriebsystversion benoetigt werden
//
// Dependencies:            bd_intyp.hpp  -> Typdefinitonen
//
// Remarks:                
//
// Revision(s):
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Alle Warnings bezueglich der C++ Exception Specification werden ignoriert.
// Da VC++ bei Konstruktoren diese nicht annimmt werden sie nur als Zeilenkommentar angegeben
// SC++ akzeptiert und kontrolliert sie
#pragma warning( disable : 4290 ) 

#define B_WIN95
#undef B_WINNT
#undef B_WIN31
#undef B_OS2
#undef B_OS2WARP
#undef B_UNIX
//#define B_WINNT
//#define B_WIN31
//#define B_OS2
//#define B_OS2WARP
//#define B_UNIX

//-- Zur Unterscheidung der beiden Libversionenen
//   Anzugeben als Linkerschalter
// #define B_KONVERTER_LIB 
// #undef  B_ENHANCED_LIB

#ifdef THALESPLUS	//ab.. 21.3.97 wird bei Thalesplus nicht benoetigt
#undef B_VB_VERSION_40
#undef B_VB_VERSION_30
#else
//-- Zur Unterscheidung der VB Versionen
#define B_VB_VERSION_40
#undef  B_VB_VERSION_30
#endif
//-- Option Compare -> muss konverter setzten da er Projektfile ausliest
//-- Konverter muss nur dann B_OPTION_COMPARE setzen wenn 1 ist
#ifdef B_VB_COMPATIBLE
  #define B_OPTION_COMPARE B_Long(0L, B_explicit)  // 0 == default
#else
  #define B_OPTION_COMPARE 0L
#endif

//-- DLL Server oder Client, speziell fuer __declspec()
// #define B_UDLL // use DLL == Client
// #define B_BDLL // build Dll == Server
// DLL-Defines

#ifdef B_BDLL
  #define DLL_DECL __declspec(dllexport) // erstellen einer DLL
#elif defined B_UDLL
  // Generic Strings sind 8Byte gross zur emulation da ja Header nicht mitgeliefert werden koennen
  // diese Werte sind sau unportabel deshalb auf jedem System testen !!!!!!!!!!!!!!!!!!
  //class dummyString {private: char c1;char c2; char c3; char c4; char c5; char c6; char c7; char c8;};
  //#define G_String dummyString
  // fuer gstring.h und alle weitern einfach fuer Anwender leere Header mitliefern
  #define DLL_DECL __declspec(dllimport) // verwenden der DLL
#else
  #define DLL_DECL // keine DLL sondern statisch binden
#endif

// Default Message fuer B_local.messages.get()
#define DFLT_MESSAGE ""
// DefaultMEssge fuer Exception whatArg argument da an Standardmeldung angehaengt wird.
#define DFLT_EH_MESSAGE ""

// Ressourcen sind hier die Stringtable IDs fuer die Language-Ressourcen-Dlls
// diese wird auch fuer die DLLs verwendet
#include "resource.h"   

// Wer nicht hoeren will muss fuehlen, auf die rauhe in die Windowsinterna eingegriffen
typedef unsigned long LCID;
#define _LCID_DEFINED

#include <windows.h>
// #include <ole.h>
// #include <oleauto.h>

// Die neuen C++ Casts emulieren wenn der Compiler sie noch nicht unterstuetzt
#ifdef SYMANTEC_CPP
       // in Version 721 noch nicht verfuegbar
       #define static_cast(TYPE, EXPR)      (TYPE)(EXPR)
       #define const_cast(TYPE, EXPR)       (TYPE)(EXPR)
       #define reinterpret_cast(TYPE, EXPR) (TYPE)(EXPR) 
       // dynamic_cast sind nicht emulierbar auf diese Weise da sie einen cast auf die Basisklasse
       // durchfuehren
#elif defined MICROSOFT_CPP
       // ab V4.1 sind die Ansi-Casts enthalten
#elif defined BORLAND_CPP
       // ab V5.0 sind die Ansi-Casts enthalten
#endif        

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
// EOF: bd_lib.hpp
#endif BD_LIB_HPP