/*
 * Copyright (C) 1994-2000 Cicero ISS
 *
 * Releaseversion: 2.0 3.8.95 Stefan Brueck
 *
 * Versionsgeschichte:
 * sb 3.8.95: globales define BNC_GMEM_ART fuer Art der Speicherallokation
 * --- BNC_RELEASE 21 ---
 * ct 3.7.96: Neue Definitionen fuer BNC-RELEASE abh. Programmausfuehrung
 * --- BNC_RELEASE 20 ---
 * ov ??.11.94 / sb 26.11.94: BNC_xxx statt xxx bei Namenskonflikten mit Makros
 *         aus WINDOWS.H
 * --- BNC_RELEASE 13 ---
 * 1.11.94 Ausgabe der Releaseversion 1.0, lokale Aenderungen gegen die zentral
 *         gepflegte Release sind jeweils im Abschnitt 'Aenderungen gegen... '
 *         einzutragen und werden spaeter fuer alle in die Releaseversion ueber-
 *         nommen
 *
 * Aenderungen gegen Releaseversion:

1) ++OV.25.9.95 Anpassungen fuer OS/2
2) ++OV.6.12.95 Anpassungen fuer Win95/NT
3) ++OV.24.1.96 B_gosub() und B_return()
4) ++CT300196 	Define fuer BNC-CVD-Version --> BNC_CVD_VERSION
5) ..CT270396	Bgosubstack[]->j_sp(j_esp) umgestellt auf 'Bstackindex == 1'
6) ..CT270396	Probleme mit dem setjmp()-Aufruf innerhalb des if()
7) ..CT040696	Neuer Variablentyp SHORT
8) ..CT040696	Neue Makros fuer die Statischen Strings in Typen
 *
 */
/* -------------------------------------------------------------------------- */
/* --------------------------- Systemabhaengiger Teil ----------------------- */
/* -------------------------------------------------------------------------- */
#include <setjmp.h>
/********************************
 *            ATARI             *
 ********************************/
#if defined(ATARI)
	#define huge
#endif /* ATARI */

/********************************
 *             MAC              *
 ********************************/
#if defined(MAC)
	#define huge
#endif /* MAC */

/********************************
 *             MSDOS            *
 ********************************/
#if defined(MSDOS)
	#define huge huge

typedef short SHORT;
typedef unsigned short WORD;
typedef long  LONG;
typedef unsigned long DWORD;
typedef char*  LPSTR;

typedef int    BOOL;
typedef unsigned long  HWND;
typedef unsigned long  HINSTANCE;
typedef unsigned long  HANDLE;
typedef unsigned long  HDC;
typedef unsigned long  LOGFONT;
typedef unsigned long  LOGBRUSH;
typedef unsigned long  LOGPEN;
typedef unsigned long  HPEN;
typedef unsigned long  HBITMAP;
typedef unsigned long  HBRUSH;
typedef unsigned long  HFONT;
typedef unsigned long  BITMAP;
typedef unsigned long  TEXTMETRIC;
typedef unsigned long  HMENU;
typedef unsigned long  RECT;

typedef void huge * Mem;

typedef struct {
	 int message;
 } MSG;

#define DLL_DECL
#define BNC_WINAPI
#define BNC_WINAPIV
#define WINAPIV

#define PASCAL

#endif /* MSDOS */

/********************************
 *             OS2              *
 ********************************/
#if defined(OS2)
#if 1 /*ab++ 6.12.95 */
	#ifdef WINDOWS
	 #undef WINDOWS
	#endif
#endif
	#define INCL_PM
	#include <os2.h>
	#include <alert.h>
	#include <io.h>
	#undef  huge
	#undef  BNC_WINAPI
	#undef  BNC_WINAPIV
	#undef  FAR
#if 0
	#undef  PASCAL
#endif
#if 1 /*ab++ 6.12.95 */
	#ifdef WINAPI
		#undef WINAPI
	#endif
	#define WINAPI
#endif
	#define huge
	#if 0 /*ab-- 13.12.95 wegen Definition im naechsten Block */
		#define BNC_WINAPI
		#define BNC_WINAPIV
	#endif
	#define FAR
#if 0
	#define PASCAL
#endif

#if 1 /*ab++ 13.12.95 Kopie aus Windows-Sektion */
		#ifndef  WINAPIV
			#define WINAPIV __cdecl
		#endif
	#if BNC_RELEASE >= 20
		/*
		 * Die Funktionen der Library werden als exportierbar gekennzeichnet
		 */
		#ifdef BNC_DLL
			#define BNC_EXPORT  _export
		#else /* !BNC_DLL */
			#define BNC_EXPORT
		#endif /* BNC_DLL */

		#define BNC_WINAPI    EXPENTRY/*WINAPI BNC_EXPORT*/ /*ab.. 14.12.*/
		#define BNC_WINAPIV   WINAPIV BNC_EXPORT
		#define BNC_GMEM_ART  (GMEM_MOVEABLE|GMEM_ZEROINIT)   /* ..sb 3.8.95 */
	#else /* BNC_RELEASE < 20 */
		#define BNC_WINAPI    WINAPI
		#define BNC_WINAPIV   WINAPIV
		#define BNC_GMEM_ART  (GMEM_FIXED|GMEM_ZEROINIT)
	#endif /* BNC_RELEASE >= 20 */
#endif /*Kopie aus Windows-Sektion */

#if WINDOWS_umdefinieren_fuer_OS2

	typedef unsigned long	MYMSG;
	typedef HAB HINSTANCE ;
	typedef HDC HANDLE;
	typedef char *LPSTR;
#if 1 /*ab++ 6.12.95 */
	typedef long *LPLONG;
	typedef unsigned short *LPWORD;
	typedef const void *HGLOBAL;
#endif
	typedef unsigned long  DWORD;
	typedef unsigned short WORD;
	typedef PRECTL 				LPRECT;
	typedef FONTMETRICS		TEXTMETRIC;
	typedef HANDLE			  HMENU;
	typedef POINTL			  *LPPOINT;
	typedef struct tagRECT
		{
		long top;
		long right;
		long bottom;
		long left;
		} RECT;

  typedef struct {
    long cx;
    long cy;
  } SIZE;

	#define POINT POINTL

	#define ShowWindow(hwnd,mode)           WinShowWindow(hwnd,mode)
	#define GetDC(hwnd)                     WinGetPS(hwnd)
	#define BeginPaint(hwnd,ps)							WinBeginPaint(hwnd,NULLHANDLE,(PRECTL)ps.rect)
	#define ReleaseDC(hwnd,hdc)             WinReleasePS(hdc)
	#define EndPaint(hwnd,ps)								WinEndPaint(hdc)
	/* #define CreateFontIndirect(plf)         GpiCreateFont() ??? */
	#define GetTextMetrics(hdc,tm)          GpiQueryFontMetrics(hdc,sizeof(tm),tm)

	#define DestroyWindow(hwnd)             WinDestroyWindow(hwnd)
	#define GetWindowRect(tree,rect)        WinQueryWindowRect(tree,(PRECTL)rect)
	#define SetWindowText(hwnd, text)       WinSetWindowText(hwnd, text)
	#define MoveWindow(hwnd,x,y,w,h,flag)   WinSetWindowPos(hwnd,(HWND)0,x,y,w,h,SWP_MOVE)
	/* Achtung Client hat eigenes Fenster-Handle WW 24.01.95 */
	#define GetClientRect(hwnd,rect)        WinQueryWindowRect(hwnd,(PRECTL)rect)
	/* gendert WW 24.01.95 */
	#define ClientToScreen(hwnd,pt)         WinMapWindowPoints(hwnd,HWND_DESKTOP,pt,1)
	#define ScreenToClient(hwnd,pt)         WinMapWindowPoints(HWND_DESKTOP,hwnd,pt,1)
	#define IntersectClipRect(hdc,x,y,x2,y2);  {RECTL rect;rect.xLeft = x;rect.yTop=y;\
																							rect.xRight=x2;rect.yBottom=y2;\
																							GpiIntersectClipRectangle(hdc,&rect);}
	#define InvalidateRect(hwnd,rect,erase)	WinInvalidateRect(hwnd,rect,FALSE)
	#define ValidateRect(hwnd,rect)         WinValidateRect(hwnd,rect,TRUE)
	#define UpdateWindow(hwnd)              WinUpdateWindow(hwnd)
	#define LoadIcon(hInst,icon)            WinLoadFileIcon(icon,FALSE)
	#define DrawIcon(hdc,x,y,hIcon)         WinDrawPointer(hdc,x,y,hIcon,DP_NORMAL)
	#define SetCursorPos(x,y)               WinSetPointerPos(HWND_DESKTOP,x,y)

	/* Menues */
	#define GetMenu(hwnd)                   WinWindowFromID(WinQueryWindow(hwnd,QW_PARENT),FID_MENU)
	#define DestroyMenu()              			/* lassen sich so nicht uebertragen */
	#define CreateMenu()               			WinCreateMenu(B_HANDLE,NULL)	/* lassen sich so nicht uebertragen */
	#define CheckMenuItem(hwndMenu, id, f)	WinCheckMenuItem(hwndMenu, id, f)
	#define IsMenuItemChecked(hwndMenu, id)	WinIsMenuItemChecked(hwndMenu, id)
	#define EnableMenuItem(hwndMenu, id, f)	WinEnableMenuItem(hwndMenu, id, f)
	#define IsMenuItemEnabled(hwndMenu, id)	WinIsMenuItemEnabled(hwndMenu, id)
	#define SetMenuItemText(hMenu, id, psz)	WinSetMenuItemText(hMenu, id, psz)
	#define RemoveMenuItem(hMenu, id)       ((BOOL)WinSendMsg(W_H[0], MM_REMOVEITEM, MPFROM2SHORT(id, 0), 0)) 	 /* ??? nicht dokumentiert -> versuchen */

	#define SetCursor(hCursor)              WinSetPointer(HWND_DESKTOP,hCursor)
	#define ShowCursor(flag)                WinShowPointer(HWND_DESKTOP,flag)

	#define CheckDlgButton(hDlg,id,flag)		WinSendDlgItemMsg(hDlg, (ULONG)id, 	\
																								(ULONG) MM_SETITEMATTR, \
																								MPFROM2SHORT(id, flag), \
																								MPFROM2SHORT(MIA_CHECKED,MIA_CHECKED))
	/* extern void CheckRadioButton(HWND hDlg, short idfirst, short idlast, short flag); */
	#define GetCurrentTime()                WinGetCurrentTime(W_H[0])
	#define SetTimer(hwnd,ph,tint,proc)     WinStartTimer(ph,hwnd,ph,tint)
	#define KillTimer(hwnd,wTimerID)        WinStopTimer(0,hwnd,wTimerID)
	#define SetFocus(hwnd)                  WinSetFocus(HWND_DESKTOP,hwnd)
	#define IsDlgButtonChecked(hDlg,id)	WinQueryButtonCheckstate(hDlg,id)
	#define GetDlgItem(hDlg,sym)		WinEnumDlgItem(hDlg,WinGetNextWindow(sym),EDI_FIRSTTABITEM)
	#define SetDlgItemText(hDlg,id,text)    WinSetDlgItemText(hDlg,id,text)
	#define GetDlgItemText(hDlg,id,text,l)  WinQueryDlgItemText(hDlg,id,l,text)
	#define GetDlgItemInt(hDlg,id,len,flag) WinQueryDlgItemShort(hDlg,id,len,flag)
	#define SetDlgItemInt(hDlg,id,wert,f) 	WinSetDlgItemShort(hDlg,id,wert,f)
	#define EndDialog(hDlg,flag)		WinDismissDlg(hDlg,SHORT1FROMMP(flag))
	#define GetFreeSpace(a)                 coreleft()
	#define MessageBox(hwnd,text,titel,st)  WinMessageBox(hwnd,hwnd,text,titel,0,st)
	#define GetSystemMetrics(par)           WinQuerySystemValue(HWND_DESKTOP,par)
	#define SetWindowPos(hDlg,hwndp,x,y,cx,cy,fl)  WinSetWindowPos(hDlg,hwndp,x,y,cx,cy,fl)
	#define SendMessage(hwnd,msg,wP,lP)     WinSendMsg(hwnd,msg,(MPARAM)wP,(MPARAM)lP)
	#define PostMessage(hwnd,msg,wP,lP)     WinPostMsg(hwnd,msg,(MPARAM)wP,(MPARAM)lP)
	#define PeekMessage(msg,hwnd,fa,fe,m)   WinPeekMsg(W_H[0],(PQMSG)msg,hwnd,fa,fe,m)
	#define GetMessage(msg,hwnd,fa,fe)      WinGetMsg(W_H[0],(PQMSG)msg,hwnd,fa,fe)
	#define TranslateMessage(msg)
	#define DispatchMessage(msg)            WinDispatchMsg(W_H[0],(PQMSG)(msg))
	#define AnsiToOem(a,b)                  strcpy(a,b)
	#define AnsiToOemBuff(a,b,c)            strncpy(a,b,c)
	#define OemToAnsi(a,b)                  strcpy(a,b)
	#define OemToAnsiBuff(a,b,c)            strncpy(a,b,c)
	#define GetCurrentTime()                WinGetCurrentTime(W_H[0])

	#define GetNearestColor(hdc,rgb)        GpiQueryNearestColor(hdc,0,rgb)
	#define RGB(r,g,b)          						((LONG)(((BYTE)(r)|((WORD)(g)<<8))|(((DWORD)(BYTE)(b))<<16)))

	#define MessageBeep(a)                  DosBeep(a,100)
	#define GetKeyState(a)                  WinGetKeyState(a,HWND_DESKTOP)
	#define LOWORD(l)           						((WORD)(l))
	#define HIWORD(l)           						((WORD)((DWORD)(l) >> 16))

	#define VK_RETURN												VK_ENTER
	#define VK_CONTROL											VK_CTRL

	#define WM_KEYDOWN                      WM_CHAR
	#define WM_LBUTTONDOWN                	WM_BUTTON1DOWN
	#define WM_RBUTTONDOWN                	WM_BUTTON2DOWN
	#define WM_LBUTTONUP                		WM_BUTTON1UP
	#define WM_RBUTTONUP	                	WM_BUTTON2UP
	#define WM_NCLBUTTONDOWN                WM_BUTTON1DOWN
	#define WM_NCRBUTTONDOWN                WM_BUTTON2DOWN
	#define WM_NCLBUTTONUP	                WM_BUTTON1UP
	#define WM_NCRBUTTONUP	                WM_BUTTON2UP
	#define MK_LBUTTON                      WM_BUTTON1DOWN
	#define MK_RBUTTON                      WM_BUTTON2DOWN
	#define WM_INITDIALOG									WM_INITDLG
	#define WM_KILLFOCUS                    WM_FOCUSCHANGE

	#define SM_CYSCREEN                     SV_CYSCREEN
	#define SWP_NOSIZE                      SWP_MOVE
	#define SWP_NOMOVE                      SWP_SIZE
	#define BS_DEFPUSHBUTTON                BS_PUSHBUTTON  		/* offenbar n.v. in OS/2 */
	#define WS_CHILD                        WS_CLIPCHILDREN  	/* offenbar n.v. in OS/2 */  /* offenbar n.v. in OS/2 */
	#define MF_SEPARATOR										MIS_SEPARATOR
	#define MF_STRING											MIS_TEXT
	#define MF_POPUP                        MIS_SUBMENU
	#define MF_GRAYED                       MIA_HILITED
	#define MF_DISABLED                     MIA_DISABLED
	#define MF_ENABLED                      ~MIA_DISABLED
	#define MF_CHECKED                      MIA_CHECKED
	#define MF_UNCHECKED                    ~MIA_CHECKED

	#define MF_STRING                       MIS_TEXT
	#define MF_SEPARATOR                    MIS_SEPARATOR

	#define BS_SOLID                        PATSYM_SOLID
	#define BS_HATCHED                      PATSYM_HATCH
	#define BS_PATTERN                      20

	#define IDOK                            DID_OK
	#define IDCANCEL                        DID_CANCEL
	#define SW_SHOW                         TRUE
	#define SW_HIDE                         FALSE
	#define SW_SHOWMAXIMIZED                TRUE

	#define wsprintf                        sprintf
	#define wvsprintf                       vsprintf
/* ++OV.25.9.95 */
	#define _fmemcpy			memcpy
	#define _fmemset			memset
	#define _fmemmove			memmove
	#define _fstrcat			strcat
	#define _fstrncat			strncat
	#define _fstrcpy			strcpy
	#define _fstrncpy			strncpy

#endif /* WINDOWS_umdefinieren_fuer_OS2 */
#else /* !OS2 */
  typedef unsigned int  UINT;
  typedef unsigned long ULONG;
#endif /* OS2 */

/********************************
 *    WINDOWS und WINDOWS_NT    *
 ********************************/
#if defined(WINDOWS) || defined(WINDOWS_NT)
# if defined(WINDOWS) && defined(WINDOWS_NT)
#  undef WINDOWS
# endif

# include <windows.h>

# ifndef  WINAPIV
#  define WINAPIV //__cdecl
# endif

# if BNC_RELEASE >= 20

#  ifdef DLL_DECL /*ab.. 21.10.96 Exportieren in CPP */
#   undef DLL_DECL
#  endif
#  define DLL_DECL
  /*
   * Die Funktionen der Library werden als exportierbar gekennzeichnet
   */
#  ifdef BNC_DLL
#   define BNC_EXPORT  _export
#  else /* !BNC_DLL */
#   define BNC_EXPORT
#  endif /* BNC_DLL */

#  define BNC_WINAPI    WINAPI BNC_EXPORT
#  define BNC_WINAPIV   WINAPIV BNC_EXPORT
#  define BNC_GMEM_ART  (GMEM_MOVEABLE|GMEM_ZEROINIT)   /* ..sb 3.8.95 */

#  if 1	/*	ab.. 21.10.96 Exportieren in CPP 
  			Laut Homer-Dll wird nur ein Kennzeichen benoetigt und zwar
			steht es an erster Stelle im Gegensatz zur bisherigen Verwendung
			von WINAPI/V direkt vor Funktionsnamen.
		*/
#   ifdef B_BDLL /* Schalter ueberommen von HOMER */
#    undef DLL_DECL
#    define DLL_DECL  __declspec(dllexport) // erstellen einer DLL
#    undef BNC_WINAPI    
#    undef BNC_WINAPIV
#    define BNC_WINAPI    
#    define BNC_WINAPIV
#   endif
#   ifdef B_UDLL /* Schalter ueberommen von HOMER */
#    undef DLL_DECL
#    define DLL_DECL  __declspec(dllimport) // benutzen einer DLL
#    undef BNC_WINAPI    
#    undef BNC_WINAPIV
#    define BNC_WINAPI    
#    define BNC_WINAPIV
#   endif

#  endif	/*	ab.. 21.10.96 Exportieren in CPP */

# else /* BNC_RELEASE < 20 */
#  define BNC_WINAPI    WINAPI
#  define BNC_WINAPIV   WINAPIV
#  define BNC_GMEM_ART  (GMEM_FIXED|GMEM_ZEROINIT)
# endif /* BNC_RELEASE >= 20 */

# ifdef __BORLANDC__
#  define Dsetdrv(a)          if(a>=0) setdisk((a)-1)
#  define _chdrive(a)         if(a>=0) setdisk((a)-1)
#  define _getdcwd(a,b,c)     getcwd((LPSTR)b,c)
#  undef lstrcpy
#  if defined(WINDOWS_NT)
#   define lstrcpy(a,b)        strcpy(a,b)
#  else  /* !WINDOWS_NT */
#   define lstrcpy(a,b)        lstrcpy((LPSTR)a,(LPSTR)b)
#  endif /* !WINDOWS_NT */

# else /* !__BORLANDC__ */

#  ifndef SYMANTEC
#   define getdisk()         (_getdrive()-1)
#  endif /* !SYMANTEC */

# endif /* __BORLANDC__ */

#endif /* WINDOWS || WINDOWS_NT */

#if defined(WINDOWS)
# define huge huge
#endif /* WINDOWS */

#if defined(WINDOWS_NT)

# ifndef huge
#  define huge
# endif

# define MoveTo(hdc,x,y)   MoveToEx(hdc,x,y,NULL)

# if 1 /* ++OV.6.12.95 */
#  ifndef _fstrcpy
#   define _fstrcpy(a,b)     strcpy(a,b)
#   define _fstrlen(a)       strlen(a)
#   define _fstrstr          strstr
#   define _fstrncpy         strncpy
#   define _fstrcat(a,b)     strcat(a,b)
#   define _fstrncat(a,b,c)  strncat(a,b,c)
#   define _fstrupr(a)       strupr(a)
#   define _fmemcpy(a,b,c)   memcpy(a,b,c)
#   define _fmemset(a,b,c)   memset(a,b,c)
#   ifndef	lstrcpy	/* ab.. 11.6.96 z.B. _MSC_VER */
#    define  lstrcpy(a,b)     strcpy(a,b)
#    define  lstrcat(a,b)     strcat(a,b)
#   endif	//lstrcpy
#  endif	//_fstrcpy
# endif		// ++OV.6.12.95

# define hmemcpy           memcpy
# define _fstrcmp          strcmp
# define _fstrchr          strchr
# define halloc            calloc
# define hfree             free
# define trunc(a)          (a)
#endif /* WINDOWS_NT */

/* -------------------------------------------------------------------------- */
/* -------------------------- Systemunabhaengiger Teil ---------------------- */
/* -------------------------------------------------------------------------- */
#define C6
#define NEU
#define BNCFLT          /* Mit Fliesskommaausgaben        */
#define BNCWINDOW       /* Immer Textausgaben im Fenster  */
#define BNCERROR        /* Mit Fehlermeldungen            */

	//ab.. 30.1.97 fuer Funktionen B_line/B_view
#define SCREEN	1
#define NOSCREEN	0
#define STEP	1
#define NOSTEP	0

typedef char huge *BStr;
typedef char huge *Bstr;
typedef char huge *BFstr;
typedef unsigned char huge *Bustr;

typedef char          BNC_BYTE;
typedef short         BNC_SHORT;
typedef unsigned int  BNC_WORD;
typedef unsigned long BNC_DWORD;

/* 7) ..CT040696	Neuer Variablentyp SHORT */
#if BNC_RELEASE >= 21

#if defined(WINDOWS) && !defined(WINDOWS_NT)// ..OV.9.6.96: besser als typedef, in WINNT schon definiert
	 typedef int SHORT;
#else
# if defined(WINDOWS)
	 typedef short SHORT;
# endif
#endif

#if 0
# ifndef SHORT
#  define SHORT	short int
# endif
#endif

#endif	//BNC_RELEASE >= 21

#ifdef OS2 // ++WW 07.12.95
  typedef ULONG  	  		BNC_MSG;
  typedef MPARAM 	  		BNC_WPARAM;
  typedef MPARAM	  		BNC_LPARAM;
#else
  typedef unsigned int  BNC_MSG;
  typedef unsigned int  BNC_WPARAM;
  typedef long          BNC_LPARAM;
#endif

typedef void (*PF)(void);

#ifdef LONG_STRINGS
  typedef long BSV;
# define MAX_STRING  2147483635L
#else /* !LONG_STRINGS */
  typedef int BSV;
# define MAX_STRING  32758L
#endif /* LONG_STRINGS */

typedef struct tagString  /* Stringdeskriptor */
{
Bstr  p;
BSV   Aktlen;
BSV   Maxlen;
} STRING;

typedef struct tagBild    /* Bilddeskriptor */
{
Bstr   adr;
BSV    Aktlen;
BSV    Maxlen;
SHORT  w;
short  h;
short  bitebene;
} BILD;

#define BNC_Point     (sizeof(STRING))
#define Deskr         (BNC_Point+1)			/* Nullbyte mitrechnen */
#define StrLaenge(a)  (((STRING huge *)(a)-1)->Aktlen)
#define MaxLaenge(a)  (((STRING huge *)(a)-1)->Maxlen)
#define StrPoint(a)   (((STRING huge *)(a)-1)->p)

#ifndef MAXSTRING
# define C_HAR       256
# define MAXSTRING   (C_HAR+Deskr)
#endif /* !MAXSTRING */

#define NULLFELD  {NULL}    /* ov 10.6.95 */

/*
 * Maximaler temp. Stringbuffer, Default: 3*64 KByte
 */
#ifndef M_AXSP
# define M_AXSP      0x2fffdL
#endif /* !M_AXSP */

#define SSTR          0   	/* statische Strings */
#define DSTR          1   	/* Dynamische Strings */
#define MAXPOLY       256 	/* max. Anzahl Polylinepunkte */

struct linesettingstype
{
int color;
int style;
unsigned int pattern;
int width;
};

struct textsettingstype
{
int color;
int backcolor;
int font;
int direction;
int charsize;
int horiz;
int vert;
};

struct fillsettingstype
{
int color;
int style;
HANDLE pattern;
};

#define BNC_DEF       0xA000    /* DEF-Funktionen */
#define BNC_TEXT      0xA001    /* Text-Funktionen */
#define BNC_LINE      0xA002    /* Zeichen-Funktionen */
#define BNC_PAINT     0xA003    /* Paint-Meldung */
#define BNC_POINT     0xA004    /* BNC_Point-Meldung */
#define BNC_MOUSE     0xA005    /* DEFMOUSE */
#define BNC_FSEL      0xA006    /* FILESELECT */
#define BNC_MENU      0xA007    /* MENU */
#define BNC_SCROLL    0xA008    /* Window scrollen */
#define BNC_GET       0xA009    /* SGET ... */
#define BNC_MOUSEX    0xA00A    /* MOUSEX */
#define BNC_MOUSEY    0xA00B    /* MOUSEY */
#define BNC_SETMOUSE  0xA00C    /* SETMOUSE */
#define BNC_CLS       0xA00D    /* Paint-Meldung */
#define BNC_PUT       0xA00E    /* SGET ... */

#define BNC_KV              0   /* Kein Variablentyp */
#define BNC_CHAR            1   /* 8-bit signed-Variable */
#define BNC_UBYTE           2   /* 8-bit unsigned Variable */
#define BNC_INT             3   /* 16-bit signed-Variable */
#define BNC_LONG            4   /* 32-bit signed-Variable */
#define BNC_DOUBLE          5   /* double-Variable */
#define BNC_STRING          6   /* String-Variable */
#define BNC_FLOAT           7   /* 32-bit Float-Variable */
#define BNC_STAT_STRING     8   /* statische String-Variable */

#define OFF   0
#define ON    1
#define SHOW  2

/* Events */
#define MN_SELECTED 10
#define MN_REDRAW   20
#define WM_TOPPED   21
#define WM_CLOSED   22
#define WM_FULLED   23
#define WM_ARROWED  24
#define WM_HSLID    25
#define WM_VSLID    26
#define WM_SIZED    27
#define WM_MOVED    28
#define WM_NEWTOP   29

#define MU_BUTTON   1
#define MU_M1       2
#define MU_M2       4
#define MU_MESAG    8
#define MU_TIMER    16
#define MU_KEYBD    32
#define OBOX1       0x40
#define OBOX2       0x80

#define BNC_NAME    0x0001
#define BNC_CLOSE   0x0002
#define BNC_FULL    0x0004
#define BNC_MOVE    0x0008
#define BNC_INFO    0x0010
#define BNC_SIZE    0x0020

#define UPARROW     0x0040
#define DNARROW     0x0080
#define VSLIDE      0x0100
#define LFARROW     0x0200
#define RTARROW     0x0400
#define HSLIDE      0x0800

#define WF_KIND          1
#define WF_NAME          2
#define WF_INFO          3
#define WF_WORKXYWH      4
#define WF_CURRXYWH      5
#define WF_PREVXYWH      6
#define WF_FULLXYWH      7
#define WF_HSLIDE        8
#define WF_VSLIDE        9
#define WF_TOP          10
#define WF_FIRSTXYWH    11
#define WF_NEXTXYWH     12
#define WF_RESVD        13
#define WF_NEWDESK      14
#define WF_HSLSIZE      15
#define WF_VSLSIZE      16
#define WF_SCREEN       17
#define WF_COLOR        18
#define WF_DCOLOR       19

#define B_DEFLINE   0
#define B_DEFTEXT   1
#define B_DEFFILL   2
#define B_RC_COPY   3
#define B_FDEFFILL  4
#define B_TEXT      0
#define B_DRAW      0
#define B_ELLIPSE   1
#define B_BOX       2
#define B_RBOX      3
#define B_PLOT      4

#define B_PELLIPSE  0
#define B_PBOX      1
#define B_PRBOX     2
#define B_FILL      3
#define B_CLS       4
#define B_POLYFILL  5
#define B_POLYLINE  6
#define B_PUT       7
#define B_POLYMARK  8
#define B_CLIPTOPIC 9


#define B_MSDOS     0
#define B_PC        B_MSDOS
#define B_ATARI     1
#define B_INTEL     0
#define B_MOTOROLA  1

/*
 * Ausgabedevices
 */
#define B_NOTUSED				0		/* Konstante 0 wird NICHT benutzt */
#define B_SCREEN        1   /* sb 13.2.94 */
#define B_PRINTER       2   /* sb 13.2.94 */
#define B_MIDI          3
#define B_USERDEFINED		4		/* sb 26.12.94 */

#define BNC_FILLED  0x8000
typedef void (*BNCPF)(HDC, LONG);

/* ++CT300196 Define fuer BNC-CVD-Version --> BNC_CVD_VERSION */
#ifndef BNC_CVD_VERSION
# define main(a)               B_main(a)
#endif
/* ++CT300196 Ende */
#define B__drive()            (_getdrive()+'A'-1)
#define B_vsync()             B_dummy()
#define getch()               B_inp(2)
#define max_(a,b)             (((a) > (b)) ? (a) : (b));
#define min_(a,b)             (((a) < (b)) ? (a) : (b));
#define kbhit()               B_keylook()


#if 1 //def BNC_GOSUB /* ++OV.24.1.96 */

#define B_gosub(marke)	{{													/* Makro BEGINN */																						\
							if(BNC_GOSUB>Bstackindex)	                  	/* Nur wenn Buffer vorhanden ist */ \
							{                                                                                   \
								int RetJmp;                                                                     \
								RetJmp = setjmp(Bgosubstack[Bstackindex]);	/* Stack merken */                  \
								if(RetJmp == 0)                                                                 \
								{                                                                               \
									Bstackindex++;                                                              \
									goto marke;  							/* jetzt nach Marke springen */     \
								}                                                                               \
							}else{                                                                              \
								B_stackfehler();                            							        \
							}                                                                                   \
						}}													/* Makro ENDE */
#define B_return()		{   												/* Makro BEGINN */                  \
							if(Bstackindex == 1)							/* dann einfach zurueckhuepfen */   \
								B_stackfehler();							/* Fehler auf dem Stack */ 			\
							else                                                                                \
							{                                                                                   \
								Bstackindex--;                                                                  \
								longjmp(Bgosubstack[Bstackindex],1);		/* Sprung zum letzten GOSUB */      \
							}                                                                                   \
						}
#endif 	/* ++OV.24.1.96 */
/* 8) ..CT040696	Neue Makros fuer die Statischen Strings in Typen */
#if BNC_RELEASE >= 21
/*
* Anlegen einer temporaren Kopie mit Referenzrueckgabe
*/
# define BNC_STAT_STR(a)		B_push_statictypestring(a, sizeof(a))

/*
* Freigabe des zu LETZT gepufferten Strings
*/
# define BNC_STAT_RET(a)		{	\
								B_typecpy(a, sizeof(a), B_gettop_statictypestring());	\
								B_pop_statictypestring();								\
							}

/* ct 3.7.96: Neue Definitionen fuer BNC-RELEASE abh. Programmausfuehrung */
# define BNC_RELEASE21_PROGRAM	2   	/* Konverter schreibt nun B_init(2); */

#endif /* BNC_RELEASE >= 21 */

//#define ZIUTEX /*ab++ 24.11.95 wird bentigt in indexreo */
/* END OF FILE */
